# DomainSets.jl

[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaApproximation.github.io/DomainSets.jl/dev)
[![Build Status](https://github.com/JuliaApproximation/DomainSets.jl/workflows/CI/badge.svg)](https://github.com/JuliaApproximation/DomainSets.jl/actions)
[![Coverage Status](https://codecov.io/gh/JuliaApproximation/DomainSets.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaApproximation/DomainSets.jl)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)

DomainSets.jl is a package designed to represent simple infinite sets. The package makes it easy to represent sets, verify membership of the set, compare sets and construct new sets from existing ones. Domains are considered equivalent if they describe the same set, regardless of their type.

## Examples

For more information, see the [documentation](https://JuliaApproximation.github.io/DomainSets.jl/dev).

### Intervals

DomainSets.jl uses [IntervalSets.jl](https://github.com/JuliaMath/IntervalSets.jl) for closed and open intervals. In addition, it defines a few standard intervals.

```julia
julia> using DomainSets

julia> UnitInterval()
0.0..1.0 (Unit)

julia> ChebyshevInterval()
-1.0..1.0 (Chebyshev)

julia> HalfLine()
0.0..Inf (closed–open) (HalfLine)
```

### Rectangles

Rectangles can be constructed as a product of intervals, where the elements of the domain
are `SVector{2}`:

```julia
julia> using DomainSets: ×

julia> (-1..1) × (0..3) × (4.0..5.0)
(-1.0..1.0) × (0.0..3.0) × (4.0..5.0)

julia> [1,2] in (-1..1) × (0..3)
true

julia> UnitInterval()^3
UnitCube()
```

### Circles and Spheres

A `UnitSphere`  contains `x` if `norm(x) == 1`. The unit sphere is N-dimensional,
and its dimension is specified with the constructor. The element types are
`SVector{N,T}` when the dimension is specified as `Val(3)`, and they
are `Vector{T}` when the dimension is specified by an integer value instead:
```julia
julia> using StaticArrays

julia> SA[0,0,1.0] in UnitSphere(Val(3))
true

julia> [0.0,1.0,0.0,0.0] in UnitSphere(4)
true
```
`UnitSphere` itself is an abstract type, hence the examples above return
concrete types `<:UnitSphere`. The intended element type can also be explicitly
specified with the `UnitSphere{T}` constructor:
```julia
julia> typeof(UnitSphere{SVector{3,BigFloat}}())
EuclideanUnitSphere{3, BigFloat} (alias for StaticUnitSphere{SArray{Tuple{3}, BigFloat, 1, 3}})

julia> typeof(UnitSphere{Vector{Float32}}(6))
VectorUnitSphere{Float32} (alias for DynamicUnitSphere{Array{Float32, 1}})
```

Without arguments, `UnitSphere()` defaults to a 3D domain with `SVector{3,Float64}`
elements. Similarly, there is a special case `UnitCircle` in 2D:
```julia
julia> SVector(1,0) in UnitCircle()
true
```



### Disks and Balls

A `UnitBall`  contains `x` if `norm(x) ≤ 1`. As with `UnitSphere`, the dimension
is specified via the constructor by type or by value:
```julia
julia> SVector(0.1,0.2,0.3) in UnitBall(Val(3))
true

julia> [0.1,0.2,0.3,-0.1] in UnitBall(4)
true
```
By default `N=3`, but `UnitDisk` is a special case in 2D, and so are `ComplexUnitDisk` and `ComplexUnitCircle` in the complex plane:
```julia
julia> SVector(0.1,0.2) in UnitDisk()
true

julia> 0.5+0.2im ∈ ComplexUnitDisk()
true
```

`UnitBall` itself is an abstract type, hence the examples above return
concrete types `<:UnitBall`. The types are similar to those associated with
`UnitSphere`. Like intervals, balls can also be open or closed:
```julia
julia> EuclideanUnitBall{3,Float64,:open}()
the 3-dimensional open unit ball
```


### Product domains

The cartesian product of domains is constructed with the `ProductDomain` or
`ProductDomain{T}` constructor. This abstract constructor returns concrete types
best adapted to the arguments given.

If `T` is not given, `ProductDomain` makes a suitable choice based on the
arguments. If all arguments are Euclidean, i.e., their element types are numbers
or static vectors, then the product is a Euclidean domain as well:
```julia
julia> ProductDomain(0..2, UnitCircle())
0.0..2.0 x the unit circle

julia> eltype(ans)
SVector{3, Float64} (alias for SArray{Tuple{3}, Float64, 1, 3})
```
The elements of the interval and the unit circle are flattened into a single
vector, much like the `vcat` function. The result is a `VcatDomain`.

If a `Vector` of domains is given, the element type is a `Vector` as well:
```julia
julia> 1:5 in ProductDomain([0..i for i in 1:5])
true
```
In other cases, the points are concatenated into a tuple and membership is
evaluated element-wise:
```julia
julia> ("a", 0.4) ∈ ProductDomain(["a","b"], 0..1)
true
```

Some arguments are recognized and return a more specialized product domain.
Examples are the unit box and more general hyperrectangles:
```julia
julia> ProductDomain(UnitInterval(), UnitInterval())
0.0..1.0 (Unit) x 0.0..1.0 (Unit)

julia> ProductDomain(0..2, 4..5, 6..7.0)
0.0..2.0 x 4.0..5.0 x 6.0..7.0

julia> typeof(ans)
Rectangle{SVector{3, Float64}}
```


### Union, intersection, and setdiff of domains

Domains can be unioned and intersected together:
```julia
julia> d = UnitCircle() ∪ 2UnitCircle();

julia> in.([SVector(1,0),SVector(0,2), SVector(1.5,1.5)], d)
3-element BitArray{1}:
 1
 1
 0

julia> d = UnitCircle() ∩ (2UnitCircle() .+ SVector(1.0,0.0))
the intersection of 2 domains:
	1.	: the unit circle
	2.	: A mapped domain based on the unit circle

julia> SVector(1,0) in d
false

julia> SVector(-1,0) in d
true
```


### Level sets

A domain can be defined by the level sets of a function. The domains of all
points `[x,y]` for which `x*y = 1` or `x*y >= 1` are represented as follows:
```julia
julia> d = LevelSet{SVector{2,Float64}}(prod, 1.0)
level set f(x) = 1.0 with f = prod

julia> [0.5,2] ∈ d
true

julia> SuperlevelSet{SVector{2,Float64}}(prod, 1.0)
superlevel set f(x) >= 1.0 with f = prod
```
There is also `SublevelSet`, and there are the special cases `ZeroSet`,
`SubzeroSet` and `SuperzeroSet`.

### Indicator functions

A domain can be defined by an indicator function or a characteristic function.
This is a function `f(x)` which evaluates to true or false, depending on whether or
not the point `x` belongs to the domain.
```julia
julia> d = IndicatorFunction{Float64}( t ->  cos(t) > 0)
indicator domain defined by function f = #5

julia> 0.5 ∈ d, 3.1 ∈ d
(true, false)
```
This enables generator syntax to define domains:
```julia
julia> d = Domain(x>0 for x in -1..1)
indicator function bounded by: -1..1

julia> 0.5 ∈ d, -0.5 ∈ d
(true, false)

julia> d = Domain( x*y > 0 for (x,y) in UnitDisk())
indicator function bounded by: the 2-dimensional closed unit ball

julia> [0.2, 0.3] ∈ d, [0.2, -0.3] ∈ d
(true, false)

julia> d = Domain( x+y+z > 0 for (x,y,z) in ProductDomain(UnitDisk(), 0..1))
indicator function bounded by: the 2-dimensional closed unit ball x 0..1

julia> [0.3,0.2,0.5] ∈ d
true
```

### The domain interface

A domain is any type that implements the functions `eltype` and `in`. If
`d` is an instance of a type that implements the domain interface, then
the domain consists of all `x` that is an `eltype(d)` such that `x in d`
returns true.

Domains often represent continuous mathematical domains, for example, a domain
`d`  representing the interval `[0,1]` would have `eltype(d) == Int` but still
have `0.2 in d` return true.

### The `Domain` type

DomainSets.jl contains an abstract type `Domain{T}`. All subtypes of `Domain{T}`
must implement the domain interface, and in addition support `convert(Domain{T}, d)`.

# FunctionMaps

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://daanhb.github.io/FunctionMaps.jl/stable/)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://daanhb.github.io/FunctionMaps.jl/dev/)
[![Build Status](https://github.com/daanhb/FunctionMaps.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/daanhb/FunctionMaps.jl/actions/workflows/CI.yml?query=branch%3Amain)
[![Coverage](https://codecov.io/gh/daanhb/FunctionMaps.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/daanhb/FunctionMaps.jl)

FunctionMaps.jl is a package designed to represent scalar- and vector-valued functions. It makes it easy to make new maps from existing ones, via composition
or by taking products.

# In this file we list all functions defined in FunctionMaps that
# were defined in the namespace of DomainSets

using FunctionMaps:
	MapRef,
	# canonical.jl
	CanonicalType, CanonicalExtensionType,
	canonicalextensiontype,
	Equal, Equivalent,
	# composite.jl
	ComposedMap, similarmap, codomaintype, applymap,
	applymap_rec, mapsize, jacobian, backpropagate,
	inverse, leftinverse, rightinverse,
	leftinverse_rec, rightinverse_rec,
	composedmap,
	isequalmap, map_hash,
	MulMap, multiply_map, multiply_map1, multiply_map2,
	SumMap, sum_map, sum_map1, sum_map2,
	composite_jacobian,
	mul_jacobian, sum_jacobian,
	# inverse.jl
	LazyInverse, implements_inverse,
	# isomorhpism
	Isomorphism, VectorToNumber, NumberToVector,
	VectorToComplex, ComplexToVector,
	VectorToTuple, TupleToVector,
	NestedToFlat, FlatToNested,
	# jacobian.jl
	LazyJacobian, DeterminantMap, determinantmap, jacdet,
	AbsMap, absmap,
	LazyDiffVolume, diffvolume,
	NumberLike,
	to_matrix, to_vector, zeromatrix, zerovector, identitymatrix,
	# lazy.jl
	LazyMap, CompositeLazyMap, SimpleLazyMap,
	supermap,
	DerivedMap, WrappedMap,
	# map.jl
	Map, TypedMap, EuclideanMap, VectorMap,
	domaintype, codomaintype, prectype, numtype,
	convert_domaintype, convert_codomaintype, convert_prectype, convert_numtype,
	promote_map_point_pair,
	promote_and_apply, promote_maps,
	isvectorvalued_type, isvectorvalued,
	issquaremap, isoverdetermined, isunderdetermined,
	isrealmap,
	is_scalar_to_vector, is_scalar_to_scalar,
	is_vector_to_scalar, is_vector_to_vector,
	isequalmap1, isequalmap2, default_isequalmap,
	map_stencil, map_stencil_broadcast,
	# product.jl
	ProductMap, VcatMapElement,
	compatibleproductdims,
	tointernalpoint, toexternalpoint,
	productmap, productmap1, productmap2,
	VcatMap, size_as_matrix, toexternalmatrix,
	VectorProductMap, TupleProductMap,
	# affine.jl
	AbstractAffineMap,
	unsafe_matrix, unsafe_vector,
	affinematrix, affinevector,
	applymap!,
	islinearmap, isaffinemap,
	LinearMap, GenericLinearMap, ScalarLinearMap,
	VectorLinearMap, StaticLinearMap,
	Translation, ScalarTranslation, StaticTranslation,
	VectorTranslation, GenericTranslation,
	AffineMap, GenericAffineMap, ScalarAffineMap,
	VectorAffineMap, StaticAffineMap,
	# arithmetics.jl
	affine_composition,
	interval_map, bounded_interval_map,
	# basic.jl
	IdentityMap, isidentitymap,
	StaticIdentityMap, DynamicIdentityMap,
	EuclideanIdentityMap, VectorIdentityMap,
	ConstantMap, isconstantmap, mapconstant,
	ZeroMap, UnityMap, FixedConstantMap,
	# coordinates.jl
	CartToPolarMap, PolarToCartMap,
	UnitCircleMap, AngleMap, UnitDiskMap,
	# common.jl
	isrealtype,
	StaticTypes,
	hashrec,
	euclideandimension,
	convert_eltype, promotable_eltypes,
	prectype, convert_prectype, to_prectype, promote_prectype,
	numtype, convert_numtype, to_numtype, promote_numtype,
	convert_fromcartesian, convert_tocartesian,
	factors, nfactors, factor

import FunctionMaps:
	convert_eltype,
	convert_prectype,
	convert_numtype,
	prectype,
	numtype,
	factors,
	tointernalpoint, toexternalpoint, compatibleproductdims

# Deprecations for symbols that were renamed in FunctionMaps.jl
const AbstractMap = Map
@deprecate isreal(::Type{T}) where {T} isrealtype(T)
@deprecate isreal(m::Map) isrealmap(m)
@deprecate islinear(m::Map) islinearmap(m)
@deprecate isaffine(m::Map) isaffinemap(m)
@deprecate isidentity(m::Map) isidentitymap(m)
@deprecate isconstant(m::Map) isconstantmap(m)
@deprecate constant(m::Map) mapconstant(m)
@deprecate matrix(m::Map) affinematrix(m) false
@deprecate vector(m::Map) affinevector(m) false
@deprecate mapdim(m::Map) mapsize(m, 2)

@testset "set operations" begin
    @testset "union" begin
        d1 = UnitDisk()
        d2 = (-0.9..0.9)^2
        d3 = ProductDomain(-.5 .. -.1, ChebyshevInterval())
        d4 = (0.0..1.5)
        d5 = [1.0,3.0]

        @test convert(Domain{SVector{2,Float64}}, d3) isa Domain{SVector{2,Float64}}

        u1 = UnitDisk() ∪ (-0.9..0.9)^2
        u2 = u1 ∪ d3
        @test dimension(u1) == 2
        @test dimension(u2) == 2
        @test boundingbox(u1) == ChebyshevInterval()^2
        @test choice(u1) ∈ u1

        u3 = d3 ∪ u1
        u4 = u1 ∪ u2
        @test SVector(0.,.15) ∈ u3
        @test SVector(0.,.15) ∈ u4
        @test SVector(1.1,.75) ∉ u3
        @test SVector(1.1,.75) ∉ u4

        @test_throws ArgumentError UnionDomain()
        ũ1 = UnionDomain(d1,d2)
        @test u1 == ũ1
        @test UnionDomain{SVector{2,Float64}}(d1,d2) == ũ1
        ũ1 = UnionDomain((d1,d2))
        @test u1 == ũ1
        ũ2 = UnionDomain([d1,d2])
        @test ũ2 == ũ2
        @test u1 == ũ2
        @test UnionDomain{SVector{2,Float64}}((d1,)) isa UnionDomain

        # Don't create a union with two identical elements
        @test UnitDisk() ∪ UnitDisk() isa UnitDisk

        # uniondomain and setdiff
        @test setdiffdomain(uniondomain(0..1, 2..3), 1.3..1.5) == uniondomain(0..1, 2..3)
        @test setdiffdomain(uniondomain(0..1, 2..3), 0.0..1.0) == 2..3
        @test setdiffdomain(UnionDomain(0..1, 0..1), 0.0..1.0) === EmptySpace{Float64}()
        @test setdiffdomain(UnionDomain(0..1, 2..3, 4..5), 0..1) == uniondomain(2..3, 4..5)
        @test setdiffdomain(0.0..1.0, uniondomain(0..1, 2..3)) == EmptySpace{Float64}()
        @test setdiffdomain(0.0..1.0, uniondomain(1..1.5, 2..3)) == Interval{:closed,:open}(0..1)

        # union with non-Domain type that implements domain interface
        u45 = uniondomain(0.0..1.5, [1.0,3.0])
        @test u45 isa Domain{Float64}
        @test u45 isa UnionDomain
        @test eltype(component(u45,1)) == Float64
        @test eltype(component(u45,2)) == Float64
        @test 0.2 ∈ u45
        @test 1.2 ∈ u45
        @test 3 ∈ u45
        @test -1.2 ∉ u45
        @test convert(Domain{BigFloat}, u45) isa Domain{BigFloat}

        u45b = uniondomain(0.0..1.5, [1,3])
        @test u45b isa Domain{Float64}
        @test component(u45b,2) isa AbstractArray{Float64}
        @test uniondomain([1,3], 0.0..1.5) isa Domain{Float64}

        @test issubset_domain([0,1], 0..1)
        @test issubset_domain(Set([0,1]), 0..1)
        @test !issubset_domain([0,1,2], 0..1)
        @test issubset_domain(Set([0,1]), 0..1)
        @test !issubset_domain(Set([0,2]), 0..1)
        @test issubset_domain([0,1], 0:5)

        @test uniondomain() == EmptySpace{Any}()
        @test uniondomain(0..1) == 0..1
        @test uniondomain(0..1, [0,1]) == 0..1
        @test uniondomain([0,1], 0..1) == 0..1

        @test uniondomain([0,1], [0.0,1.0]) == [0,1]
        @test isequaldomain(uniondomain([0,2], [0.0,1.0]), [0.0,2.0,1.0])

        # larger union expressions
        @test uniondomain(0..1, 1..3, Point(0.4), 2..5, FullSpace(), Point(-0.2)) isa FullSpace
        @test uniondomain(0..1, 1..3, Point(0.4)) == 0..3
        @test uniondomain(0..1, Point(0.4), 1..3) == 0..3
        @test uniondomain(Point(0.4), 0..1, 1..3) == 0..3
        @test uniondomain(0..1, 2..3, 0..3) == 0..3
        @test uniondomain(0..1, 0..3, 2..3) == 0..3
        @test uniondomain(0..3, 0..1, 2..3) == 0..3

        # ordering doesn't matter
        @test UnionDomain(d1,d2) == UnionDomain(d2,d1)

        @test UnionDomain((d1,d2)) == UnionDomain(d1,d2)
        @test UnionDomain(UnionDomain(d1,d2),d3) == UnionDomain(d3,UnionDomain(d1,d2))

        @test convert(Domain, [Point(0),Point(2),Point(3)]) isa UnionDomain{Int}
        @test convert(Domain{Float64}, [Point(1),Point(2),Point(3)]) isa UnionDomain{Float64}
        @test convert(Domain, Set([Point(0),Point(2),Point(3)])) isa UnionDomain{Int}
        @test convert(Domain{Float64}, Set([Point(0),Point(2),Point(3)])) isa UnionDomain{Float64}
        @test 2 ∈ convert(Domain, Set([1,2,3]))
        @test 2 ∈ convert(Domain{Float64}, Set([1,2,3]))
        @test 4 ∉ convert(Domain, Set([1,2,3]))

        @test interior(uniondomain(0..1, 2..3)) == uniondomain(OpenInterval(0,1),OpenInterval(2,3))
        @test closure(uniondomain(OpenInterval(0,1),OpenInterval(2,3))) == uniondomain(0..1, 2..3)

        @test uniondomain(0..1, 2..3) \ (0.5..2.5) == uniondomain(Interval{:closed,:open}(0..0.5), Interval{:open,:closed}(2.5..3.0))
        @test uniondomain(0..1, 2..3) \ uniondomain(0.5..2.5, -2..(-1)) == uniondomain(Interval{:closed,:open}(0..0.5), Interval{:open,:closed}(2.5,3.0))

        @test !isempty(u1)
        show(io, textmime, u1)
        @test String(take!(io)) == "UnitDisk() ∪ (($(-0.9..0.9)) × ($(-0.9..0.9)))"

        # repeated union
        @test ncomponents(uniondomain(-2 .. -1, UnitInterval(), UnitInterval())) == 2
        @test ncomponents(uniondomain(UnitInterval(), -2 .. -1, UnitInterval())) == 2
        @test ncomponents(uniondomain(UnitInterval(), UnitInterval(), -2 .. -1)) == 2
    end

    @testset "intersect" begin
        @test IntersectDomain{Float64}(0..1, 1..2) == IntersectDomain((0..1, 1..2))
        @test intersectdomain(0..1, 1..2) == Point(1)

        @test intersectdomain(0..1, 0.5..1.5) == (0..1) & (0.5..1.5)

        # intersection of productdomains
        i1 = intersectdomain((-0.4..0.4)^2, cartesianproduct(-.5 .. 0.5, -0.1.. 0.1))
        @test i1 == productdomain(-0.4..0.4, -0.1..0.1)
        show(io,i1)
        @test String(take!(io)) == "($(-0.4..0.4)) × ($(-0.1..0.1))"
        @test intersectdomain(productdomain(UnitDisk(),-1..1), productdomain(-1..1, UnitDisk())) isa IntersectDomain
        i2 = UnitDisk() & (-0.4..0.4)^2
        show(io, textmime, i2)
        @test String(take!(io)) == "UnitDisk() ∩ (($(-0.4..0.4)) × ($(-0.4..0.4)))"
        @test dimension(i1) == 2
        @test dimension(i2) == 2

        i3 = cartesianproduct(-.5 .. 0.5, -0.1.. 0.1) & i2
        i4 = i2 & cartesianproduct(-.5 .. 0.5, -0.1.. 0.1)
        i5 = i3 & i2
        @test SVector(0.,.05) ∈ i3
        @test SVector(0.,.05) ∈ i4
        @test SVector(0.,.75) ∉ i3
        @test SVector(0.,.75) ∉ i4

        d45 = IntersectDomain(0.0..1.5, [1.0,3.0])
        @test d45 isa Domain{Float64}
        @test 1.0 ∈ d45
        @test 1.1 ∉ d45
        @test convert(Domain{BigFloat}, d45) isa Domain{BigFloat}

        @test intersectdomain() == EmptySpace{Any}()
        @test intersectdomain(UnitDisk()) == UnitDisk()

        @test intersectdomain(0..1, [1.5]) isa IntersectDomain{Float64}
        @test intersectdomain([0.5], 1..2) isa IntersectDomain{Float64}

        @test intersectdomain(0..1, [0,1]) == [0,1]
        @test intersectdomain([0,1], 0..1) == [0,1]
        @test intersectdomain([0,1], [0.0,1.0]) == [0,1]
        @test intersectdomain([0,2], [0.0,1.0]) == [0.0]
        @test isempty(intersectdomain([0,2], Set(3:7)))

        @test IntersectDomain(UnitDisk(), UnitSquare()) == IntersectDomain(UnitSquare(), UnitDisk())

        @test intersectdomain(uniondomain(0..1, 2..3), uniondomain(0..0.5, 3.5..4.5)) == 0..0.5
        @test intersectdomain(uniondomain(0..1, 2..3), 2..4) == 2..3
        @test intersectdomain(2..4, uniondomain(0..1, 2..3)) == 2..3

        # repeated intersection
        @test ncomponents(intersectdomain(UnitBall{Float64}(), UnitInterval(), UnitInterval())) == 0
        @test ncomponents(intersectdomain(UnitInterval(), UnitBall{Float64}(), UnitInterval())) == 0
        @test ncomponents(intersectdomain(UnitInterval(), UnitInterval(), UnitBall{Float64}())) == 0
        # larger intersection expressions
        @test intersectdomain(0..1, 1..3, Point(0.4), 2..5, FullSpace(), Point(-0.2)) isa EmptySpace
        @test intersectdomain(0..1, 1..3, Point(1.0)) == Point(1.0)
        @test intersectdomain(0..1, Point(1.0), 1..3) == Point(1.0)
        @test intersectdomain(Point(1.0), 0..1, 1..3) == Point(1.0)

        pt = Point(SA[0.0,0.0])
        @test intersectdomain(UnitDisk(), UnitSquare(), pt) == pt
        @test intersectdomain(UnitDisk(), pt, UnitSquare()) == pt
        @test intersectdomain(pt, UnitDisk(), UnitSquare()) == pt

        @test boundingbox(UnitSphere() ∩ 2UnitBall()) == (-1..1)^3
    end

    @testset "setdiff" begin
        d1 = UnitDisk() \ ProductDomain(-0.5..0.5, -0.1..0.1)
        @test dimension(d1) == 2
        @test SVector(0.,.74) ∈ d1
        @test SVector(0.,.25) ∈ d1
        @test SVector(0.,-.05) ∉ d1
        @test SVector(0.5, 0.1) ∉ d1
        @test SVector(1.01, 0.1) ∉ d1
        @test approx_in(SVector(1.01, 0.1), d1, 0.1)
        show(io, textmime, d1)
        @test String(take!(io)) == "UnitDisk() \\ (($(-0.5..0.5)) × ($(-0.1..0.1)))"
        @test setdiff(d1, ProductDomain(-0.5..0.5, -0.1..0.1)) == d1

        d2 = SetdiffDomain(0.0..3.0, [1.0, 2.5])
        @test d2 isa Domain{Float64}
        @test d2 isa SetdiffDomain
        @test 0.99 ∈ d2
        @test approx_in(3.01, d2, 0.1)
        @test !approx_in(3.01, d2, 0.009)
        @test 1.0 ∉ d2
        @test convert(Domain{BigFloat}, d2) isa Domain{BigFloat}

        @test setdiffdomain(0..1, [0.5]) isa SetdiffDomain{Float64}
        d3 = setdiffdomain([0,5], 0..3)
        @test d3 isa SetdiffDomain{Int}
        @test 0 ∉ d3
        @test 5 ∈ d3

        @test setdiff(0..1, 2..3) == setdiffdomain(0..1, 2..3)
        @test setdiff(0..1, DomainRef(0.5)) == setdiffdomain(0..1, 0.5)
        @test setdiff(DomainRef(0.5), 0..1) == setdiffdomain(0.5, 0..1)

        @test setdiff(0..1, EmptySpace()) == 0..1
        @test setdiffdomain(0..1, 0.0..1.0) == EmptySpace()

        @test (0..1)^2 \ UnitCircle() == UnitInterval()^2 \ UnitCircle()
    end

    @testset "arithmetic" begin
        d1 = (0..1)
        d2 = (2..3)
        d = UnionDomain((d1,)) ∪ UnionDomain((d2,))

        @test d .+ 1 == UnionDomain((d1 .+ 1,)) ∪ (d2 .+ 1)
        @test d .- 1 == UnionDomain((d1 .- 1,)) ∪ (d2 .- 1)
        @test 2 * d  == UnionDomain((2*d1,))  ∪ 2 * d2
        @test d * 2 == UnionDomain((d1 * 2,)) ∪ (d2 * 2)
        @test d / 2 == UnionDomain((d1 / 2,)) ∪ (d2 / 2)
        @test 2 \ d == UnionDomain((2 \ d1,)) ∪ (2 \ d2)

        @test infimum(d) == minimum(d) == 0
        @test supremum(d) == maximum(d) == 3
    end

    @testset "different types" begin
        d1 = 0..1
        d2 = 0f0..1f0
        d3 = 2..3

        @test UnionDomain(d1,d2) ∪ d3 == d1 ∪ UnionDomain(d2, d3)
    end

    @testset "disk × interval" begin
        d = cartesianproduct(0.0..1, UnitDisk())
        @test SVector(0.1, 0.2, 0.3) ∈ d

        d = cartesianproduct(UnitDisk(), 0.0..1)
        @test SVector(0.1, 0.2, 0.3) ∈ d
    end

    @testset "Wrapped domain" begin
        d = 0..1.0
        w = DomainSets.WrappedDomain(d)
        @test w isa Domain
        @test 0.5 ∈ w

        d1 = DomainSets.WrappedDomain{Any}([0,5])
        @test 0 ∈ d1
        @test 1 ∉ d1

        @test convert(Domain{Float64}, [0.4,0.5]) isa Domain{Float64}
    end

    @testset "more set operations" begin
        D = UnitInterval()^3
        S = 2 * UnitBall()
        @testset "joint domain" begin
            DS = D ∪ S
            @test SA[0.0, 0.6, 0.0] ∈ DS
            @test SA[0.9, 0.6,-2.5] ∉ DS
        end

        @testset "domain intersection" begin
            DS = D ∩ S
            @test SA[0.1, 0.1, 0.1] ∈ DS
            @test SA[0.1, -0.1, 0.1] ∉ DS
        end
        @testset "domain difference" begin
            DS = D\S
            @test SA[0.1, 0.1, 0.1] ∉ DS

            D1 = 2 * D
            D2 = D * 2
            D3 = D / 2

            @test SA[2., 2., 2.] ∈ D1
            @test SA[0.9, 0.6,-2.5] ∉ D1
            @test SA[2., 2., 2.] ∈ D2
            @test SA[0.9, 0.6,-2.5] ∉ D2
            @test SA[.5, .4, .45] ∈ D3
            @test SA[.3, 0.6,-.2] ∉ D3
        end
    end
end

"A lazy inverse stores a map `m` and returns `inverse(m, x)`."
struct LazyInverse{T,M} <: SimpleLazyMap{T}
	map	::	M
end

LazyInverse(m) = LazyInverse{codomaintype(m)}(m)
LazyInverse{T}(m) where {T} = LazyInverse{T,typeof(m)}(m)

applymap(m::LazyInverse, x) = inverse(supermap(m), x)

Display.displaystencil(m::LazyInverse) = ["LazyInverse(", supermap(m), ")"]
show(io::IO, mime::MIME"text/plain", m::LazyInverse) = composite_show(io, mime, m)


"""
    inverse(m[, x])

Return the inverse of `m`. The two-argument function evaluates the inverse
at the point `x`.
"""
inverse(m) = LazyInverse(m)
inverse(m::LazyInverse) = supermap(m)
# Concrete maps should implement inverse(m, x)

Base.:\(m::AbstractMap, x) = inverse(m, x)

implements_inverse(m) = !(inverse(m) isa LazyInverse)

"""
    leftinverse(m[, x])

Return a left inverse of the given map. This left inverse `mli` is not unique,
but in any case it is such that `(mli ∘ m) * x = x` for each `x` in the domain
of `m`.

The two-argument function applies the left inverse to the point `x`.
"""
leftinverse(m) = inverse(m)
leftinverse(m, x) = inverse(m, x)

"""
    rightinverse(m[, x])

Return a right inverse of the given map. This right inverse `mri` is not unique,
but in any case it is such that `(m ∘ mri) * y = y` for each `y` in the range
of `m`.

The two-argument function applies the right inverse to the point `x`.
"""
rightinverse(m) = inverse(m)
rightinverse(m, x) = inverse(m, x)

isequalmap(m1::LazyInverse, m2::LazyInverse) = isequalmap(supermap(m1), supermap(m2))
map_hash(m::LazyInverse, h::UInt) = hashrec("LazyInverse", supermap(m), h)

using DomainSets: factors, nfactors, factor


widen_eltype(::Type{T}) where {T<:Number} = widen(T)
widen_eltype(::Type{SVector{N,T}}) where {N,T<:Number} = SVector{N,widen(T)}
widen_eltype(::Type{Vector{T}}) where {T<:Number} = Vector{widen(T)}


# We test the generic functionality of a domain.
# These tests check whether the given domain correctly implements the
# interface of a domain.
function test_generic_domain(d)
    @test isrealdomain(d) == isrealtype(domaineltype(d))
    @test isrealdomain(d) == isrealtype(domain_numtype(d))

    if d isa Domain
        @test convert(Domain{eltype(d)}, d) == d
        @test convert(Domain{widen_eltype(eltype(d))}, d) == d
    elseif DomainStyle(d) isa IsDomain
        @test convert_eltype(eltype(d), d) == d
        @test convert_eltype(widen_eltype(eltype(d)), d) == d
    end
    @test prectype(convert_prectype(BigFloat, 2)) == BigFloat

    if !isempty(d)
        x = choice(d)
        @test x ∈ d
        @test approx_in(x, d, 0.01)
        @test_throws ErrorException approx_in(x, d, -1)
        @test in.([x,x], d) == in.([x,x], Ref(d))
        @test approx_in.([x,x], d, 0.01) == approx_in.([x,x], Ref(d), 0.01)
    else
        try
            x = choice(d)
            @test false
        catch
        end
    end
    @test isequaldomain(canonicaldomain(DomainSets.Equal(), d), d)
    @test hash(d) == hash(DomainSets.simplify(d))
    if hascanonicaldomain(d)
        cd = canonicaldomain(d)
        @test mapfrom_canonical(d) == mapto(cd, d)
        @test mapto_canonical(d) == mapto(d, cd)
        x1 = choice(cd)
        @test mapfrom_canonical(d, x1) ∈ d
        @test mapto_canonical(d, x) ∈ cd
    else
        @test mapto_canonical(d) == IdentityMap{eltype(d)}(dimension(d))
        @test mapfrom_canonical(d) == IdentityMap{eltype(d)}(dimension(d))
    end
    if hasparameterization(d)
        par = parameterdomain(d)
        @test mapfrom_parameterdomain(d) == mapto(par, d)
        xp = choice(par)
        @test approx_in(mapfrom_parameterdomain(d, xp), d)
    end
    if iscomposite(d)
        @test ncomponents(d) == length(components(d))
        els = components(d)
        @test all([component(d,i) == els[i] for i in 1:ncomponents(d)])
        if d isa ProductDomain
            @test factors(d) == components(d)
            @test nfactors(d) == ncomponents(d)
            if nfactors(d) > 0
                @test factor(d, 1) == component(d, 1)
            end
        end
    end
end

@testset "generic domain interface" begin
    domains = [
        0..1,
        UnitInterval(),
        ChebyshevInterval(),
        HalfLine(),
        NegativeHalfLine(),
        UnitInterval()^3,
        cartesianproduct(0..1, 2.0..3, 3..4),
        UnitBall(),
        VectorUnitBall(),
        VectorUnitBall(8),
        UnitDisk(),
        VectorUnitDisk(),
        UnitCircle(),
        VectorUnitCircle(),
        UnitSphere(),
        VectorUnitSphere(),
        UnitSimplex(Val(2)),
        UnitSimplex(2),
        DomainSets.WrappedDomain(0..2.0)
    ]

    @testset "generic domains" begin
        for domain in domains
            test_generic_domain(domain)
        end
    end

    @testset "generic functionality" begin
        struct SomeDomain <: Domain{Float64}
        end
        @test_throws MethodError 0.5 ∈ SomeDomain()
        @test_throws MethodError approx_in(0.5, SomeDomain())

        @test_logs (:warn, "`in`: incompatible combination of point: Tuple{Float64, Float64} and domain eltype: SVector{2, Float64}. Returning false.") (0.5,0.2) ∈ UnitCircle()
        @test_logs (:warn, "`in`: incompatible combination of point: Tuple{Float64, Float64} and domain eltype: SVector{2, Float64}. Returning false.") approx_in((0.5,0.2), UnitCircle())

        # functionality using broadcast
        @test 2 * (1..2) == 2 .* (1..2)
        @test (1..2) * 2 == (1..2) .* 2
        @test (1..2) / 2 ≈ 0.5..1
        @test 2 \ (1..2) ≈ 0.5..1
        @test all(rand(4) .∈ (-1..1))
        @test all(approx_in.(rand(4), (-1..1)))
        @test all(approx_in.([1.005,1.0005], (-1..1), [1e-2,1e-3]))
        @test all(rand(4) .∉ (2..3))
        @test_throws MethodError (0..1) + 0.4

        # promotion
        @test DomainSets.promote_domains() == ()
        @test DomainSets.promote_domains(0..1, 2..4.0) isa Tuple{ClosedInterval{Float64},ClosedInterval{Float64}}
        @test DomainSets.promote_domains(0..1.0, [1,2,3]) isa Tuple{Interval,Vector{Float64}}
        @test DomainSets.promote_domains([1,2,3], 0..1.0) isa Tuple{Vector{Float64},Interval}

        # compatible point-domain pairs
        @test DomainSets.iscompatiblepair(0.5, 0..1)
        @test DomainSets.iscompatiblepair(0.5, 0..1.0)
        @test !DomainSets.iscompatiblepair(0.5, UnitBall())
        @test DomainSets.iscompatiblepair(0.5, [0.3])
        @test DomainSets.iscompatiblepair(0, [0.3])
        @test DomainSets.iscompatiblepair(0.5, [1, 2, 3])
        @test DomainSets.iscompatiblepair(0, Set([1, 2, 3]))
        @test DomainSets.iscompatiblepair(0.5, Set([1, 2, 3]))
        @test DomainSets.iscompatiblepair(0, Set([1.0, 2, 3]))

        @test DomainSets.convert_eltype(Float64, Set([1,2])) isa Set{Float64}
        @test_throws ArgumentError DomainSets.convert_eltype(Float64, (1,2)) isa NTuple{2,Float64}
        @test DomainSets.convert_eltype(Int, (1,2)) == (1,2)
    end

    @test choice(Set([1,2,3])) ∈ Set([1,2,3])
    @test choice([1,2,3]) == 1
end

# The type hierarchy is as follows:
# abstract Ball
# |-> abstract UnitBall: radius is 1
#     |-> StaticUnitBall: dimension is part of type
#     |-> DynamicUnitBall: dimension is specified by int field
# |-> GenericBall: stores center and radius. Here, the dimension can be
#     obtained from the center, so there is only one type.
# There are aliases for SVector{N,T} and Vector{T}:
#   EuclideanBall, VectorBall,
#   EuclideanUnitBall (StaticUnitBall), VectorUnitBall (DynamicUnitBall).

"""
    Ball{T,C} <: Domain{T}

Abstract supertype for volumes of elements satisfying `norm(x-center(ball)) < radius(ball)`
(open ball) or `norm(x-center(ball)) <= radius(ball)` (closed ball).
"""
abstract type Ball{T,C} <: Domain{T} end

"A ball in a fixed N-dimensional Euclidean space."
const EuclideanBall{N,T,C} = Ball{SVector{N,T},C}

"A ball with vector elements of variable length."
const VectorBall{T,C} = Ball{Vector{T},C}

iscompatiblepair(x::AbstractVector, d::VectorBall) = length(x) == dimension(d)

const ClosedBall{T} = Ball{T,:closed}
const OpenBall{T} = Ball{T,:open}

isclosedset(::ClosedBall) = true
isclosedset(::OpenBall) = false
isopenset(d::Ball) = !isclosedset(d)

"""
    Ball(radius = 1[, center])
    Ball{T,C=:closed}(radius = 1[, center])

Return a concrete subtype of `Ball` which represents a ball with the given
radius and center, the given eltype `T`, and which is open or closed.

The default center is the origin. In case both radius and center are omitted,
a subtype of `UnitBall` is returned, whose concrete type depends on `T`.

A ball represents a volume. For the boundary of a ball, see [`Sphere()`](@ref).
"""
Ball(; radius=One(), center=Origin()) = Ball(radius, center)
Ball(radius; center=Origin()) = Ball(radius, center)
Ball(::One, ::Origin) = UnitBall()
Ball(radius, center) = GenericBall(radius, center)
Ball(::One, center) = GenericBall(1, center)
Ball(radius, center::Origin) = GenericBall(radius)

Ball{T}(args...; options...) where T = Ball{T,:closed}(args...; options...)

Ball{T,C}(; radius = One(), center = Origin()) where {T,C} = Ball{T,C}(radius, center)
Ball{T,C}(radius; center=Origin()) where {T,C} = Ball{T,C}(radius, center)
Ball{T,C}(radius, center) where {T,C} = GenericBall{T,C}(radius, center)
Ball{T,C}(::One, ::Origin) where {T,C} = UnitBall{T,C}()
Ball{T,C}(radius::One, center) where {T,C} = GenericBall{T,C}(1, center)
Ball{T,C}(radius, center::Origin) where {T,C} = GenericBall{T,C}(radius)


indomain(x, d::OpenBall) = norm(x-center(d)) < radius(d)
indomain(x, d::ClosedBall) = norm(x-center(d)) <= radius(d)
approx_indomain(x, d::OpenBall, tolerance) = norm(x-center(d)) < radius(d)+tolerance
approx_indomain(x, d::ClosedBall, tolerance) = norm(x-center(d)) <= radius(d)+tolerance

# A closed ball always contains at least its center point.
isempty(d::ClosedBall) = false
isempty(d::OpenBall) = radius(d) == 0

isequaldomain(d1::Ball, d2::Ball) = isclosedset(d1)==isclosedset(d2) &&
    radius(d1)==radius(d2) && center(d1)==center(d2)
domainhash(d::Ball, h::UInt) = hashrec("Ball", isclosedset(d), radius(d), center(d), h)

function issubset_domain(d1::Ball, d2::Ball)
    if dimension(d1) == dimension(d2)
        if center(d1) == center(d2)
            if radius(d1) < radius(d2)
                true
            elseif radius(d1) == radius(d2)
                isclosedset(d2) || isopenset(d1)
            else
                false
            end
        else
            dist = norm(center(d1)-center(d2))
            if dist + radius(d1) < radius(d2)
                true
            else
                false
            end
        end
    else
        false
    end
end

normal(d::Ball, x) = normal(boundary(d), x)

distance_to(d::Ball, x) = x ∈ d ? zero(prectype(d)) : norm(x-center(d))-radius(d)

# We choose the center of the ball here. Concrete types should implement 'center'
choice(d::Ball) = center(d)


abstract type UnitBall{T,C} <: Ball{T,C} end

radius(::UnitBall) = 1
center(d::UnitBall{T}) where {T<:StaticTypes} = zero(T)

"""
    UnitBall([dim::Int])
    UnitBall{T}([dim::Int])
    UnitBall{T,C=:closed}([dim::Int])

The open or closed volume of all points of type `T` with norm smaller than (or equal to) 1.
"""
UnitBall(::Val{N} = Val(3)) where {N} = EuclideanUnitBall{N}()
UnitBall(dim::Int) = DynamicUnitBall(dim)

UnitBall{T}(dim::Int) where {T <: StaticTypes} = StaticUnitBall{T}(dim)
UnitBall{T}(::Val{N}) where {N,T} = StaticUnitBall{T}(Val(N))
UnitBall{T}() where {T <: StaticTypes} = StaticUnitBall{T}()
UnitBall{T}(dim::Int) where {T} = DynamicUnitBall{T}(dim)

UnitBall{T,C}(dim::Int) where {T <: StaticTypes,C} = StaticUnitBall{T,C}(dim)
UnitBall{T,C}(::Val{N}) where {N,T,C} = StaticUnitBall{T,C}(Val(N))
UnitBall{T,C}() where {T <: StaticTypes,C} = StaticUnitBall{T,C}()
UnitBall{T,C}(dim::Int) where {T,C} = DynamicUnitBall{T,C}(dim)

const ClosedUnitBall{T} = UnitBall{T,:closed}
const OpenUnitBall{T} = UnitBall{T,:open}

indomain(x, d::OpenUnitBall) = norm(x) < 1
indomain(x, d::ClosedUnitBall) = norm(x) <= 1
approx_indomain(x, d::OpenUnitBall, tolerance) = norm(x) < 1+tolerance
approx_indomain(x, d::ClosedUnitBall, tolerance) = norm(x) <= 1+tolerance



isequaldomain(d1::UnitBall, d2::UnitBall) = isclosedset(d1)==isclosedset(d2) &&
    dimension(d1) == dimension(d2)

issubset_domain(d1::UnitBall, d2::UnitBall) =
    dimension(d1) == dimension(d2) && (isclosedset(d2) || isopenset(d1))

convert(::Type{SublevelSet}, d::UnitBall{T,C}) where {T,C} =
    SublevelSet{T,C}(norm, radius(d))
convert(::Type{SublevelSet{T}}, d::UnitBall{S,C}) where {T,S,C} =
    SublevelSet{T,C}(norm, radius(d))


"""
    StaticUnitBall()
    StaticUnitBall{T}()
    StaticUnitBall{T,C=:closed}()

The open or closed unit ball with static dimension determined by the element type.
"""
struct StaticUnitBall{T,C} <: UnitBall{T,C}
end

StaticUnitBall() = StaticUnitBall{Float64}()
StaticUnitBall(::Val{N}) where {N} = StaticUnitBall{SVector{N,Float64}}()

StaticUnitBall{T}() where {T} = StaticUnitBall{T,:closed}()

StaticUnitBall{T}(dim::Int) where {T} =
    (@assert dim == euclideandimension(T); StaticUnitBall{T}())
StaticUnitBall{T}(::Val{N}) where {N,T} =
    (@assert N == euclideandimension(T); StaticUnitBall{T}())

StaticUnitBall{T,C}(dim::Int) where {T,C} =
    (@assert dim == euclideandimension(T); StaticUnitBall{T,C}())
StaticUnitBall{T,C}(::Val{N}) where {N,T,C} =
    (@assert N == euclideandimension(T); StaticUnitBall{T,C}())


"The unit ball in a fixed N-dimensional space."
const EuclideanUnitBall{N,T,C} = StaticUnitBall{SVector{N,T},C}

EuclideanUnitBall{N}() where {N} = EuclideanUnitBall{N,Float64}()

similardomain(d::StaticUnitBall{S,C}, ::Type{T}) where {S,C,T<:StaticTypes} =
    StaticUnitBall{T,C}()
similardomain(d::StaticUnitBall{S,C}, ::Type{T}) where {S,C,T} =
    DynamicUnitBall{T,C}(dimension(d))

"""
    UnitDisk()
    UnitDisk{T=Float64}()

The closed unit disk in 2D, with element type `SVector{2,T}`.
"""
const UnitDisk{T} = UnitBall{SVector{2,T},:closed}
UnitDisk() = UnitDisk{Float64}()

canonicaldomain(::Parameterization, d::UnitDisk{T}) where {T} = UnitSquare{T}()
mapfrom_canonical(::Parameterization, d::UnitDisk{T}) where {T} = UnitDiskMap{T}()

const Disk{T} = Ball{SVector{2,T},:closed}
Disk() = Disk{Float64}()
Disk(radius::Number) = Disk(float(radius))
Disk(radius::AbstractFloat) = Disk{typeof(radius)}(radius)
Disk(radius,center) = Disk{float(promote_type(typeof(radius),eltype(center)))}(radius, center)

## A StaticUnitBall{<:Number} equals the interval [-1,1]  (open or closed)
convert(::Type{Interval}, d::StaticUnitBall{T,:closed}) where {T <: Number} =
    ChebyshevInterval{T}()
convert(::Type{Interval}, d::StaticUnitBall{T,:open}) where {T <: Number} =
    OpenInterval{T}(-1, 1)

canonicaldomain(::Equal, d::StaticUnitBall{T}) where {T<:Number} = convert(Interval, d)


"""
    DynamicUnitBall(dim::Int)
    DynamicUnitBall{T}(dim::Int)
    DynamicUnitBall{T,C=:closed}(dim::Int)

The open or closed unit ball with variable dimension. Typically the element
type is a `Vector{T}` and `dim` specifies the length of the vectors.
"""
struct DynamicUnitBall{T,C} <: UnitBall{T,C}
    dimension   ::  Int

    DynamicUnitBall{T,C}(dim::Int) where {T,C} = new(dim)
    DynamicUnitBall{T,C}(dim::Int) where {T<:StaticTypes,C} =
        (@assert dim == euclideandimension(T); new(dim))
end

DynamicUnitBall(dim::Int) = DynamicUnitBall{Vector{Float64}}(dim)
DynamicUnitBall{T}(dim::Int) where {T} = DynamicUnitBall{T,:closed}(dim)

dimension(d::DynamicUnitBall) = d.dimension

center(d::DynamicUnitBall{T}) where {T} = zeros(eltype(T), dimension(d))

"The unit ball with vector elements of a given dimension."
const VectorUnitBall{T,C} = DynamicUnitBall{Vector{T},C}

VectorUnitBall(dim::Int = 3) = VectorUnitBall{Float64}(dim)
VectorUnitDisk() = VectorUnitBall(2)

similardomain(d::DynamicUnitBall{S,C}, ::Type{T}) where {S,C,T} =
    DynamicUnitBall{T,C}(dimension(d))
similardomain(d::DynamicUnitBall{S,C}, ::Type{T}) where {S,C,T<:StaticTypes} =
    StaticUnitBall{T,C}()

canonicaldomain(::Parameterization, d::VectorUnitBall{T}) where {T} =
    dimension(d) == 2 ? UnitSquare{T}() : d
mapfrom_canonical(::Parameterization, d::VectorUnitBall{T}) where {T} =
    dimension(d) == 2 ? UnitDiskMap{T}() : identitymap(d)


"A `GenericBall` is a ball with a given radius and center."
struct GenericBall{T,C,S} <: Ball{T,C}
    radius  ::  S
    center  ::  T
end

GenericBall() = GenericBall(1.0)
GenericBall(radius::S) where {S<:Number} = GenericBall(radius, zero(SVector{3,float(S)}))
GenericBall(radius::S, center::T) where {S<:Number,U,T<:Vector{U}} =
    GenericBall{Vector{promote_type(S,U)}}(radius, center)
GenericBall(radius::S, center::T) where {S<:Number,N,U,T<:SVector{N,U}} =
    GenericBall{SVector{N,promote_type(S,U)}}(radius, center)
GenericBall(radius::S, center::T) where {S<:Number,T<:AbstractVector} =
    GenericBall{Vector{promote_type(S,eltype(T))}}(radius, center)
GenericBall(radius::S, center::T) where {S<:Number,T<:Number} =
    GenericBall{promote_type(S,T)}(radius, center)
GenericBall{T}(radius) where {T} = GenericBall{T,:closed}(radius)
GenericBall{T}(radius, center) where {T} = GenericBall{T,:closed}(radius, center)
GenericBall{T,C}(radius) where {T,C} = GenericBall{T,C}(radius, zero(T))
GenericBall{T,C}(radius, center) where {T,C} = GenericBall{T,C,eltype(T)}(radius, center)

GenericBall(radius::S, center::Point) where {S<:Number} =
    GenericBall(radius, pointval(center))
GenericBall{T,C}(radius, center::Point) where {T,C} =
    GenericBall{T,C}(radius, pointval(center))

radius(d::GenericBall) = d.radius
center(d::GenericBall) = d.center

similardomain(d::GenericBall{S,C}, ::Type{T}) where {S,T,C} =
    GenericBall{T,C}(d.radius, d.center)

dimension(d::GenericBall) = length(d.center)

canonicaldomain(d::GenericBall{T,C}) where {T,C} = UnitBall{T,C}(dimension(d))
mapfrom_canonical(d::GenericBall) = AffineMap(radius(d), center(d))

boundingbox(d::GenericBall) =
    map_boundingbox(boundingbox(canonicaldomain(d)), mapfrom_canonical(d))

# Preserve the `Ball` type under affine maps which preserve shape
map_domain(m::GenericAffineMap{T,S}, d::Ball{U,C}) where {T<:AbstractVector,S<:Number,U<:AbstractVector,C} =
    Ball{U,C}(m.A * radius(d), m.A * center(d) + m.b)
map_domain(m::AffineMap{T}, d::Ball{U,C}) where {T<:Number,U<:Number,C} =
    Ball{promote_type(U,T),C}(m.A * radius(d), m.A * center(d) + m.b)
map_domain(m::GenericLinearMap{T,S}, d::Ball{U,C}) where {S<:Number,T<:AbstractVector,U<:AbstractVector,C} =
    Ball{promote_type(T,U),C}(m.A * radius(d), m.A * center(d))
map_domain(m::LinearMap{T}, d::Ball{U,C}) where {T<:Number,U<:Number,C} =
    Ball{promote_type(T,U),C}(m.A * radius(d), m.A * center(d))
map_domain(m::LinearMap{T}, d::Ball{U,C}) where {T<:Number,U,C} =
    Ball{U,C}(m.A * radius(d), m.A * center(d))
map_domain(m::Translation{T}, d::Ball{S,C}) where {T<:AbstractVector,S<:AbstractVector,C} =
    Ball{S,C}(radius(d), center(d) + m.b)
map_domain(m::Translation{T}, d::Ball{S,C}) where {T<:Number,S<:Number,C} =
    Ball{S,C}(radius(d), center(d) + m.b)


show(io::IO, d::EuclideanUnitBall{3,Float64,:closed}) = print(io, "UnitBall()")
show(io::IO, d::EuclideanUnitBall{N,Float64,:closed}) where {N} = print(io, "UnitBall(Val($(N)))")
show(io::IO, d::EuclideanUnitBall{3,Float64,:open}) = print(io, "UnitBall()  (open)")
show(io::IO, d::EuclideanUnitBall{N,Float64,:open}) where {N} = print(io, "UnitBall(Val($(N)))  (open)")
Display.object_parentheses(d::EuclideanUnitBall{N,Float64,:open}) where {N} = true
show(io::IO, d::EuclideanUnitBall{2,Float64,:closed}) = print(io, "UnitDisk()")
show(io::IO, d::UnitDisk{T}) where {T} = print(io, "UnitDisk{$(T)}()")
show(io::IO, d::UnitBall{T}) where {T<:Number} = print(io, "UnitBall{$(T)}()")
show(io::IO, d::UnitBall{T,:open}) where {T<:Number} = print(io, "UnitBall{$(T)}()  (open)")
Display.object_parentheses(d::UnitBall{T,:open}) where {T<:Number} = true
show(io::IO, d::VectorUnitBall{Float64,:closed}) = print(io, "UnitBall($(dimension(d)))")
show(io::IO, d::VectorUnitBall{Float64,:open}) = print(io, "UnitBall($(dimension(d)))  (open)")
show(io::IO, d::Ball) = print(io, "Ball($(radius(d)), $(center(d)))")


# The type hierarchy of spheres parallels that of Ball above:
# abstract Sphere
# |-> abstract UnitSphere: radius is 1
#     |-> StaticUnitSphere: dimension is part of type
#     |-> DynamicUnitSphere: dimension is specified by int field
# |-> GenericSphere: stores center and radius. Here, the dimension can be
#     obtained from the center, so there is only one type.
# There are aliases for SVector{N,T} and Vector{T}.

"Supertype of spherical domains for which elements satisfy `norm(x) == radius(sphere)`."
abstract type Sphere{T} <: Domain{T} end

indomain(x, d::Sphere) = norm(x-center(d)) == radius(d)
approx_indomain(x, d::Sphere, tolerance) =
    radius(d)-tolerance <= norm(x-center(d)) <= radius(d)+tolerance

"""
    Sphere(radius = 1[, center])
    Sphere{T}(radius = 1[, center])

Return a concrete subtype of `Sphere` which represents a sphere with the given
radius and center, and the given eltype `T`.

The default center is the origin. In case both radius and center are omitted,
a subtype of `UnitSphere` is returned, whose concrete type depends on `T`.

A sphere represents the boundary of a ball. For the volume, see [`Ball()`](@ref).
"""
Sphere(; radius=One(), center=Origin()) = Sphere(radius, center)
Sphere(radius; center=Origin()) = Sphere(radius, center)
Sphere(::One, ::Origin) = UnitSphere()
Sphere(radius, center) = GenericSphere(radius, center)
Sphere(::One, center) = GenericSphere(1, center)
Sphere(radius, center::Origin) = GenericSphere(radius)

Sphere{T}(; radius = One(), center = Origin()) where T = Sphere{T}(radius, center)
Sphere{T}(radius; center=Origin()) where T = Sphere{T}(radius, center)
Sphere{T}(radius, center) where T = GenericSphere{T}(radius, center)
Sphere{T}(::One, ::Origin) where T = UnitSphere{T}()
Sphere{T}(radius::One, center) where T = GenericSphere{T}(1, center)
Sphere{T}(radius, center::Origin) where T = GenericSphere{T}(radius)

isempty(::Sphere) = false

isclosedset(::Sphere) = true
isopenset(::Sphere) = false

normal(d::Sphere, x) = (x-center(d))/norm(x-center(d))

distance_to(d::Sphere, x) = abs(norm(x-center(d))-radius(d))

choice(d::Sphere) = center(d) + unitvector(d, 1)

isequaldomain(d1::Sphere, d2::Sphere) =
    radius(d1)==radius(d2) && center(d1)==center(d2)
domainhash(d::Sphere, h::UInt) = hashrec("Sphere", radius(d), center(d), h)

"A hypersphere in a fixed N-dimensional Euclidean space."
const EuclideanSphere{N,T} = Sphere{SVector{N,T}}

"A sphere with vector elements of variable length."
const VectorSphere{T} = Sphere{Vector{T}}


"The unit sphere."
abstract type UnitSphere{T} <: Sphere{T} end

radius(::UnitSphere) = 1
center(d::UnitSphere{T}) where {T<:StaticTypes} = zero(T)

normal(d::UnitSphere, x) = x/norm(x)

indomain(x, d::UnitSphere) = norm(x) == 1
approx_indomain(x, d::UnitSphere, tolerance) =
    1-tolerance <= norm(x) <= 1+tolerance


"""
    UnitSphere([dim::Int])
    UnitSphere{T}([dim::Int])
    UnitSphere{T,C=:closed}([dim::Int])

The set of all points of type `T` with norm 1.
"""
UnitSphere(::Val{N} = Val(3)) where {N} = EuclideanUnitSphere{N}()
UnitSphere(dim::Int) = DynamicUnitSphere(dim)

UnitSphere{T}(dim::Int) where {T <: StaticTypes} = StaticUnitSphere{T}(dim)
UnitSphere{T}(::Val{N}) where {N,T} = StaticUnitSphere{T}(Val(N))
UnitSphere{T}() where {T <: StaticTypes} = StaticUnitSphere{T}()
UnitSphere{T}(dim::Int) where {T} = DynamicUnitSphere{T}(dim)

isequaldomain(d1::UnitSphere, d2::UnitSphere) = dimension(d1)==dimension(d2)

issubset1(d1::UnitSphere, d2::UnitBall) =
    dimension(d1) == dimension(d2) && isclosedset(d2)

convert(::Type{LevelSet}, d::UnitSphere{T}) where {T} = LevelSet{T}(norm, radius(d))
convert(::Type{LevelSet{T}}, d::UnitSphere) where {T} = LevelSet{T}(norm, radius(d))


"The unit sphere with fixed dimension(s) specified by the element type."
struct StaticUnitSphere{T} <: UnitSphere{T}
end

StaticUnitSphere() = StaticUnitSphere{Float64}()
StaticUnitSphere(::Val{N}) where {N} = StaticUnitSphere{SVector{N,Float64}}()

StaticUnitSphere{T}(dim::Int) where {T} =
    (@assert dim == euclideandimension(T); StaticUnitSphere{T}())
StaticUnitSphere{T}(::Val{N}) where {N,T} =
    (@assert N == euclideandimension(T); StaticUnitSphere{T}())

similardomain(d::StaticUnitSphere, ::Type{T}) where {T<:StaticTypes} =
    StaticUnitSphere{T}()
similardomain(d::StaticUnitSphere, ::Type{T}) where {T} =
    DynamicUnitSphere{T}(dimension(d))


"The unit sphere in a fixed N-dimensional Euclidean space."
const EuclideanUnitSphere{N,T} = StaticUnitSphere{SVector{N,T}}

EuclideanUnitSphere{N}() where {N} = EuclideanUnitSphere{N,Float64}()


"""
    UnitCircle()
    UnitCircle{T=Float64}()

The unit circle in 2D, with element type `SVector{2,T}`.
"""
const UnitCircle{T} = UnitSphere{SVector{2,T}}
UnitCircle() = UnitCircle{Float64}()

canonicaldomain(::Parameterization, d::UnitCircle{T}) where {T} = UnitInterval{T}()
mapfrom_canonical(::Parameterization, d::UnitCircle{T}) where {T} = UnitCircleMap{T}()


"The unit sphere with variable dimension."
struct DynamicUnitSphere{T} <: UnitSphere{T}
    dimension   ::  Int

    DynamicUnitSphere{T}(dim::Int) where {T} = new(dim)
    DynamicUnitSphere{T}(dim::Int) where {T<:StaticTypes} =
        (@assert dim == euclideandimension(T); new(dim))
end

DynamicUnitSphere(dim::Int) = DynamicUnitSphere{Vector{Float64}}(dim)

dimension(d::DynamicUnitSphere) = d.dimension

center(d::DynamicUnitSphere{T}) where {T} = zeros(eltype(T), dimension(d))

"The unit sphere with vector elements of a given dimension."
const VectorUnitSphere{T} = DynamicUnitSphere{Vector{T}}

VectorUnitSphere(dim::Int = 3) = VectorUnitSphere{Float64}(dim)
VectorUnitCircle() = VectorUnitSphere(2)

similardomain(d::DynamicUnitSphere, ::Type{T}) where {T} =
    DynamicUnitSphere{T}(d.dimension)
similardomain(d::DynamicUnitSphere, ::Type{T}) where {T <: StaticTypes} =
    StaticUnitSphere{T}()

canonicaldomain(::Parameterization, d::VectorUnitSphere{T}) where {T} =
    dimension(d) == 2 ? UnitInterval{T}() : d
mapfrom_canonical(::Parameterization, d::VectorUnitSphere{T}) where {T} =
    dimension(d) == 2 ? UnitCircleMap{T}() : identitymap(d)


"A `GenericSphere` is a sphere with a given radius and center."
struct GenericSphere{T,S} <: Sphere{T}
    radius  ::  S
    center  ::  T
end

GenericSphere() = GenericSphere(1.0)
GenericSphere(radius::S) where {S<:Number} =
    GenericSphere(radius, zero(SVector{3,float(S)}))
GenericSphere(radius::S, center::T) where {S<:Number,U,T<:Vector{U}} =
    GenericSphere{Vector{promote_type(S,U)}}(radius, center)
GenericSphere(radius::S, center::T) where {S<:Number,N,U,T<:SVector{N,U}} =
    GenericSphere{SVector{N,promote_type(S,U)}}(radius, center)
GenericSphere(radius::S, center::T) where {S<:Number,T<:AbstractVector} =
    GenericSphere{Vector{promote_type(S,eltype(T))}}(radius, center)
GenericSphere{T}(radius) where {T} = GenericSphere{T}(radius, zero(T))
GenericSphere{T}(radius, center) where {T} =
    GenericSphere{T,eltype(T)}(radius, center)

GenericSphere(radius::S, center::Point) where {S<:Number} =
    GenericSphere(radius, pointval(center))
GenericSphere{T}(radius, center::Point) where {T} =
    GenericSphere{T}(radius, pointval(center))

radius(d::GenericSphere) = d.radius
center(d::GenericSphere) = d.center

dimension(d::GenericSphere) = length(d.center)

canonicaldomain(d::GenericSphere{T}) where {T} = UnitSphere{T}(dimension(d))
mapfrom_canonical(d::GenericSphere) = AffineMap(radius(d), center(d))

boundingbox(d::GenericSphere) =
    map_boundingbox(boundingbox(canonicaldomain(d)), mapfrom_canonical(d))

# Preserve the `Sphere` type under affine maps which preserve shape
map_domain(m::GenericAffineMap{T,S}, d::Sphere{U}) where {T<:AbstractVector,S<:Number,U<:AbstractVector} =
    Sphere{U}(m.A * radius(d), m.A * center(d) + m.b)
map_domain(m::AffineMap{T}, d::Sphere{U}) where {T<:Number,U<:Number} =
    Sphere{promote_type(U,T)}(m.A * radius(d), m.A * center(d) + m.b)
map_domain(m::GenericLinearMap{T,S}, d::Sphere{U}) where {S<:Number,T<:AbstractVector,U<:AbstractVector} =
    Sphere{promote_type(T,U)}(m.A * radius(d), m.A * center(d))
map_domain(m::LinearMap{T}, d::Sphere{U}) where {T<:Number,U<:Number} =
    Sphere{promote_type(T,U)}(m.A * radius(d), m.A * center(d))
map_domain(m::LinearMap{T}, d::Sphere{U}) where {T<:Number,U} =
    Sphere{U}(m.A * radius(d), m.A * center(d))
map_domain(m::Translation{T}, d::Sphere{S}) where {T<:AbstractVector,S<:AbstractVector} =
    Sphere{S}(radius(d), center(d) + m.b)
map_domain(m::Translation{T}, d::Sphere{S}) where {T<:Number,S<:Number} =
    Sphere{S}(radius(d), center(d) + m.b)

show(io::IO, d::EuclideanUnitSphere{3,Float64}) = print(io, "UnitSphere()")
show(io::IO, d::EuclideanUnitSphere{N,Float64}) where {N} = print(io, "UnitSphere(Val($(N)))")
show(io::IO, d::EuclideanUnitSphere{2,Float64}) = print(io, "UnitCircle()")
show(io::IO, d::UnitCircle{T}) where {T} = print(io, "UnitCircle{$(T)}()")
show(io::IO, d::VectorUnitSphere{Float64}) = print(io, "UnitSphere($(dimension(d)))")
show(io::IO, d::UnitSphere{T}) where {T<:Number} = print(io, "UnitSphere{$(T)}()")
show(io::IO, d::Sphere) = print(io, "Sphere($(radius(d)), $(center(d)))")


boundary(d::UnitBall{T}) where {T} = UnitSphere{T}(dimension(d))
boundary(d::Ball{T}) where {T} = Sphere{T}(radius(d), center(d))

interior(d::StaticUnitBall{T}) where {T} = StaticUnitBall{T,:open}()
interior(d::DynamicUnitBall{T}) where {T} = DynamicUnitBall{T,:open}(dimension(d))
interior(d::Ball{T}) where {T} = Ball{T,:open}(radius(d), center(d))

closure(d::StaticUnitBall{T}) where {T} = StaticUnitBall{T,:closed}()
closure(d::DynamicUnitBall{T}) where {T} = DynamicUnitBall{T,:closed}(dimension(d))
closure(d::Ball{T}) where {T} = Ball{T,:closed}(radius(d), center(d))

boundingbox(d::UnitBall{T}) where {T<:Number} = ChebyshevInterval{T}()
boundingbox(d::UnitBall{<:StaticVector{N,T}}) where {N,T} =
    ChebyshevProductDomain{N,T}()
boundingbox(d::UnitBall{T}) where {T} =
    Rectangle{T}(-ones(eltype(T), dimension(d)), ones(eltype(T), dimension(d)))

boundingbox(d::UnitSphere{T}) where {T<:Number} = ChebyshevInterval{T}()
boundingbox(d::UnitSphere{<:StaticVector{N,T}}) where {N,T} =
    ChebyshevProductDomain{N,T}()
boundingbox(d::UnitSphere{T}) where {T} =
    Rectangle{T}(-ones(eltype(T), dimension(d)), ones(eltype(T), dimension(d)))



################
# Applications
################

"Create a cylinder with given radius and length."
cylinder(::Type{T} = Float64) where {T} = cartesianproduct(UnitDisk{T}(), UnitInterval{T}())
cylinder(radius, length) = cylinder(promote(radius, length)...)
cylinder(radius::T, length::T) where {T} = cartesianproduct(radius .* UnitDisk{T}(), 0..length)

"Create an ellipse curve with semi-axes lengths `a` and `b` respectively."
ellipse(a::Number, b::Number) = ellipse(promote(a,b)...)
ellipse(a::T, b::T) where {T <: Number} = LinearMap(a, b).(UnitCircle{T}())

"Create an ellipse-shaped domain with semi-axes lengths `a` and `b` respectively."
ellipse_shape(a::Number, b::Number) = ellipse_shape(promote(a,b)...)
ellipse_shape(a::T, b::T) where {T <: Number} = LinearMap(a, b).(UnitDisk{T}())

using DomainSets: unionbox, intersectbox

function test_product_domains()
    @test productdomain() == ()
    @test productdomain(2) == 2

    @testset "VcatDomain" begin
        d1 = VcatDomain(-1.0..1.0, -1.0..1.0)
        @test d1 isa DomainSets.VcatDomain
        @test d1.domains isa Tuple
        @test eltype(d1) == SVector{2,typeof(1.0)}
        @test SA[0.5,0.5] ∈ d1
        @test SA[-1.1,0.3] ∉ d1
        @test @inferred(VcatDomain(-1.0..1, -1.0..1)) === d1
        # Test promotion
        @test convert(Domain{SVector{2,BigFloat}}, d1) isa ProductDomain{SVector{2,BigFloat}}
        d1w = convert(Domain{SVector{2,BigFloat}}, d1)
        @test eltype(d1w) == SVector{2,BigFloat}
        @test eltype(component(d1w, 1)) == BigFloat
        @test eltype(component(d1w, 2)) == BigFloat

        @test VcatDomain( (-1..1, -2..2)) isa VcatDomain{2,Int,(1,1),Tuple{ClosedInterval{Int64}, ClosedInterval{Int64}}}

        show(io,d1)
        @test String(take!(io)) == "($(-1.0..1.0)) × ($(-1.0..1.0))"

        bnd = boundary(d1)
        @test bnd isa EuclideanDomain
        @test bnd isa UnionDomain
        @test [-1.0, 0.5] ∈ bnd
        @test [1.0, 0.5] ∈ bnd
        @test [0.5, -1.0] ∈ bnd
        @test [0.5, 1.0] ∈ bnd
        @test [0.5, 0.2] ∉ bnd

        # A single domain
        @test VcatDomain(UnitCircle()) isa VcatDomain{2}

        # Test vectors of wrong length
        @test_logs (:warn, "`in`: incompatible combination of vector with length 3 and domain '($(-1.0..1.0)) × ($(-1.0..1.0))' with dimension 2. Returning false.") SA[0.0,0.0,0.0] ∉ d1
        @test_logs (:warn, "`in`: incompatible combination of vector with length 1 and domain '($(-1.0..1.0)) × ($(-1.0..1.0))' with dimension 2. Returning false.") SA[0.0] ∉ d1
        @test_logs (:warn, "`in`: incompatible combination of vector with length 3 and domain '($(-1.0..1.0)) × ($(-1.0..1.0))' with dimension 2. Returning false.") [0.0,0.0,0.0] ∉ d1
        @test_logs (:warn, "`in`: incompatible combination of vector with length 1 and domain '($(-1.0..1.0)) × ($(-1.0..1.0))' with dimension 2. Returning false.") [0.0] ∉ d1

        d2 = VcatDomain(-1.0 .. 1.0, -1.5 .. 2.5)
        @test SA[0.5,0.5] ∈ d2
        @test SA[-1.1,0.3] ∉ d2

        d3 = VcatDomain(1.05 * UnitDisk(), -1.0 .. 1.0)
        @inferred(cartesianproduct(1.05 * UnitDisk(), -1.0 .. 1.0)) === d3
        @test d3 isa VcatDomain
        @test eltype(d3) == SVector{3,Float64}
        @test SA[0.5,0.5,0.8] ∈ d3
        @test SA[-1.1,0.3,0.1] ∉ d3
        @test choice(d3) ∈ d3

        v = SA[0.1,0.2,0.3]
        @test map_domain(Translation(v), productdomain(UnitDisk(), UnitInterval())) isa VcatDomain
    end
    @testset "mixed intervals" begin
        d = cartesianproduct(0..1, 0.0..1)
        @test SA[0.1,0.2] ∈ d
        @test SA[0.1,1.2] ∉ d
        @test SA[1.1,1.3] ∉ d
        @test d isa EuclideanDomain{2}
        # Make sure promotion of domains happened
        @test eltype(component(d,1)) == Float64
        @test eltype(component(d,2)) == Float64
        @test choice(d) ∈ d
    end
    @testset "vector domains" begin
        d1 = VectorProductDomain([0..1.0, 0..2.0])
        @test d1 isa VectorDomain{Float64}
        @test d1.domains isa Vector
        @test dimension(d1) == 2
        @test [0.1,0.2] ∈ d1
        @test SA[0.1,0.2] ∈ d1
        @test choice(d1) ∈ d1
        @test convert(Domain{Vector{BigFloat}}, d1) == d1
        d1big = convert(Domain{Vector{BigFloat}}, d1)
        @test eltype(d1big) == Vector{BigFloat}

        # Test an integer type as well
        d2 = VectorProductDomain([0..1, 0..3])
        @test dimension(d2) == 2
        @test [0.1,0.2] ∈ d2
        @test choice(d2) ∈ d2

        # other constructor calls
        @test VectorProductDomain(0..1, 1..2) isa VectorProductDomain{Vector{Int}}
        @test VectorProductDomain((0..1, 1..2)) isa VectorProductDomain{Vector{Int}}
        @test VectorProductDomain{Vector{Int}}(0..1, 1..2) isa VectorProductDomain{Vector{Int}}
        @test VectorProductDomain{Vector{Int}}((0..1, 1..2)) isa VectorProductDomain{Vector{Int}}

        bnd = boundary(d1)
        @test bnd isa VectorDomain
        @test bnd isa UnionDomain
        @test dimension(bnd) == 2
        @test [0.0, 0.5] ∈ bnd
        @test [1.0, 0.5] ∈ bnd
        @test [0.2, 0.0] ∈ bnd
        @test [0.2, 2.0] ∈ bnd
        @test [0.2, 0.5] ∉ bnd

        d3 = VectorProductDomain([0..i for i in 1:10])
        @test d3 isa VectorProductDomain
        @test eltype(d3) == Vector{Int}
        @test rand(10) ∈ d3
        @test 2 .+ rand(10) ∉ d3
        d4 = VectorProductDomain{Vector{Float64}}([0..i for i in 1:10])
        @test d4 isa VectorProductDomain
        @test eltype(d4) == Vector{Float64}
        @test rand(10) ∈ d4
        @test 2 .+ rand(10) ∉ d4

        @test eltype(VectorProductDomain{SVector{2,Float64}}(SVector(0..1, 0..2)).domains[1]) == Float64
    end
    @testset "Tuple product domain" begin
        # Use the constructor ProductDomain{T} directly
        d1 = TupleProductDomain{Tuple{Float64,Float64}}(0..0.5, 0..0.7)
        @test d1 isa TupleProductDomain{Tuple{Float64,Float64}}
        @test d1.domains isa Tuple
        @test eltype(d1) == Tuple{Float64,Float64}
        @test dimension(d1) == 2
        @test (0.2,0.6) ∈ d1
        @test (0.2,0.8) ∉ d1
        @test (true,0.6) ∉ d1
        if VERSION < v"1.6-"
            @test_logs (:warn, "`in`: incompatible combination of point: SArray{Tuple{2},Float64,1,2} and domain eltype: Tuple{Float64,Float64}. Returning false.") SA[0.2,0.6] ∉ d1
            @test_logs (:warn, "`in`: incompatible combination of point: Array{Float64,1} and domain eltype: Tuple{Float64,Float64}. Returning false.") [0.2,0.6] ∉ d1
        else
            @test_logs (:warn, "`in`: incompatible combination of point: SVector{2, Float64} and domain eltype: Tuple{Float64, Float64}. Returning false.") SA[0.2,0.6] ∉ d1
            @test_logs (:warn, "`in`: incompatible combination of point: Vector{Float64} and domain eltype: Tuple{Float64, Float64}. Returning false.") [0.2,0.6] ∉ d1
        end
        @test convert(Domain{Tuple{BigFloat,BigFloat}}, d1) == d1
        d1big = convert(Domain{Tuple{BigFloat,BigFloat}}, d1)
        @test eltype(d1big) == Tuple{BigFloat,BigFloat}
        @test eltype(component(d1big,1)) == BigFloat
        @test eltype(component(d1big,2)) == BigFloat

        d2 = TupleProductDomain(['a','b'], 0..1)
        @test d2.domains isa Tuple
        @test dimension(d2) == 2
        @test eltype(d2) == Tuple{Char,Int}
        @test ('a',0.4) ∈ d2
        @test ('b',1.5) ∉ d2
        @test ('c',0.5) ∉ d2

        # other constructor calls
        @test TupleProductDomain(0..1, 1..2.0) isa TupleProductDomain{Tuple{Int,Float64}}
        @test TupleProductDomain([0..1, 1..2.0]) isa TupleProductDomain{Tuple{Float64,Float64}}
        @test TupleProductDomain{Tuple{Int,Float64}}(0..1, 1..2.0) isa TupleProductDomain{Tuple{Int,Float64}}
        @test TupleProductDomain{Tuple{Float64,Float64}}(0..1, 1..2.0) isa TupleProductDomain{Tuple{Float64,Float64}}
        @test TupleProductDomain{Tuple{Float64,Float64}}([0..1, 1..2.0]) isa TupleProductDomain{Tuple{Float64,Float64}}

        bnd = boundary(d1)
        @test eltype(bnd) == Tuple{Float64,Float64}
        @test bnd isa UnionDomain
        @test dimension(bnd) == 2
        @test (0.0, 0.5) ∈ bnd
        @test (0.5, 0.5) ∈ bnd
        @test (0.3, 0.2) ∉ bnd
        @test (0.3, 0.0) ∈ bnd
        @test (0.3, 0.7) ∈ bnd
    end
    @testset "cube" begin
        @test volume(UnitCube()) == 1
        @test EuclideanUnitCube{2}() == EuclideanUnitCube{2,Float64}()
        @test UnitSquare() == UnitSquare{Float64}()
        @test UnitCube(Val(2)) isa EuclideanUnitCube{2,Float64}
        @test UnitCube{SVector{2,BigFloat}}(Val(2)) isa EuclideanUnitCube{2,BigFloat}

        @test Set(corners((0..1)^2)) == Set([ [1,0], [0,1], [1,1], [0,0]])
        @test Set(corners(UnitCube())) == Set([ [0,0,0], [1,0,0], [0,1,0], [0,0,1], [1,1,0], [1,0,1], [0,1,1], [1,1,1]])
        @test boundary(boundary(UnitSquare())) == UnionDomain(map(t->Point(SVector{2}(t)), corners(UnitSquare())))
        @test boundary(boundary(boundary(UnitCube()))) == UnionDomain(map(t->Point(SVector{3}(t)), corners(UnitCube())))
        @test UnitCube() == UnitCube(3)
        @test boundary(UnitCube()) == boundary(UnitCube(3))
        @test boundary(boundary(UnitCube())) == boundary(boundary(UnitCube(3)))
        @test boundary(boundary(boundary(UnitCube()))) == boundary(boundary(boundary(UnitCube(3))))
        @test UnitSquare() == UnitCube(2)
        @test boundary(UnitSquare()) == boundary(UnitCube(2))
        @test boundary(boundary(UnitSquare())) == boundary(boundary(UnitCube(2)))

        @test StaticUnitCube() == UnitCube()
        @test StaticUnitCube(Val(3)) == UnitCube()
        @test convert(Domain{SVector{2,Float64}}, UnitCube()) == StaticUnitCube(Val(2))
        @test convert(Domain{Vector{Float64}}, UnitCube()) === VectorUnitCube(3)

        @test DynamicUnitCube{SVector{3,Float64}}(3) isa DynamicUnitCube
        @test_throws AssertionError DynamicUnitCube{SVector{3,Float64}}(2)

        d1 = VectorUnitCube{Float64}(4)
        @test VectorUnitCube(4) == d1
        @test UnitCube(4) == d1
        @test UnitCube{Vector{Float64}}(4) == d1
        @test dimension(d1) == 4
        @test component(d1, 1) == 0..1
        @test SA[0.9,0.9,0.4,0.2] ∈ d1
        @test [1.2,0.3,0.4,0.6] ∉ d1
        @test convert(Domain{SVector{4,Float64}}, d1) isa StaticUnitCube
        @test convert(Domain{Vector{BigFloat}}, d1) === VectorUnitCube{BigFloat}(4)
        @test DomainSets.VectorUnitSquare() === UnitCube(2)

        @test ProductDomain([UnitInterval(),UnitInterval()]) isa VectorUnitCube{Float64}
        @test ProductDomain{Vector{Float64}}([UnitInterval(),UnitInterval()]) isa VectorUnitCube{Float64}
        @test ProductDomain{Vector{BigFloat}}([UnitInterval(),UnitInterval()]) isa VectorUnitCube{BigFloat}
        @test ProductDomain{SVector{2,BigFloat}}(UnitInterval(),UnitInterval()) isa EuclideanUnitCube{2,BigFloat}
        @test ProductDomain{SVector{2,BigFloat}}((UnitInterval(),UnitInterval())) isa EuclideanUnitCube{2,BigFloat}
        @test ProductDomain{SVector{2,BigFloat}}(SVector(UnitInterval(),UnitInterval())) isa EuclideanUnitCube{2,BigFloat}

        @test repr(UnitCube()) == "UnitCube()"
        @test repr(UnitCube(Val(4))) == "UnitCube(Val(4))"
        @test repr(UnitSquare()) == "UnitSquare()"
        @test repr(UnitSquare{BigFloat}()) == "UnitSquare{BigFloat}()"
        @test repr(UnitCube(4)) == "UnitCube(4)"

        D = UnitInterval()^2
        @test D isa EuclideanUnitCube{2,Float64}
        @test SA[0.9, 0.9] ∈ D
        @test SA[1.1, 1.1] ∉ D
        @test !isempty(D)
        @test isclosedset(D)
        @test !isopenset(D)
        @test convert(DomainSets.HyperRectangle, VcatDomain(UnitInterval(), UnitInterval())) isa StaticUnitCube

        @test approx_in(SA[-0.1,-0.1], D, 0.1)
        @test !approx_in(SA[-0.1,-0.1], D, 0.09)

        @test intersect(ChebyshevInterval()^3, UnitInterval()^3) isa EuclideanUnitCube{3,Float64}

        #Cube
        D = cartesianproduct(-1.5 .. 2.2, 0.5 .. 0.7, -3.0 .. -1.0)
        @test SA[0.9, 0.6, -2.5] ∈ D
        @test SA[0.0, 0.6, 0.0] ∉ D

        @test issubset( (0..1)^3, (-1..2)^3 )
    end
    @testset "Rectangle" begin
        d1 = cartesianproduct(-1.0..1.0, -1.0..1.0)

        d4 = cartesianproduct(d1, -1.0..1.0)
        @test d4 isa Rectangle
        @test SA[0.5,0.5,0.8] ∈ d4
        @test SA[-1.1,0.3,0.1] ∉ d4
        @test choice(d4) ∈ d4
        @test center(d4) == [0.0,0.0,0.0]

        @test d1[Component(1)] == -1..1
        @test d1[Component(2)] == -1..1
        @test_throws BoundsError d1[Component(3)]

        d5 = cartesianproduct(-1.0..1., d1)
        @test d5 isa Rectangle
        @test SA[0.,0.5,0.5] ∈ d5
        @test SA[0.,-1.1,0.3] ∉ d5
        @test choice(d5) ∈ d5

        d6 = cartesianproduct(d1, d1)
        @test d6 isa Rectangle
        @test SA[0.,0.,0.5,0.5] ∈ d6
        @test SA[0.,0.,-1.1,0.3] ∉ d6
        @test choice(d6) ∈ d6

        @test Rectangle( SA[1,2], SA[2.0,3.0]) isa Rectangle{SVector{2,Float64}}
        @test Rectangle( Point(SA[1,2]), Point(SA[2.0,3.0])) isa Rectangle{SVector{2,Float64}}
        @test Rectangle([0..1, 2..3]) isa Rectangle{Vector{Int}}
        @test Rectangle((0..1, 2..3)) isa Rectangle{SVector{2,Int}}
        @test Rectangle{SVector{2,Float64}}((0..1, 2..3)) isa Rectangle{SVector{2,Float64}}

        @test_throws ArgumentError Rectangle(UnitCircle(), UnitDisk())
        @test_throws ArgumentError Rectangle(OpenInterval(1,2), 3..4)
        @test_throws ArgumentError Rectangle{SVector{2,Float64}}(UnitCircle(), UnitDisk())
        @test_throws ArgumentError Rectangle(0.0, 1.0)

        bnd = boundary(Rectangle([1,2],[3,4]))
        @test [1,3] ∈ bnd
        @test [1,2.5] ∈ bnd
        @test [1.5,4] ∈ bnd
        @test [1.5,3.5] ∉ bnd

        @test 2 .* UnitCube() isa Rectangle{SVector{3,Float64}}
        @test 2 .* UnitCube() .+ SA[1,2,3.0] isa Rectangle{SVector{3,Float64}}
        @test 2 .* UnitCube() .+ SA[1,2,3.0] == ProductDomain(1..3, 2..4, 3..5)
    end
    @testset "fixed product domains" begin
        d1 = ProductDomain(ChebyshevInterval(), ChebyshevInterval())
        @test d1 isa DomainSets.FixedIntervalProduct
        @test d1 isa DomainSets.ChebyshevProductDomain
        @test volume(d1) == 4
        @test component(d1,1) isa ChebyshevInterval{Float64}
        @test components(d1) isa NTuple{2,ChebyshevInterval{Float64}}
        @test convert(Domain{SVector{2,BigFloat}}, d1) isa DomainSets.ChebyshevProductDomain{2,BigFloat}
        @test d1 == DomainSets.ChebyshevProductDomain(Val(2))
        @test d1 == DomainSets.ChebyshevProductDomain{2}()
        @test ProductDomain(components(d1)) == d1
        @test ProductDomain{SVector{2,BigFloat}}(components(d1)) isa DomainSets.ChebyshevProductDomain{2,BigFloat}
        @test ProductDomain{SVector{2,BigFloat}}(components(d1)...) isa DomainSets.ChebyshevProductDomain{2,BigFloat}
    end
    @testset "ProductDomain" begin
        d1 = 0..1.0
        d2 = UnitBall{Float64}()
        d3 = UnitCircle()
        @test ProductDomain{SVector{2,Float64}}(d1, d2) isa VcatDomain
        @test ProductDomain{Tuple{Float64,Float64}}(d1, d2) isa TupleProductDomain
        @test ProductDomain{Vector{Float64}}([d1; d2]) isa VectorProductDomain

        @test ProductDomain((d1,d3)) isa VcatDomain
        @test ProductDomain((d1,d1)) isa Rectangle

        @test volume(ProductDomain(0..1,1..3)) == 2

        @test ProductDomain(SVector(0..1, 0..2)) isa Rectangle{SVector{2,Int}}
        @test ProductDomain(1.05 * UnitDisk(), -1.0 .. 1.0) isa VcatDomain{3,Float64}
        @test ProductDomain(['a','b'], 0..1) isa TupleProductDomain

        @test ProductDomain{Tuple{Float64,Float64}}(0..0.5, 0..0.7) isa Rectangle{Tuple{Float64,Float64}}
        # Some conversions
        @test convert(Domain{Vector{Float64}}, productdomain(d1,d2)) isa VectorProductDomain{Vector{Float64}}
        @test convert(Domain{SVector{2,Float64}}, ProductDomain([d1,d2])) isa VcatDomain{2,Float64}
        @test convert(Domain{Vector{Float64}}, TupleProductDomain(d1,d2)) isa VectorDomain{Float64}

        # intersection of product domains
        @test ProductDomain([0..1.0, 0..2.0]) ∩ ProductDomain([0..1, 0..3]) isa Rectangle{Vector{Float64}}
        @test ProductDomain(0..1.0, 0..2.0) ∩ ProductDomain(0..1, 0..3) isa Rectangle{SVector{2,Float64}}

        # Generic functionality
        long_domain = ProductDomain([0..i for i in 1:20])
        show(io, long_domain)
        @test String(take!(io)) == "($(0..1)) × ($(0..2)) × ($(0..3)) × ... × ($(0..20))"
        @test isopenset(interior(UnitCube()))
        @test isclosedset(closure(interior(UnitCube())))

        @test ProductDomain(SVector(0..1.0, Point(0.5))) isa VcatDomain
    end
    @testset "bounding box" begin
        @test boundingbox([0.2, -0.4, 1.0]) == -0.4..1.0
        @test boundingbox(Set([0.2, -0.4, 1.0])) == -0.4..1.0


        @test unionbox(0..1) == 0..1
        @test unionbox(0..1, 2..3) == 0..3
        @test unionbox(0..1, 2..3, 5..6.0) === 0..6.0
        @test unionbox(ChebyshevInterval(), ChebyshevInterval()) === ChebyshevInterval()

        @test unionbox(EmptySpace{Float64}(), 2..3) === 2..3.0
        @test unionbox(2..3, EmptySpace{Float64}()) === 2..3.0
        @test unionbox(FullSpace{Int}(), 2..3.0) === FullSpace{Float64}()
        @test unionbox(2..3.0, FullSpace{Int}()) === FullSpace{Float64}()

        @test DomainSets.unionbox2(0..1, 0..1) == FullSpace()

        d1 = ProductDomain(0..1.0, 2..4.0)
        d2 = ProductDomain(0.5..1.5, 2.5..4.5)
        @test unionbox(d1, d2) == ProductDomain(0..1.5, 2..4.5)

        @test intersectbox(0..1) == 0..1
        @test intersectbox(0..1.5, 1..3) === 1.0..1.5
        @test intersectbox(0..1, 0.5..3, 0.0..4.0) === 0.5..1.0
        @test intersectbox(ChebyshevInterval(), ChebyshevInterval()) === ChebyshevInterval()

        @test intersectbox(EmptySpace{Int}(), 2..3.0) === EmptySpace{Float64}()
        @test intersectbox(2..3.0, EmptySpace{Int}()) === EmptySpace{Float64}()
        @test intersectbox(FullSpace{Float64}(), 2..3) === 2.0..3.0
        @test intersectbox(2..3, FullSpace{Float64}()) === 2.0..3.0

        @test DomainSets.intersectbox2(0..1, 0..1) == FullSpace()

        d1 = ProductDomain(0..1.0, 2..4.0)
        d2 = ProductDomain(0.5..1.5, 2.5..4.5)
        @test intersectbox(d1, d2) == ProductDomain(0.5..1.0, 2.5..4.0)

        @test boundingbox(MappedDomain(LinearMap(1/2), 2..3)) == 4.0..6.0
    end
    @testset "product mapto" begin
        d1 = ProductDomain(1.0..2.0, 1.0..2.0)
        d2 = ProductDomain(2.0..4.0, 2.0..4.0)
        @test mapto(d1, d2) isa DomainSets.VcatMap
        @test jacobian(mapto(d1,d2)) isa ConstantMap
        @test jacdet(mapto(d1,d2)) == DomainSets.ConstantMap{SVector{2,Float64}}(4.0)
        d1v = ProductDomain([1.0..2.0, 1.0..2.0])
        d2v = ProductDomain([2.0..4.0, 2.0..4.0])
        @test mapto(d1v, d2v) isa DomainSets.VectorProductMap
        @test jacobian(mapto(d1v,d2v)) isa DomainSets.ConstantMap
        @test jacdet(mapto(d1v,d2v)) == DomainSets.ConstantMap{Vector{Float64}}(4.0)
    end

    @testset "VcatDomain == bug" begin
        x = VcatDomain(0.0:0.5:2.0, [1,3,4])
        y = VcatDomain(0.0:0.5:2.0, [1,3,4])
        @test x == y
        @test isequaldomain(5, [5.0])
        @test isequaldomain(Set([5.0]), [5.0])
    end
end

"""
A lazy domain evaluates its membership function on the fly in terms of that of
other domains.

The `in(x, domain::LazyDomain)` applies three types of transformations:
1. Point mapping: `y = tointernalpoint(domain, x)`
2. Distribution of `y` over member domains given by `components(domain)`
3. Combination of the outputs into a single boolean result.

The distribution step is determined by the result of `composition(domain)`,
see `composition`. The combination is performed by `combine`. Mapping between
points of the lazy domain and points of its member domains is described by
`y = tointernalpoint(domain, x)` and `x = toexternalpoint(domain, y)`.
"""
abstract type LazyDomain{T} <: Domain{T} end

"Translate a point of the lazy domain to a point (or points) of the composing domain."
tointernalpoint(d::LazyDomain, x) = x
"Inverse of `tointernalpoint`."
toexternalpoint(d::LazyDomain{T}, y) where {T} = T(y)

Base.getindex(d::LazyDomain, I::ComponentIndex...) =
    component(d, map(Indexing.to_index, I)...)

"""
A simple lazy domain is defined in terms of a single domain.

It has no composition and no combination of its `in` function.
"""
abstract type SimpleLazyDomain{T} <: LazyDomain{T} end

superdomain(d::SimpleLazyDomain) = d.domain

components(d::SimpleLazyDomain) = (superdomain(d),)

indomain(x, d::SimpleLazyDomain) = in(tointernalpoint(d, x), superdomain(d))
approx_indomain(x, d::SimpleLazyDomain, tolerance) = approx_in(tointernalpoint(d, x), superdomain(d), tolerance)

"A composite lazy domain is defined in terms of multiple domains."
abstract type CompositeDomain{T} <: LazyDomain{T} end

components(d::CompositeDomain) = d.domains

# (daanhb) Note: upon revisiting this code, abstracting away the nature of
# the composition may have been a step too far - it makes the concrete composite
# domains harder to understand

"""
Supertype of all compositions of a lazy domain. The composition determines how
the point `x` is distributed to the member domains of a lazy domain.

Three compositions implemented in the package are:
- `NoComposedMap`: the lazy domain encapsulates a single domain and `x` is passed
	through unaltered
- `Combination`: the lazy domain has several members and `x` is passed to the `in`
	method of all members
- `Product`: the lazy domain has several members and the components of `x` are
	passed to the components of the lazy domain
"""
abstract type LazyComposedMap end

struct NoComposedMap <: LazyComposedMap end
struct Combination <: LazyComposedMap end
struct Product <: LazyComposedMap end

composition(d::CompositeDomain) = NoComposedMap()

indomain(x, d::CompositeDomain) =
	_composite_indomain(tointernalpoint(d, x), d, composition(d), components(d))
_composite_indomain(x, d, ::NoComposedMap, domains) = in(x, domains[1])
_composite_indomain(x, d, ::Combination, domains) = combine(d, map(d->in(x, d), domains))
_composite_indomain(x, d, ::Product, domains) = mapreduce(in, &, x, domains)

approx_indomain(x, d::CompositeDomain, tolerance) =
	_composite_approx_indomain(tointernalpoint(d, x), d, tolerance, composition(d), components(d))

_composite_approx_indomain(x, d, tolerance, ::NoComposedMap, domains) =
    approx_in(x, domains[1], tolerance)
_composite_approx_indomain(x, d, tolerance, ::Combination, domains) =
    combine(d, map(d -> approx_in(x, d, tolerance), domains))
_composite_approx_indomain(x, d, tolerance, ::Product, domains) =
    mapreduce((u,v)->approx_in(u, v, tolerance), &, x, domains)

choice(d::SimpleLazyDomain) = toexternalpoint(d, choice(superdomain(d)))
choice(d::CompositeDomain) = toexternalpoint(d, map(choice, components(d)))

isequaldomain(a::D, b::D) where {D<:CompositeDomain} = components(a) == components(b)


dimension(d::SimpleLazyDomain{Vector{T}}) where {T} = dimension(superdomain(d))
function dimension(d::CompositeDomain{Vector{T}}) where {T}
	dim = dimension(component(d,1))
	@assert all(isequal(dim), map(dimension, components(d)))
	dim
end

"""
Combine the outputs of `in` of member domains into a single output of the lazy
domain.
"""
combine


"Abstract supertype for domains that wrap another domain."
abstract type DerivedDomain{T} <: SimpleLazyDomain{T} end

isempty(d::DerivedDomain) = isempty(superdomain(d))
isinterval(d::DerivedDomain) = isinterval(superdomain(d))

# We assume the derived domain and the superdomain are equal
canonicaldomain(d::DerivedDomain) = canonicaldomain(superdomain(d))
canonicaldomain(::Equal, d::DerivedDomain) = canonicaldomain(Equal(), superdomain(d))
canonicaldomain(::Isomorphic, d::DerivedDomain) = canonicaldomain(Isomorphic(), superdomain(d))
canonicaldomain(::Parameterization, d::DerivedDomain) = canonicaldomain(Parameterization(), superdomain(d))

mapfrom_canonical(d::DerivedDomain) = mapfrom_canonical(superdomain(d))

boundingbox(d::DerivedDomain) = boundingbox(superdomain(d))
interior(d::DerivedDomain) = interior(superdomain(d))
closure(d::DerivedDomain) = closure(superdomain(d))

"""
A `WrappedDomain` is a wrapper around an object that implements the domain
interface, and that is itself a domain.
"""
struct WrappedDomain{T,D} <: DerivedDomain{T}
    domain  ::  D
end

WrappedDomain(domain::Domain{T}) where {T} = WrappedDomain{T}(domain)
WrappedDomain(domain) = WrappedDomain{domaineltype(domain)}(domain)

WrappedDomain{T}(domain::D) where {T,D<:Domain{T}} = WrappedDomain{T,D}(domain)
WrappedDomain{T}(domain::Domain) where {T} = WrappedDomain{T}(convert(Domain{T}, domain))
WrappedDomain{T}(domain) where {T} = _WrappedDomain(convert_eltype(T, domain))
_WrappedDomain(domain) = WrappedDomain{domaineltype(domain),typeof(domain)}(domain)

similardomain(d::WrappedDomain, ::Type{T}) where {T} = WrappedDomain{T}(d.domain)

# Anything can be converted to a domain by wrapping it. An error will be thrown
# if the object does not support `eltype`.
convert(::Type{Domain}, v::Domain) = v
convert(::Type{Domain}, v) = WrappedDomain(v)
convert(::Type{Domain{T}}, v) where {T} = WrappedDomain{T}(v)

isequaldomain(d1::WrappedDomain, d2::WrappedDomain) = superdomain(d1)==superdomain(d2)

"Example of a domain that wraps another domain and thus obtains its own type."
struct ExampleNamedDomain{T,D} <: DerivedDomain{T}
	domain	::	D
end
ExampleNamedDomain(domain::D) where {T,D<:Domain{T}} = ExampleNamedDomain{T,D}(domain)

# We define a new broadcast style for domains, because they may
# represent continuous sets

"The broadcast style associated with domains"
struct DomainSetStyle <: Base.Broadcast.BroadcastStyle end

Base.BroadcastStyle(::Type{<:Domain}) = DomainSetStyle()
Base.BroadcastStyle(::Type{<:DomainRef}) = DomainSetStyle()

Base.broadcastable(d::Domain) = d
Base.broadcastable(d::DomainRef) = d

# DomainSetStyle doesn't mix with ArrayStyle
Base.BroadcastStyle(::DomainSetStyle, ::Base.Broadcast.AbstractArrayStyle) = DomainSetStyle()
Base.BroadcastStyle(::Base.Broadcast.AbstractArrayStyle, ::DomainSetStyle) = DomainSetStyle()

import Base.Broadcast: broadcasted

broadcasted(::DomainSetStyle, ::typeof(+), a::Union{Number,AbstractArray}, d::AnyDomain) =
    map_domain(Translation(a), domain(d))
broadcasted(::DomainSetStyle, ::typeof(+), d::AnyDomain, a::Union{Number,AbstractArray}) =
    map_domain(Translation(a), domain(d))

broadcasted(::DomainSetStyle, ::typeof(-), a::Union{Number,AbstractArray}, d::AnyDomain) =
    map_domain(AffineMap(-1, a), domain(d))
broadcasted(::DomainSetStyle, ::typeof(-), d::AnyDomain, a::Union{Number,AbstractArray}) =
    map_domain(Translation(-a), domain(d))
broadcasted(::DomainSetStyle, ::typeof(-), d::AnyDomain) =
    map_domain(LinearMap{domaineltype(d)}(-1), domain(d))

broadcasted(::DomainSetStyle, ::typeof(*), a::Number, d::AnyDomain) =
    map_domain(LinearMap{domaineltype(d)}(a), domain(d))
broadcasted(::DomainSetStyle, ::typeof(*), d::AnyDomain, a::Number) =
    map_domain(LinearMap{domaineltype(d)}(a), domain(d))


broadcasted(::DomainSetStyle, ::typeof(/), d::AnyDomain, a::Number) =
    mapped_domain(LinearMap(a), domain(d))

broadcasted(::DomainSetStyle, ::typeof(\), a::Number, d::AnyDomain) =
    mapped_domain(LinearMap(a), domain(d))

broadcasted(::DomainSetStyle, m::AbstractMap, d::AnyDomain) =
    map_domain(m, domain(d))

broadcasted(::DomainSetStyle, fun::Function, d::AnyDomain) =
    parametric_domain(fun, domain(d))

# Intercept broadcast applied to `in`, e.g. in.(A, d).
# This gives domains an opportunity to provide a more efficient implementation
# when invoked with a set of points `A` at once, especially if `A`
# has particular structure. A common case would be a raster of points,
# for plotting purposes.
# This call can be avoided by typing in.(A, Ref(d)) instead.
broadcasted(::DomainSetStyle, ::typeof(in), A, d::AnyDomain) =
    vectorized_in(A, domain(d))
broadcasted(::DomainSetStyle, ::typeof(approx_in), A, d::AnyDomain) =
    vectorized_approx_in(A, domain(d))
broadcasted(::DomainSetStyle, ::typeof(approx_in), A, d::AnyDomain, tol) =
    vectorized_approx_in(A, domain(d), tol)

broadcasted(::DomainSetStyle, ::typeof(∉), A, d::AnyDomain) = A .∉ Ref(domain(d))

"Vectorized version of `in`: apply `x ∈ d` to all elements of `A`."
vectorized_in(A, d) = in.(A, Ref(d))

"Vectorized version of `approx_in`: apply `x ∈ d` to all elements of `A`."
vectorized_approx_in(A, d) = approx_in.(A, Ref(d))
vectorized_approx_in(A, d, tol) = approx_in.(A, Ref(d), tol)


## Some arithmetics

# Allow unary minus, but use broadcast for the implementation
Base.:-(d::AnyDomain) = (-).(d)

# Allow multiplication and division by numbers, like for vectors
Base.:*(a::Number, domain::AnyDomain) = a .* domain
Base.:*(domain::AnyDomain, a::Number) = domain .* a
Base.:/(domain::AnyDomain, a::Number) = domain ./ a
Base.:\(a::Number, domain::AnyDomain) = a .\ domain

"""
	One()

Representation of the number 1.
"""
const One = Val{1}

"""
	Origin()

Representation of the origin.
"""
const Origin = Val{:origin}

unitvector(d::Domain{T}, dim) where {N,S,T<:SVector{N,S}} = SVector{N,S}(ntuple(i -> i==dim, N))
function unitvector(d::Domain{T}, dim) where {T<:AbstractVector}
    p = zeros(eltype(T), dimension(d))
    p[dim] = 1
    p
end
unitvector(d::Domain{T}, dim) where {T<:Number} = (@assert dim==1; one(T))

origin(d::Domain{T}) where {T <: StaticTypes} = zero(T)
function origin(d::Domain{T}) where {T <: AbstractVector}
	p = similar(choice(d))
	fill!(p, 0)
	convert(T, p)
end

# Simplifications go here

# Basic maps

composedmap1(m1::IdentityMap, m2) = m2
composedmap1(m1::IdentityMap{T}, m2::Map{T}) where {T} = m2
composedmap1(m1::IdentityMap{T}, m2::Map{S}) where {S,T} = convert(Map{T}, m2)

composedmap2(m1, m2::IdentityMap) = m1
composedmap2(m1::Map{T}, m2::IdentityMap{T}) where {T} = m1
composedmap2(m1::Map{S}, m2::IdentityMap{T}) where {S,T} = convert(Map{T}, m1)

composedmap2(m1, m2::ConstantMap) = m2
composedmap2(m1::Map{T}, m2::ConstantMap) where {T} = ConstantMap{T}(mapconstant(m2))
composedmap1(m1::ConstantMap{T}, m2) where {T} = ConstantMap{T}(m2(mapconstant(m1)))

composedmap2(m1, m2::ZeroMap) = m2
composedmap2(m1::Map{T}, m2::ZeroMap{S,U}) where {S,T,U} = ZeroMap{T,U}()
composedmap1(m1::ConstantMap{T}, m2::ZeroMap{S,U}) where {S,T,U} = ZeroMap{T,U}()

multiply_map1(m1::ZeroMap, m2) = m1
multiply_map2(m1, m2::ZeroMap) = m2
multiply_map2(m1, m2::ConstantMap) = _constant_multiply_map(m1, m2)
_constant_multiply_map(m1::ConstantMap{T}, m2::ConstantMap{S}) where {S,T} =
    ConstantMap{promote_type(S,T)}(mapconstant(m1)*mapconstant(m2))
_constant_multiply_map(m1, m2::ConstantMap) = default_multiply_map(m1, m2)

multiply_map(m1::Function, m2::Function) = t -> m1(t)*m2(t)

sum_map1(m1::ZeroMap, m2) = m2
sum_map2(m1, m2::ZeroMap) = m1
sum_map2(m1, m2::ConstantMap) = _constant_sum_map(m1, m2)
_constant_sum_map(m1::ConstantMap{T}, m2::ConstantMap{S}) where {S,T} =
    ConstantMap{promote_type(S,T)}(mapconstant(m1)+mapconstant(m2))
_constant_sum_map(m1, m2::ConstantMap) = default_sum_map(m1, m2)

## Affine maps

composedmap(m1::AbstractAffineMap, m2::AbstractAffineMap) = affine_composition(m1, m2)

"""
Compute the affine map that represents map2 after map1, that is:
`y = a2*(a1*x+b1)+b2 = a2*a1*x + a2*b1 + b2`.
"""
affine_composition(map1::AbstractAffineMap, map2::AbstractAffineMap) =
    AffineMap(affinematrix(map2) * affinematrix(map1),
        affinematrix(map2)*affinevector(map1) + affinevector(map2))

affine_composition(map1::AffineMap, map2::AffineMap) =
    AffineMap(unsafe_matrix(map2) * unsafe_matrix(map1),
        unsafe_matrix(map2)*unsafe_vector(map1) + unsafe_vector(map2))

affine_composition(map1::LinearMap, map2::LinearMap) =
    LinearMap(unsafe_matrix(map2) * unsafe_matrix(map1))

affine_composition(map1::LinearMap, map2::AffineMap) =
    AffineMap(unsafe_matrix(map2) * unsafe_matrix(map1), unsafe_vector(map2))

affine_composition(map1::AffineMap, map2::LinearMap) =
    AffineMap(unsafe_matrix(map2) * unsafe_matrix(map1), unsafe_matrix(map2)*unsafe_vector(map1))

affine_composition(map1::Translation, map2::Translation) =
    Translation(unsafe_vector(map2) + unsafe_vector(map1))

affine_composition(map1::Translation, map2::LinearMap) =
    AffineMap(unsafe_matrix(map2), unsafe_matrix(map2)*unsafe_vector(map1))

affine_composition(map1::LinearMap, map2::Translation) =
    AffineMap(unsafe_matrix(map1), unsafe_vector(map2))

# The sum of two affine maps is again an affine map
sum_map(map1::AbstractAffineMap, map2::AbstractAffineMap) =
    AffineMap(affinematrix(map1)+affinematrix(map2), affinevector(map1)+affinevector(map2))


isequalmap(m1::ProductMap, m2::IdentityMap) = all(map(isidentitymap, components(m1)))
isequalmap(m1::IdentityMap, m2::ProductMap) = isequalmap(m2, m1)


"""
Map the interval `[a,b]` to the interval `[c,d]`.

This function deals with infinite intervals, and the type of the
map returned may depend on the value (finiteness) of the given endpoints.
"""
interval_map(a, b, c, d) = interval_map(promote(a,b,c,d)...)

function interval_map(a::T, b::T, c::T, d::T) where {T}
    FT = float(T)
    if isfinite(a) && isfinite(b) && isfinite(c) && isfinite(d)
        bounded_interval_map(a, b, c, d)
    elseif isfinite(a) && !isfinite(b) && isfinite(c) && !isfinite(d)
        # (a,Inf) to (c,Inf)
        AffineMap(one(FT), c-a)
    elseif isfinite(a) && !isfinite(b) && !isfinite(c) && isfinite(d)
        # (a,Inf) to (Inf,d)
        AffineMap(-one(FT), d+a)
    elseif !isfinite(a) && isfinite(b) && isfinite(c) && !isfinite(d)
        # (Inf,b) to (c,Inf)
        AffineMap(-one(FT), c+b)
    elseif !isfinite(a) && isfinite(b) && !isfinite(c) && isfinite(d)
        # (Inf,b) to (Inf,d)
        AffineMap(one(FT), d-b)
    elseif !isfinite(a) && !isfinite(b) && !isfinite(c) && !isfinite(d)
        if (a < 0) && (b > 0) && (c < 0) && (d > 0)
            # (-Inf,Inf) to (-Inf,Inf)
            StaticIdentityMap{FT}()
        elseif (a < 0) && (b > 0) && (c > 0) && (d < 0)
            # (-Inf,Inf) to (Inf,-Inf)
            LinearMap(-one(FT))
        elseif (a > 0) && (b < 0) && (c < 0) && (d > 0)
            # (Inf,-Inf) to (-Inf,Inf)
            LinearMap(-one(FT))
        elseif (a > 0) && (b < 0) && (c > 0) && (d < 0)
            # (Inf,-Inf) to (Inf,-Inf)
            StaticIdentityMap{FT}()
        elseif (a > 0) && (b > 0) && (c > 0) && (d > 0)
            # (Inf,Inf) to (Inf,Inf)
            StaticIdentityMap{FT}()
        elseif (a < 0) && (b < 0) && (c < 0) && (d < 0)
            # (-Inf,-Inf) to (-Inf,-Inf)
            StaticIdentityMap{FT}()
        elseif (a < 0) && (b < 0) && (c > 0) && (d > 0)
            # (-Inf,-Inf) to (Inf,Inf)
            LinearMap(-one(FT))
        elseif (a > 0) && (b > 0) && (c < 0) && (d < 0)
            # (Inf,Inf) to (-Inf,-Inf)
            LinearMap(-one(FT))
        else
            throw(ArgumentError("Requested affine map is unbounded"))
        end
    else
        throw(ArgumentError("Requested affine map is unbounded"))
    end
end

"Like interval_map, but guaranteed to return a scalar affine map."
bounded_interval_map(a, b, c, d) = bounded_interval_map(promote(a,b,c,d)...)
bounded_interval_map(a::T, b::T, c::T, d::T) where {T} =
    AffineMap((d-c)/(b-a), c - a*(d-c)/(b-a))

## Creating a domain from a generator

Domain(gen::Base.Generator) = generator_domain(gen)

generator_domain(gen::Base.Generator) = generator_domain(gen.f, gen.iter)

# Example: Domain(x for x in 0..1)
generator_domain(f::typeof(identity), iter) = checkdomain(iter)
# Example: Domain(x>1 for x in 0..2)
generator_domain(f, iter) = BoundedIndicatorFunction(f, checkdomain(iter))

# Example: Domain(x for x in 0..2 if x > 1)
generator_domain(f::typeof(identity), iter::Base.Iterators.Filter) =
    generator_domain(iter.flt, iter.itr)
# Example: Domain(x>1 for x in 0..2 if x < 1.5)
generator_domain(f, iter::Base.Iterators.Filter) =
    generator_domain(t -> f(t) && iter.flt(t), iter.itr)
# Example: Domain(x*y>0 for (x,y) in UnitDisk())
generator_domain(f, iter::Base.Iterators.ProductIterator) =
    generator_productdomain(f, iter.iterators)
# avoids ambiguity warning by Aqua, method is never called
generator_domain(f::typeof(identity), iter::Base.Iterators.ProductIterator) =
    generator_productdomain(f, iter.iterators)

function generator_productdomain(f, iterators)
    domain = TupleProductDomain(iterators)
    BoundedIndicatorFunction(f, domain)
end

struct MyDomain{T} <: Domain{T}
    somefield::T
end

@testset "canonical domains" begin
    d1 = 2..3.0

    equal = DomainSets.Equal()
    @test !hascanonicaldomain(equal, d1)
    @test canonicaldomain(equal, d1) === d1
    @test mapfrom_canonical(equal, d1) isa IdentityMap
    @test mapto_canonical(equal, d1) isa IdentityMap
    @test mapfrom_canonical(equal, d1, 2.5) == 2.5
    @test mapto_canonical(equal, d1, 2.5) == 2.5

    @test hascanonicaldomain(d1)
    @test canonicaldomain(d1) isa ChebyshevInterval
    @test canonicaldomain(2..3) == ChebyshevInterval{Float64}()
    @test mapfrom_canonical(d1) isa AffineMap
    @test mapto_canonical(d1) isa AffineMap
    @test mapfrom_canonical(d1, 0.4) ≈ 2.7
    @test mapto_canonical(d1, 2.7) ≈ 0.4

    # test simplify beyond equaldomain
    @test hasequaldomain(UnitBall{Float64}())
    @test !hasequaldomain(2*UnitBall{Float64}())
    @test DomainSets.simplifies(2*UnitBall{Float64}())
    @test DomainSets.simplifies(2*UnitBall{Float64}() .+ 1)
    @test DomainSets.simplify(2*UnitBall{Float64}() .+ 1) isa Interval
    @test (2*UnitBall{Float64}() .+ 1) == -1..3

    iso = DomainSets.Isomorphic()
    @test !hascanonicaldomain(iso, d1)
    @test canonicaldomain(iso, d1) === d1
    @test mapfrom_canonical(iso, d1) isa IdentityMap
    @test mapto_canonical(iso, d1) isa IdentityMap
    @test mapfrom_canonical(iso, d1, 2.5) == 2.5
    @test mapto_canonical(iso, d1, 2.5) == 2.5

    d2 = UnitBall(Val(1))
    @test canonicaldomain(iso, d2) == UnitBall{Float64}()
    @test mapfrom_canonical(iso, d2) isa DomainSets.NumberToVector
    @test mapto_canonical(iso, d2) isa DomainSets.VectorToNumber

    @test_throws ArgumentError mapto(UnitCircle(), UnitDisk())
    @test mapto(UnitInterval(), UnitInterval()) isa IdentityMap
    @test mapto(UnitInterval(), ChebyshevInterval()) isa AffineMap

    @test canonicaldomain(2.0..Inf) isa ChebyshevInterval  # for now

    @test canonicaldomain(OpenInterval(2.0,Inf)) === HalfLine{Float64,:open}()
    @test canonicaldomain(OpenInterval(-Inf,2.0)) === HalfLine{Float64,:open}()
    @test canonicaldomain(OpenInterval(-Inf,Inf)) === RealLine{Float64}()
    @test canonicaldomain(OpenInterval(Inf,-Inf)) === RealLine{Float64}()
    @test canonicaldomain(Interval{:closed,:open}(2.0,Inf)) === HalfLine{Float64,:closed}()
    @test canonicaldomain(Interval{:closed,:open}(2.0,4.0)) == Interval{:closed,:open}(-1.0,1.0)
    @test canonicaldomain(Interval{:open,:closed}(-Inf,2.0)) === HalfLine{Float64,:closed}()
    @test canonicaldomain(Interval{:open,:closed}(1.0,2.0)) ==  Interval{:open,:closed}(-1.0,1.0)
    @test_throws ArgumentError canonicaldomain(Interval{:closed,:open}(-Inf,Inf))
    @test_throws ArgumentError canonicaldomain(Interval{:closed,:open}(-Inf,2.0))
    @test_throws ArgumentError canonicaldomain(Interval{:open,:closed}(2.0,Inf))

    @test mapfrom_canonical(OpenInterval(2.0,Inf))(0.0) == 2.0
    @test mapfrom_canonical(OpenInterval(-Inf,2.0))(0.0) == 2.0
    @test DomainSets.isidentitymap(mapfrom_canonical(OpenInterval(-Inf,Inf)))
    @test mapfrom_canonical(OpenInterval(Inf,-Inf))(2.0) == -2.0
    @test mapfrom_canonical(Interval{:closed,:open}(2.0,Inf))(0.0) == 2.0
    @test mapfrom_canonical(Interval{:closed,:open}(2.0,4.0))(-1.0) == 2.0
    @test mapfrom_canonical(Interval{:open,:closed}(-Inf,2.0))(0.0) == 2.0
    @test mapfrom_canonical(Interval{:open,:closed}(1.0,2.0))(1.0) == 2.0
    @test_throws ArgumentError mapfrom_canonical(Interval{:closed,:open}(-Inf,Inf))
    @test_throws ArgumentError mapfrom_canonical(Interval{:closed,:open}(-Inf,2.0))
    @test_throws ArgumentError mapfrom_canonical(Interval{:open,:closed}(2.0,Inf))

    @test DomainSets.interval_map(-Inf,Inf,-Inf,Inf) isa StaticIdentityMap
    @test DomainSets.interval_map(Inf,-Inf,Inf,-Inf) isa StaticIdentityMap
    @test DomainSets.interval_map(-Inf,Inf,Inf,-Inf) == LinearMap(-1)
    @test DomainSets.interval_map(Inf,-Inf,-Inf,Inf) == LinearMap(-1)
    @test DomainSets.interval_map(Inf,Inf,Inf,Inf) isa StaticIdentityMap
    @test DomainSets.interval_map(-Inf,-Inf,-Inf,-Inf) isa StaticIdentityMap

    @testset "canonical types" begin
        struct MyCanonicalType <: DomainSets.CanonicalType
        end
        ctype = MyCanonicalType()
        d = 2..3
        @test canonicaldomain(ctype, d) == d
        @test mapfrom_canonical(ctype, d) isa IdentityMap
        @test mapfrom_canonical(ctype, d, 2.5) == 2.5
        @test mapto_canonical(ctype, d, 2.5) == 2.5
    end

    @testset "domainhash" begin
        mydomain = MyDomain(2.0)
        @test hash(mydomain) == DomainSets.domainhash(mydomain)
    end
end

function test_simplex()
    @test UnitSimplex() isa EuclideanUnitSimplex{3,Float64}
    @test UnitSimplex(2) isa VectorUnitSimplex{Float64}
    @test UnitSimplex(Val(2)) isa EuclideanUnitSimplex{2,Float64}
    @test UnitSimplex{Float64}() isa StaticUnitSimplex{Float64}
    @test UnitSimplex{Float64}(1) isa StaticUnitSimplex{Float64}
    @test_throws AssertionError UnitSimplex{Float64}(2)
    @test UnitSimplex{SVector{2,Float64}}(Val(2)) isa EuclideanUnitSimplex{2,Float64}
    @test_throws AssertionError UnitSimplex{SVector{2,Float64}}(Val(3))
    @test UnitSimplex{SVector{2,Float64}}(2) isa EuclideanUnitSimplex{2,Float64}
    @test_throws AssertionError UnitSimplex{SVector{2,Float64}}(3)
    @test UnitSimplex{SVector{2,Float64}}() isa EuclideanUnitSimplex{2,Float64}
    @test UnitSimplex{Vector{Float64}}(2) isa VectorUnitSimplex{Float64}
    @test_throws MethodError UnitSimplex{Vector{Float64}}()

    @test UnitSimplex{Float64,:open}() isa StaticUnitSimplex{Float64,:open}
    @test UnitSimplex{Float64,:closed}(1) isa StaticUnitSimplex{Float64,:closed}
    @test_throws AssertionError UnitSimplex{Float64,:closed}(2)
    @test UnitSimplex{SVector{2,Float64},:open}(Val(2)) isa EuclideanUnitSimplex{2,Float64,:open}
    @test_throws AssertionError UnitSimplex{SVector{2,Float64},:closed}(Val(3))
    @test UnitSimplex{SVector{2,Float64},:open}(2) isa EuclideanUnitSimplex{2,Float64,:open}
    @test_throws AssertionError UnitSimplex{SVector{2,Float64},:closed}(3)
    @test UnitSimplex{SVector{2,Float64},:open}() isa EuclideanUnitSimplex{2,Float64,:open}
    @test UnitSimplex{Vector{Float64},:closed}(2) isa VectorUnitSimplex{Float64,:closed}
    @test_throws MethodError UnitSimplex{Vector{Float64},:open}()

    @test StaticUnitSimplex(Val(3)) isa StaticUnitSimplex{SVector{3,Float64}}
    @test DynamicUnitSimplex{Float64}(1) isa DynamicUnitSimplex{Float64}
    @test_throws AssertionError DynamicUnitSimplex{Float64}(2)

    @test repr(UnitSimplex(Val(2))) == "UnitSimplex(Val(2))"
    @test repr(UnitSimplex(3)) == "UnitSimplex(3)"

    d0 = UnitSimplex(Val(1))
    @test corners(d0) isa SVector{2,SVector{1,Float64}}
    @test corners(d0) == [[0],[1]]

    d = UnitSimplex(Val(2))
    # We test a point in the interior, a point on each of the boundaries and
    # all corners.
    @test SA[0.2,0.2] ∈ d
    @test SA[0.0,0.2] ∈ d
    @test SA[0.2,0.0] ∈ d
    @test SA[0.5,0.5] ∈ d
    @test SA[0.0,0.0] ∈ d
    @test SA[1.0,0.0] ∈ d
    @test SA[0.0,1.0] ∈ d
    # And then some points outside
    @test SA[0.6,0.5] ∉ d
    @test SA[0.5,0.6] ∉ d
    @test SA[-0.2,0.2] ∉ d
    @test SA[0.2,-0.2] ∉ d
    @test boundingbox(d) == UnitCube{SVector{2,Float64}}()

    # @test distance_to(d, SA[0.2,0.2]) == 0.0
    # @test distance_to(d, SA[1.0,1.0]) ≈ sqrt(2)
    @test normal(d, SA[0,0.5]) == SA[-1,0]
    @test normal(d, SA[0.5,0.5]) == SA[sqrt(2)/2,sqrt(2)/2]
    @test boundary(d) isa UnionDomain

    # issue #102
    @test !([0.3,0.4,0.2] ∈ UnitSimplex(2))
    z1 = @test_logs (:warn, "`in`: incompatible combination of vector with length 3 and domain 'UnitSimplex(Val(2))' with dimension 2. Returning false.") !([0.3,0.4,0.2] ∈ UnitSimplex(Val(2)))
    @test z1
    z2 = @test_logs (:warn, "`in`: incompatible combination of vector with length 3 and domain 'UnitSimplex(Val(2))' with dimension 2. Returning false.") !(SVector(0.3,0.4,0.2) ∈ UnitSimplex(Val(2)))
    @test z2

    @test approx_in(SA[-0.1,-0.1], d, 0.1)
    @test !approx_in(SA[-0.1,-0.1], d, 0.09)

    @test corners(d) isa SVector{3,SVector{2,Float64}}
    @test corners(d) == [ SA[0.0,0.0], SA[1.0,0.0], SA[0.0,1.0]]

    @test convert(Domain{SVector{2,BigFloat}}, d) == EuclideanUnitSimplex{2,BigFloat}()
    @test hash(convert(Domain{SVector{2,BigFloat}}, d)) == hash(EuclideanUnitSimplex{2,BigFloat}())

    @test isclosedset(d)
    @test !isopenset(d)
    @test isopenset(interior(d))
    @test closure(d) == d
    @test choice(d) ∈ d

    # open/closed
    d2 = EuclideanUnitSimplex{2,Float64,:open}()
    @test !isclosedset(d2)
    @test isopenset(d2)
    @test boundary(d2) == boundary(closure(d2))
    @test SA[0.3,0.1] ∈ d2
    @test SA[0.0,0.1] ∉ d2
    @test SA[0.3,0.0] ∉ d2
    @test approx_in(SA[-0.01,0.0], d2, 0.1)
    @test !approx_in(SA[-0.01,0.0], d2, 0.001)

    d3 = EuclideanUnitSimplex{3,BigFloat}()
    @test choice(d3) ∈ d3
    x0 = big(0.0)
    x1 = big(1.0)
    x2 = big(0.3)
    @test SA[x0,x0,x0] ∈ d3
    @test SA[x1,x0,x0] ∈ d3
    @test SA[x0,x1,x0] ∈ d3
    @test SA[x0,x0,x1] ∈ d3
    @test SA[x2,x0,x0] ∈ d3
    @test SA[x0,x2,x0] ∈ d3
    @test SA[x0,x0,x2] ∈ d3
    @test SA[x2,x2,x2] ∈ d3
    @test SA[-x2,x2,x2] ∉ d3
    @test SA[x2,-x2,x2] ∉ d3
    @test SA[x2,x2,-x2] ∉ d3
    @test SA[x1,x1,x1] ∉ d3
    @test corners(d3) isa SVector{4,SVector{3,BigFloat}}
    @test corners(d3) == [ [0,0,0], [1,0,0], [0,1,0], [0,0,1]]

    D = VectorUnitSimplex(2)
    @test isopenset(interior(D))
    @test closure(D) == D
    @test SA[0.2,0.2] ∈ D
    @test SA[0.0,0.2] ∈ D
    @test SA[0.2,0.0] ∈ D
    @test SA[0.5,0.5] ∈ D
    @test SA[0.0,0.0] ∈ D
    @test SA[1.0,0.0] ∈ D
    @test SA[0.0,1.0] ∈ D
    # And then some points outside
    @test SA[0.6,0.5] ∉ D
    @test SA[0.5,0.6] ∉ D
    @test SA[-0.2,0.2] ∉ D
    @test SA[0.2,-0.2] ∉ D
    @test convert(Domain{Vector{BigFloat}}, D) == VectorUnitSimplex{BigFloat}(2)
    @test corners(D) == [ [0.0,0.0], [1.0,0.0], [0.0,1.0]]
    @test boundingbox(D) == UnitCube(2)

    d4 = EuclideanUnitSimplex{4,Float64}()
    @test corners(d4) isa SVector{5,SVector{4,Float64}}

    d5 = StaticUnitSimplex{Float64,:closed}()
    @test convert(AbstractInterval, d5) isa UnitInterval
    @test convert(AbstractInterval, StaticUnitSimplex{Float64,:open}()) isa OpenInterval{Float64}
    @test canonicaldomain(d5) isa UnitInterval
    @test canonicaldomain(DomainSets.Equal(), d5) isa UnitInterval
    @test boundary(d5) == Point(0.0) ∪ Point(1.0)
end

"""
    Isomorphism{T,U} <: TypedMap{T,U}

An isomorphism is a bijection between types that preserves norms.
"""
abstract type Isomorphism{T,U} <: TypedMap{T,U} end

show(io::IO, m::Isomorphism{T,U}) where {T,U} = print(io, "x : $(T) -> x : $(U)")
map_object_parentheses(m::Isomorphism) = true

struct VectorToNumber{T} <: Isomorphism{SVector{1,T},T}
end
struct NumberToVector{T} <: Isomorphism{T,SVector{1,T}}
end

"""
    VectorToNumber()
    VectorToNumber{T}()

Map a length 1 vector `x` to the number `x[1]`.

See also: [`NumberToVector`](@ref).
"""
VectorToNumber() = VectorToNumber{Float64}()

"""
    NumberToVector()
    NumberToVector{T}()

Map a number `x` to the length 1 vector `[x]`.

See also: [`VectorToNumber`](@ref).
"""
NumberToVector() = NumberToVector{Float64}()

mapsize(::VectorToNumber) = (1,1)
mapsize(::NumberToVector) = (1,)

inverse(::VectorToNumber{T}) where {T} = NumberToVector{T}()
inverse(::NumberToVector{T}) where {T} = VectorToNumber{T}()
inverse(m::VectorToNumber, x) = inverse(m)(x)
inverse(m::NumberToVector, x) = inverse(m)(x)

applymap(::VectorToNumber, x) = x[1]
applymap(::NumberToVector, x) = SVector(x)

jacobian(::VectorToNumber{T}, x) where {T} = transpose(SVector(one(T)))
jacobian(::VectorToNumber{T}) where {T} = ConstantMap{SVector{1,T}}(transpose(SVector(one(T))))

jacobian(::NumberToVector{T}, x) where {T} = SVector(one(T))
jacobian(::NumberToVector{T}) where {T} = ConstantMap{T}(SVector(one(T)))


struct VectorToComplex{T} <: Isomorphism{SVector{2,T},Complex{T}}
end
struct ComplexToVector{T} <: Isomorphism{Complex{T},SVector{2,T}}
end

"""
    VectorToComplex()
    VectorToComplex{T}()

Map a length 2 vector ``[a;b]`` to the complex number ``a+bi``.

See also: [`ComplexToVector`](@ref).
"""
VectorToComplex() = VectorToComplex{Float64}()

"""
    ComplexToVector()
    ComplexToVector{T}()

Map a complex number ``a+bi`` to the length 2 vector ``[a; b]``.

See also: [`VectorToComplex`](@ref).
"""
ComplexToVector() = ComplexToVector{Float64}()

mapsize(::VectorToComplex) = (1,2)
mapsize(::ComplexToVector) = (2,)

applymap(::VectorToComplex, x) = x[1] + im*x[2]
applymap(::ComplexToVector, x) = SVector(real(x), imag(x))

inverse(::VectorToComplex{T}) where {T} = ComplexToVector{T}()
inverse(::ComplexToVector{T}) where {T} = VectorToComplex{T}()
inverse(m::VectorToComplex, x) = inverse(m)(x)
inverse(m::ComplexToVector, x) = inverse(m)(x)

jacobian(::VectorToComplex{T}, x) where {T} = transpose(SVector(one(T),one(T)*im))
jacobian(::VectorToComplex{T}) where {T} = ConstantMap{SVector{2,T}}(transpose(SVector(one(T),one(T)*im)))


"Map a static vector to a tuple."
struct VectorToTuple{N,T} <: Isomorphism{SVector{N,T},NTuple{N,T}}
end
"Map a tuple to a static vector."
struct TupleToVector{N,T} <: Isomorphism{NTuple{N,T},SVector{N,T}}
end

inverse(::VectorToTuple{N,T}) where {N,T} = TupleToVector{N,T}()
inverse(::TupleToVector{N,T}) where {N,T} = VectorToTuple{N,T}()
inverse(m::VectorToTuple, x) = inverse(m)(x)
inverse(m::TupleToVector, x) = inverse(m)(x)

applymap(::VectorToTuple, x) = tuple(x...)
applymap(::TupleToVector, x) = SVector(x)


"Map a nested vector or tuple to a flat vector."
struct NestedToFlat{N,T,U,DIM} <: Isomorphism{U,SVector{N,T}}
end
"Map a flattened vector to a nested one."
struct FlatToNested{N,T,U,DIM} <: Isomorphism{SVector{N,T},U}
end

inverse(::NestedToFlat{N,T,U,DIM}) where {N,T,U,DIM} = FlatToNested{N,T,U,DIM}()
inverse(::FlatToNested{N,T,U,DIM}) where {N,T,U,DIM} = NestedToFlat{N,T,U,DIM}()
inverse(m::NestedToFlat, x) = inverse(m)(x)
inverse(m::FlatToNested, x) = inverse(m)(x)

applymap(::NestedToFlat{N,T,U,DIM}, x) where {N,T,U,DIM} = convert_tocartesian(x, Val{DIM}())
applymap(::FlatToNested{N,T,U,DIM}, x) where {N,T,U,DIM} = convert_fromcartesian(x, Val{DIM}())

"""
    Point(x)

represents a single point at `x`.
"""
struct Point{T} <: Domain{T}
    x::T
end

similardomain(d::Point, ::Type{T}) where {T} = Point{T}(d.x)

(::Type{T})(p::Point{<:Number}) where {T<:Number} = T(p.x)
convert(::Type{N}, d::Point{<:Number}) where {N<:Number} = N(d)

convert(::Type{Domain}, c::Number) = Point(c)
convert(::Type{Domain{T}}, c::Number) where T = Point{T}(c)

pointval(d::Point) = d.x

isequaldomain(d1::Point, d2::Point) = pointval(d1) == pointval(d2)
isequaldomain(d1::Point, x::Number) = pointval(d1) == x
domainhash(d::Point, h::UInt) = hashrec("Point", pointval(d), h)

indomain(x, d::Point) = x == pointval(d)
isempty(::Point) = false

approx_indomain(x, d::Point, tolerance) = norm(x-pointval(d)) <= tolerance

dimension(d::Point{<:AbstractVector}) = length(pointval(d))

# The canonical domain of a point is a point at the origin.
# To avoid StackOverflow in hascanonicaldomain, for points already at the origin
# we return the original point
canonicaldomain(d::Point{T}) where {T<:StaticTypes} =
    iszero(d.x) ? d : Point(zero(T))
canonicaldomain(d::Point{T}) where {T<:AbstractVector} =
    iszero(d.x) ? d : Point(zeros(eltype(T),dimension(d)))

mapfrom_canonical(d::Point) = Translation(pointval(d))

isopenset(d::Point) = false
isclosedset(d::Point) = true

boundary(d::Point) = d
boundingbox(d::Point) = pointval(d)..pointval(d)

infimum(d::Point) = pointval(d)
supremum(d::Point) = pointval(d)

interior(d::Point) = emptyspace(d)
closure(d::Point) = d

choice(d::Point) = pointval(d)

distance_to(d::Point, x) = norm(x-pointval(d))

mapped_domain(invmap, p::Point) = Point(inverse(invmap, pointval(p)))
map_domain(map, p::Point) = Point(applymap(map, pointval(p)))
parametric_domain(map, p::Point) = Point(applymap(map, pointval(p)))

Base.:+(a::Point, b::Point) = Point(pointval(a) + pointval(b))
Base.:-(a::Point, b::Point) = Point(pointval(a) - pointval(b))


intersectdomain1(d1::Point, d2) = pointval(d1) ∈ d2 ? d1 : emptyspace(d1)
intersectdomain2(d1, d2::Point) = pointval(d2) ∈ d1 ? d2 : emptyspace(d2)

# Interval minus a point:
setdiffdomain(d::Interval, x::Number) = setdiffdomain(d, Point(x))
setdiffdomain(d::Interval, p::Point) = setdiffdomain(promote_domains((d,p))...)
function setdiffdomain(d::Interval{L,R,T}, p::Point{T}) where {L,R,T}
    a = leftendpoint(d)
    b = rightendpoint(d)
    x = pointval(p)

    a == x && return Interval{:open,R,T}(a,b)
    a < x < b && return UnionDomain(Interval{L,:open,T}(a,x), Interval{:open,R,T}(x,b))
    b == x && return Interval{L,:open,T}(a,b)
    return d
end

issubset1(d1::Point, d2) = pointval(d1) ∈ d2

setdiffdomain1(p::Point, d2) = issubset(p, d2) ? emptyspace(p) : p

intersectdomain(d1::Point, d2::Point) = pointval(d1) ∈ d2 ? d1 : emptyspace(d1)

show(io::IO,d::Point) = print(io,"Point(", pointval(d), ")")

"A `HyperRectangle` is the cartesian product of intervals."
abstract type HyperRectangle{T} <: ProductDomain{T} end

convert(::Type{HyperRectangle}, d::ProductDomain) =
	ProductDomain(map(t->convert(AbstractInterval, t), components(d)))

boundingbox(d::HyperRectangle) = d

"Return all corners of the domain in a vector."
function corners(d::HyperRectangle)
	left = leftendpoint(d)
	right = rightendpoint(d)
    N = length(left)
    corners = [zeros(numtype(d),dimension(d)) for i in 1:2^N]
    # All possible permutations of the corners
    for i=1:2^length(left)
        for j=1:N
            corners[i][j] = ((i>>(j-1))%2==0) ? left[j] : right[j]
        end
    end
    [convert(eltype(d), p) for p in corners]
end

# map the interval [a,b] to a cube defined by c (bottom-left) and d (top-right)
cube_face_map(a::Number, b::Number, c::StaticVector{2}, d::StaticVector{2}) = AffineMap((d-c)/(b-a), c - (d-c)/(b-a)*a)
function cube_face_map(a::Number, b::Number, c::Vector, d::Vector)
	@assert length(c) == length(d) == 2
	AffineMap((d-c)/(b-a), c - (d-c)/(b-a)*a)
end

# map the cube defined by a and b, to the cube defined by c and d,
# where the dimension of c and d is one larger, and one of the coordinates (dim) is fixed to dimval.
function cube_face_map(a::StaticVector{M}, b::StaticVector{M}, c::StaticVector{N}, d::StaticVector{N}, dim, dimval) where {N,M}
	@assert N == M+1
	T = promote_type(eltype(a),eltype(c))
	A = MMatrix{N,M,T}(undef)
	B = MVector{N,T}(undef)
	fill!(A, 0)
	fill!(B, 0)
	B[dim] = dimval
	for m = 1:dim-1
		# scalar map along the dimension "m"
		mapdim = interval_map(a[m], b[m], c[m], d[m])
		A[m,m] = mapdim.A
		B[m] = mapdim.b
	end
	for m = dim+1:N
		mapdim = interval_map(a[m-1], b[m-1], c[m], d[m])
		A[m,m-1] = mapdim.A
		B[m] = mapdim.b
	end
	AffineMap(SMatrix{N,M}(A), SVector{N}(B))
end

function cube_face_map(a::Vector, b::Vector, c::Vector, d::Vector, dim, dimval)
	M = length(a)
	N = length(c)
	@assert length(a)==length(b)
	@assert length(c)==length(d)
	@assert N == M+1
	T = promote_type(eltype(a),eltype(c))
	A = Matrix{T}(undef, N, M)
	B = Vector{T}(undef, N)
	fill!(A, 0)
	fill!(B, 0)
	B[dim] = dimval
	for m = 1:dim-1
		# scalar map along the dimension "m"
		mapdim = interval_map(a[m], b[m], c[m], d[m])
		A[m,m] = mapdim.A
		B[m] = mapdim.b
	end
	for m = dim+1:N
		mapdim = interval_map(a[m-1], b[m-1], c[m], d[m])
		A[m,m-1] = mapdim.A
		B[m] = mapdim.b
	end
	AffineMap(A, B)
end

# The boundary of a rectangle is a collection of mapped lower-dimensional rectangles.
# Dimension 2 is a special case, because the lower dimension is 1 where we use
# scalars instead of vectors
function boundary(d::HyperRectangle{<:StaticVector{2,T}}) where {T}
	left = leftendpoint(d)
	right = rightendpoint(d)
	x1 = left[1]; y1 = left[2]; x2 = right[1]; y2 = right[2]
	d_unit = UnitInterval{T}()
	maps = [
		cube_face_map(zero(T), one(T), SVector(x1,y1), SVector(x2,y1)),
		cube_face_map(zero(T), one(T), SVector(x2,y1), SVector(x2,y2)),
		cube_face_map(zero(T), one(T), SVector(x2,y2), SVector(x1,y2)),
		cube_face_map(zero(T), one(T), SVector(x1,y2), SVector(x1,y1))
	]
	faces = map(m -> ParametricDomain(m, d_unit), maps)
	UnionDomain(faces)
end

function boundary(d::HyperRectangle{<:StaticVector{N,T}}) where {N,T}
	left2 = leftendpoint(d)
	right2 = rightendpoint(d)
	d_unit = UnitCube{SVector{N-1,T}}()
	left1 = leftendpoint(d_unit)
	right1 = rightendpoint(d_unit)

	map1 = cube_face_map(left1, right1, left2, right2, 1, left2[1])
	MAP = typeof(map1)
	maps = MAP[]
	for dim in 1:N
		push!(maps, cube_face_map(left1, right1, left2, right2, dim, left2[dim]))
		push!(maps, cube_face_map(left1, right1, left2, right2, dim, right2[dim]))
	end
	faces = map(m -> ParametricDomain(m, d_unit), maps)
	UnionDomain(faces)
end

function boundary(d::HyperRectangle{Vector{T}}) where {T}
	if dimension(d) == 2
		left = leftendpoint(d)
		right = rightendpoint(d)
		x1 = left[1]; y1 = left[2]; x2 = right[1]; y2 = right[2]
		d_unit = UnitInterval{T}()
		maps = [
			cube_face_map(zero(T), one(T), [x1,y1], [x2,y1]),
			cube_face_map(zero(T), one(T), [x2,y1], [x2,y2]),
			cube_face_map(zero(T), one(T), [x2,y2], [x1,y2]),
			cube_face_map(zero(T), one(T), [x1,y2], [x1,y1])
		]
	else
		left2 = leftendpoint(d)
		right2 = rightendpoint(d)
		d_unit = UnitCube(dimension(d)-1)
		left1 = leftendpoint(d_unit)
		right1 = rightendpoint(d_unit)

		map1 = cube_face_map(left1, right1, left2, right2, 1, left2[1])
		MAP = typeof(map1)
		maps = MAP[]
		for dim in 1:dimension(d)
			push!(maps, cube_face_map(left1, right1, left2, right2, dim, left2[dim]))
			push!(maps, cube_face_map(left1, right1, left2, right2, dim, right2[dim]))
		end
	end
	faces = map(m -> ParametricDomain(m, d_unit), maps)
	UnionDomain(faces)
end


"A `Cube` is a hyperrectangle with equal side lengths in each dimension."
abstract type Cube{T} <: HyperRectangle{T} end

"A cube in a fixed N-dimensional Euclidean space."
const EuclideanCube{N,T} = Cube{SVector{N,T}}

"A cube with vector elements of variable length."
const VectorCube{T} = Cube{Vector{T}}

# This will cause a warning if vectors of different length are used with cubes
iscompatiblepair(x::AbstractVector, d::VectorCube) = length(x) == dimension(d)


"""
	UnitCube()
	UnitCube(::Val{N=3})
	UnitCube(dim::Int)

The `d`-dimensional domain ``[0,1]^d``.
"""
abstract type UnitCube{T} <: Cube{T} end

component(d::UnitCube, i::Int) =
    (1 <= i <= dimension(d) || throw(BoundsError); UnitInterval{numtype(d)}())

volume(d::UnitCube) = 1


"A unit cube that is specified by the element type `T`."
struct StaticUnitCube{T} <: UnitCube{T}
end

StaticUnitCube() = StaticUnitCube{SVector{3,Float64}}()
StaticUnitCube(::Val{N}) where {N} = StaticUnitCube{SVector{N,Float64}}()

StaticUnitCube{T}(n::Int) where {T} =
    (@assert n == euclideandimension(T); StaticUnitCube{T}())
StaticUnitCube{T}(::Val{N}) where {N,T} =
    (@assert N == euclideandimension(T); StaticUnitCube{T}())

similardomain(d::StaticUnitCube, ::Type{T}) where {T<:StaticTypes} =
    StaticUnitCube{T}()
similardomain(d::StaticUnitCube, ::Type{T}) where {T} =
    DynamicUnitCube{T}(dimension(d))

components(d::StaticUnitCube{<:StaticVector{N,T}}) where {N,T} =
    ntuple(x->UnitInterval{T}(), Val(N))

"The unit cube in a fixed N-dimensional space."
const EuclideanUnitCube{N,T} = StaticUnitCube{SVector{N,T}}

EuclideanUnitCube{N}() where {N} = EuclideanUnitCube{N,Float64}()

"""
	UnitSquare()
	UnitSquare{T=Float64}()

The domain ``[0,1]^2``.
"""
const UnitSquare{T} = EuclideanUnitCube{2,T}


"A unit cube whose dimension is specified by a field."
struct DynamicUnitCube{T} <: UnitCube{T}
    dimension   ::  Int

    DynamicUnitCube{T}(n::Int) where {T} = new(n)
    DynamicUnitCube{T}(n::Int) where {T<:StaticTypes} =
        (@assert n == euclideandimension(T); new(n))
end

DynamicUnitCube(n::Int) = DynamicUnitCube{Vector{Float64}}(n)

dimension(d::DynamicUnitCube) = d.dimension

components(d::DynamicUnitCube) = map(x->UnitInterval{numtype(d)}(), 1:dimension(d))

similardomain(d::DynamicUnitCube, ::Type{T}) where {T} =
    DynamicUnitCube{T}(d.dimension)
similardomain(d::DynamicUnitCube, ::Type{T}) where {T <: StaticTypes} =
    StaticUnitCube{T}()

"The unit cube with vector elements of a given dimension."
const VectorUnitCube{T} = DynamicUnitCube{Vector{T}}

VectorUnitCube(n::Int = 3) = VectorUnitCube{Float64}(n)
VectorUnitSquare() = VectorUnitCube(2)


UnitCube(n::Int) = DynamicUnitCube(n)
UnitCube(::Val{N} = Val(3)) where {N} = EuclideanUnitCube{N}()

UnitCube{T}(n::Int) where {T <: StaticTypes} = StaticUnitCube{T}(n)
UnitCube{T}(::Val{N}) where {N,T} = StaticUnitCube{T}(Val(N))
UnitCube{T}() where {T <: StaticTypes} = StaticUnitCube{T}()
UnitCube{T}(n::Int) where {T} = DynamicUnitCube{T}(n)

UnitCube(domains::UnitInterval...) = UnitCube(domains)
UnitCube(domains::NTuple{N,UnitInterval{T}}) where {N,T} =
    UnitCube{SVector{N,T}}(domains)
UnitCube(domains::StaticVector{N,UnitInterval{T}}) where {N,T} =
    UnitCube{SVector{N,T}}(domains)

UnitCube{T}(domains::UnitInterval...) where {T} = UnitCube{T}(domains)
UnitCube{T}(domain::NTuple{N,<:UnitInterval}) where {N,T<:SVector{N}} =
    StaticUnitCube{T}()
UnitCube{T}(domain::StaticVector{N,<:UnitInterval}) where {N,T<:StaticVector{N}} =
    StaticUnitCube{T}()

# Constructor: careful about ambiguities with FixedInterval arguments below
ProductDomain(domains::UnitInterval...) = UnitCube(domains...)
ProductDomain(domains::NTuple{N,<:UnitInterval}) where {N} = UnitCube(domains)
ProductDomain(domains::StaticVector{N,<:UnitInterval}) where {N} = UnitCube(domains)
ProductDomain(domains::AbstractVector{<:UnitInterval{T}}) where {T} =
    VectorUnitCube{T}(length(domains))
ProductDomain{T}(domains::UnitInterval...) where {N,S,T<:StaticVector{N,S}} =
	UnitCube{T}(domains...)
ProductDomain{T}(domains::NTuple{N,<:UnitInterval}) where {N,S,T<:StaticVector{N,S}} =
	UnitCube{T}(domains)
ProductDomain{T}(domains::StaticVector{N,<:UnitInterval}) where {N,S,T<:StaticVector{N,S}} =
	UnitCube{T}(domains)
ProductDomain{T}(domains::AbstractVector{<:UnitInterval}) where {S,T<:Vector{S}} =
	VectorUnitCube{S}(length(domains))

## Display:
show(io::IO, d::EuclideanUnitCube{3,Float64}) = print(io, "UnitCube()")
show(io::IO, d::EuclideanUnitCube{N,Float64}) where {N} = print(io, "UnitCube(Val($(N)))")
show(io::IO, d::UnitSquare{Float64}) = print(io, "UnitSquare()")
show(io::IO, d::UnitSquare{T}) where {T} = print(io, "UnitSquare{$(T)}()")
show(io::IO, d::VectorUnitCube{Float64}) = print(io, "UnitCube($(dimension(d)))")

# set the display stencils to [] to opt-out of composite display for the types above
Display.displaystencil(d::EuclideanUnitCube{N,Float64}) where {N} = []
Display.displaystencil(d::UnitSquare) = []
Display.displaystencil(d::VectorUnitCube{Float64}) = []
Display.object_parentheses(d::EuclideanUnitCube{N,Float64}) where {N} = false
Display.object_parentheses(d::UnitSquare) = false
Display.object_parentheses(d::VectorUnitCube{Float64}) = false


"""
	Rectangle(a, b)
	Rectangle(domains::ClosedInterval...)
	Rectangle{T}(domains::ClosedInterval...)

A rectangular domain in `n` dimensions with extrema determined by the vectors
or points `a` and `b` or by the endpoints of the given intervals.
"""
struct Rectangle{T} <: HyperRectangle{T}
    a   ::  T
    b   ::  T

    function Rectangle{T}(a::S,b::S) where {S,T}
        @assert length(a)==length(b)
        new(a,b)
    end
end

dimension(d::Rectangle) = length(d.a)
component(d::Rectangle, i::Int) = ClosedInterval(d.a[i],d.b[i])
components(d::Rectangle) = map(ClosedInterval, d.a, d.b)

Rectangle(a, b) = Rectangle(promote(a,b)...)
Rectangle(a::NTuple{N,T}, b::NTuple{N,T}) where {N,T} =
    Rectangle(SVector{N,T}(a), SVector{N,T}(b))
Rectangle(a::Point, b::Point) = Rectangle(pointval(a), pointval(b))
Rectangle(a::T, b::T) where {T} = Rectangle{T}(a, b)
Rectangle(a::T, b::T) where {T<:Number} =
	throw(ArgumentError("Rectangles have to be constructed from vectors or tuples, not numbers."))

Rectangle(domains::Tuple) = Rectangle(domains...)
Rectangle(domains::ClosedInterval...) = Rectangle(promote_domains(domains)...)
Rectangle(domains::ClosedInterval{T}...) where {T} =
    Rectangle(map(leftendpoint, domains), map(rightendpoint, domains))
Rectangle(domains::AbstractVector{<:ClosedInterval}) =
    Rectangle(map(leftendpoint, domains), map(rightendpoint, domains))
Rectangle(domains::Domain...) =
    throw(ArgumentError("The Rectangle constructor expects two points or a list of intervals (closed)."))

Rectangle{T}(domains::Tuple) where {T} = Rectangle{T}(domains...)
Rectangle{T}(domains::ClosedInterval...) where {T} =
	Rectangle{T}(map(leftendpoint, domains), map(rightendpoint, domains))
Rectangle{T}(domains::AbstractVector{<:ClosedInterval}) where {T} =
    Rectangle{T}(map(leftendpoint, domains), map(rightendpoint, domains))
Rectangle{T}(domains::Domain...) where {T} =
    throw(ArgumentError("The Rectangle constructor expects two points or a list of intervals (closed)."))

ProductDomain(domains::ClosedInterval{<:Number}...) = Rectangle(domains...)
ProductDomain(domains::AbstractVector{<:ClosedInterval{<:Number}}) =
    Rectangle(map(leftendpoint, domains), map(rightendpoint, domains))
ProductDomain{T}(domains::ClosedInterval...) where {T} = Rectangle{T}(domains...)
ProductDomain{T}(domains::AbstractVector{<:ClosedInterval}) where {T} =
    Rectangle{T}(map(leftendpoint, domains), map(rightendpoint, domains))



"The N-fold cartesian product of a fixed interval."
struct FixedIntervalProduct{N,T,D} <: Cube{SVector{N,T}}
end

component(d::FixedIntervalProduct{N,T,D}, i::Int) where {N,T,D} =
    (1 <= i <= dimension(d) || throw(BoundsError); D())
components(d::FixedIntervalProduct{N,T,D}) where {N,T,D} =
    ntuple(x->D(), Val(N))

volume(d::FixedIntervalProduct{N,T,D}) where {N,T,D} = volume(D())^N

FixedIntervalProduct(domains::NTuple{N,D}) where {N,D <: FixedInterval} =
	FixedIntervalProduct{N,eltype(D),D}()
FixedIntervalProduct(domains::StaticVector{N,D}) where {N,D <: FixedInterval} =
	FixedIntervalProduct{N,eltype(D),D}()

const ChebyshevProductDomain{N,T} = FixedIntervalProduct{N,T,ChebyshevInterval{T}}
ChebyshevProductDomain(::Val{N}) where {N} = ChebyshevProductDomain{N}()
ChebyshevProductDomain{N}() where {N} = ChebyshevProductDomain{N,Float64}()

ProductDomain(domains::D...) where {D <: FixedInterval} =
	FixedIntervalProduct(domains)
ProductDomain(domains::NTuple{N,D}) where {N,D <: FixedInterval} =
	FixedIntervalProduct(domains)
ProductDomain(domains::StaticVector{N,<:FixedInterval}) where {N} =
	FixedIntervalProduct(domains)
ProductDomain{T}(domains::D...) where {N,S,T<:StaticVector{N,S},D <: FixedInterval} =
	FixedIntervalProduct(convert_eltype.(Ref(S), domains))
ProductDomain{T}(domains::NTuple{N,D}) where {N,S,T<:StaticVector{N,S},D <: FixedInterval} =
	FixedIntervalProduct(convert_eltype.(Ref(S), domains))
ProductDomain{T}(domains::StaticVector{N,<:FixedInterval}) where {N,T<:StaticVector{N}} =
	FixedIntervalProduct(domains)

boundingbox(d::Vector{T}) where {T <: Number} = minimum(d)..maximum(d)
boundingbox(d::Set{T}) where {T<:Number} = minimum(d)..maximum(d)

"Return the bounding box of the union of two or more bounding boxes."
unionbox(d) = d
unionbox(d1, d2) = unionbox1(promote_domains(d1, d2)...)
unionbox(d1, d2, domains...) =
    unionbox(unionbox(d1,d2), domains...)
unionbox1(d1, d2) = unionbox2(d1, d2)
unionbox2(d1, d2) = fullspace(d1)
unionbox1(d1::EmptySpace, d2) = d2
unionbox1(d1::FullSpace, d2) = d1
unionbox2(d1, d2::EmptySpace) = d1
unionbox2(d1, d2::FullSpace) = d2

unionbox1(d1::D, d2::D) where {D<:FixedInterval} = d1

function unionbox1(d1::AbstractInterval, d2::AbstractInterval)
    a, b = endpoints(d1)
    c, d = endpoints(d2)
    A = min(a, c)
    B = max(b, d)
    isinf(A) && isinf(B) ? fullspace(d1) : A..B
end

function unionbox(d1::HyperRectangle, d2::HyperRectangle)
    @assert dimension(d1) == dimension(d2)
    T = promote_type(eltype(d1),eltype(d2))
    Rectangle{T}(map(unionbox, components(d1), components(d2)))
end

"Return the bounding box of the intersection of two or more bounding boxes."
intersectbox(d) = d
intersectbox(d1, d2) = intersectbox1(promote_domains(d1, d2)...)
intersectbox(d1, d2, domains...) =
    intersectbox(intersectbox(d1,d2), domains...)

intersectbox1(d1, d2) = intersectbox2(d1, d2)
intersectbox2(d1, d2) = fullspace(d1)
intersectbox1(d1::EmptySpace, d2) = d1
intersectbox1(d1::FullSpace, d2) = d2
intersectbox2(d1, d2::EmptySpace) = d2
intersectbox2(d1, d2::FullSpace) = d1

intersectbox1(d1::D, d2::D) where {D<:FixedInterval} = d1

intersectbox1(d1::AbstractInterval, d2::AbstractInterval) =
    intersectdomain(d1, d2)

function intersectbox1(d1::HyperRectangle, d2::HyperRectangle)
    @assert dimension(d1) == dimension(d2)
    T = eltype(d1)
    d = Rectangle{T}(map(intersectbox, components(d1), components(d2)))
    isempty(d) ? emptyspace(d) : d
end

boundingbox(d::AbstractMappedDomain) = map_boundingbox(boundingbox(superdomain(d)), forward_map(d))

function map_boundingbox(box::AbstractInterval, fmap)
    l,r = (leftendpoint(box),rightendpoint(box))
    ml = fmap(l); mr = fmap(r)
    min(ml,mr)..max(ml,mr)
end

# This is a best effort implementation, it could be wrong for some maps,
# because we only map the corners. Hence we restrict to affine maps here.
map_boundingbox(box::HyperRectangle, fmap::AbstractAffineMap) =
    map_boundingbox_generic(box, fmap)

# This is a best effort implementation. It could be wrong for some maps,
# because we only map the corners.
function map_boundingbox_generic(box::HyperRectangle{T}, fmap) where {T}
    mapped_corners = map(fmap, corners(box))
    left = [minimum(x[j] for x in mapped_corners) for j in 1:dimension(box)]
    right = [maximum(x[j] for x in mapped_corners) for j in 1:dimension(box)]
    Rectangle{T}(left, right)
end

# Definition of the abstract Domain type and its interface

Domain(d) = convert(Domain, d)

prectype(::Type{<:Domain{T}}) where T = prectype(T)
numtype(::Type{<:Domain{T}}) where T = numtype(T)

# Domain-specific prectype and numtype default to using domaineltype
domain_prectype(d) = prectype(domaineltype(d))
domain_numtype(d) = numtype(domaineltype(d))
domain_prectype(domains...) = prectype(map(domaineltype, domains)...)
domain_numtype(domains...) = numtype(map(domaineltype, domains)...)
prectype(d::DomainRef) = prectype(domaineltype(d))
numtype(d::DomainRef) = numtype(domaineltype(d))

# Concrete types can implement similardomain(d, ::Type{T}) where {T}
# to support convert(Domain{T}, d) functionality.
convert(::Type{Domain{T}}, d::Domain{T}) where {T} = d
convert(::Type{Domain{T}}, d::Domain{S}) where {S,T} = similardomain(d, T)

"Can the domains be promoted without throwing an error?"
promotable_domains(domains...) = promotable_eltypes(map(domaineltype, domains)...)

"Promote the given domains to have a common element type."
promote_domains() = ()
promote_domains(domains...) = promote_domains(domains)
promote_domains(domains) = convert_eltype.(mapreduce(domaineltype, promote_type, domains), domains)

convert_eltype(::Type{T}, d::Domain) where {T} = convert(Domain{T}, d)
convert_eltype(::Type{T}, d) where {T} = _convert_eltype(T, d, domaineltype(d), DomainStyle(d))
_convert_eltype(::Type{T}, d, ::Type{T}, ::IsDomain) where {T} = d
_convert_eltype(::Type{T}, d, ::Type{S}, ::IsDomain) where {S,T} =
    throw(ArgumentError("Don't know how to convert the `eltype` of $(d)."))
_convert_eltype(::Type{T}, d, ::Type{T}, ::NotDomain) where {T} = d
_convert_eltype(::Type{T}, d, ::Type{S}, ::NotDomain) where {S,T} =
    throw(ArgumentError("Convert eltype: argument given is not a domain."))


"A `EuclideanDomain` is any domain whose eltype is `<:StaticVector{N,T}`."
const EuclideanDomain{N,T} = Domain{<:StaticVector{N,T}}

"A `VectorDomain` is any domain whose eltype is `Vector{T}`."
const VectorDomain{T} = Domain{Vector{T}}

"An `AbstractVectorDomain` is any domain whose eltype is `<:AbstractVector{T}`."
const AbstractVectorDomain{T} = Domain{<:AbstractVector{T}}

CompositeTypes.Display.displaysymbol(d::Domain) = 'D'

"What is the Euclidean dimension of the domain?"
dimension(d) = euclideandimension(domaineltype(d))

"Is the given combination of point and domain compatible?"
iscompatiblepair(x, d) = _iscompatiblepair(x, d, typeof(x), domaineltype(d))
_iscompatiblepair(x, d, ::Type{S}, ::Type{T}) where {S,T} =
    _iscompatiblepair(x, d, S, T, promote_type(S,T))
_iscompatiblepair(x, d, ::Type{S}, ::Type{T}, ::Type{U}) where {S,T,U} = true
_iscompatiblepair(x, d, ::Type{S}, ::Type{T}, ::Type{Any}) where {S,T} = false
_iscompatiblepair(x, d, ::Type{S}, ::Type{Any}, ::Type{Any}) where {S} = true

# Some generic cases where we can be sure:
_iscompatiblepair(x, d, ::Type{<:StaticVector{N}}, ::Type{<:StaticVector{N}}) where N = true
_iscompatiblepair(x, d, ::Type{<:StaticVector{N}}, ::Type{<:StaticVector{M}}) where {N,M} = false
_iscompatiblepair(x, d, ::Type{<:AbstractVector}, ::Type{<:StaticVector{N}}) where N =
    length(x) == N

# Note: there are cases where this warning reveals a bug, and cases where it is
# annoying. In cases where it is annoying, the domain may want to specialize `in`.
compatible_or_false(x, domain) = _compatible_or_false(x, domain)
_compatible_or_false(x, domain) =
    iscompatiblepair(x, domain) ? true : (@warn "`in`: incompatible combination of point: $(typeof(x)) and domain eltype: $(domaineltype(domain)). Returning false."; false)
# indirection to _compatible_or_false enables fallback below without ambiguity
# if some concrete domain type specializes compatible_or_false
_compatible_or_false(x::AbstractVector, domain::AbstractVectorDomain) =
    iscompatiblepair(x, domain) ? true : (@warn "`in`: incompatible combination of vector with length $(length(x)) and domain '$(domain)' with dimension $(dimension(domain)). Returning false."; false)


"Promote point and domain to compatible types."
promote_pair(x, d) = _promote_pair(x, d, promote_type(typeof(x), domaineltype(d)))
_promote_pair(x, d, ::Type{T}) where {T} = convert(T, x), convert_eltype(T, d)
_promote_pair(x, d, ::Type{Any}) = x, d
# Some exceptions:
# - matching types: avoid promotion just in case it is expensive
promote_pair(x::T, d::Domain{T}) where {T} = x, d
# - `Any` domain
promote_pair(x, d::Domain{Any}) = x, d
# - tuples: these are typically composite domains and the elements may be promoted later on
promote_pair(x::Tuple, d::Domain{<:Tuple}) = x, d
# - abstract vectors: promotion may be expensive
promote_pair(x::AbstractVector, d::AbstractVectorDomain) = x, d
# - SVector: promotion is likely cheap
promote_pair(x::AbstractVector{S}, d::EuclideanDomain{N,T}) where {N,S,T} =
    _promote_pair(x, d, SVector{N,promote_type(S,T)})


# For subtypes of Domain we attempt to promote the arguments to compatible
# types, then we invoke indomain. Concrete subtypes may implement
# indomain. They may also implement `in` in order to accept more types.
in(x, d::Domain) = compatible_or_false(x, d) && indomain(promote_pair(x, d)...)

# Generically, the domain interface specifies to implement `in` so for
# references we invoke `in` with the referenced domain.
in(x, d::DomainRef) = in(x, domain(d))

"""
Return a suitable tolerance to use for verifying whether a point is close to
a domain. Typically, the tolerance is close to the precision limit of the numeric
type associated with the domain.
"""
domain_tolerance(d) = domain_tolerance(domain_prectype(d))
domain_tolerance(::Type{T}) where {T <: AbstractFloat} = 100eps(T)

# a version with a tolerance, for use in approx_in
function compatible_or_false(x, d, tol)
    tol >= 0 || error("Tolerance has to be positive in `approx_in`.")
    compatible_or_false(x, d)
end

"""
`approx_in(x, domain::Domain [, tolerance])`

Verify whether a point lies in the given domain with a certain tolerance.

The tolerance has to be positive. The meaning of the tolerance, in relation
to the possible distance of the point to the domain, is domain-dependent.
Usually, if the outcome is true, it means that the distance of the point to
the domain is smaller than a constant times the tolerance. That constant may
depend on the domain.

Up to inexact computations due to floating point numbers, it should also be
the case that `approx_in(x, d, 0) == in(x,d)`. This implies that `approx_in`
reflects whether a domain is open or closed.
"""
approx_in(x, d) = approx_in(x, d, domain_tolerance(d))
approx_in(x, d, tol) =
    compatible_or_false(x, d, tol) && approx_indomain(promote_pair(x, d)..., tol)
approx_in(x, d::DomainRef, tol) = approx_in(x, domain(d), tol)

# Fallback to `in`
approx_indomain(x, d, tol) = in(x, d)

isapprox(d1::Domain, d2::Domain; kwds...) = d1 == d2

isrealdomain(d::Domain) = isrealtype(domaineltype(d))

"Return a point from the given domain."
function choice(d) end

choice(d::AbstractSet) = first(d)
choice(d::AbstractArray) = first(d)

"""
    canonicaldomain([ctype::CanonicalType, ]d)

Return an associated canonical domain, if any, of the given domain.

For example, the canonical domain of an Interval `[a,b]` is the interval `[-1,1]`.

Optionally, a canonical type argument may specify an alternative canonical domain.
Canonical domains help with establishing equality between domains, with finding
maps between domains and with finding parameterizations.

If a domain implements a canonical domain, it should also implement
`mapfrom_canonical` and `mapto_canonical`.

See also: [`mapfrom_canonical`](@ref), [`mapto_canonical`](@ref).
"""
canonicaldomain(d) = d

"""
    hascanonicaldomain([ctype::CanonicalType, ]d)

Does the domain have a canonical domain?

See also: [`canonicaldomain`](@ref).
"""
hascanonicaldomain(d) = !(d === canonicaldomain(d))

identitymap(d) = IdentityMap{domaineltype(d)}(dimension(d))

"""
    mapfrom_canonical(d[, x])

Return a map to a domain `d` from its canonical domain.

If a second argument `x` is given, the map is evaluated at that point.
The point `x` should be a point in the canonical domain of `d`, and the
result is a point in `d`.

See also: [`mapto_canonical`](@ref), [`canonicaldomain`](@ref).
"""
mapfrom_canonical(d) = identitymap(d)
mapfrom_canonical(d, x) = mapfrom_canonical(d)(x)

"""
    mapto_canonical(d[, x])

Return a map from a domain `d` to its canonical domain.

If a second argument `x` is given, the map is evaluated at that point.
The point `x` should be a point in the domain `d`, and the
result is a point in the canonical domain.

See also: [`mapfrom_canonical`](@ref), [`canonicaldomain`](@ref).
"""
mapto_canonical(d) = leftinverse(mapfrom_canonical(d))
mapto_canonical(d, x) = mapto_canonical(d)(x)

# For definition of CanonicalType: see FunctionMaps

canonicaldomain(ctype::CanonicalType, d) = d
hascanonicaldomain(ctype::CanonicalType, d) = !(d === canonicaldomain(ctype, d))

mapfrom_canonical(ctype::CanonicalType, d) = identitymap(d)
mapto_canonical(ctype::CanonicalType, d) = leftinverse(mapfrom_canonical(ctype, d))

mapfrom_canonical(ctype::CanonicalType, d, x) = mapfrom_canonical(ctype, d)(x)
mapto_canonical(ctype::CanonicalType, d, x) = mapto_canonical(ctype, d)(x)


canonicaldomain(::Equal, d) = d
mapfrom_canonical(::Equal, d) = identitymap(d)
mapto_canonical(::Equal, d) = leftinverse(mapfrom_canonical(Equal(), d))

"""
    equaldomain(domain)

Return a canonical domain that is equal, but simpler. For example,
a 1-dimensional ball is an interval. This function is equivalent to
`canonicaldomain(Equal(), d)`.

A domain and its `equaldomain` are always equal domains according to
`isequaldomain`.

See also: [`canonicaldomain`](@ref).
"""
equaldomain(d) = canonicaldomain(Equal(), d)

"""
    hasequaldomain(d)

Does the domain have a known equal domain?
"""
hasequaldomain(d) = hascanonicaldomain(Equal(), d)

# these definitions should be removed because equal domains are never mapped
@deprecate mapfrom_equaldomain(d) mapfrom_canonical(Equal(), d)
@deprecate mapto_equaldomain(d) mapto_canonical(Equal(), d)
@deprecate mapfrom_equaldomain(d, x) mapfrom_canonical(Equal(), d, x)
@deprecate mapto_equaldomain(d, x) mapto_canonical(Equal(), d, x)

"""
    simplify(domain)

Simplify the given domain to an equal domain.
"""
function simplify(d)
    if hasequaldomain(d)
        equaldomain(d)
    elseif hasparameterization(d) && hasequaldomain(parameterdomain(d))
        map_domain(mapfrom_parameterdomain(d), simplify(parameterdomain(d)))
    else
        d
    end
end

"""
    simplifies(domain)

Does the domain simplify?
"""
simplifies(d) = hasequaldomain(d) ||
    (hasparameterization(d) && hasequaldomain(parameterdomain(d)))

"Convert the given domain to a domain defined in DomainSets.jl."
todomainset(d::Domain) = d
todomainset(d::DomainRef) = todomainset(domain(d))


"""
    Isomorphic <: CanonicalType

An isomorphic canonical domain is a domain that is the same up to an isomorphism.
"""
struct Isomorphic <: CanonicalType end

canonicaldomain(::Isomorphic, d) = canonicaldomain(Equal(), d)
mapfrom_canonical(::Isomorphic, d) = mapfrom_canonical(Equal(), d)
mapto_canonical(::Isomorphic, d) = leftinverse(mapfrom_canonical(Isomorphic(), d))

canonicaldomain(::Isomorphic, d::Domain{<:StaticVector{1,T}}) where {T} =
    convert(Domain{T}, d)
mapfrom_canonical(::Isomorphic, d::Domain{<:StaticVector{1,T}}) where {T} =
    NumberToVector{T}()

canonicaldomain(::Isomorphic, d::Domain{NTuple{N,T}}) where {N,T} =
    convert(Domain{SVector{N,T}}, d)
mapfrom_canonical(::Isomorphic, d::Domain{NTuple{N,T}}) where {N,T} =
    VectorToTuple{N,T}()



"""
    Parameterization <: CanonicalType

A parametric canonical domain can be parameterized from a simpler domain.
"""
struct Parameterization <: CanonicalType end

canonicaldomain(ctype::Parameterization, d) =
    hascanonicaldomain(d) ? canonicaldomain(ctype, canonicaldomain(d)) : d
mapfrom_canonical(ctype::Parameterization, d) =
    hascanonicaldomain(d) ? mapfrom_canonical(d) ∘ mapfrom_canonical(ctype, canonicaldomain(d)) : mapfrom_canonical(d)
mapto_canonical(ctype::Parameterization, d) = leftinverse(mapfrom_canonical(ctype, d))

# We define some convenience functions:
"""
    parameterdomain(d)

A domain from which `d` can be parameterized.
"""
parameterdomain(d) = canonicaldomain(Parameterization(), d)

"""
    parameterization(d)

A map from the parameter domain of `d` to `d`.
"""
parameterization(d) = mapfrom_canonical(Parameterization(), d)

"""
    hasparameterization(d)

Does the domain have a parameterization?
"""
hasparameterization(d) = hascanonicaldomain(Parameterization(), d)

"""
    mapfrom_parameterdomain(d[, x])

Convenience alias for `mapfrom_canonical(Paramaterization(), d[, x])`.
"""
mapfrom_parameterdomain(d) = mapfrom_canonical(Parameterization(), d)

"""
    mapto_parameterdomain(d[, x])

Convenience alias for `mapto_canonical(Paramaterization(), d[, x])`.

See also: [`mapfrom_parameterdomain`](@ref).
"""
mapto_parameterdomain(d) = mapto_canonical(Parameterization(), d)
mapfrom_parameterdomain(d, x) = mapfrom_canonical(Parameterization(), d, x)
mapto_parameterdomain(d, x) = mapto_canonical(Parameterization(), d, x)


"""
    mapto(d1, d2)

Return a map from domain `d1` to domain `d2`.
"""
mapto(d1, d2) = mapto1(d1, d2)
mapto(d1::D, d2::D) where {D} = d1 == d2 ? identitymap(d1) : mapto1(d1,d2)

# simplify the first argument
mapto1(d1, d2) =
    hasparameterization(d1) ? mapto(parameterdomain(d1), d2) ∘ mapto_parameterdomain(d1) : mapto2(d1, d2)
# simplify the second argument
mapto2(d1, d2) =
    hasparameterization(d2) ? mapfrom_parameterdomain(d2) ∘ mapto(d1, parameterdomain(d2)) : default_mapto(d1,d2)

default_mapto(d1, d2) = d1 == d2 ? identitymap(d1) : throw(ArgumentError("No map known between $(d1) and $(d2)."))



## Equality for domains
# We generically define the equality of Domains, using the framework
# of canonical domains.

"""
    isequaldomain(d1, d2)

Are the two given domains equal?

Domains are considered equal if their membership functions return the same
output for the same input.

It is not always possible to verify this automatically. If the result is `true`,
then the domains are guaranteed to be equal. If the result is `false`, then
either the domains are not equal or they are equal but the implementation fails
to recognize this.
"""
isequaldomain(d1, d2) = isequaldomain1(d1, d2)
isequaldomain1(d1, d2) = simplifies(d1) ? isequaldomain(simplify(d1), d2) : isequaldomain2(d1, d2)
isequaldomain2(d1, d2) = simplifies(d2) ? isequaldomain(d1, simplify(d2)) : default_isequaldomain(d1, d2)
default_isequaldomain(d1, d2) = d1 === d2

# Can't use == for arrays etcetera since order doesn't matter
isequaldomain(d1::BaseDomainType, d2::BaseDomainType) = d1 ⊆ d2 && d2 ⊆ d1

==(d1::AnyDomain, d2::AnyDomain) = isequaldomain(domain(d1), domain(d2))

# Associated with == we have to define the hashes of domains
# Since equality is based on `simplify`, so should hash be. To that end we
# are forced to intercept hash to call simplify. In order to avoid a stack
# overflow we call a different function `domainhash`, for which we provide
# a fallback by invoking the implementation in Base.
hash(d::Domain, h::UInt) = domainhash(simplify(d), h)

domainhash(d) = domainhash(d, zero(UInt))
domainhash(d, h::UInt) = invoke(hash, Tuple{Any,UInt}, d, h)

using DomainSets, DomainSets.FunctionMaps

# for test_common.jl
using DomainSets.FunctionMaps:
    convert_numtype,
    convert_prectype,
    promote_numtype,
    promote_prectype,
    euclideandimension

# for test_interface.jl
using DomainSets.FunctionMaps:
    MapStyle, IsMap, NotMap,
    functionmap, checkmap

# for test_generic.jl
using DomainSets.FunctionMaps:
    convert_domaintype, convert_codomaintype,
    map_hash,
    LazyInverse, jacobian!

# for test_maps.jl
using DomainSets.FunctionMaps: ScalarAffineMap,
    VectorAffineMap,
    StaticAffineMap,
    GenericAffineMap,
    ScalarLinearMap,
    VectorLinearMap,
    StaticLinearMap,
    GenericLinearMap,
    ScalarTranslation,
    VectorTranslation,
    StaticTranslation,
    GenericTranslation,
    ProductMap,
    TupleProductMap, VcatMap, VectorProductMap,
    WrappedMap,
    interval_map, multiply_map,
    SumMap, sum_map,
    composedmap, ComposedMap,
    composite_jacobian, sum_jacobian,
    CartToPolarMap, PolarToCartMap,
    UnitCircleMap, AngleMap, UnitDiskMap,
    VectorToComplex

# for test_affine.jl
using DomainSets.FunctionMaps:
    to_matrix, to_vector,
    matrix_pinv

# for test_arithmetics.jl
using DomainSets.FunctionMaps:
    interval_map, bounded_interval_map

using DomainSets:
    PositiveRealLine,
    NonnegativeRealLine,
    NegativeRealLine,
    NonpositiveRealLine,
    isinterval

using IntervalSets

function test_intervals()
    T = Float64
    @testset "ClosedInterval" begin
        d = zero(T)..one(T)
        @test approx_in(-0.1, d, 0.2)
        @test approx_in(1.1, d, 0.2)
        @test !approx_in(-0.2, d, 0.1)
        @test !approx_in(1.2, d, 0.1)
        @test isclosedset(d)
        @test !isopenset(d)
        @test similar_interval(d, big(0), big(1)) == Interval{:closed,:closed,BigInt}(0,1)
        @test closure(d) == d
        @test isopenset(interior(d))
        @test center(d) == one(T)/2

        @test iscompact(d)
        @test isinterval(d)
        @test typeof(similar_interval(d, one(T), 2*one(T))) == typeof(d)

        @test leftendpoint(d) ∈ ∂(d)
        @test rightendpoint(d) ∈ ∂(d)

        @test boundary(d) == uniondomain(Point(zero(T)), Point(one(T)))
        @test corners(d) == [0,1]
        @test boundingbox(d) == d
        @test closure(d) == d

        @test similar_interval(0..1, 0, big(1.0)) isa ClosedInterval{BigFloat}
        @test convert(AbstractInterval{Float64}, 0..1) isa ClosedInterval{Float64}

        @test canonicaldomain(d) isa ChebyshevInterval{Float64}
        @test canonicaldomain(0..1) isa ChebyshevInterval{Int}

        @test intersectdomain(0..1, 1..3) isa Point{Int}
        @test 1..1 == Point(1)
        @test 1..1 != Point(2)

        @test normal(0..1, -0.3) == -1
        @test normal(0..1, 0.7) == 1
        @test distance_to(0..1, 1.5) == 0.5
        @test distance_to(0..1, 0.5) == 0
        @test distance_to(OpenInterval(0,0.0), 0.5) == Inf
    end
    @testset "UnitInterval" begin
        d = UnitInterval{T}()
        @test leftendpoint(d) == zero(T)
        @test rightendpoint(d) == one(T)
        @test minimum(d) == infimum(d) == leftendpoint(d)
        @test maximum(d) == supremum(d) == rightendpoint(d)

        @test d ∩ d === d
        @test d ∪ d === d
        @test d \ d === EmptySpace{T}()

        @test isclosedset(d)
        @test !isopenset(d)
        @test iscompact(d)

        @test convert(Domain, d) ≡ d
        @test convert(Domain{T}, d) ≡ d
        @test convert(AbstractInterval, d) ≡ d
        @test convert(AbstractInterval{T}, d) ≡ d
        @test convert(UnitInterval, d) ≡ d
        @test convert(UnitInterval{T}, d) ≡ d
        @test convert(Domain{Float64}, d) ≡ UnitInterval()
        @test convert(AbstractInterval{Float64}, d) ≡ UnitInterval()
        @test convert(UnitInterval{Float64}, d) ≡ UnitInterval()

        @test canonicaldomain(d) === d
    end
    @testset "ChebyshevInterval" begin
        d = ChebyshevInterval{T}()
        @test leftendpoint(d) == -one(T)
        @test rightendpoint(d) == one(T)
        @test minimum(d) == infimum(d) == leftendpoint(d)
        @test maximum(d) == supremum(d) == rightendpoint(d)

        # test for promotion
        @test intersect(0..1, ChebyshevInterval()) == 0..1

        @test d ∩ d === d
        @test d ∪ d === d
        @test d \ d === EmptySpace{T}()
        unit = UnitInterval{T}()
        @test d ∩ unit === unit
        @test unit ∩ d === unit
        @test d ∪ unit === d
        @test unit ∪ d === d
        @test unit \ d === EmptySpace{T}()
        @test -d == d

        @test isclosedset(d)
        @test !isopenset(d)
        @test iscompact(d)

        @test convert(Domain, d) ≡ d
        @test convert(Domain{T}, d) ≡ d
        @test convert(AbstractInterval, d) ≡ d
        @test convert(AbstractInterval{T}, d) ≡ d
        @test convert(ChebyshevInterval, d) ≡ d
        @test convert(ChebyshevInterval{T}, d) ≡ d
        @test convert(Domain{Float64}, d) ≡ ChebyshevInterval()
        @test convert(AbstractInterval{Float64}, d) ≡ ChebyshevInterval()
        @test convert(ChebyshevInterval{Float64}, d) ≡ ChebyshevInterval()

        @test canonicaldomain(d) === d

        show(io, ChebyshevInterval())
        @test String(take!(io)) == "$(-1.0..1.0) (Chebyshev)"
    end
    @testset "HalfLine" begin
        d = HalfLine{T}()
        d_open = PositiveRealLine{T}()
        @test d_open === HalfLine{T,:open}()
        @test leftendpoint(d) == zero(T)
        @test rightendpoint(d) == T(Inf)
        @test DomainSets.endpoints(d) == DomainSets.endpoints(d_open)
        @test minimum(d) == infimum(d) == leftendpoint(d)
        @test infimum(d_open) == leftendpoint(d_open)
        @test_throws ArgumentError minimum(d_open)
        @test supremum(d) == rightendpoint(d)
        @test supremum(d_open) == rightendpoint(d_open)
        @test_throws ArgumentError maximum(d)
        @test_throws ArgumentError maximum(d_open)

        @test d ∩ d === d
        @test d ∪ d === d
        @test d \ d == EmptySpace{T}()
        @test d_open ∩ d_open === d_open
        @test d_open ∪ d_open === d_open
        @test d_open \ d_open == EmptySpace{T}()
        @test d ∩ d_open === d_open
        @test d_open ∩ d === d_open
        @test d ∪ d_open === d
        @test d_open ∪ d === d
        unit = UnitInterval{T}()
        cheb = ChebyshevInterval{T}()
        @test d ∩ unit === unit
        @test unit ∩ d === unit
        @test d ∩ cheb === unit
        @test cheb ∩ d === unit
        @test d ∪ unit === d
        @test unit ∪ d === d
        @test unit \ d === EmptySpace{T}()

        @test !isclosedset(d)
        @test !isopenset(d)
        @test !iscompact(d)
        @test 1. ∈ d
        @test -1. ∉ d
        @test approx_in(-0.1, d, 0.5)
        @test !approx_in(-0.5, d, 0.1)
        @test similar_interval(d, T(0), T(Inf)) == d

        @test 2d isa MappedDomain
        @test -2d isa MappedDomain

        @test boundary(d) == Point(0)
        @test leftendpoint(d) ∈ ∂(d)
        @test rightendpoint(d) ∉ ∂(d)
        @test choice(d) == 0
        @test choice(d_open) == 1

        @test isopenset(d_open)
        @test !isclosedset(d_open)
        @test boundary(d_open) == boundary(d)
        @test 1 ∈ d_open
        @test 0 ∉ d_open
        @test interior(d) == d_open
        @test closure(d_open) == d

        show(io, HalfLine())
        @test String(take!(io)) == "0.0 .. Inf (closed-open) (HalfLine)"
    end
    @testset "NegativeHalfLine" begin
        d = NegativeHalfLine{T}()
        d_closed = NonpositiveRealLine{T}()
        @test d_closed == NegativeHalfLine{T,:closed}()
        @test leftendpoint(d) == -T(Inf)
        @test rightendpoint(d) == zero(T)
        @test infimum(d) == leftendpoint(d)
        @test supremum(d) == rightendpoint(d)
        @test_throws ArgumentError minimum(d)
        @test_throws ArgumentError maximum(d)
        @test_throws ArgumentError minimum(d_closed)
        @test maximum(d_closed) == supremum(d_closed) == rightendpoint(d_closed)

        @test d ∩ d === d
        @test d ∪ d === d
        @test d \ d == EmptySpace{T}()
        halfline = HalfLine{T}()
        halfline_open = HalfLine{T,:open}()
        @test isempty(d ∩ halfline)
        @test d ∩ halfline === EmptySpace{T}()
        @test d ∩ halfline_open === EmptySpace{T}()
        @test d_closed ∩ halfline == Point(zero(T))
        @test halfline ∩ d === EmptySpace{T}()
        @test d ∪ halfline === RealLine{T}()
        @test halfline ∪ d === RealLine{T}()
        @test d_closed ∪ halfline === RealLine{T}()
        @test halfline ∪ d_closed === RealLine{T}()
        @test halfline_open ∪ d_closed === RealLine{T}()
        @test d_closed ∪ halfline_open === RealLine{T}()
        @test setdiffdomain(halfline, d) === halfline
        @test setdiffdomain(halfline, d_closed) === halfline_open
        unit = UnitInterval{T}()
        cheb = ChebyshevInterval{T}()
        @test unit ∩ d === EmptySpace{T}()
        @test d ∩ unit === EmptySpace{T}()
        @test unit \ d === unit
        @test cheb \ d === unit
        @test halfline \ d === halfline
        @test d \ unit === d
        @test d \ halfline === d

        @test !isclosedset(d)
        @test isopenset(d)
        @test !iscompact(d)
        @test -1. ∈ d
        @test 0 ∉ d
        @test 1. ∉ d
        @test approx_in(0.5, d, 1.)
        @test !approx_in(0.5, d, 0.4)
        @test similar_interval(d, T(-Inf), T(0)) == d

        @test 2d isa MappedDomain
        @test -2d isa MappedDomain

        @test boundary(d) == Point(0)
        @test leftendpoint(d) ∉ ∂(d)
        @test rightendpoint(d) ∈ ∂(d)
        @test choice(d) == -1
        @test choice(d_closed) == 0

        # additional tests for the right-closed negative half line
        @test !isrightopen(d_closed)
        @test !isopenset(d_closed)
        @test boundary(d_closed) == boundary(d)
        @test -1 ∈ d_closed
        @test 0 ∈ d_closed
        @test interior(d_closed) == d
        @test closure(d) == d_closed

        show(io, NegativeHalfLine())
        @test String(take!(io)) == "-Inf .. 0.0 (open) (NegativeHalfLine)"
    end

    @testset "RealLine" begin
        @test RealLine() isa RealLine{Float64}
        d = RealLine{T}()
        @test isopenset(d)
        @test DomainSets.isfullspace(d)
        @test 1 ∈ d
        @test choice(d) ∈ d
        @test choice(d) isa T
        @test isempty(boundary(d))
        @test interior(d) == d
        @test_throws ArgumentError minimum(d)
        @test_throws ArgumentError maximum(d)
        @test interior(d) == d
        @test DomainSets.similardomain(d, widen(T)) isa RealLine{widen(T)}
        @test setdiffdomain(d, NonnegativeRealLine{T}()) === NegativeRealLine{T}()
        @test setdiffdomain(d, PositiveRealLine{T}()) === NonpositiveRealLine{T}()
        @test setdiffdomain(d, NonpositiveRealLine{T}()) === PositiveRealLine{T}()
        @test setdiffdomain(d, NegativeRealLine{T}()) === NonnegativeRealLine{T}()

        @test similar_interval(d, T(-Inf), T(Inf)) == d

        @test (0..1) ∩ d == 0..1
        @test d ∩ (0..1) == 0..1
        @test (0..1) ∪ d == d
        @test d ∪ (0..1) == d
    end

    @testset "OpenInterval" begin
        d = OpenInterval(0.0,1.0)
        @test isopenset(d)
        @test closure(d) == UnitInterval()

        @test leftendpoint(d) ∈ ∂(d)
        @test rightendpoint(d) ∈ ∂(d)

        @test canonicaldomain(d) == OpenInterval(-1,1)
        @test canonicaldomain(OpenInterval(0,1)) isa OpenInterval{Int}
        @test canonicaldomain(OpenInterval(0,0)) == EmptySpace()
        @test canonicaldomain(OpenInterval(2,Inf)) == DomainSets.PositiveRealLine()
        @test mapfrom_canonical(OpenInterval(2,Inf)) isa AffineMap
        @test canonicaldomain(OpenInterval(-Inf,Inf)) == DomainSets.RealLine()
        @test canonicaldomain(OpenInterval(Inf,-Inf)) == DomainSets.RealLine()
        @test canonicaldomain(OpenInterval(Inf,Inf)) === EmptySpace{Float64}()

        @test isempty(boundary(OpenInterval(0,0)))
        @test length(corners(OpenInterval(0,0))) == 0
    end
    @testset "Halfopen intervals" begin
        d1 = Interval{:closed,:open}(0.0,1.0)
        @test closure(d1) == 0..1
        @test leftendpoint(d1) ∈ ∂(d1)
        @test rightendpoint(d1) ∈ ∂(d1)
        d2 = Interval{:open,:closed}(0,1)
        @test closure(d2) == 0..1
        @test leftendpoint(d2) ∈ ∂(d2)
        @test rightendpoint(d2) ∈ ∂(d2)

        @test canonicaldomain(Interval{:closed,:open}(0,1)) isa Interval{:closed,:open,Int}
        @test canonicaldomain(Interval{:open,:closed}(0,1)) isa Interval{:open,:closed,Int}

        @test canonicaldomain(Interval{:closed,:open}(0,1)) == Interval{:closed,:open}(-1,1)
        @test canonicaldomain(Interval{:open,:closed}(0,1)) == Interval{:open,:closed}(-1,1)
        @test canonicaldomain(Interval{:closed,:open}(0,0)) == EmptySpace()
        @test canonicaldomain(Interval{:open,:closed}(0,0)) == EmptySpace()
        @test canonicaldomain(Interval{:closed,:open}(0,Inf)) == HalfLine()
        @test canonicaldomain(Interval{:open,:closed}(-Inf,0)) == HalfLine()
        @test_throws ArgumentError canonicaldomain(Interval{:closed,:open}(Inf,0))
        @test_throws ArgumentError canonicaldomain(Interval{:open,:closed}(0,Inf))
    end

    @testset "Integer intervals" begin
        d1 = 0..1
        @test leftendpoint(d1) ∈ ∂(d1)
        @test rightendpoint(d1) ∈ ∂(d1)

        d2 = Interval{:open,:closed}(0,1)
        @test leftendpoint(d2) ∈ ∂(d2)
        @test rightendpoint(d2) ∈ ∂(d2)
        @test closure(d2) == 0..1
        @test choice(d2) == 1

        d3 = Interval{:closed,:open}(0,1)
        @test leftendpoint(d3) ∈ ∂(d3)
        @test rightendpoint(d3) ∈ ∂(d3)
        @test closure(d3) == 0..1
        @test choice(d3) == 0

        d4 = Interval{:open,:open}(0,1)
        @test_throws BoundsError choice(d4)
    end

    @testset "approximate in for open and closed intervals" begin
        @test !approx_in(1.0, Interval{:open,:open}(0,1), 0)
        @test !approx_in(1.0, Interval{:closed,:open}(0,1), 0)
        @test !approx_in(0.0, Interval{:open,:open}(0,1), 0)
        @test !approx_in(0.0, Interval{:open,:closed}(0,1), 0)
        @test approx_in(0.0, Interval{:closed,:closed}(0,1), 0)
        @test approx_in(1.0, Interval{:closed,:closed}(0,1), 0)
    end

    @testset "mapping between intervals" begin
        @test canonicaldomain(UnitInterval()) == UnitInterval()
        m = mapto(2..3, ChebyshevInterval())
        @test isaffinemap(m)
        @test m(2) ≈ -1
        @test m(3) ≈ 1
        m2 = mapto(4.0..6, 2..3)
        @test isaffinemap(m2)
        @test m2(4) ≈ 2
        @test m2(6) ≈ 3
    end

    @test DomainSets.isinterval(0..1)
    @test !DomainSets.isinterval(UnitBall())

    @test typeof(UnitInterval{Float64}(0.0..1.0)) <: UnitInterval
    @test typeof(ChebyshevInterval{Float64}(-1.0..1.0)) <: ChebyshevInterval

    @testset "some mappings that preserve interval structure" begin
        # Translation
        d = zero(T)..one(T)

        @test -Interval{:closed,:open}(2,3) isa Interval{:open,:closed}

        d2 = d .+ one(T)
        @test typeof(d2) == typeof(d)
        @test leftendpoint(d2) == one(T)
        @test rightendpoint(d2) == 2*one(T)

        d2 = one(T) .+ d
        @test typeof(d2) == typeof(d)
        @test leftendpoint(d2) == one(T)
        @test rightendpoint(d2) == 2*one(T)

        d2 = d .- one(T)
        @test typeof(d2) == typeof(d)
        @test leftendpoint(d2) == -one(T)
        @test rightendpoint(d2) == zero(T)

        d2 = -d
        @test typeof(d2) == typeof(d)
        @test leftendpoint(d2) == -one(T)
        @test rightendpoint(d2) == zero(T)

        d2 = one(T) .- d
        @test d2 == d

        # translation for UnitInterval
        # Does a shifted unit interval return an interval?
        d = UnitInterval{T}()
        d2 = d .+ one(T)
        @test typeof(d2) <: AbstractInterval
        @test leftendpoint(d2) == one(T)
        @test rightendpoint(d2) == 2*one(T)

        d2 = one(T) .+ d
        @test typeof(d2) <: AbstractInterval
        @test leftendpoint(d2) == one(T)
        @test rightendpoint(d2) == 2*one(T)

        d2 = d .- one(T)
        @test typeof(d2) <: AbstractInterval
        @test leftendpoint(d2) == -one(T)
        @test rightendpoint(d2) == zero(T)

        d2 = -d
        @test typeof(d2) <: AbstractInterval
        @test leftendpoint(d2) == -one(T)
        @test rightendpoint(d2) == zero(T)

        d2 = one(T) .- d
        @test typeof(d2) <: AbstractInterval
        @test leftendpoint(d2) == zero(T)
        @test rightendpoint(d2) == one(T)


        # translation for ChebyshevInterval
        d = ChebyshevInterval{T}()
        d2 = d .+ one(T)
        @test typeof(d2) <: AbstractInterval
        @test leftendpoint(d2) == zero(T)
        @test rightendpoint(d2) == 2*one(T)

        d2 = one(T) .+ d
        @test typeof(d2) <: AbstractInterval
        @test leftendpoint(d2) == zero(T)
        @test rightendpoint(d2) == 2*one(T)

        d2 = d .- one(T)
        @test typeof(d2) <: AbstractInterval
        @test leftendpoint(d2) == -2one(T)
        @test rightendpoint(d2) == zero(T)

        @test -d == d

        d2 = one(T) .- d
        @test typeof(d2) <: AbstractInterval
        @test leftendpoint(d2) == zero(T)
        @test rightendpoint(d2) == 2one(T)
    end

    # Scaling
    d = zero(T)..one(T)
    d3 = T(2) * d
    @test typeof(d3) == typeof(d)
    @test leftendpoint(d3) == zero(T)
    @test rightendpoint(d3) == T(2)

    d3 = d * T(2)
    @test typeof(d3) == typeof(d)
    @test leftendpoint(d3) == zero(T)
    @test rightendpoint(d3) == T(2)

    d = zero(T)..one(T)
    d4 = d / T(2)
    @test typeof(d4) == typeof(d)
    @test leftendpoint(d4) == zero(T)
    @test rightendpoint(d4) == T(1)/T(2)

    d4 = T(2) \ d
    @test typeof(d4) == typeof(d)
    @test leftendpoint(d4) == zero(T)
    @test rightendpoint(d4) == T(1)/T(2)

    # Equality
    @test ChebyshevInterval() == ClosedInterval(-1.0,1.0) == ClosedInterval(-1,1)
    @test ChebyshevInterval() ≠ Interval{:closed,:open}(-1.0,1.0)
    @test ChebyshevInterval() ≈ ClosedInterval(-1.0,1.0)

    @testset "union and intersection of intervals" begin
        # Union and intersection of intervals
        i1 = zero(T)..one(T)
        i2 = one(T)/3 .. one(T)/2
        i3 = one(T)/2 .. 2*one(T)
        i4 = T(2) .. T(3)
        # - union of completely overlapping intervals
        du1 = uniondomain(i1, i2)
        @test typeof(du1) <: AbstractInterval
        @test leftendpoint(du1) == leftendpoint(i1)
        @test rightendpoint(du1) == rightendpoint(i1)
        @test uniondomain(0..1, 0.1..1.5) isa AbstractInterval{Float64}

        # - intersection of completely overlapping intervals
        du2 = intersectdomain(i1, i2)
        @test typeof(du2) <: AbstractInterval
        @test leftendpoint(du2) == leftendpoint(i2)
        @test rightendpoint(du2) == rightendpoint(i2)

        # - union of partially overlapping intervals
        du3 = uniondomain(i1, i3)
        @test typeof(du3) <: AbstractInterval
        @test leftendpoint(du3) == leftendpoint(i1)
        @test rightendpoint(du3) == rightendpoint(i3)

        @test uniondomain(OpenInterval(0,1), 0..2) == 0..2
        @test uniondomain(OpenInterval(0,1), OpenInterval(0,2)) == OpenInterval(0,2)
        @test uniondomain(1..2, 0..1.5) == 0..2.0
        @test uniondomain(1..2.5, 0.8..1.5) == 0.8..2.5
        @test uniondomain(1..2.5, 0.8..2.5) == 0.8..2.5
        @test uniondomain(OpenInterval(1,2.5), OpenInterval(0.8,2.5)) == OpenInterval(0.8,2.5)

        # - intersection of partially overlapping intervals
        du4 = intersectdomain(i1, i3)
        @test typeof(du4) <: AbstractInterval
        @test leftendpoint(du4) == leftendpoint(i3)
        @test rightendpoint(du4) == rightendpoint(i1)

        # - union of non-overlapping intervals
        du5 = UnionDomain((i1,)) ∪ UnionDomain((i4,))
        @test typeof(du5) <: UnionDomain

        # - intersection of non-overlapping intervals
        du6 = intersectdomain(i1, i4)
        @test isempty(du6)

        # - setdiff of intervals
        @test setdiffdomain(1.0..0.0, 2.0..3.0) == 1..0.0
        @test setdiffdomain(1.0..0.0, -3.0 .. -2.0) == 1..0.0
        @test setdiffdomain(1.0..1.0, 2.0..3) == 1.0..1.0
        @test setdiffdomain(1.0..1.0, 0.0..3) isa EmptySpace{Float64}
        @test setdiffdomain(1.0..2.0, 0.0..0.0) == 1.0..2.0
        @test setdiffdomain(1.0..2.0, 1.5..1.5) ==
            uniondomain(Interval{:closed,:open}(1,1.5), Interval{:open,:closed}(1.5,2))
        @test setdiffdomain(1.0..2.0, 0.0..0.5) == 1.0..2.0
        @test setdiffdomain(1.0..2.0, 2.5..3.0) == 1.0..2.0
        @test setdiffdomain(1.0..2.0, 0.0..3.0) == EmptySpace{Float64}()
        @test setdiffdomain(1.0..2.0, 2.0..3.0) == Interval{:closed,:open}(1.0..2.0)
        @test setdiffdomain(1.0..2.0, OpenInterval(2.0,3.0)) == Interval{:closed,:closed}(1.0..2.0)
        @test setdiffdomain(1.0..2.0, 1.5..3.0) == Interval{:closed,:open}(1,1.5)
        @test setdiffdomain(1.0..2.0, OpenInterval(1.5,3.0)) == 1.0..1.5
        @test setdiffdomain(1.0..2.0, 1.5..2.0) == Interval{:closed,:open}(1.0,1.5)
        @test setdiffdomain(1.0..2.0, OpenInterval(1.5,2.0)) == (1.0..1.5) ∪ Point(2.0)
        @test setdiffdomain(1.0..2.0, Interval{:closed,:open}(1.5,2.0)) == Interval{:closed,:open}(1.0..1.5) ∪ Point(2.0)
        @test setdiffdomain(0.0..3.0, 1.0..2.0) ==
            uniondomain(Interval{:closed,:open}(0.0,1.0), Interval{:open,:closed}(2.0,3.0))
        @test setdiffdomain(0.0..1.0, 0.0..2.0) isa EmptySpace{Float64}
        @test setdiffdomain(0.0..1.0, OpenInterval(0.0,2.0)) == Point(0.0)
        @test setdiffdomain(0.0..2.0, 0.0..1.0) == Interval{:open,:closed}(1.0, 2.0)
        @test setdiffdomain(0.0..2.0, OpenInterval(0.0,1.0)) ==
            uniondomain(Point(0.0), Interval{:closed,:closed}(1.0,2.0))
        @test setdiffdomain(0.0..1.0, 0.0..1.0) isa EmptySpace{Float64}
        @test setdiffdomain(0.0..1.0, OpenInterval(0.0,1.0)) == Point(0.0) ∪ Point(1.0)
        @test setdiffdomain(0.0..1.0, Interval{:closed,:open}(0.0,1.0)) == Point(1.0)
        @test setdiffdomain(0.0..1.0, Interval{:open,:closed}(0.0,1.0)) == Point(0.0)
        @test setdiffdomain(1.0..2.0, 0.0..1.0) == Interval{:open,:closed}(1.0,2.0)
        @test setdiffdomain(1.0..2.0, OpenInterval(0.0,1.0)) == 1.0..2.0
        @test setdiffdomain(1.0..2.0, 0.0..1.5) == Interval{:open,:closed}(1.5,2.0)
        @test setdiffdomain(1.0..2.0, OpenInterval(0.0,1.5)) == 1.5..2.0
        @test setdiffdomain(1.0..2.0, 0.0..2.0) == EmptySpace{Float64}()
        @test setdiffdomain(1.0..2.0, OpenInterval(0.0,2.0)) == Point(2.0)
    end

    @testset "conversion to domain" begin
        d = zero(T).. one(T)
        @test convert(Domain, d) ≡ d
        @test convert(Domain{Float32}, d) ≡ (0f0 .. 1f0)
        @test convert(Domain{Float64}, d) ≡ (0.0 .. 1.0)
        @test convert(Domain, zero(T)..one(T)) ≡ d
        @test convert(Domain{T}, zero(T)..one(T)) ≡ d
    end

    @testset "operations on special intervals" begin
        @test isempty(UnitInterval() \ UnitInterval())
        @test ChebyshevInterval() ∩ UnitInterval() === UnitInterval()
        @test UnitInterval() ∩ ChebyshevInterval() === UnitInterval()
        @test UnitInterval() ∩ NonnegativeRealLine() === UnitInterval()
        @test NonnegativeRealLine() ∩ UnitInterval() === UnitInterval()
        @test isempty(UnitInterval() ∩ NegativeRealLine())
        @test isempty(NegativeRealLine() ∩ UnitInterval())
        @test ChebyshevInterval() ∩ NonnegativeRealLine() === UnitInterval()
        @test NonnegativeRealLine() ∩ ChebyshevInterval() === UnitInterval()
        @test isempty(HalfLine() ∩ NegativeRealLine())
        @test isempty(NegativeRealLine() ∩ HalfLine())
        @test NonpositiveRealLine() ∩ NonnegativeRealLine() == Point(0)
        @test NonnegativeRealLine() ∩ NonpositiveRealLine() == Point(0)
        @test NonnegativeRealLine() ∩ PositiveRealLine() === PositiveRealLine()
        @test PositiveRealLine() ∩ NonnegativeRealLine() === PositiveRealLine()
        @test (0..1) ∩ RealLine() == (0..1)
        @test OpenInterval(0,1) ∩ RealLine() == OpenInterval(0,1)
        @test RealLine() ∩ (0..1) == (0..1)
        @test RealLine() ∩ OpenInterval(0,1) == OpenInterval(0,1)
        @test RealLine() ∩ RealLine() == RealLine()

        @test UnitInterval() ∪ ChebyshevInterval() === ChebyshevInterval()
        @test ChebyshevInterval() ∪ UnitInterval() === ChebyshevInterval()
        @test UnitInterval() ∪ NonnegativeRealLine() === NonnegativeRealLine()
        @test NonnegativeRealLine() ∪ UnitInterval() === NonnegativeRealLine()
        @test NonnegativeRealLine() ∪ NonpositiveRealLine() === RealLine()
        @test NonpositiveRealLine() ∪ NonnegativeRealLine() === RealLine()
        @test PositiveRealLine() ∪ NonpositiveRealLine() === RealLine()
        @test NonpositiveRealLine() ∪ PositiveRealLine() === RealLine()
        @test NegativeRealLine() ∪ NonnegativeRealLine() === RealLine()
        @test NonnegativeRealLine() ∪ NegativeRealLine() === RealLine()
        @test NonnegativeRealLine() ∪ PositiveRealLine() === NonnegativeRealLine()
        @test PositiveRealLine() ∪ NonnegativeRealLine() === NonnegativeRealLine()
        @test NonpositiveRealLine() ∪ NegativeHalfLine() === NonpositiveRealLine()
        @test NegativeHalfLine() ∪ NonpositiveRealLine() === NonpositiveRealLine()
        @test NonpositiveRealLine() ∪ NonpositiveRealLine() === NonpositiveRealLine()
        @test RealLine() ∪ RealLine() === RealLine()
        @test uniondomain(0..1, RealLine()) === RealLine()
        @test uniondomain(OpenInterval(0,1), RealLine()) === RealLine()
        @test uniondomain(RealLine(), 0..1) === RealLine()
        @test uniondomain(RealLine(), OpenInterval(0,1)) === RealLine()

        @test isempty(UnitInterval() \ ChebyshevInterval())
        @test isempty(UnitInterval() \ NonnegativeRealLine())
        @test UnitInterval() \ NegativeRealLine() === UnitInterval()
        @test ChebyshevInterval() \ NegativeRealLine() === UnitInterval()
        @test HalfLine() \ NegativeRealLine() === HalfLine()
        @test HalfLine() \ NonpositiveRealLine() === HalfLine{T,:open}()
        @test NegativeRealLine() \ UnitInterval() === NegativeRealLine()
        @test NegativeHalfLine() \ PositiveRealLine() === NegativeHalfLine()
        @test NegativeHalfLine() \ NonnegativeRealLine() === NegativeRealLine()
        @test RealLine() \ NonnegativeRealLine() === NegativeRealLine()
        @test RealLine() \ PositiveRealLine() === NonpositiveRealLine()
        @test RealLine() \ NonpositiveRealLine() === PositiveRealLine()
        @test RealLine() \ NegativeRealLine() === NonnegativeRealLine()

        @test issubset(UnitInterval{T}(), ChebyshevInterval{T}())
    end
end

###########################
# An n-dimensional simplex
###########################

"Supertype of an N-dimensional simplex."
abstract type Simplex{T,C} <: Domain{T} end

isclosedset(::Simplex{T,:closed}) where {T} = true
isclosedset(::Simplex{T,:open}) where {T} = false

isopenset(d::Simplex) = !isclosedset(d)

"""
    UnitSimplex{T,C}

A polytope with the origin and all unit vectors as vertices.
"""
abstract type UnitSimplex{T,C} <: Simplex{T,C} end

const ClosedUnitSimplex{T} = UnitSimplex{T,:closed}
const OpenUnitSimplex{T} = UnitSimplex{T,:open}

"""
    UnitSimplex([dim::Int])
    UnitSimplex{T}([dim::Int])
    UnitSimplex{T,C=:closed}([dim::Int])

The open or closed volume of all points of type `x`, for which the sum of
components is smaller than (or equal to) 1.

The unit simplex has the origin and all Euclidean unit vector as vertices.
"""
UnitSimplex(::Val{N} = Val(3)) where {N} = EuclideanUnitSimplex{N}()
UnitSimplex(dim::Int) = DynamicUnitSimplex(dim)

UnitSimplex{T}(dim::Int) where {T <: StaticTypes} = StaticUnitSimplex{T}(dim)
UnitSimplex{T}(::Val{N}) where {N,T} = StaticUnitSimplex{T}(Val(N))
UnitSimplex{T}() where {T <: StaticTypes} = StaticUnitSimplex{T}()
UnitSimplex{T}(dim::Int) where {T} = DynamicUnitSimplex{T}(dim)

UnitSimplex{T,C}(dim::Int) where {T <: StaticTypes,C} = StaticUnitSimplex{T,C}(dim)
UnitSimplex{T,C}(::Val{N}) where {N,T,C} = StaticUnitSimplex{T,C}(Val(N))
UnitSimplex{T,C}() where {T <: StaticTypes,C} = StaticUnitSimplex{T,C}()
UnitSimplex{T,C}(dim::Int) where {T,C} = DynamicUnitSimplex{T,C}(dim)

insimplex_closed(x) = mapreduce( t-> t >= 0, &, x) && norm(x,1) <= 1
insimplex_open(x) = mapreduce( t-> t > 0, &, x) && norm(x,1) < 1
insimplex_closed(x, tol) = mapreduce( t-> t >= -tol, &, x) && norm(x,1) <= 1+tol
insimplex_open(x, tol) = mapreduce( t-> t > -tol, &, x) && norm(x,1) < 1+tol

indomain(x, d::ClosedUnitSimplex) = length(x)==dimension(d) && insimplex_closed(x)
indomain(x, d::OpenUnitSimplex) = length(x)==dimension(d) && insimplex_open(x)
approx_indomain(x, d::ClosedUnitSimplex, tolerance) = length(x)==dimension(d) && insimplex_closed(x, tolerance)
approx_indomain(x, d::OpenUnitSimplex, tolerance) = length(x)==dimension(d) && insimplex_open(x, tolerance)

isempty(::UnitSimplex) = false

isequaldomain(d1::UnitSimplex, d2::UnitSimplex) =
    isclosedset(d1)==isclosedset(d2) && dimension(d1)==dimension(d2)
domainhash(d::UnitSimplex, h::UInt) = hashrec("UnitSimplex", isclosedset(d), dimension(d), h)

boundingbox(d::UnitSimplex{T}) where {T} = UnitCube{T}(dimension(d))

# TODO: implement when segments are available
# distance_to(d::UnitSimplex, x) = x ∈ d ? zero(prectype(d)) : minimum(distance_to(el, x) for el in components(boundary(d)))

function normal(d::UnitSimplex, x)
    z = similar(x)
    fill!(z, 0)
    if sum(x) ≈ 1
        fill!(z, one(eltype(z))/sqrt(length(z)))
    else
        index = findmin(x)[2]
        z[index] = -1
    end
    return convert(eltype(d), z/norm(z))
end


"A unit simplex whose dimension is determined by its element type."
struct StaticUnitSimplex{T,C} <: UnitSimplex{T,C}
end

StaticUnitSimplex(::Val{N}) where {N} = StaticUnitSimplex{SVector{N,Float64}}()

StaticUnitSimplex{T}() where {T} = StaticUnitSimplex{T,:closed}()

StaticUnitSimplex{T}(dim::Int) where {T} =
    (@assert dim == euclideandimension(T); StaticUnitSimplex{T}())
StaticUnitSimplex{T}(::Val{N}) where {N,T} =
    (@assert N == euclideandimension(T); StaticUnitSimplex{T}())

StaticUnitSimplex{T,C}(dim::Int) where {T,C} =
    (@assert dim == euclideandimension(T); StaticUnitSimplex{T,C}())
StaticUnitSimplex{T,C}(::Val{N}) where {N,T,C} =
    (@assert N == euclideandimension(T); StaticUnitSimplex{T,C}())

const EuclideanUnitSimplex{N,T,C} = StaticUnitSimplex{SVector{N,T},C}

EuclideanUnitSimplex{N}() where {N} = EuclideanUnitSimplex{N,Float64}()

## A StaticUnitSimplex{<:Number} equals the interval [0,1]  (open or closed)
AbstractInterval(d::StaticUnitSimplex{T,:closed}) where {T <: Number} = UnitInterval{T}()
AbstractInterval(d::StaticUnitSimplex{T,:open}) where {T <: Number} = OpenInterval{T}(0, 1)

convert(::Type{AbstractInterval}, d::StaticUnitSimplex{T}) where {T <: Number} =
	AbstractInterval(d)

canonicaldomain(d::StaticUnitSimplex{T}) where {T<:Number} = AbstractInterval(d)
canonicaldomain(::Equal, d::StaticUnitSimplex{T}) where {T<:Number} = AbstractInterval(d)

boundary(d::StaticUnitSimplex{T}) where {T<:Number} = boundary(AbstractInterval(d))


"A unit simplex with vector elements with variable dimension determined by a field."
struct DynamicUnitSimplex{T,C} <: UnitSimplex{T,C}
    dimension   ::  Int

    DynamicUnitSimplex{T,C}(dim::Int) where {T,C} = new(dim)
    DynamicUnitSimplex{T,C}(dim::Int) where {T<:StaticTypes,C} =
        (@assert dim == euclideandimension(T); new(dim))
end

DynamicUnitSimplex(dim::Int) = DynamicUnitSimplex{Vector{Float64}}(dim)
DynamicUnitSimplex{T}(dim::Int) where {T} = DynamicUnitSimplex{T,:closed}(dim)

dimension(d::DynamicUnitSimplex) = d.dimension

const VectorUnitSimplex{T,C} = DynamicUnitSimplex{Vector{T},C}

VectorUnitSimplex(dimension) = VectorUnitSimplex{Float64}(dimension)

show(io::IO, d::EuclideanUnitSimplex{N,Float64,:closed}) where {N} = print(io, "UnitSimplex(Val($(N)))")
show(io::IO, d::VectorUnitSimplex{Float64,:closed}) = print(io, "UnitSimplex($(dimension(d)))")


center(d::EuclideanUnitSimplex{N,T}) where {N,T} = ones(SVector{N,T})/N
center(d::VectorUnitSimplex{T}) where {T} = ones(T, dimension(d))/dimension(d)

corners(d::UnitSimplex) = vcat([origin(d)], [ unitvector(d, i) for i in 1:dimension(d)])
# low-dimensional special cases
corners(d::EuclideanUnitSimplex{1,T}) where T =
	SVector{2,SVector{1,T}}(SA[0],SA[1])
corners(d::EuclideanUnitSimplex{2,T}) where T =
	SVector{3,SVector{2,T}}(SA[0,0],SA[1,0],SA[0,1])
corners(d::EuclideanUnitSimplex{3,T}) where T =
	SVector{4,SVector{3,T}}(SA[0,0,0],SA[1,0,0],SA[0,1,0],SA[0,0,1])
corners(d::EuclideanUnitSimplex{4,T}) where T =
	SVector{5,SVector{4,T}}(SA[0,0,0,0],SA[1,0,0,0],SA[0,1,0,0],SA[0,0,1,0],SA[0,0,0,1])

interior(d::EuclideanUnitSimplex{N,T}) where {N,T} = EuclideanUnitSimplex{N,T,:open}()
closure(d::EuclideanUnitSimplex{N,T}) where {N,T} = EuclideanUnitSimplex{N,T,:closed}()
interior(d::VectorUnitSimplex{T}) where {T} = VectorUnitSimplex{T,:open}(dimension(d))
closure(d::VectorUnitSimplex{T}) where {T} = VectorUnitSimplex{T,:closed}(dimension(d))


# We pick the center point, because it belongs to the domain regardless of
# whether it is open or closed.
choice(d::UnitSimplex) = center(d)

similardomain(d::StaticUnitSimplex{S,C}, ::Type{T}) where {S,T,C} =
    StaticUnitSimplex{T,C}()
similardomain(d::DynamicUnitSimplex{S,C}, ::Type{T}) where {S,T,C} =
    DynamicUnitSimplex{T,C}(d.dimension)


simplex_face_map(a::Number, b::Number, c::StaticVector{2}, d::StaticVector{2}) =
	AffineMap((d-c)/(b-a), c - (d-c)/(b-a)*a)
function simplex_face_map(a::Number, b::Number, c::Vector, d::Vector)
	@assert length(c) == length(d) == 2
	AffineMap((d-c)/(b-a), c - (d-c)/(b-a)*a)
end

function boundary(d::StaticUnitSimplex{<:StaticVector{2,T}}) where T
    d0 = UnitInterval{T}()
	T0 = zero(T)
	T1 = one(T)
	maps = [
		simplex_face_map(T0, T1, SVector(T0,T0), SVector(T1,T0)),
		simplex_face_map(T0, T1, SVector(T1,T0), SVector(T0,T1)),
		simplex_face_map(T0, T1, SVector(T0,T1), SVector(T0,T0))
	]
	faces = map(m -> ParametricDomain(m, d0), maps)
	UnionDomain(faces)
end

# function boundary(d::StaticUnitSimplex{<:StaticVector{N,T},:closed}) where {N,T}
# 	left2 = infimum(d)
# 	right2 = supremum(d)
# 	d0 = UnitSimplex{SVector{N-1,T},:closed}()
# 	T0 = zero(T)
# 	T1 = one(T)
#
# 	map1 = cube_face_map(left1, right1, left2, right2, 1, left2[1])
# 	MAP = typeof(map1)
# 	maps = MAP[]
# 	for dim in 1:N
# 		push!(maps, cube_face_map(left1, right1, left2, right2, dim, left2[dim]))
# 		push!(maps, cube_face_map(left1, right1, left2, right2, dim, right2[dim]))
# 	end
# 	faces = map(m -> ParametricDomain(m, d_unit), maps)
# 	UnionDomain(faces)
# end

using DomainSets, StaticArrays
using CairoMakie: plot, plot!
using DomainSets: Sphere


##
# 2D
##
p = plot(cartesianproduct(0..1, 1..2))
plot!(UnitDisk())
plot!(Sphere(2.0, SVector(1.0, 0.5)))
plot!(Sphere(3.0, [1.0, 0.5]))
plot!(Point(SVector(2,3)))
p



##
# 3D
##
p = plot(cartesianproduct(0..1, 1..2, 3..4))
plot!(UnitBall())
plot!(Sphere(2.0, SVector(1.0, 0.5,0.5)))
plot!(Sphere(3.0, [1.0, 0.5,0.5]))
p

# The union, intersection and difference of domains are represented with lazy domains.

issubset(d1::AnyDomain, d2::AnyDomain) = issubset_domain(domain(d1), domain(d2))

issubset_domain(d1, d2) =
	promotable_domains(d1, d2) && issubset1(promote_domains(d1, d2)...)

issubset1(d1, d2) = simplifies(d1) ? issubset_domain(simplify(d1),d2) : issubset2(d1, d2)
issubset2(d1, d2) = simplifies(d2) ? issubset_domain(d1, simplify(d2)) : default_issubset_domain(d1, d2)

default_issubset_domain(d1, d2) = d1 == d2
# this last fallback is only an approximation of the truth: if d1 equals d2, then
# d1 is a subset of d2, but the reverse is not true. So we might be returning false
# even when the correct mathematical answer is true.
# What `issubset` means in this package is:
# - if true: we are sure that d1 is a subset of d2
# - if false: either it really is false, or we don't really know

issubset1(d1::Number, d2) = in(d1, d2)
issubset1(d1::AbstractArray, d2) = all(in(d2), d1)
issubset1(d1::AbstractSet, d2) = all(in(d2), d1)
# use Julia's implementation for Julia types
issubset_domain(d1::BaseDomainType, d2::BaseDomainType) = issubset(d1, d2)


############################
# The union of two domains
############################

"""
	UnionDomain(domains...)
	UnionDomain{T}(domains...)

The lazy union of the given domains.

See also: [`uniondomain`](@ref).
"""
struct UnionDomain{T,DD} <: CompositeDomain{T}
	domains	::	DD
end

UnionDomain() = throw(ArgumentError("Can't create an empty UnionDomain."))
UnionDomain(domains...) = UnionDomain(domains)
UnionDomain(domains) = _UnionDomain(promote_domains(domains))
_UnionDomain(domains) = _UnionDomain(domaineltype(first(domains)), domains)

UnionDomain{T}(domains...) where {T} = UnionDomain{T}(domains)
UnionDomain{T}(domains) where {T} = _UnionDomain(T, convert_eltype.(T, domains))
_UnionDomain(::Type{T}, domains) where {T} = UnionDomain{T,typeof(domains)}(domains)

# The union of domains corresponds to a logical OR of their characteristic functions
composition(d::UnionDomain) = Combination()
combine(d::UnionDomain, results) = reduce(|, results)

# Make d1 ∪ d2 invoke `uniondomain` if the arguments are domains
union(domains::AnyDomain...) =	uniondomain(map(domain, domains)...)

"""
	uniondomain(domains...)

Return a domain that agrees with the mathematical union of the arguments.

See also: [`UnionDomain`](@ref).
"""
uniondomain() = emptyspace(Any)
uniondomain(d1) = d1
uniondomain(d1, d2) = uniondomain1(promote_domains(d1, d2)...)
uniondomain1(d1, d2) = simplifies(d1) ? uniondomain(simplify(d1), d2) : uniondomain2(d1, d2)
uniondomain2(d1, d2) = simplifies(d2) ? uniondomain(d1, simplify(d2)) : default_uniondomain(d1, d2)

function default_uniondomain(d1, d2)
	if issubset_domain(d2, d1)
		d1
	elseif issubset_domain(d1, d2)
		d2
	else
		UnionDomain(d1, d2)
	end
end
uniondomain(d1::BaseDomainType, d2::BaseDomainType) = union(d1, d2)

uniondomain(d1, d2, d3) = _ud3(promote_domains(d1, d2, d3)...)
_ud3(d1, d2, d3) =
	_ud3(d1, d2, d3, uniondomain(d1, d2), uniondomain(d2, d3), uniondomain(d1, d3))
_ud3(d1, d2, d3, d12::UnionDomain, d23::UnionDomain, d13::UnionDomain) =
	uniondomain(d12, d3)
_ud3(d1, d2, d3, d12, d23::UnionDomain, d13::UnionDomain) =
	uniondomain(d12, d3)
_ud3(d1, d2, d3, d12::UnionDomain, d23, d13::UnionDomain) =
	uniondomain(d23, d1)
_ud3(d1, d2, d3, d12::UnionDomain, d23::UnionDomain, d13) =
	uniondomain(d13, d2)
_ud3(d1, d2, d3, d12::UnionDomain, d23, d13) =
	uniondomain(d23, d1)
_ud3(d1, d2, d3, d12, d23::UnionDomain, d13) =
	uniondomain(d12, d3)
_ud3(d1, d2, d3, d12, d23, d13::UnionDomain) =
	uniondomain(d12, d3)
_ud3(d1, d2, d3, d12, d23, d13) =
	uniondomain(d12, d3)

uniondomain(d1, d2, d3, domains...) = _ud(promote_domains(d1, d2, d3, domains...)...)
_ud(d1, d2, d3, domains...) = uniondomain(uniondomain(d1, d2, d3), domains...)

# avoid nested union domains
uniondomain(d1::UnionDomain, d2::UnionDomain) =
	d1 == d2 ? d1 : UnionDomain(collect(Set(components(d1)) ∪ Set(components(d2))))
uniondomain1(d1::UnionDomain, d2) = UnionDomain(components(d1)..., d2)
uniondomain2(d1, d2::UnionDomain) = UnionDomain(d1, components(d2)...)

isequaldomain(a::UnionDomain, b::UnionDomain) = Set(components(a)) == Set(components(b))
domainhash(d::UnionDomain, h::UInt) = hashrec("UnionDomain", Set(components(d)), h)


convert(::Type{Domain}, v::AbstractVector{<:Domain}) = UnionDomain(v)
convert(::Type{Domain}, v::AbstractSet{<:Domain}) = UnionDomain(v)
convert(::Type{Domain}, s::AbstractSet) = UnionDomain(map(Point,collect(s)))
convert(::Type{Domain{T}}, v::AbstractVector{<:Domain}) where {T} = UnionDomain{T}(v)
convert(::Type{Domain{T}}, v::AbstractSet{<:Domain}) where {T} = UnionDomain{T}(v)
convert(::Type{Domain{T}}, s::AbstractSet) where {T} = UnionDomain{T}(map(Point,collect(s)))

similardomain(d::UnionDomain, ::Type{T}) where {T} =
    UnionDomain(convert_eltype.(T, components(d)))



choice(d::UnionDomain) = convert(eltype(d), choice(component(d,1)))

isempty(d::UnionDomain) = all(isempty, d.domains)

interior(d::UnionDomain) = UnionDomain(map(interior, components(d)))
closure(d::UnionDomain) = UnionDomain(map(closure, components(d)))

boundingbox(d::UnionDomain) = unionbox(map(boundingbox, components(d))...)

boundary(d::UnionDomain) = uniondomain(map(boundary, components(d))...)

Display.combinationsymbol(d::UnionDomain) = Display.Symbol('∪')
Display.displaystencil(d::UnionDomain) = composite_displaystencil(d)
show(io::IO, mime::MIME"text/plain", d::UnionDomain) = Display.composite_show(io, mime, d)
show(io::IO, d::UnionDomain) = Display.composite_show_compact(io, d)

## algebra

# preserve the uniondomain when mapping
map_domain(map, domain::UnionDomain) = UnionDomain(map_domain.(Ref(map), components(domain)))
mapped_domain(map, domain::UnionDomain) = UnionDomain(mapped_domain.(Ref(map), components(domain)))


# TODO: what is the correct semantics for these functions? Should we have them?
Base.minimum(d::UnionDomain) = mapreduce(minimum, min, components(d))
Base.maximum(d::UnionDomain) = mapreduce(maximum, max, components(d))
infimum(d::UnionDomain) = mapreduce(infimum, min, components(d))
supremum(d::UnionDomain) = mapreduce(supremum, max, components(d))

setdiffdomain(d1::UnionDomain, d2::UnionDomain) =
	UnionDomain(setdiffdomain.(components(d1), Ref(d2)))
function setdiffdomain1(d1::UnionDomain, d2)
	if d2 ∈ components(d1)
		el = filter(x->x!=d2, components(d1))
		if length(el) == 0
			EmptySpace{domaineltype(d1)}()
		elseif length(el) == 1
			first(el)
		else
			UnionDomain(el)
		end
	else
		UnionDomain(setdiffdomain.(components(d1), Ref(d2)))
	end
end
setdiffdomain2(d1, d2::UnionDomain) =
	reduce(setdiffdomain, components(d2), init=d1)


##############################
# The intersection of domains
##############################


"""
	IntersectDomain(domains...)
	IntersectDomain{T}(domains...)

The lazy intersection of an iterable list of domains.

See also: [`intersectdomain`](@ref).
"""
struct IntersectDomain{T,DD} <: CompositeDomain{T}
    domains ::  DD
end

IntersectDomain(domains...) = IntersectDomain(domains)
IntersectDomain(domains) = _IntersectDomain(promote_domains(domains))
_IntersectDomain(domains) = IntersectDomain{domaineltype(first(domains))}(domains)

IntersectDomain{T}(domains...) where {T} = IntersectDomain{T}(domains)
IntersectDomain{T}(domains) where {T} = _IntersectDomain(T, convert_eltype.(T, domains))
_IntersectDomain(::Type{T}, domains) where {T} = IntersectDomain{T,typeof(domains)}(domains)

# The intersection of domains corresponds to a logical AND of their characteristic functions
composition(d::IntersectDomain) = Combination()
combine(d::IntersectDomain, results) = reduce(&, results)


# Make d1 ∩ d2 invoke `intersectdomain` if the arguments are Domains
intersect(domains::AnyDomain...) = intersectdomain(map(domain, domains)...)

"""
	intersectdomain(domains...)

Return a domain which agrees with the mathematical intersection of the given
domains.

See also: [`IntersectDomain`](@ref).
"""
intersectdomain() = emptyspace(Any)
intersectdomain(d1) = d1
intersectdomain(d1, d2) = intersectdomain1(promote_domains(d1, d2)...)

intersectdomain1(d1, d2) = simplifies(d1) ? intersectdomain(simplify(d1), d2) : intersectdomain2(d1, d2)
intersectdomain2(d1, d2) = simplifies(d2) ? intersectdomain(d1, simplify(d2)) : default_intersectdomain(d1, d2)

function default_intersectdomain(d1, d2)
	if issubset_domain(d2, d1)
		d2
	elseif issubset_domain(d1, d2)
		d1
	else
		IntersectDomain(d1, d2)
	end
end
intersectdomain(d1::BaseDomainType, d2::BaseDomainType) = intersect(d1, d2)

intersectdomain(d1, d2, d3) = _id3(promote_domains(d1, d2, d3)...)
_id3(d1, d2, d3) =
	_id3(d1, d2, d3, intersectdomain(d1, d2), intersectdomain(d2, d3), intersectdomain(d1, d3))
_id3(d1, d2, d3, d12::IntersectDomain, d23::IntersectDomain, d13::IntersectDomain) =
	intersectdomain(d12, d3)
_id3(d1, d2, d3, d12, d23::IntersectDomain, d13::IntersectDomain) =
	intersectdomain(d12, d3)
_id3(d1, d2, d3, d12::IntersectDomain, d23, d13::IntersectDomain) =
	intersectdomain(d23, d1)
_id3(d1, d2, d3, d12::IntersectDomain, d23::IntersectDomain, d13) =
	intersectdomain(d13, d2)
_id3(d1, d2, d3, d12::IntersectDomain, d23, d13) =
	intersectdomain(d23, d1)
_id3(d1, d2, d3, d12, d23::IntersectDomain, d13) =
	intersectdomain(d12, d3)
_id3(d1, d2, d3, d12, d23, d13::IntersectDomain) =
	intersectdomain(d12, d3)
_id3(d1, d2, d3, d12, d23, d13) =
	intersectdomain(d12, d3)

intersectdomain(d1, d2, d3, domains...) = _id(promote_domains(d1, d2, d3, domains...)...)
_id(d1, d2, d3, domains...) = intersectdomain(intersectdomain(d1, d2, d3), domains...)

# avoid nested intersect domains
intersectdomain(d1::IntersectDomain, d2::IntersectDomain) =
	d1 == d2 ? d1 : IntersectDomain(components(d1)..., components(d2)...)
intersectdomain1(d1::IntersectDomain, d2) = IntersectDomain(components(d1)..., d2)
intersectdomain2(d1, d2::IntersectDomain) = IntersectDomain(d1, components(d2)...)


function intersectdomain(d1::UnionDomain, d2::UnionDomain)
    d1 == d2 && return d1
    uniondomain(intersectdomain.(Ref(d1), components(d2))...)
end
intersectdomain1(d1::UnionDomain, d2) = uniondomain(intersectdomain.(d1.domains, Ref(d2))...)
intersectdomain2(d1, d2::UnionDomain) = uniondomain(intersectdomain.(Ref(d1), d2.domains)...)

(&)(d1::AnyDomain, d2::AnyDomain) = intersectdomain(domain(d1),domain(d2))

function intersectdomain(d1::ProductDomain, d2::ProductDomain)
	if compatibleproductdims(d1, d2)
        ProductDomain(map(intersectdomain, components(d1), components(d2)))
    else
        IntersectDomain(d1, d2)
    end
end

similardomain(d::IntersectDomain, ::Type{T}) where {T} =
    IntersectDomain(convert_eltype.(T, components(d)))

isequaldomain(a::IntersectDomain, b::IntersectDomain) = Set(components(a)) == Set(components(b))
domainhash(d::IntersectDomain, h::UInt) = hashrec("IntersectDomain", Set(components(d)), h)

boundingbox(d::IntersectDomain) = intersectbox(map(boundingbox, components(d))...)

Display.combinationsymbol(d::IntersectDomain) = Display.Symbol('∩')
Display.displaystencil(d::IntersectDomain) = composite_displaystencil(d)
show(io::IO, mime::MIME"text/plain", d::IntersectDomain) = Display.composite_show(io, mime, d)
show(io::IO, d::IntersectDomain) = Display.composite_show_compact(io, d)


#########################################
### The difference between two domains
#########################################


"""
	SetdiffDomain(d1, d2)
	SetdiffDomain{T}(d1, d2)

The lazy set difference of the given domains.

See also: [`setdiffdomain`](@ref).
"""
struct SetdiffDomain{T,DD} <: CompositeDomain{T}
    domains	::	DD
	function SetdiffDomain{T,DD}(domains::DD) where {T,DD}
		@assert length(domains) == 2
		new(domains)
	end
end

SetdiffDomain(d1, d2) = _SetdiffDomain(promote_domains((d1, d2))...)
_SetdiffDomain(d1, d2) = SetdiffDomain{domaineltype(d1)}((d1,d2))
SetdiffDomain{T}(domains) where {T} = SetdiffDomain{T,typeof(domains)}(domains)

# The difference between two domains corresponds to a logical AND NOT of their characteristic functions
composition(d::SetdiffDomain) = Combination()
combine(d::SetdiffDomain, results) = results[1] & !results[2]

# It is difficult to calculate approximate membership exactly, but we can at
# least not enlarge the subtracted domain by invoking in rather than approx_in on it.
_composite_approx_indomain(x, d::SetdiffDomain, tolerance, comp::Combination, domains) =
    approx_in(x, domains[1], tolerance) & !in(x, domains[2])

similardomain(d::SetdiffDomain, ::Type{T}) where {T} =
    SetdiffDomain(convert_eltype(T, d.domains[1]), convert_eltype(T, d.domains[2]))

# use \ as a synomym for setdiff, in the context of domains (though, generically,
# \ means left division in Julia)
\(d1::AnyDomain, d2::AnyDomain) = setdiffdomain(domain(d1), domain(d2))

# Make setdiff invoke `setdiffdomain` if the arguments are domains
setdiff(d1::AnyDomain, d2::AnyDomain) = setdiffdomain(domain(d1), domain(d2))

"""
	setdiffdomain(d1, d2)

Return a domain which agrees with the mathematical difference of the given domains.

See also: [`SetdiffDomain`](@ref).
"""
setdiffdomain(d1, d2) = setdiffdomain1(promote_domains(d1, d2)...)
setdiffdomain1(d1, d2) = simplifies(d1) ? setdiffdomain(simplify(d1), d2) : setdiffdomain2(d1, d2)
setdiffdomain2(d1, d2) = simplifies(d2) ? setdiffdomain(d1, simplify(d2)) : default_setdiffdomain(d1, d2)

function default_setdiffdomain(d1, d2)
	if isempty(d2)
		d1
	elseif issubset_domain(d1,d2)
		emptyspace(d1)
	else
		SetdiffDomain(d1, d2)
	end
end
setdiffdomain(d1::BaseDomainType, d2::BaseDomainType) = setdiff(d1, d2)

# avoid nested difference domains
setdiffdomain1(d1::SetdiffDomain, d2) = setdiffdomain(d1.domains[1], uniondomain(d2, d1.domains[2]))

isequaldomain(a::SetdiffDomain, b::SetdiffDomain) = components(a) == components(b)
domainhash(d::SetdiffDomain, h::UInt) = hashrec("SetdiffDomain", components(d), h)

boundingbox(d::SetdiffDomain) =  boundingbox(d.domains[1])

Display.combinationsymbol(d::SetdiffDomain) = Display.Symbol('\\')
Display.displaystencil(d::SetdiffDomain) = composite_displaystencil(d)
show(io::IO, mime::MIME"text/plain", d::SetdiffDomain) = Display.composite_show(io, mime, d)
show(io::IO, d::SetdiffDomain) = Display.composite_show_compact(io, d)

module FunctionMapsTests

using Test, LinearAlgebra, StaticArrays
using CompositeTypes, CompositeTypes.Indexing

include("using_fmaps2.jl")

include("test_common.jl")
include("test_interface.jl")

include("test_generic.jl")
include("test_basic.jl")
include("test_affine.jl")
include("test_product.jl")
include("test_maps.jl")
include("test_arithmetics.jl")

end

module DomainSets

using CompositeTypes, CompositeTypes.Display, CompositeTypes.Indexing
using IntervalSets
using LinearAlgebra
using StaticArrays
using FunctionMaps

################################
## Exhaustive list of imports
################################

import Base:
    ==, isapprox,
    # Set operations
    setdiff, in, isempty, issubset, intersect, union, &, \,
    # Arrays
    eltype, hash, isreal,
    # Types, promotions and conversions
    convert, promote,
    # for maps (both deprecated and to be removed)
    size, inv,
    # Display
    show

import CompositeTypes: component, components

import IntervalSets: (..), endpoints, Domain, AbstractInterval, TypedEndpointsInterval,
                        leftendpoint, rightendpoint, isleftopen, isleftclosed,
                        isrightopen, isrightclosed, isopenset, isclosedset,
                        infimum, supremum
export ..

# to be removed in breaking version 0.8
import LinearAlgebra: cross, ×, pinv


################################
## Exhaustive list of exports
################################

## Utils

# from util/common.jl
export prectype, numtype,
    convert_numtype, promote_numtype,
    convert_prectype, promote_prectype,
    iscomposite, component, components, ncomponents

## Maps

include("maps_imports.jl")

# from maps/map.jl
export AbstractMap, Map, MapRef, TypedMap,
    applymap, isequalmap,
    domaintype, codomaintype,
    inverse, leftinverse, rightinverse,
    mapsize, mapdim,           # mapdim is deprecated
    jacobian, jacdet, diffvolume,
    isrealmap
# from maps/composite.jl
export ComposedMap, composedmap
# from maps/product.jl
export ProductMap, productmap
# from maps/basic.jl
export IdentityMap,
    StaticIdentityMap, VectorIdentityMap,
    ZeroMap, UnityMap, ConstantMap,
    isconstant, constant,       # deprecated
    isconstantmap, mapconstant,
    isidentity, isidentitymap   # isidentity is deprecated
# from maps/affine.jl
export AffineMap, Translation, LinearMap,
    affinematrix, affinevector,
    islinear, isaffine,         # deprecated
    islinearmap, isaffinemap

## Generic domains

# from generic/domain.jl
export Domain, EuclideanDomain, VectorDomain,
    dimension,
    approx_in,
    isopenset, isclosedset, iscompact,
    boundary, ∂,
    interior, closure,
    isrealdomain,
    choice

# from generic/geometry.jl
export boundingbox,
    volume,
    normal, tangents,
    distance_to,
    infimum, supremum

# from generic/canonical.jl
export canonicaldomain, hascanonicaldomain,
    mapto, mapto_canonical, mapfrom_canonical,
    equaldomain, hasequaldomain,
    mapfrom_equaldomain, mapto_equaldomain,
    parameterdomain, parameterization, hasparameterization,
    mapfrom_parameterdomain, mapto_parameterdomain,
    isequaldomain

# from generic/lazy.jl
export superdomain

# from generic/productdomain.jl
export ProductDomain, productdomain, center,
    cartesianproduct,
    VcatDomain, VectorProductDomain, TupleProductDomain,
    factors

# from generic/mapped.jl
export MappedDomain,
    map_domain,
    mapped_domain,
    forward_map,
    inverse_map

# from generic/setoperations.jl
export UnionDomain, uniondomain,
    IntersectDomain, intersectdomain,
    SetdiffDomain, setdiffdomain,
    issubset_domain

# from applications/rotations.jl
export rotate


## Specific domains

# from domains/trivial.jl
export EmptySpace, FullSpace, TypeDomain,
    emptyspace, fullspace, typedomain
# from domains/numbers.jl
export Integers, RealNumbers, Rationals, ComplexNumbers,
    ℕ, ℤ, ℚ, ℝ, ℂ, ℝ1, ℝ2, ℝ3, ℝ4
# from domains/interval.jl
export AbstractInterval, Interval, UnitInterval, ChebyshevInterval,
    OpenInterval, ClosedInterval,
    leftendpoint, rightendpoint, isleftopen, isrightopen,
    HalfLine, NegativeHalfLine, RealLine
# from domains/simplex.jl
export UnitSimplex,
    StaticUnitSimplex, DynamicUnitSimplex,
    EuclideanUnitSimplex, VectorUnitSimplex,
    corners
# from domains/point.jl
export Point
# from domains/ball.jl
export Ball, UnitBall,
    center, radius,
    StaticUnitBall, DynamicUnitBall,
    EuclideanUnitBall, VectorUnitBall,
    Sphere, UnitSphere,
    StaticUnitSphere, DynamicUnitSphere,
    VectorUnitSphere, EuclideanUnitSphere,
    Disk, UnitDisk, VectorUnitDisk,
    UnitCircle, VectorUnitCircle,
    ellipse, ellipse_shape, cylinder
# from domains/complex.jl
export ComplexUnitCircle, ComplexUnitDisk
# from domains/cube.jl
export UnitCube,
    StaticUnitCube, DynamicUnitCube,
    EuclideanUnitCube, VectorUnitCube,
    UnitSquare, UnitCube,
    Rectangle
# from domain/levelset.jl
export LevelSet, ZeroSet,
    SublevelSet, SubzeroSet,
    SuperlevelSet, SuperzeroSet,
    pseudolevel
# from domain/indicator.jl
export IndicatorFunction

## Applications
# from applications/rotation.jl
export rotation_map,
    CartToPolarMap, PolarToCartMap

include("util/common.jl")

include("generic/interface.jl")
include("generic/domain.jl")
include("generic/geometry.jl")
include("generic/canonical.jl")
include("generic/lazy.jl")
include("generic/productdomain.jl")
include("generic/setoperations.jl")
include("generic/mapped.jl")
include("generic/broadcast.jl")

include("domains/trivial.jl")
include("domains/numbers.jl")
include("domains/levelset.jl")
include("domains/point.jl")
include("domains/interval.jl")
include("domains/simplex.jl")
include("domains/ball.jl")
include("domains/complex.jl")
include("domains/cube.jl")
include("domains/indicator.jl")
include("domains/boundingbox.jl")

include("generic/generator.jl")

include("applications/coordinates.jl")
include("applications/rotation.jl")

include("deprecated.jl")

end # module

function test_affine_maps(T)
    A = rand(T,2,2)
    @test FunctionMaps.to_matrix(Vector{T}, A) == A
    @test FunctionMaps.to_matrix(T, 2) == 2
    @test FunctionMaps.to_matrix(SVector{2,T}, 2) == SMatrix{2,2}(2,0,0,2)
    @test FunctionMaps.to_matrix(SVector{2,T}, LinearAlgebra.I) == SMatrix{2,2}(1,0,0,1)
    @test FunctionMaps.to_matrix(Vector{T}, 2) == UniformScaling(2)
    @test FunctionMaps.to_matrix(Vector{T}, LinearAlgebra.I) == LinearAlgebra.I
    # test fallback with nonsensical call
    @test FunctionMaps.to_matrix(Tuple{Int}, 2) == 2

    @test FunctionMaps.to_matrix(T, A, 2) == A
    @test FunctionMaps.to_matrix(T, 2, 3) == 2
    @test FunctionMaps.to_matrix(T, UniformScaling(2), 3) == 2
    @test FunctionMaps.to_matrix(T, LinearAlgebra.I, zero(T)) isa T
    @test FunctionMaps.to_matrix(SVector{2,T}, 2, SVector(1,1)) == SMatrix{2,2}(2,0,0,2)
    @test FunctionMaps.to_matrix(Vector{T}, 2, [1,2]) == [2 0 ; 0 2]

    @test FunctionMaps.to_vector(T, 2) == 0
    @test FunctionMaps.to_vector(SVector{2,T}, 2) == SVector(0,0)
    @test FunctionMaps.to_vector(Vector{T}, A) == [0,0]
    @test FunctionMaps.to_vector(T, 2, 3) == 3

    if T != BigFloat    # BigFloat's make pinv fail for StaticArrays
        @test FunctionMaps.matrix_pinv(SMatrix{2,2}(rand(T),rand(T),rand(T),rand(T))) isa SMatrix{2,2}
        @test FunctionMaps.matrix_pinv(SVector(rand(T),rand(T))) isa Transpose{T,SVector{2,T}}
    end

    test_linearmap(T)
    test_translation(T)
    test_affinemap(T)
    test_abstractarraymap(T)
end



function test_linearmap(T)
    m1 = LinearMap(2one(T))
    @test m1 isa LinearMap{T}
    @test domaintype(m1) == T
    @test islinearmap(m1)
    @test isaffinemap(m1)
    @test m1(3) == 6
    @test m1(3one(T)) == 6
    @test m1(3one(widen(T))) isa widen(T)
    @test m1(SVector(1,2)) == SVector(2,4)
    @test m1([1.0,2.0]) == [2.0,4.0]
    mw1 = convert(Map{widen(T)}, m1)
    @test mw1 isa Map{widen(T)}
    @test mw1.A isa widen(T)
    @test jacobian(m1) isa ConstantMap{T}
    @test jacobian(m1, 1) == 2
    @test LinearMap(one(T)) == StaticIdentityMap{T}()

    m2 = LinearMap(2)
    @test domaintype(m2) == Int
    @test m2 === ScalarLinearMap(2)
    @test m2(one(T)) isa T
    @test m2 == convert(Map, 2)
    @test jacobian(m2, 1) == 2
    @test jacobian(m2) isa ConstantMap{Int}
    @test jacobian(m2, 1) == 2
    @test LinearMap(1) == StaticIdentityMap{T}()

    m3 = LinearMap(SMatrix{2,2}(one(T), 2one(T), 3one(T), 4one(T)))
    @test m3 isa LinearMap{SVector{2,T}}
    @test m3 === StaticLinearMap(m3.A)
    @test m3(SVector(1,2)) == SVector(7, 10)
    @test m3(SVector{2,T}(1,2)) == SVector{2,T}(7, 10)
    @test m3 ∘ m3 isa LinearMap
    @test LinearMap(SA[1 0; 0 1]) == StaticIdentityMap{domaintype(m3)}()

    A = rand(T,2,2)
    m4 = LinearMap(A)
    @test m4 isa LinearMap{Vector{T}}
    @test m4([1,2]) ==  A * [1,2]
    y = zeros(T,2)
    @test (FunctionMaps.applymap!(y, m4, [1,2]); y == A * [1,2])
    @test jacobian(m4, [1,2]) == A

    m5 = LinearMap{Vector{T}}(UniformScaling(2*one(T)))
    @test m5 isa LinearMap{Vector{T}}
    @test m5([1,2]) ==  2 * [1,2]
    @test jacobian(m5, [1,2]) == UniformScaling(2)

    m6 = LinearMap{SVector{2,T}}(2)
    @test m6 isa GenericLinearMap{SVector{2,T},T}
    @test m6(SA[one(T),one(T)]) == [2,2]
    @test leftinverse(m6) isa LinearMap{SVector{2,T}}
    @test leftinverse(m6)([2,2]) == [1,1]

    # Test construction and conversion
    @test LinearMap{T}(1) isa ScalarLinearMap{T}
    @test LinearMap{Vector{T}}(rand(Int,5,5)) isa VectorLinearMap{T}
    @test LinearMap{SVector{2,T}}(SMatrix{2,2}(1, 2, 3, 4)) isa StaticLinearMap{T,2,2,4}

    @test GenericLinearMap(one(T)) isa GenericLinearMap{T,T}
    @test GenericLinearMap(SMatrix{2,2,T}(1,1,1,1)) isa GenericLinearMap{SVector{2,T},SMatrix{2,2,T,4}}

    @test VectorLinearMap(rand(T,3,3)) isa VectorLinearMap{T}
    @test StaticLinearMap(SMatrix{2,2,T}(1,2,3,4)) isa StaticLinearMap{T,2,2,4}

    @test convert(Map{SVector{2,T}}, LinearMap(rand(T,2,2))) isa StaticLinearMap{T,2,2,4}
    @test convert(Map{T}, 1) isa LinearMap{T}
end



function test_translation(T)
    v = randvec(T,3)
    m = Translation(v)
    @test !islinearmap(m)
    @test isaffinemap(m)
    @test inverse(inverse(m)) == m
    @test jacobian(m) isa ConstantMap
    @test affinevector(jacobian(m)) == [1 0 0; 0 1 0; 0 0 1]
    @test jacdet(m) isa UnityMap{SVector{3,T},T}

    @test mapsize(Translation(one(T))) == ()

    # Test construction and conversion
    @test Translation(one(T)) isa ScalarTranslation{T}
    @test Translation{T}(1) isa ScalarTranslation{T}
    @test Translation(SVector{2,T}(1,2)) isa StaticTranslation{T,2}
    @test Translation{SVector{2,T}}(rand(T,2)) isa StaticTranslation{T,2}
    @test Translation(rand(Int,2)) isa VectorTranslation{Int}
    @test Translation{Vector{T}}(rand(Int,2)) isa VectorTranslation{T}
    @test Translation(1:10) isa GenericTranslation{Vector{Int}}
    @test Translation{Vector{T}}(1:10) isa GenericTranslation{Vector{T}}

    @test StaticTranslation(MVector(one(T),2)) isa StaticTranslation{T,2}
    @test StaticTranslation{T}(SVector(1,2)) isa StaticTranslation{T,2}

    @test VectorTranslation(1:10) isa VectorTranslation{Int}
    @test VectorTranslation{T}(1:10) isa VectorTranslation{T}

    @test GenericTranslation(1:10) isa GenericTranslation{Vector{Int}}
    @test GenericTranslation{Vector{T}}(1:10) isa GenericTranslation{Vector{T}}

    @test GenericTranslation(one(T)) isa GenericTranslation{T,T}
    @test GenericTranslation{T}(1) isa GenericTranslation{T,T}
    @test_throws InexactError GenericTranslation{Int}(one(T)/2)

    @test convert(Map{SVector{2,T}}, Translation(rand(T,2))) isa StaticTranslation{T,2}
end


function test_affinemap(T)
    m1 = AffineMap(T(2), T(3))
    @test m1 isa ScalarAffineMap{T}
    @test !islinearmap(m1)
    @test isaffinemap(m1)
    @test m1(2) == 7

    @test convert(ScalarAffineMap{BigFloat}, m1) == m1

    @test m1 ∘ m1 isa AffineMap
    @test (m1 ∘ m1)(2) == 2*(2*2+3)+3

    m2 = AffineMap(T(2), SVector{2,T}(1,2))
    @test m2 isa GenericAffineMap{SVector{2,T}}
    @test m2(SVector(1,2)) == SVector(3,6)
    @test mapsize(m2) == (2,2)

    m3 = AffineMap(UniformScaling(2*one(T)), [one(T),2*one(T)])
    @test m3 isa AffineMap{Vector{T}}
    @test mapsize(m3) == (2,2)
    @test m3([1,2]) ==  2 * [1,2] + [1,2]
    y = zeros(T,2)
    @test (FunctionMaps.applymap!(y, m3, [1,2]); y == m3([1,2]))
    @test jacobian(m3, [1,2]) == [2 0; 0 2]
    @test jacdet(m3, [1,2]) == 4

    @test AffineMap(LinearAlgebra.I, 2.0) isa ScalarAffineMap
    m4 = GenericAffineMap(LinearAlgebra.I, 2.0)
    @test m4.A isa UniformScaling{Float64}
    @test jacdet(m4, 3.0) == 1.0

    @test mapsize(AffineMap(rand(3),rand(3))) == (3,)
    @test mapsize(AffineMap(LinearAlgebra.I,2)) == ()

    # Test construction and conversion
    @test AffineMap(1, 2*one(T)) isa ScalarAffineMap{T}
    @test AffineMap{BigFloat}(1, 2.0) isa ScalarAffineMap{BigFloat}
    @test AffineMap(rand(T,2),rand(T,2)) isa GenericAffineMap{T}
    @test AffineMap(rand(T,2,2),rand(T,2)) isa VectorAffineMap{T}
    @test AffineMap{Vector{T}}(rand(Int,2,2),rand(Int,2)) isa VectorAffineMap{T}
    @test AffineMap{SVector{2,T}}(rand(T,2,2),rand(T,2)) isa StaticAffineMap{T,2,2,4}
    @test AffineMap{SVector{2,T}}(rand(Int,2,2),rand(T,2)) isa StaticAffineMap{T,2,2,4}
    @test AffineMap{SVector{2,T}}(rand(Int,2,2),rand(Int,2)) isa StaticAffineMap{T,2,2,4}
    @test AffineMap{SVector{2,T}}(1,rand(Int,2)) isa GenericAffineMap{SVector{2,T},T,SVector{2,T}}
    @test AffineMap{SVector{2,T}}(SMatrix{3,2}(3,2,1,4,5,6),SVector(1,2,3)) isa StaticAffineMap{T,2,3,6}

    @test GenericAffineMap(SMatrix{2,2,T}(1,2,3,4), [1,2]) isa GenericAffineMap{SVector{2,T},SMatrix{2,2,T,4}}
    @test GenericAffineMap(SMatrix{1,1,Int}(1),SVector{1,T}(1)) isa GenericAffineMap{SVector{1,T}}
    @test GenericAffineMap(rand(T,2,2),rand(Int,2)) isa GenericAffineMap{Vector{T},Matrix{T},Vector{T}}
    @test GenericAffineMap{Vector{T}}(1, [1,2]) isa GenericAffineMap{Vector{T},T,Vector{Int}}
    @test GenericAffineMap{Vector{T}}(rand(Int,2,2), rand(Int,2)) isa GenericAffineMap{Vector{T},Matrix{T},Vector{T}}
    @test convert(GenericAffineMap{Vector{T}}, GenericAffineMap(rand(Int,2,2), rand(Int,2))) isa GenericAffineMap{Vector{T}}
    @test GenericAffineMap(rand(T,2),rand(T,2)) isa GenericAffineMap{T}
    @test GenericAffineMap{T}(rand(Int,2),rand(Int,2)) isa GenericAffineMap{T}

    @test VectorAffineMap(rand(T,2,2),rand(T,2)) isa VectorAffineMap{T}

    @test StaticAffineMap(SMatrix{1,1,T}(1),SVector{1,T}(1)) isa StaticAffineMap{T}
    @test StaticAffineMap(SMatrix{1,1,T}(1),SVector{1,Int}(1)) isa StaticAffineMap{T}

    @test StaticAffineMap(rand(T,2,2),SVector{2,T}(1,1)) isa StaticAffineMap{T}
    @test_throws AssertionError StaticAffineMap(rand(T,3,2),SVector{2,T}(1,1))
    @test StaticAffineMap(SMatrix{2,2,T}(1,2,3,4),[1,1]) isa StaticAffineMap{T,2}
    @test StaticAffineMap(SMatrix{3,2,T}(1,2,3,4,5,6),SVector{3,T}(1,2,3)) isa StaticAffineMap{T,2,3,6}

    @test convert(Map{SVector{2,T}}, AffineMap(rand(2,2),rand(2))) isa StaticAffineMap{T,2,2,4}
end

function test_abstractarraymap(T)
    A = rand(T, 3, 3)
    @test FunctionMaps.MapStyle(A) isa FunctionMaps.IsMap
    @test FunctionMaps.checkmap(A) == A
    @test Map(A) isa LinearMap
    @test Map(A) isa VectorLinearMap
    @test Map(SA[1 2; 3 4]) isa StaticLinearMap
    @test Map(Diagonal(rand(3))) isa GenericLinearMap
    @test mapsize(A) == size(A)
    @test applymap(A, 1:3) == A*(1:3)
    @test islinearmap(A)
    @test isaffinemap(A)
    @test affinematrix(A) == A
    @test affinevector(A) == [0,0,0]
    @test jacobian(A) isa ConstantMap
    @test jacobian(A, 1:3) == A
    @test inverse(A) ≈ inv(A)
    @test inverse(A, 1:3) ≈ A \ (1:3)
    @test canonicalmap(A) isa LinearMap
    @test FunctionMaps.equalmap(A) isa LinearMap
    @test isequalmap(A, LinearMap(A))
end

# Make sure the examples in the README continue to function

@testset "examples" begin
    using DomainSets, StaticArrays
    @test repr(UnitInterval()) == "$(0.0..1.0) (Unit)"
    @test repr(ChebyshevInterval()) == "$(-1.0..1.0) (Chebyshev)"
    @test repr(HalfLine())[1:10] == "$(0.0..Inf)"

    using DomainSets: ×
    @test repr(cartesianproduct(-1..1, 0..3, 4.0..5.0)) == "($(-1.0..1.0)) × ($(0.0..3.0)) × ($(4.0..5.0))"
    @test SVector(1,2) in cartesianproduct(-1..1, 0..3)

    @test SVector(0,0,1.0) in UnitSphere(Val(3))
    @test [0.0,1.0,0.0,0.0] in UnitSphere(4)
    @test SVector(1,0) in UnitCircle()

    @test SVector(0.1,0.2,0.3) in UnitBall(Val(3))
    @test [0.1,0.2,0.3,-0.1] in UnitBall(4)
    @test SVector(0.1,0.2) in UnitDisk()

    @test 1:5 in ProductDomain([0..i for i in 1:5])
    @test ("a", 0.4) ∈ ProductDomain(["a","b"], 0..1)

    d = UnitCircle() ∪ 2UnitCircle()
    @test in.([SVector(1,0),SVector(0,2), SVector(1.5,1.5)], Ref(d)) == [1,1,0]
    d = UnitCircle() ∩ (2UnitCircle() .+ SVector(1.0,0.0))
    @test !(SVector(1,0) in d)
    @test SVector(-1,0) in d

    d = LevelSet{SVector{2,Float64}}(prod, 1.0)
    @test [0.5,2] ∈ d

    d = IndicatorFunction{Float64}( t ->  cos(t) > 0)
    @test (0.5 ∈ d, 3.1 ∈ d) == (true, false)

    d = Domain(x>0 for x in -1..1)
    @test (0.5 ∈ d, -0.5 ∈ d) == (true, false)

    d = Domain( x*y > 0 for (x,y) in UnitDisk())
    @test ([0.2, 0.3] ∈ d, [0.2, -0.3] ∈ d) == (true, false)

    d = Domain( x+y+z > 0 for (x,y,z) in ProductDomain(UnitDisk(), 0..1))
    @test [0.3,0.2,0.5] ∈ d
end

"A lazy Jacobian `J` stores a map `m` and returns `J(x) = jacobian(m, x)`."
struct LazyJacobian{T,M} <: SimpleLazyMap{T}
	map	::	M
end

LazyJacobian(m) = LazyJacobian{domaintype(m),typeof(m)}(m)
applymap(m::LazyJacobian, x) = jacobian(supermap(m), x)

mapsize(m::LazyJacobian) = mapsize(supermap(m))

Display.displaystencil(m::LazyJacobian) = ["LazyJacobian(", supermap(m), ")"]
show(io::IO, mime::MIME"text/plain", m::LazyJacobian) = composite_show(io, mime, m)


"""
    jacobian(m[, x])

Return the jacobian map. The two-argument version evaluates the jacobian
at a point `x`.
"""
jacobian(m) = LazyJacobian(m)
jacobian!(y, m, x) = y .= jacobian(m, x)


"A `DeterminantMap` returns the determinant of the result of a given map."
struct DeterminantMap{T,M} <: SimpleLazyMap{T}
    map ::  M
end

DeterminantMap(m) = DeterminantMap{domaintype(m)}(m)
DeterminantMap{T}(m) where {T} = DeterminantMap{T,typeof(m)}(m)
DeterminantMap{T}(m::Map{T}) where {T} = DeterminantMap{T,typeof(m)}(m)
DeterminantMap{T}(m::Map{S}) where {S,T} = DeterminantMap{T}(convert(Map{T}, m))

determinantmap(m) = DeterminantMap(m)

applymap(m::DeterminantMap, x) = det(supermap(m)(x))


"""
    jacdet(m[, x])

Return the determinant of the jacobian as a map. The two-argument version
evaluates the jacobian determinant at a point `x`.
"""
jacdet(m) = determinantmap(jacobian(m))
jacdet(m, x) = det(jacobian(m, x))


"An `AbsMap` returns the absolute value of the result of a given map."
struct AbsMap{T,M} <: SimpleLazyMap{T}
    map ::  M
end

AbsMap(m) = AbsMap{domaintype(m)}(m)
AbsMap{T}(m) where {T} = AbsMap{T,typeof(m)}(m)
AbsMap{T}(m::Map{T}) where {T} = AbsMap{T,typeof(m)}(m)
AbsMap{T}(m::Map{S}) where {S,T} = AbsMap{T}(convert(Map{T}, m))

absmap(m) = AbsMap(m)

applymap(m::AbsMap, x) = abs(supermap(m)(x))


"A lazy volume element evaluates to `diffvolume(m, x)` on the fly."
struct LazyDiffVolume{T,M} <: SimpleLazyMap{T}
	map	::	M
end

LazyDiffVolume(m) = LazyDiffVolume{domaintype(m)}(m)
LazyDiffVolume{T}(m) where {T} = LazyDiffVolume{T,typeof(m)}(m)
LazyDiffVolume{T}(m::Map{T}) where {T} = LazyDiffVolume{T,typeof(m)}(m)
LazyDiffVolume{T}(m::Map{S}) where {S,T} = LazyDiffVolume{T}(convert(Map{T}, m))

applymap(m::LazyDiffVolume, x) = diffvolume(supermap(m), x)

Display.displaystencil(m::LazyDiffVolume) = ["LazyDiffVolume(", supermap(m), ")"]
show(io::IO, mime::MIME"text/plain", m::LazyDiffVolume) = composite_show(io, mime, m)

"""
    diffvolume(m[, x])

Compute the differential volume (at a point `x`). If `J` is the Jacobian matrix,
possibly rectangular, then the differential volume is `sqrt(det(J'*J))`.

If the map is square, then the differential volume is the absolute value of the
Jacobian determinant.
"""
function diffvolume(m)
	if issquaremap(m)
		if mapsize(m,1) > 1
			absmap(jacdet(m))
		else
			jacdet(m)
		end
	else
		LazyDiffVolume(m)
	end
end

function diffvolume(m, x)
	if issquaremap(m)
		if mapsize(m,1) > 1
			abs(jacdet(m, x))
		else
			jacdet(m, x)
		end
	else
		jac = jacobian(m, x)
		sqrt(det(adjoint(jac)*jac))
	end
end



const NumberLike = Union{Number,UniformScaling}

"""
    to_matrix(::Type{T}, A[, b])

Convert the `A` in the affine map `A*x` or `A*x+b` with domaintype `T` to a matrix.
"""
to_matrix(::Type{T}, A) where {T} = A
to_matrix(::Type{T}, A::AbstractMatrix) where {T} = A
to_matrix(::Type{T}, A::NumberLike) where {T<:Number} = A
to_matrix(::Type{<:StaticVector{N,T}}, A::Number) where {N,T} = A * one(SMatrix{N,N,T})
to_matrix(::Type{<:StaticVector{N,T}}, A::UniformScaling) where {N,T} = A.λ * one(SMatrix{N,N,T})
to_matrix(::Type{T}, A::Number) where {T<:AbstractVector} = A * I
to_matrix(::Type{T}, A::UniformScaling) where {T<:Number} = one(T)
to_matrix(::Type{T}, A::UniformScaling) where {T<:AbstractVector} = A

to_matrix(::Type{T}, A, b) where {T} = A
to_matrix(::Type{T}, A::AbstractMatrix, b) where {T} = A
to_matrix(::Type{T}, A::Number, b::Number) where {T<:Number} = A
to_matrix(::Type{T}, A::UniformScaling{S}, b::Number) where {S,T<:Number} =
	convert(promote_type(S,T,typeof(b)), A.λ)
to_matrix(::Type{<:StaticVector{N,T}}, A::NumberLike, b::StaticVector{N,T}) where {N,T} = A * one(SMatrix{N,N,T})
to_matrix(::Type{T}, A::NumberLike, b::AbstractVector) where {S,T<:AbstractVector{S}} =
    A * Array{S,2}(I, length(b), length(b))

"""
    to_vector(::Type{T}, A[, b])

Convert the `b` in the affine map `A*x` or `A*x+b` with domaintype `T` to a vector.
"""
to_vector(::Type{T}, A) where {T} = zero(T)
to_vector(::Type{T}, A::StaticVector{M,S}) where {T,M,S} = zero(SVector{M,S})
to_vector(::Type{T}, A::StaticMatrix{M,N,S}) where {T,M,N,S} = zero(SVector{M,S})
to_vector(::Type{T}, A::AbstractArray) where {T} = zeros(eltype(T),size(A,1))
to_vector(::Type{T}, A, b) where {T} = b


"Return a zero matrix of the same size as the map."
zeromatrix(m) = zeromatrix(m, domaintype(m), codomaintype(m))
zeromatrix(m, ::Type{T}, ::Type{U}) where {T,U} = zeros(numtype(T),mapsize(m))
zeromatrix(m, ::Type{T}, ::Type{U}) where {T<:Number,U<:Number} = zero(promote_type(T,U))
zeromatrix(m, ::Type{T}, ::Type{U}) where {N,T<:StaticVector{N},U<:Number} =
	transpose(zero(SVector{N,eltype(T)}))
zeromatrix(m, ::Type{T}, ::Type{U}) where {N,M,T<:StaticVector{N},U<:StaticVector{M}} =
	zero(SMatrix{M,N,promote_type(eltype(T),eltype(U))})
zeromatrix(m, ::Type{T}, ::Type{U}) where {T<:Number,M,U<:StaticVector{M}} =
	zero(SVector{M,promote_type(T,eltype(U))})
zeromatrix(m, ::Type{T}, ::Type{U}) where {T<:AbstractVector,U<:Number} =
	transpose(zeros(promote_type(eltype(T),U), mapsize(m,1)))


"Return a zero vector of the same size as the codomain of the map."
zerovector(m) = zerovector(m, codomaintype(m))
zerovector(m, ::Type{U}) where {U} = zero(U)
zerovector(m, ::Type{<:StaticVector{M,T}}) where {M,T} = zero(SVector{M,T})
# If the output type is a vector, the map itself should store the size information.
zerovector(m, ::Type{<:AbstractVector{T}}) where {T} = zeros(T, mapsize(m,1))

"Return an identity matrix with the same size as the map."
identitymatrix(m) = identitymatrix(m, codomaintype(m))
identitymatrix(m, ::Type{T}) where {T} = one(T)
identitymatrix(m, ::Type{<:StaticVector{N,T}}) where {N,T} = one(SMatrix{N,N,T})
identitymatrix(m, ::Type{<:AbstractVector{T}}) where {T} = Diagonal{T}(ones(mapsize(m,1)))

"""
	abstract type ProductDomain{T}

Represents the cartesian product of other domains.
"""
abstract type ProductDomain{T} <: CompositeDomain{T} end

composition(d::ProductDomain) = Product()

components(d::ProductDomain) = d.domains
factors(d::ProductDomain) = components(d)

isequaldomain(d1::ProductDomain, d2::ProductDomain) =
	compatibleproductdims(d1,d2) && mapreduce(isequaldomain, &, components(d1), components(d2))
domainhash(d::ProductDomain, h::UInt) = hashrec("ProductDomain", collect(components(d)), h)

isempty(d::ProductDomain) = any(isempty, components(d))
isclosedset(d::ProductDomain) = all(isclosedset, components(d))
isopenset(d::ProductDomain) = all(isopenset, components(d))

issubset_domain(d1::ProductDomain, d2::ProductDomain) =
	compatibleproductdims(d1, d2) && all(map(issubset_domain, factors(d1), factors(d2)))

volume(d::ProductDomain) = prod(map(volume, components(d)))

distance_to(d::ProductDomain, x) = sqrt(sum(distance_to(component(d, i), x[i])^2 for i in 1:ncomponents(d)))

compatibleproductdims(d1::ProductDomain, d2::ProductDomain) =
	dimension(d1) == dimension(d2) &&
		all(map(==, map(dimension, factors(d1)), map(dimension, factors(d2))))

Display.combinationsymbol(d::ProductDomain) = Display.Times()
Display.displaystencil(d::ProductDomain) = composite_displaystencil(d)
show(io::IO, mime::MIME"text/plain", d::ProductDomain) = composite_show(io, mime, d)
show(io::IO, d::ProductDomain) = composite_show_compact(io, d)

boundary_part(d::ProductDomain{T}, domains, i) where {T} =
	ProductDomain{T}(domains[1:i-1]..., boundary(domains[i]), domains[i+1:end]...)

boundary(d::ProductDomain) = productboundary(d)
productboundary(d) = productboundary(d, factors(d))
productboundary(d, domains) =
	UnionDomain(boundary_part(d, domains, i) for i in 1:length(domains))
productboundary(d, domains::Tuple) =
	UnionDomain(tuple((boundary_part(d, domains, i) for i in 1:length(domains))...))

boundingbox(d::ProductDomain{T}) where {T} = ProductDomain{T}(map(boundingbox, components(d)))

infimum(d::ProductDomain) = toexternalpoint(d, map(infimum, components(d)))
supremum(d::ProductDomain) = toexternalpoint(d, map(supremum, components(d)))
leftendpoint(d::ProductDomain) = toexternalpoint(d, map(leftendpoint, components(d)))
rightendpoint(d::ProductDomain) = toexternalpoint(d, map(rightendpoint, components(d)))

interior(d::ProductDomain) = ProductDomain(map(interior, components(d)))
closure(d::ProductDomain) = ProductDomain(map(closure, components(d)))

center(d::ProductDomain) = toexternalpoint(d, map(center, components(d)))

VcatDomainElement = Union{Domain{<:Number},EuclideanDomain}
VcatEltype = Union{Type{<:Number},Type{<:StaticVector}}

"""
	ProductDomain(domains...)
	ProductDomain{T}(domains...)

Return a concrete subtype of `ProductDomain` which agrees mathematically
with the cartesian product of the given domains.

The concrete subtype being returned depends on `T`. If `T` is provided, it will
be the eltype of the product domain. If `T` is not provided, a suitable choice
is deduced from the arguments.

See also: [`VcatDomain`](@ref), [`VectorProductDomain`](@ref),
[`TupleProductDomain`](@ref), [`Rectangle(a,b)`](@ref).
"""
ProductDomain() = throw(ArgumentError("Empty product domain"))
ProductDomain(domains...) = _ProductDomain(domains, map(domaineltype, domains)...)
_ProductDomain(domains, types...) = TupleProductDomain(domains...)
_ProductDomain(domains, types::VcatEltype...) = VcatDomain(domains...)
ProductDomain(domains::AbstractVector) = VectorProductDomain(domains)
ProductDomain(domains::StaticVector) = ProductDomain(domains...)
# To create a tuple product domain, invoke ProductDomain{T}. Here, we splat
# and this may end up creating a VcatDomain instead.
ProductDomain(domains::Tuple) = ProductDomain(domains...)

ProductDomain{T}(domains::Tuple) where {T} = ProductDomain{T}(domains...)
ProductDomain{T}(domains...) where {T} = _TypedProductDomain(T, domains...)
_TypedProductDomain(::Type{SVector{N,T}}, domains...) where {N,T} = VcatDomain{N,T}(domains...)
_TypedProductDomain(::Type{T}, domains...) where {T<:Vector} = VectorProductDomain{T}(domains...)
_TypedProductDomain(::Type{T}, domains...) where {T<:Tuple} = TupleProductDomain{T}(domains...)
_TypedProductDomain(::Type{T}, domains...) where {T} = TupleProductDomain{T}(domains...)

productdomain() = ()
productdomain(d) = d
productdomain(d1, d2, d3...) = productdomain(productdomain(d1, d2), d3...)

productdomain(d1, d2) = productdomain1(d1, d2)
productdomain1(d1, d2) = productdomain2(d1, d2)
productdomain2(d1, d2) = ProductDomain(d1, d2)

productdomain(d1::ProductDomain, d2::ProductDomain) =
	ProductDomain(factors(d1)..., factors(d2)...)
productdomain1(d1::ProductDomain, d2) = ProductDomain(factors(d1)..., d2)
productdomain2(d1, d2::ProductDomain) = ProductDomain(d1, factors(d2)...)

"""
	cartesianproduct(domains...)

Return the cartesian product of the given domains.

The function may simplify the result in some cases. Use the `ProductDomain`
constructor to obtain an explicit representation as a product.

# Examples
```julia
julia> using DomainSets: ×

julia> (0..1) × (2..3)
(0 .. 1) × (2 .. 3)
````
"""
cartesianproduct(d...) = productdomain(d...)
# To be activated in v0.8:
# × = cartesianproduct

Base.:^(d::Domain, n::Int) = productdomain(ntuple(i->d, n)...)

similardomain(d::ProductDomain, ::Type{T}) where {T} =
	ProductDomain{T}(factors(d))

canonicaldomain(d::ProductDomain) = any(map(hascanonicaldomain, factors(d))) ?
	ProductDomain(map(canonicaldomain, components(d))) : d

# this function is meant to avoid, e.g., making a VcatMap for a TupleProductDomain
matching_product_map(d::ProductDomain, maps) = ProductMap(maps)

mapto_canonical(d::ProductDomain) =
	matching_product_map(d, map(mapto_canonical, components(d)))
mapfrom_canonical(d::ProductDomain) =
	matching_product_map(d, map(mapfrom_canonical, components(d)))

for CTYPE in (Parameterization, Equal)
	@eval canonicaldomain(ctype::$CTYPE, d::ProductDomain) =
		any(hascanonicaldomain.(Ref(ctype), factors(d))) ?
			ProductDomain(canonicaldomain.(Ref(ctype), factors(d))) : d
	@eval mapto_canonical(ctype::$CTYPE, d::ProductDomain) =
		matching_product_map(d, mapto_canonical.(Ref(ctype), factors(d)))
	@eval mapfrom_canonical(ctype::$CTYPE, d::ProductDomain) =
		matching_product_map(d, mapfrom_canonical.(Ref(ctype), factors(d)))
end

# multiplication with a scalar number
function map_domain(linmap::GenericLinearMap{<:StaticVector{N,S},A}, domain::ProductDomain{<:StaticVector{N,T}}) where {N,S,T,A<:Number}
	c = unsafe_matrix(linmap)
	ProductDomain{SVector{N,promote_type(S,T)}}(map(d -> c .* d, components(domain)))
end

function map_domain(transmap::Translation{<:StaticVector{N,S}}, domain::ProductDomain{<:StaticVector{N,T}}) where {N,S,T}
    vec = unsafe_vector(transmap)
    ProductDomain{SVector{N,promote_type(S,T)}}(
            map( (d,v) -> d .+ v, components(domain), tointernalpoint(domain, vec)))
end


"""
A `VcatDomain` concatenates the element types of its member domains in a single
static vector.
"""
struct VcatDomain{N,T,DIM,DD} <: ProductDomain{SVector{N,T}}
	domains	::	DD
end

VcatDomain(domains::Union{Vector,Tuple}) = VcatDomain(domains...)
function VcatDomain(domains...)
	T = domain_numtype(domains...)
	N = sum(map(dimension, domains))
	VcatDomain{N,T}(domains...)
end

VcatDomain{N,T}(domains::Union{AbstractVector,Tuple}) where {N,T} = VcatDomain{N,T}(domains...)
function VcatDomain{N,T}(domains...) where {N,T}
	DIM = map(dimension,domains)
	VcatDomain{N,T,DIM}(convert_numtype.(T, domains)...)
end

VcatDomain{N,T,DIM}(domains...) where {N,T,DIM} =
	VcatDomain{N,T,DIM,typeof(domains)}(domains)

tointernalpoint(d::VcatDomain{N,T,DIM}, x) where {N,T,DIM} =
	convert_fromcartesian(x, Val{DIM}())
toexternalpoint(d::VcatDomain{N,T,DIM}, y) where {N,T,DIM} =
	convert_tocartesian(y, Val{DIM}())

"""
A `VectorProductDomain` is a product domain of arbitrary dimension where the
element type is a vector, and all member domains have the same element type.
"""
struct VectorProductDomain{V<:AbstractVector,DD<:AbstractVector} <: ProductDomain{V}
	domains	::	DD

	function VectorProductDomain{V,DD}(domains::DD) where {V,DD}
		@assert eltype(domaineltype(domains[1])) == eltype(V)
		new(domains)
	end
end

VectorProductDomain(domains::AbstractVector) =
	VectorProductDomain{Vector{eltype(domaineltype(domains[1]))}}(domains)

VectorProductDomain{V}(domains::AbstractVector{<:Domain{T}}) where {T,V<:AbstractVector{T}} =
	VectorProductDomain{V,typeof(domains)}(domains)
function VectorProductDomain{V}(domains::AbstractVector) where {T,V<:AbstractVector{T}}
	Tdomains = convert_eltype.(T, domains)
	VectorProductDomain{V,typeof(Tdomains)}(Tdomains)
end

# Convenience: allow constructor to be called with multiple arguments, or with
# a container that is not a vector
VectorProductDomain(domains...) = VectorProductDomain(promote_domains(domains...))
VectorProductDomain(domains) = VectorProductDomain(collect(domains))
VectorProductDomain{V}(domains...) where {V} = VectorProductDomain{V}(promote_domains(domains...))
VectorProductDomain{V}(domains) where {V} = VectorProductDomain{V}(collect(domains))

# the dimension equals the number of composite elements
dimension(d::VectorProductDomain) = ncomponents(d)

tointernalpoint(d::VectorProductDomain, x) =
	(@assert length(x) == dimension(d); x)
toexternalpoint(d::VectorProductDomain, y) =
	(@assert length(y) == dimension(d); y)





"""
A `TupleProductDomain` is a product domain that concatenates the elements of
its member domains in a tuple.
"""
struct TupleProductDomain{T,DD} <: ProductDomain{T}
	domains	::	DD
end

TupleProductDomain(domains::Vector) = TupleProductDomain(domains...)
TupleProductDomain(domains...) = TupleProductDomain(map(checkdomain, domains))
function TupleProductDomain(domains::Tuple)
	T = Tuple{map(domaineltype, domains)...}
	TupleProductDomain{T}(domains)
end

TupleProductDomain{T}(domains::Vector) where {T} = TupleProductDomain{T}(domains...)
TupleProductDomain{T}(domains...) where {T} = TupleProductDomain{T}(domains)
function TupleProductDomain{T}(domains::Tuple) where {T <: Tuple}
	Tdomains = map((t,d) -> convert_eltype(t, d), tuple(T.parameters...), domains)
	TupleProductDomain{T,typeof(Tdomains)}(Tdomains)
end
TupleProductDomain{T}(domains::Tuple) where {T} =
	TupleProductDomain{T,typeof(domains)}(domains)

matching_product_map(d::TupleProductDomain, maps) = TupleProductMap(maps)

iscompact(d::TypedEndpointsInterval{:closed,:closed}) = true
iscompact(d::TypedEndpointsInterval) = false

isinterval(d) = false
isinterval(d::AbstractInterval) = true

issubset_domain(d1::TypedEndpointsInterval, d2::TypedEndpointsInterval) = issubset(d1, d2)
isequaldomain(d1::TypedEndpointsInterval, d2::TypedEndpointsInterval) = isequal(d1, d2)

# Invoke the implementation of hash by IntervalSets
domainhash(d::AbstractInterval, h::UInt) = hash(d, h)

Display.object_parentheses(::AbstractInterval) = true

approx_indomain(x, d::AbstractInterval, tolerance) =
    (x >= leftendpoint(d)-tolerance) && (x <= rightendpoint(d)+tolerance)

approx_indomain(x, d::TypedEndpointsInterval{:closed,:closed}, tolerance) =
    (x >= leftendpoint(d)-tolerance) && (x <= rightendpoint(d)+tolerance)
approx_indomain(x, d::TypedEndpointsInterval{:open,:closed}, tolerance) =
    (x > leftendpoint(d)-tolerance) && (x <= rightendpoint(d)+tolerance)
approx_indomain(x, d::TypedEndpointsInterval{:closed,:open}, tolerance) =
    (x >= leftendpoint(d)-tolerance) && (x < rightendpoint(d)+tolerance)
approx_indomain(x, d::TypedEndpointsInterval{:open,:open}, tolerance) =
    (x > leftendpoint(d)-tolerance) && (x < rightendpoint(d)+tolerance)


center(d::AbstractInterval) = IntervalSets.mean(d)

function choice(d::AbstractInterval)
    isempty(d) && throw(BoundsError())
    center(d)
end

# For an interval of integers, try to find an integer point
function choice(d::AbstractInterval{T}) where {T<:Integer}
    isempty(d) && throw(BoundsError())
    x = round(T, IntervalSets.mean(d))
    if x ∈ d
        x
    else
        # the mean is not inside the interval when rounded, this means
        # we have to choose an endpoint
        if isleftclosed(d)
            leftendpoint(d)
        elseif isrightclosed(d)
            rightendpoint(d)
        else
            # the interval is open and contains no integers in its interior
            throw(BoundsError())
        end
    end
end


boundary(d::AbstractInterval{T}) where T =
    isempty(d) ? EmptySpace{T}() : Point(leftendpoint(d)) ∪ Point(rightendpoint(d))
corners(d::AbstractInterval{T}) where T =
    isempty(d) ? T[] : [leftendpoint(d), rightendpoint(d)]

normal(d::AbstractInterval, x) = (abs(minimum(d)-x) < abs(maximum(d)-x)) ? -one(domaineltype(d)) : one(domaineltype(d))

function distance_to(d::AbstractInterval{T}, x) where T
    if x ∈ d
        zero(T)
    elseif isempty(d)
        T(Inf)
    else
        min(abs(x-supremum(d)), abs(x-infimum(d)))
    end
end

boundingbox(d::AbstractInterval) = d

volume(d::AbstractInterval) = width(d)

similar_interval(d::AbstractInterval, a, b) = similar_interval(d, promote(a, b)...)

## Some special intervals follow, e.g.:
# - the unit interval [0,1]
# - the 'Chebyshev' interval [-1,1]
# - ...
# Unlike a generic interval, these specific intervals have no data, and only one
# type parameter (T).

"""
The abstract type `FixedInterval` is the supertype of intervals with endpoints
determined by the type, rather than field values. Examples include `UnitInterval`
and `ChebyshevInterval`.
"""
abstract type FixedInterval{L,R,T} <: TypedEndpointsInterval{L,R,T} end
const ClosedFixedInterval{T} = FixedInterval{:closed,:closed,T}

convert(::Type{AbstractInterval{T}}, d::FixedInterval{L,R,T}) where {L,R,T} = d
convert(::Type{AbstractInterval{T}}, d::FixedInterval{L,R,S}) where {L,R,S,T} =
    similardomain(d, T)

closure(d::AbstractInterval) = ClosedInterval(endpoints(d)...)
closure(d::ClosedInterval) = d

interior(d::AbstractInterval) = OpenInterval(endpoints(d)...)

"""
Return an interval that is similar to the given interval, but with endpoints
`a` and `b` instead.
"""
similar_interval(d::ClosedFixedInterval{T}, a::S, b::S) where {S,T} =
    ClosedInterval{promote_type(T,S)}(a, b)

"""
    UnitInterval()
    UnitInterval{T=Float64}()

The closed unit interval `[0,1]`.
"""
struct UnitInterval{T} <: ClosedFixedInterval{T} end

UnitInterval() = UnitInterval{Float64}()

endpoints(d::UnitInterval{T}) where {T} = (zero(T), one(T))

similardomain(::UnitInterval, ::Type{T}) where {T} = UnitInterval{T}()


"""
    ChebyshevInterval()
    ChebyshevInterval{T=Float64}()

The closed interval `[-1,1]`.
"""
struct ChebyshevInterval{T} <: ClosedFixedInterval{T}
end

ChebyshevInterval() = ChebyshevInterval{Float64}()

endpoints(d::ChebyshevInterval{T}) where {T} = (-one(T),one(T))

similardomain(::ChebyshevInterval, ::Type{T}) where {T} = ChebyshevInterval{T}()

Base.:-(d::ChebyshevInterval) = d

mapto(d1::D, d2::D) where {D <: FixedInterval} = identitymap(d1)
mapto(d1::AbstractInterval, d2::AbstractInterval) =
    interval_map(leftendpoint(d1), rightendpoint(d1), leftendpoint(d2), rightendpoint(d2))

identitymap(d::TypedEndpointsInterval{L,R,T}) where {L,R,T<:Integer} = IdentityMap{float(T)}()

canonicaldomain(d::TypedEndpointsInterval{:closed,:closed,T}) where {T} =
    ChebyshevInterval{T}()
mapfrom_canonical(d::TypedEndpointsInterval{:closed,:closed}) =
    bounded_interval_map(-1, 1, endpoints(d)...)

canonicaldomain(d::FixedInterval) = d
canonicaldomain(ctype::Equal, d::FixedInterval) = d
mapfrom_canonical(d::FixedInterval) = identitymap(d)

function canonicaldomain(d::TypedEndpointsInterval{:open,:open,T}) where {T}
    if isfinite(leftendpoint(d)) && isfinite(rightendpoint(d))
        isempty(d) ? EmptySpace{T}() : Interval{:open,:open,T}(-1, 1)
    elseif isfinite(leftendpoint(d)) || isfinite(rightendpoint(d))
        # one finite endpoint
        PositiveRealLine{T}()
    elseif leftendpoint(d) != rightendpoint(d)
        # two infinite endpoints
        RealLine{T}()
    else
        # this is an interval like (Inf,Inf)
        EmptySpace{T}()
    end
end

function canonicaldomain(d::TypedEndpointsInterval{:open,:closed,T}) where {T}
    if isfinite(leftendpoint(d)) && isfinite(rightendpoint(d))
        isempty(d) ? EmptySpace{T}() : Interval{:open,:closed,T}(-1, 1)
    elseif isfinite(rightendpoint(d))
        NonnegativeRealLine{T}()
    else
        throw(ArgumentError("Canonical domains can not be closed at infinity."))
    end
end

function canonicaldomain(d::TypedEndpointsInterval{:closed,:open,T}) where {T}
    if isfinite(leftendpoint(d)) && isfinite(rightendpoint(d))
        isempty(d) ? EmptySpace{T}() : Interval{:closed,:open,T}(-1, 1)
    elseif isfinite(leftendpoint(d))
        NonnegativeRealLine{T}()
    else
        throw(ArgumentError("Canonical domains can not be closed at infinity."))
    end
end

mapfrom_canonical(d::AbstractInterval) = mapto(canonicaldomain(d), d)


"""
    HalfLine()
    HalfLine{T=Float64,C=:closed}()

The positive halfline `[0,∞)` when `C` is `:closed` or `(0,∞)` when `C` is
`:open`. The interval is always open at infinity.

See also: [`NonnegativeRealLine`](@ref), [`PositiveRealLine`](@ref).
"""
struct HalfLine{T,C} <: FixedInterval{C,:open,T} end
HalfLine() = HalfLine{Float64}()
HalfLine{T}() where {T} = HalfLine{Float64,:closed}()

"""
    NonnegativeRealLine{T=Float64}()

The closed positive halfline `[0,∞)`.
"""
const NonnegativeRealLine{T} = HalfLine{T,:closed}
"""
    PositiveRealLine{T=Float64}()

The open positive halfline `(0,∞)`.
"""
const PositiveRealLine{T} = HalfLine{T,:open}

NonnegativeRealLine() = NonnegativeRealLine{Float64}()
PositiveRealLine() = PositiveRealLine{Float64}()

endpoints(d::HalfLine{T}) where {T} = (zero(T), T(Inf))
boundary(d::HalfLine) = Point(leftendpoint(d))
interior(d::HalfLine{T}) where {T} = PositiveRealLine{T}()
closure(d::HalfLine{T}) where {T} = NonnegativeRealLine{T}()

similardomain(::HalfLine{S,C}, ::Type{T}) where {S,T,C} = HalfLine{T,C}()

# intercept and simplify the definition of IntervalSets
in(x, d::NonnegativeRealLine) = x >= 0
in(x, d::PositiveRealLine) = x > 0

approx_indomain(x, d::HalfLine, tolerance) = x >= -tolerance

function similar_interval(d::HalfLine{T,C}, a::S, b::S) where {T,S,C}
    @assert a == 0
    @assert isinf(b) && b > 0
    HalfLine{promote_type(T,S),C}()
end

choice(d::NonnegativeRealLine) = zero(domaineltype(d))
choice(d::PositiveRealLine) = one(domaineltype(d))


"""
    NegativeHalfLine()
    NegativeHalfLine{T=Float64,C=:closed}()

The negative halfline `(-∞,0]` when `C` is `:closed` or `(-∞,0)` when `C` is
`:open`. The interval is always open at minus infinity.

See also: [`NonpositiveRealLine`](@ref), [`NegativeRealLine`](@ref).
"""
struct NegativeHalfLine{T,C} <: FixedInterval{:open,C,T} end
NegativeHalfLine() = NegativeHalfLine{Float64}()
NegativeHalfLine{T}() where {T} = NegativeHalfLine{T,:open}()

"""
    NonpositiveRealLine{T=Float64}()

The closed negative halfline `(-∞,0]`.
"""
const NonpositiveRealLine{T} = NegativeHalfLine{T,:closed}
"""
    NegativeRealLine{T=Float64}()

The open negative halfline `(-∞,0)`.
"""
const NegativeRealLine{T} = NegativeHalfLine{T,:open}
NonpositiveRealLine() = NonpositiveRealLine{Float64}()
NegativeRealLine() = NegativeRealLine{Float64}()

similardomain(::NegativeHalfLine{S,C}, ::Type{T}) where {S,T,C} =
    NegativeHalfLine{T,C}()

endpoints(d::NegativeHalfLine{T}) where {T} = (-T(Inf), zero(T))
boundary(d::NegativeHalfLine) = Point(rightendpoint(d))
interior(d::NegativeHalfLine{T}) where {T} = NegativeRealLine{T}()
closure(d::NegativeHalfLine{T}) where {T} = NonpositiveRealLine{T}()

# intercept and simplify the definition of IntervalSets
in(x, d::NonpositiveRealLine) = x <= 0
in(x, d::NegativeRealLine) = x < 0

approx_indomain(x, d::NegativeHalfLine, tolerance) = x < tolerance

function similar_interval(d::NegativeHalfLine{T,C}, a::S, b::S) where {S,T,C}
    @assert isinf(a) && a < 0
    @assert b == 0
    NegativeHalfLine{promote_type(S,T),C}()
end

choice(d::NegativeRealLine) = -one(domaineltype(d))
choice(d::NonpositiveRealLine) = zero(domaineltype(d))


"The real line `(-∞,∞)`."
struct RealLine{T} <: FixedInterval{:open,:open,T} end
RealLine() = RealLine{Float64}()

choice(d::RealLine) = zero(eltype(d))

similardomain(::RealLine, ::Type{T}) where {T} = RealLine{T}()

function similar_interval(d::RealLine{T}, a::S, b::S) where {S,T}
    @assert isinf(a) && a < 0
    @assert isinf(b) && b > 0
    RealLine{promote_type(S,T)}()
end

endpoints(d::RealLine{T}) where {T} = (-T(Inf), T(Inf))
boundary(d::RealLine) = emptyspace(d)
interior(d::RealLine) = d

isfullspace(d::RealLine) = true

similar_interval(d::Interval{L,R,T}, a::S, b::S) where {L,R,T,S} =
    Interval{L,R,promote_type(T,S)}(a, b)


#########################################
# A few set operations with known result
#########################################

# We define an exhaustive list of combinations of the four fixed intervals
# combined above in the routines 'intersect', 'union' and 'setdiff' where
# the output is known explicitly.

# Override the definition of Intervals.jl for FixedInterval's defined here
Base.union(d1::FixedInterval, d2::FixedInterval) = uniondomain(d1, d2)
Base.intersect(d1::FixedInterval, d2::FixedInterval) = intersectdomain(d1, d2)

# Promotion to joint type T
uniondomain(d1::TypedEndpointsInterval, d2::TypedEndpointsInterval) =
    uniondomain(promote_domains(d1,d2)...)
intersectdomain(d1::TypedEndpointsInterval, d2::TypedEndpointsInterval) =
    intersectdomain(promote_domains(d1,d2)...)
setdiffdomain(d1::AbstractInterval, d2::AbstractInterval) =
    setdiffdomain(promote_domains(d1,d2)...)



# type-unstable union of intervals. This function differs from `union` in
# IntervalSets.jl because that one throws an error if the intervals do not overlap
function uniondomain(d1::TypedEndpointsInterval{L1,R1,T}, d2::TypedEndpointsInterval{L2,R2,T}) where {L1,R1,L2,R2,T}
    a1 = leftendpoint(d1)
    b1 = rightendpoint(d1)
    a2 = leftendpoint(d2)
    b2 = rightendpoint(d2)

    # are they empty?
    isempty(d1) && return d2
    isempty(d2) && return d1
    # are they equal?
    d1 == d2 && return d1
    # does one lie within the other?
    a2 > a1 && b2 < b1 && return d1
    a1 > a2 && b1 < b2 && return d2
    # are they disjoint?
    b2 < a1 && return UnionDomain(d1, d2)   # return a UnionDomain for disjoint intervals
    b1 < a2 && return UnionDomain(d1, d2)
    if a1 ≤ b1 == a2 ≤ b2
        if R1 == :closed || L2 == :closed
            return Interval{L1,R2,T}(a1,b2)
        else
            return UnionDomain(Interval{L1,:open,T}(a1,b1), Interval{:open,R2,T}(a2,b2))
        end
    end
    # at this stage they must overlap
    if a1 < a2
        a = a1
        L = L1
    elseif a1 == a2
        a = a1
        L = (L1==L2==:open) ? :open : :closed
    else
        a = a2
        L = L2
    end
    if b1 > b2
        b = b1
        R = R1
    elseif b1 == b2
        b = b1
        R = (R1==R2==:open) ? :open : :closed
    else
        b = b2
        R = R2
    end
    Interval{L,R,T}(a, b)
end

function intersectdomain(d1::TypedEndpointsInterval{L1,R1,T}, d2::TypedEndpointsInterval{L2,R2,T}) where {L1,R1,L2,R2,T}
    # go back to the definition of IntervalSets.jl
    # to that end, convert to Interval in order to avoid stack overflow
    d = intersect(Interval(d1), Interval(d2))
    if isempty(d)
        # but avoid returning an interval like 2..1
        emptyspace(d)
    elseif leftendpoint(d)==rightendpoint(d)
        # and avoid an interval like 1..1
        Point(leftendpoint(d))
    else
        d
    end
end

isequaldomain(d1::TypedEndpointsInterval, d2::Point) =
    isclosedset(d1) && (leftendpoint(d1)==rightendpoint(d1)==pointval(d2))

# Since fixed intervals are fully determined by their type,
# the result of intersect, union or setdiff is always known for two
# domains of the same type.
intersectdomain(d1::D, d2::D) where {D <: FixedInterval} = d1
uniondomain(d1::D, d2::D) where {D <: FixedInterval} = d1
setdiffdomain(d1::D, d2::D) where {D <: FixedInterval} = emptyspace(d1)

# [0,1] ∩ [-1,1] = [0,1]
intersectdomain(d1::UnitInterval{T}, d2::ChebyshevInterval{T}) where {T} = UnitInterval{T}()
intersectdomain(d1::ChebyshevInterval{T}, d2::UnitInterval{T}) where {T} = UnitInterval{T}()
# [0,1] ∩ [0,∞) = [0,1]
intersectdomain(d1::UnitInterval{T}, d2::NonnegativeRealLine{T}) where {T} = UnitInterval{T}()
intersectdomain(d1::NonnegativeRealLine{T}, d2::UnitInterval{T}) where {T} = UnitInterval{T}()
# [0,1] ∩ (-∞,0) = {}
intersectdomain(d1::UnitInterval{T}, d2::NegativeRealLine{T}) where {T} = emptyspace(T)
intersectdomain(d1::NegativeRealLine{T}, d2::UnitInterval{T}) where {T} = emptyspace(T)
# [-1,1] ∩ [0,∞) = [0,1]
intersectdomain(d1::ChebyshevInterval{T}, d2::NonnegativeRealLine{T}) where {T} = UnitInterval{T}()
intersectdomain(d1::NonnegativeRealLine{T}, d2::ChebyshevInterval{T}) where {T} = UnitInterval{T}()
# open and closed halfline
intersectdomain(d1::HalfLine{T}, d2::NegativeRealLine{T}) where {T} = emptyspace(T)
intersectdomain(d1::NegativeRealLine{T}, d2::HalfLine{T}) where {T} = emptyspace(T)
intersectdomain(d1::NonnegativeRealLine{T}, d2::NonpositiveRealLine{T}) where {T} = Point(zero(T))
intersectdomain(d1::NonpositiveRealLine{T}, d2::NonnegativeRealLine{T}) where {T} = Point(zero(T))
intersectdomain(d1::NonnegativeRealLine{T}, d2::PositiveRealLine{T}) where {T} = d2
intersectdomain(d1::PositiveRealLine{T}, d2::NonnegativeRealLine{T}) where {T} = d1
# [a,b] ∩ (-∞,∞) = [a,b]
intersectdomain(d1::AbstractInterval{T}, d2::RealLine{T}) where {T} = d1
intersectdomain(d1::TypedEndpointsInterval{L,R,T}, d2::RealLine{T}) where {L,R,T} = d1
intersectdomain(d1::RealLine{T}, d2::AbstractInterval{T}) where {T} = d2
intersectdomain(d1::RealLine{T}, d2::TypedEndpointsInterval{L,R,T}) where {L,R,T} = d2
intersectdomain(d1::RealLine{T}, d2::RealLine{T}) where {T} = d1


# [0,1] ∪ [-1,1] = [-1,1]
uniondomain(d1::UnitInterval{T}, d2::ChebyshevInterval{T}) where {T} = ChebyshevInterval{T}()
uniondomain(d1::ChebyshevInterval{T}, d2::UnitInterval{T}) where {T} = ChebyshevInterval{T}()
# [0,1] ∪ [0,∞) = [0,∞)
uniondomain(d1::UnitInterval{T}, d2::NonnegativeRealLine{T}) where {T} = d2
uniondomain(d1::NonnegativeRealLine{T}, d2::UnitInterval{T}) where {T} = d1
# open and closed halflines
uniondomain(d1::NonnegativeRealLine{T}, d2::NonpositiveRealLine{T}) where {T} = RealLine{T}()
uniondomain(d1::NonpositiveRealLine{T}, d2::NonnegativeRealLine{T}) where {T} = RealLine{T}()
uniondomain(d1::PositiveRealLine{T}, d2::NonpositiveRealLine{T}) where {T} = RealLine{T}()
uniondomain(d1::NonpositiveRealLine{T}, d2::PositiveRealLine{T}) where {T} = RealLine{T}()
uniondomain(d1::NonnegativeRealLine{T}, d2::NegativeRealLine{T}) where {T} = RealLine{T}()
uniondomain(d1::NegativeRealLine{T}, d2::NonnegativeRealLine{T}) where {T} = RealLine{T}()
uniondomain(d1::NonnegativeRealLine{T}, d2::PositiveRealLine{T}) where {T} = d1
uniondomain(d1::PositiveRealLine{T}, d2::NonnegativeRealLine{T}) where {T} = d2
uniondomain(d1::NonpositiveRealLine{T}, d2::NegativeHalfLine{T}) where {T} = d1
uniondomain(d1::NegativeHalfLine{T}, d2::NonpositiveRealLine{T}) where {T} = d2
uniondomain(d1::NonpositiveRealLine{T}, d2::NonpositiveRealLine{T}) where {T} = d1
# [a,b] ∪ (-∞,∞) = (-∞,∞)
uniondomain(d1::AbstractInterval{T}, d2::RealLine{T}) where {T} = d2
uniondomain(d1::TypedEndpointsInterval{L,R,T}, d2::RealLine{T}) where {L,R,T} = d2
uniondomain(d1::RealLine{T}, d2::AbstractInterval{T}) where {T} = d1
uniondomain(d1::RealLine{T}, d2::TypedEndpointsInterval{L,R,T}) where {L,R,T} = d1
uniondomain(d1::RealLine{T}, d2::RealLine{T}) where {T} = d1


# [0,1] ∖ [-1,1] = {}
setdiffdomain(d1::UnitInterval{T}, d2::ChebyshevInterval{T}) where {T} = emptyspace(T)
# [0,1] ∖ [0,∞) = {}
setdiffdomain(d1::UnitInterval{T}, d2::NonnegativeRealLine{T}) where {T} = emptyspace(T)
# [0,1] ∖ (-∞,0) = [0,1]
setdiffdomain(d1::UnitInterval{T}, d2::NegativeRealLine{T}) where {T} = d1
# [-1,1] ∖ (-∞,0) = [0,1]
setdiffdomain(d1::ChebyshevInterval{T}, d2::NegativeRealLine{T}) where {T} = UnitInterval{T}()
# [0,∞) ∖ (-∞,0) = [0,∞)
setdiffdomain(d1::HalfLine{T}, d2::NegativeRealLine{T}) where {T} = d1
setdiffdomain(d1::HalfLine{T}, d2::NonpositiveRealLine{T}) where {T} = HalfLine{T,:open}()
# (-∞,0) ∖ [0,1] = (-∞,0)
setdiffdomain(d1::NegativeRealLine{T}, d2::UnitInterval{T}) where {T} = d1
# (-∞,0) ∖ [0,∞) = (-∞,0)
setdiffdomain(d1::NegativeHalfLine{T}, d2::PositiveRealLine{T}) where {T} = d1
setdiffdomain(d1::NegativeHalfLine{T}, d2::NonnegativeRealLine{T}) where {T} = NegativeRealLine{T}()
# (-∞,∞) ∖ [0,∞) = (-∞,0)
setdiffdomain(d1::RealLine{T}, d2::NonnegativeRealLine{T}) where {T} = NegativeRealLine{T}()
setdiffdomain(d1::RealLine{T}, d2::PositiveRealLine{T}) where {T} = NonpositiveRealLine{T}()
setdiffdomain(d1::RealLine{T}, d2::NonpositiveRealLine{T}) where {T} = PositiveRealLine{T}()
setdiffdomain(d1::RealLine{T}, d2::NegativeRealLine{T}) where {T} = NonnegativeRealLine{T}()


#################################
# Conversions between intervals
#################################
# Avoid depcrecated warning: Warning: Constructors no longer fall back to `convert`.
# example: A constructor `AbstractInterval{Float64}(::IntervalSets.ClosedInterval{Float64})` should be defined instead.

function convert(::Type{UnitInterval{T}}, d::AbstractInterval) where {T}
    endpoints(d) == (0,1) || throw(InexactError(:convert,UnitInterval,d))
    UnitInterval{T}()
end

function convert(::Type{ChebyshevInterval{T}}, d::AbstractInterval) where {T}
    endpoints(d) == (-1,1)|| throw(InexactError(:convert,ChebyshevInterval,d))
    ChebyshevInterval{T}()
end

UnitInterval{T}(d::AbstractInterval) where T = convert(UnitInterval{T}, d)
ChebyshevInterval{T}(d::AbstractInterval) where T = convert(ChebyshevInterval{T}, d)


function show(io::IO, d::ChebyshevInterval)
    print(io, Interval(d))
    print(io, " (Chebyshev)")
end
function show(io::IO, d::UnitInterval)
    print(io, Interval(d))
    print(io, " (Unit)")
end
function show(io::IO, d::HalfLine)
    print(io, Interval(d))
    print(io, " (HalfLine)")
end
function show(io::IO, d::RealLine)
    print(io, Interval(d))
    print(io, " (RealLine)")
end
function show(io::IO, d::NegativeHalfLine)
    print(io, Interval(d))
    print(io, " (NegativeHalfLine)")
end


########################
# Arithmetic operations
########################

complement(L) = L == :open ? :closed : :open

function setdiffdomain(d1::TypedEndpointsInterval{L1,R1,T}, d2::TypedEndpointsInterval{L2,R2,T}) where {L1,R1,L2,R2,T}
    a1 = leftendpoint(d1)
    b1 = rightendpoint(d1)
    a2 = leftendpoint(d2)
    b2 = rightendpoint(d2)

    # First treat the case of empty intervals
    isempty(d1) && return d1
    isempty(d2) && return d1

    # - the case where either interval is a point
    if a1 == b1
        return a1 ∈ d2 ? emptyspace(T) : d1
    end
    if a2 == b2
        return setdiffdomain(d1, Point(a2))
    end

    # We now know that a1 < b1 and a2 < b2
    # - the case where intervals are disjoint
    if (b1 < a2) || (a1 > b2)
        return d1
    end
    # - the case where the first is embedded in the second
    if (a2 < a1) && (b1 < b2)
        return EmptySpace{T}()
    end
    # - intervals overlap in whole or in part, with a1 <= a2
    if b1 == a2  # hence a1 < b1 = a2 < b2
        return L2 == :open && R1 == :closed ? d1 : Interval{L1,:open}(a1,b1)
    end
    if a1 < a2 < b1 < b2
        return Interval{L1,complement(L2),T}(a1,a2)
    end
    if a1 < a2 < b1 == b2
        int1 = Interval{L1,complement(L2),T}(a1,a2)
        return isrightopen(d2) && isrightclosed(d1) ?
            uniondomain(int1, Point(b1)) : int1
    end
    if a1 < a2 < b2 < b1
        int1 = Interval{L1,complement(L2)}(a1, a2)
        int2 = Interval{complement(R2),R1}(b2, b1)
        return uniondomain(int1, int2)
    end
    if a1 == a2 < b1 < b2
        return isleftclosed(d1) && isleftopen(d2) ?
            Point(a1) : EmptySpace{T}()
    end
    if a1 == a2 < b2 < b1
        int1 = Interval{complement(R2),R1}(b2, b1)
        return isleftclosed(d1) && isleftopen(d2) ?
            uniondomain(Point(a1), int1) : int1
    end
    # - intervals overlap completely
    if (a1 == a2) && (b1 == b2)
        no_left = isleftopen(d1) || isleftclosed(d2)
        no_right = isrightopen(d1) || isrightclosed(d2)
        if no_left && no_right
            return EmptySpace{T}()
        elseif no_left
            return Point(b1)
        elseif no_right
            return Point(a1)
        else
            return uniondomain(Point(a1), Point(b2))
        end
    end
    # - intervals overlap in part, with a2 < a1
    if a1 == b2  # hence a2 < b2 = a1 < b1
        return L1 == :closed && R2 == :open ? d1 : Interval{:open,R1}(a1,b1)
    end
    if a2 < a1 < b2 < b1
        return Interval{complement(R2),R1,T}(b2,b1)
    end
    if a2 < a1 && b1 == b2
        return isrightclosed(d1) && isrightopen(d2) ?
            Point(b1) : EmptySpace{T}()
    end
    # All cases covered, this line can't be reached
end


switch_open_closed_if_applicable(d::AbstractInterval) = d
switch_open_closed_if_applicable(d::Interval{L,R,T}) where {L,R,T} =
    Interval{R,L,T}(leftendpoint(d),rightendpoint(d))

function map_domain(map::AbstractAffineMap{<:Number}, domain::AbstractInterval)
    le = map(leftendpoint(domain))
    re = map(rightendpoint(domain))
    if le<re
        similar_interval(domain,le,re)
    else
        similar_interval(switch_open_closed_if_applicable(domain),re,le)
    end
end

mapped_domain(invmap::AbstractAffineMap{<:Number}, domain::AbstractInterval) =
    map_domain(inverse(invmap), domain)

# Preserve maps when acting on the half line and negative halfline, because
# the map may not always preserve the domain type
map_domain(map::AbstractAffineMap{<:Number}, domain::HalfLine) = MappedDomain(inverse(map), domain)
map_domain(map::AbstractAffineMap{<:Number}, domain::NegativeHalfLine) = MappedDomain(inverse(map), domain)

"""
A `DomainPoint` is a point which is an element of a domain by construction.

A domain point is just a point, not a domain. This is different from a `Point`
type.

The type is a wrapper: retrieve the underlying point using `point(p)`.
"""
abstract type DomainPoint{T} end

## Points on a sphere

"A point on the unit sphere."
abstract type SpherePoint{T} <: DomainPoint{T} end

domain(p::SpherePoint{T}) where {T<:StaticTypes} = UnitSphere{T}()
domain(p::SpherePoint{T}) where {T<:AbstractVector} = UnitSphere{T}(length(point(p)))

"A point on the unit sphere represented by a standard Euclidean vector."
struct EuclideanSpherePoint{T} <: SpherePoint{T}
    x   ::  T

    function EuclideanSpherePoint{T}(x::T) where T
        @assert norm(x) ≈ 1
        new(x)
    end
end
EuclideanSpherePoint(x::T) where T = EuclideanSpherePoint{T}(x)

point(p::EuclideanSpherePoint) = p.x

in(p::EuclideanSpherePoint{T}, d::UnitSphere{T}) where {T<:StaticTypes} = true
in(p::EuclideanSpherePoint{T}, d::UnitSphere{T}) where {T<:AbstractVector} =
    length(point(p)) == dimension(d)

"""
A point on the unit sphere represented in spherical coordinates.
"""
struct SphericalCoordinate{T} <: SpherePoint{SVector{3,T}}
    θ   ::  T   # inclination or polar angle
    ϕ   ::  T   # azimuthal angle
end
SphericalCoordinate(θ, ϕ) = SphericalCoordinate(promote(θ, ϕ)...)
SphericalCoordinate(θ::T, ϕ::T) where {T <: Integer} =
    SphericalCoordinate(float(θ), float(ϕ))

point(p::SphericalCoordinate) = SVector(sin(p.θ)*cos(p.ϕ), sin(p.θ)*sin(p.ϕ), cos(p.θ))

in(p::SphericalCoordinate{T}, d::EuclideanUnitSphere{3,T}) where T = true

struct InheritedDomain <: Domain{Int} end

struct InterfaceDomain end
DomainSets.domaineltype(::InterfaceDomain) = Int
DomainSets.DomainStyle(::Type{InterfaceDomain}) = IsDomain()

struct NonDomain end

@testset "Domain interface" begin
    d1 = InheritedDomain()
    @test d1 isa Domain
    # @test eltype(d1) == Any   # to be changed in breaking release
    @test eltype(d1) == Int
    @test domaineltype(d1) == Int
    @test domaineltype(DomainRef(d1)) == Int
    @test DomainStyle(d1) == IsDomain()
    @test checkdomain(d1) === d1
    @test domain(d1) === d1

    d2 = InterfaceDomain()
    @test !(d2 isa Domain)
    @test domaineltype(d2) == Int
    @test domaineltype(DomainRef(d2)) == Int
    @test domaineltype(DomainRef(d2)) == domaineltype(d2)
    @test DomainStyle(d2) == IsDomain()
    @test DomainRef(d2) isa DomainRef
    @test domain(DomainRef(d2)) == d2
    @test checkdomain(d2) === d2
    @test checkdomain(DomainRef(d2)) === d2

    d3 = NonDomain()
    @test !(d3 isa Domain)
    @test DomainStyle(d3) == NotDomain()
    @test_throws ErrorException checkdomain(d3)

    @test DomainStyle(2.0) == IsDomain()
    @test DomainStyle([1,2]) == IsDomain()
    @test DomainStyle(Set([1,2])) == IsDomain()

    s = "string"
    @test domaineltype(s) == eltype(s)
    p = Point(0.5)
    @test !(p == 0.5)
    @test p == DomainRef(0.5)

    @test union(0.5,0.7) isa Vector{Float64}
    @test uniondomain(0.5, 0.7) == [0.5, 0.7]
    @test uniondomain(0.5, 1) == [0.5, 1]
    # @test_throws MethodError union(Point(0.5), 0.5)
    @test union(Point(0.5), DomainRef(0.5)) == Point(0.5)
    @test union(Point(0.5), DomainRef(0.7)) isa UnionDomain{Float64}
end

function test_dimension()
    @test euclideandimension(Int) == 1
    @test euclideandimension(Float64) == 1
    @test euclideandimension(ComplexF64) == 1
    @test euclideandimension(SVector{2,Float64}) == 2
    @test euclideandimension(MVector{2,Float64}) == 2
    @test euclideandimension(Tuple{Int,Int}) == 2
    @test euclideandimension(Tuple{Int,Float64}) == 2
    @test_throws ArgumentError euclideandimension(Vector{Float64})
end

function test_prectype()
    @test prectype(1.0) == Float64
    @test prectype(big(1.0)) == BigFloat
    @test prectype(1) == typeof(float(1))
    @test prectype(SVector(1,2)) == typeof(float(1))
    @test prectype(SVector(1,big(2))) == typeof(float(big(2)))
    @test prectype(1.0+2.0im) == Float64
    @test prectype([1.0+2.0im, 3.0]) == Float64
    @test prectype(NTuple{2,Int}) == Float64
    @test prectype(typeof((1.0,))) == Float64
    @test prectype(typeof((1.0, 2.0))) == Float64
    @test prectype(typeof((1.0, 2.0, 3.0))) == Float64
    @test prectype(typeof((1.0, big(2.0), 3.0+im))) == BigFloat
    @test prectype(NTuple{4,Int}) == Float64
    @test @inferred(prectype(1, 2.0)) == Float64
    @test @inferred(prectype(typeof((1, 2.0, 3, 40+im)))) == Float64

    @test convert_prectype(Float64, 2) == 2
    @test convert_prectype(Float64, 2) isa Float64
    @test convert_prectype(BigFloat, 1.0+im) == 1+im
    @test convert_prectype(BigFloat, 1.0+im) isa Complex{BigFloat}
    @test convert_prectype(Float64, SA[1,2]) == SA[1.0,2.0]
    @test convert_prectype(Float64, SA[1,2]) isa SVector{2,Float64}
    @test convert_prectype(Float64, MVector(1,2)) == MVector(1.0,2.0)
    @test convert_prectype(Float64, MVector(1,2)) isa MVector
    @test convert_prectype(Float64, SA[1 2; 3 4]) == SA[1.0 2.0; 3.0 4.0]
    @test convert_prectype(Float64, SA[1 2; 3 4]) isa SMatrix{2,2,Float64}
    @test convert_prectype(Float64, MMatrix{2,2}(1, 2, 3, 4)) == SA[1.0 3.0; 2.0 4.0]
    @test convert_prectype(Float64, MMatrix{2,2}(1, 2, 3, 4)) isa MMatrix{2,2,Float64}
    @test convert_prectype(BigFloat, SA[1,2+im]) isa SVector{2,Complex{BigFloat}}
    @test_throws ArgumentError convert_prectype(BigFloat, "a")

    @test promote_prectype(2) == 2
    @test promote_prectype(2, 3.0) isa Tuple{Float64,Float64}
    @test promote_prectype(2, 3.0+im, big(4)) isa Tuple{BigFloat,Complex{BigFloat},BigFloat}
end


function test_numtype()
    @test numtype(1.0) == Float64
    @test numtype(big(1.0)) == BigFloat
    @test numtype(1) == Int
    @test numtype([1,2,3], [4,5,6]) == Int
    @test numtype(SVector(1,2)) == Int
    @test numtype(SVector(1,big(2))) == BigInt
    @test numtype(Array{Float64,2}) == Float64
    @test numtype(1.0+2.0im) == Complex{Float64}
    @test numtype([1.0+2.0im, 3.0]) == Complex{Float64}
    @test numtype(NTuple{2,Complex{Int}}) == Complex{Int}
    @test numtype(typeof((1.0,))) == Float64
    @test numtype(typeof((1.0, 2.0))) == Float64
    @test numtype((1.0, 2.0, 3.0)) == Float64
    @test numtype((1.0, 2.0, 3.0, 4.0)) == Float64
    @test numtype(1.0, big(2.0), 3.0+im) == Complex{BigFloat}
    @test numtype(typeof((1.0, big(2.0), 3.0+im))) == Complex{BigFloat}
    @test @inferred(numtype(1, 2.0)) == Float64
    @test @inferred(numtype(typeof((1, 2.0, 3, 40+im)))) == Complex{Float64}

    @test convert_numtype(Float64, 2) == 2
    @test convert_numtype(Float64, 2) isa Float64
    @test convert_numtype(Float64, SA[1,2]) == SA[1.0,2.0]
    @test convert_numtype(Float64, SA[1,2]) isa SVector{2,Float64}
    @test convert_numtype(Float64, MVector(1,2)) == MVector(1.0,2.0)
    @test convert_numtype(Float64, MVector(1,2)) isa MVector
    @test convert_numtype(Float64, SA[1 2; 3 4]) == SA[1.0 2.0; 3.0 4.0]
    @test convert_numtype(Float64, SA[1 2; 3 4]) isa SMatrix{2,2,Float64}
    @test convert_numtype(Float64, MMatrix{2,2}(1, 2, 3, 4)) == SA[1.0 3.0; 2.0 4.0]
    @test convert_numtype(Float64, MMatrix{2,2}(1, 2, 3, 4)) isa MMatrix{2,2,Float64}
    @test_throws ArgumentError convert_numtype(BigFloat, "a")

    @test promote_numtype(2) == 2
    @test promote_numtype(2, 3.0) isa Tuple{Float64,Float64}
    @test promote_numtype(2, 3.0+im, big(4)) isa Tuple{Complex{BigFloat},Complex{BigFloat},Complex{BigFloat}}
end

@testset "common functionality" begin
    @testset "dimension" begin
        test_dimension()
    end
    @testset "prectype" begin
        test_prectype()
    end
    @testset "numtype" begin
        test_numtype()
    end
end

@deprecate convert_prectype(d::Domain, ::Type{T}) where {T} convert_prectype(T, d)
@deprecate convert_numtype(d::Domain, ::Type{T}) where {T} convert_numtype(T, d)

@deprecate point_in_domain(d) choice(d)

@deprecate broadcast_in(A, d::Domain) vectorized_in(A, d)
@deprecate broadcast_approx_in(A, d::Domain) vectorized_approx_in(A, d)
@deprecate broadcast_approx_in(A, d::Domain, tol) vectorized_approx_in(A, d, tol)

@deprecate UnionDomain(domain::Domain) UnionDomain((domain,))
@deprecate UnionDomain{T}(domain::Domain) where {T} UnionDomain{T}((domain,))
@deprecate IntersectDomain(domain::Domain) IntersectDomain((domain,))
@deprecate IntersectDomain{T}(domain::Domain) where T IntersectDomain((domain,))

@deprecate issubset(d1::AnyDomain, d2) issubset(d1, DomainRef(d2))
@deprecate union(d1::AnyDomain, d2, domains...) union(d1, DomainRef(d2), domains...)
@deprecate union(d1, d2::AnyDomain, domains...) union(DomainRef(d1), d2, domains...)
@deprecate intersect(d1, d2::AnyDomain) intersect(DomainRef(d1), d2)
@deprecate intersect(d1::AnyDomain, d2) intersect(d1, DomainRef(d2))
@deprecate \(d1::AnyDomain, d2) d1 \ DomainRef(d2)
@deprecate \(d1, d2::AnyDomain) DomainRef(d1) \ d2
@deprecate setdiff(d1::AnyDomain, d2) setdiff(d1, DomainRef(d2))
@deprecate setdiff(d1, d2::AnyDomain) setdiff(DomainRef(d1), d2)
@deprecate (&)(d1::AnyDomain, d2) d1 & DomainRef(d2)
@deprecate (&)(d1, d2::AnyDomain) DomainRef(d1) & d2

@deprecate isequal1(d1,d2) isequaldomain1(d1,d2)
@deprecate isequal2(d1,d2) isequaldomain2(d1,d2)

# AsDomain was defined in versions 0.7 and 0.7.1, and then replaced by DomainRef
@deprecate AsDomain(d) DomainRef(d)

@deprecate inv(m::AbstractMap) inverse(m)

@deprecate size(m::AbstractMap) mapsize(m)
@deprecate size(m::AbstractMap, i) mapsize(m, i)
@deprecate issquare(m::AbstractMap) issquaremap(m)

# Added in v0.7.17, to be removed in v0.8
@deprecate isreal(d::Domain) isrealdomain(d)
LinearAlgebra.cross(d1::Domain, domains...) = linearalgebra_x_becomes_domainsets_x(d1, domains...)
@deprecate linearalgebra_x_becomes_domainsets_x(d1::Domain, domains...) cartesianproduct(d1, domains...)

isrealtype(::Type{<:Real}) = true
isrealtype(::Type{<:Complex}) = false
isrealtype(::Type{T}) where {T} = isrealtype(eltype(T))

const StaticTypes = Union{Number,<:StaticVector{N} where N,<:NTuple{N,Any} where N}

"Apply the `hash` function recursively to the given arguments."
hashrec(x) = hash(x)
hashrec(x, args...) = hash(x, hashrec(args...))

# Workaround for #88, manually compute the hash of an array using all its elements
hashrec() = zero(UInt)
function hashrec(A::AbstractArray, args...)
	h = hash(size(A))
	for x in A
		h = hash(x, h)
	end
	hash(h, hashrec(args...))
end

"What is the euclidean dimension of the given type (if applicable)?"
euclideandimension(::Type{T}) where {T <: Number} = 1
euclideandimension(::Type{T}) where {N,T <: StaticVector{N}} = N
euclideandimension(::Type{T}) where {N,T <: NTuple{N,Any}} = N
euclideandimension(::Type{T}) where {T} =
	throw(ArgumentError("Don't know the euclidean dimension of $(T)."))

#################
# Element type
#################

"""
	convert_eltype(T, x)

Convert `x` such that its `eltype` equals `T`.
"""
convert_eltype(::Type{T}, d::AbstractArray) where {T} = convert(AbstractArray{T}, d)
convert_eltype(::Type{T}, d::AbstractRange) where {T} = map(T, d)
convert_eltype(::Type{T}, d::Set) where {T} = convert(Set{T}, d)
convert_eltype(::Type{T}, d::Number) where {T} = convert(T, d)

"Are the given element types promotable to a concrete supertype?"
promotable_eltypes(types...) = isconcretetype(promote_type(types...))
promotable_eltypes(::Type{S}, ::Type{T}) where {S<:AbstractVector,T<:AbstractVector} =
    promotable_eltypes(eltype(S), eltype(T))

#################
# Precision type
#################

"""
	prectype(x[, ...])

The floating point precision type associated with the argument(s).
"""
prectype(x) = prectype(typeof(x))
prectype(::Type{T}) where T = Any		# fallback
prectype(::Type{T}) where {T<:AbstractFloat} = T
prectype(::Type{T}) where {T<:Number} = prectype(float(T))
prectype(::Type{<:AbstractArray{T}}) where T = prectype(T)
prectype(::Type{<:Complex{T}}) where {T} = prectype(T)
prectype(::Type{NTuple{N,T}}) where {N,T} = prectype(T)
prectype(::Type{Tuple{A}}) where {A} = prectype(A)
prectype(::Type{Tuple{A,B}}) where {A,B} = prectype(A,B)
prectype(::Type{Tuple{A,B,C}}) where {A,B,C} = prectype(A,B,C)
@generated function prectype(T::Type{<:Tuple})
    quote $(promote_type(map(prectype, T.parameters[1].parameters)...)) end
end

prectype(a...) = promote_type(map(prectype, a)...)

"""
	convert_prectype(T, x)

Convert `x` such that its `prectype` equals `T`.
"""
convert_prectype(::Type{T}, x) where {T} =
	convert_eltype(to_prectype(T, eltype(x)), x)

"""
	to_prectype(U, T)

Return the type to which `T` can be converted, such that the `prectype` becomes `U`.
"""
to_prectype(::Type{U}, ::Type{T}) where {T,U} = throw(ArgumentError("Don't know how to convert the prectype of $(T) to $(U)."))
to_prectype(::Type{U}, ::Type{T}) where {T <: Real,U <: Real} = U
to_prectype(::Type{U}, ::Type{Complex{T}}) where {T <: Real,U <: Real} = Complex{U}
to_prectype(::Type{U}, ::Type{Vector{T}}) where {T,U} = Vector{to_prectype(U,T)}
to_prectype(::Type{U}, ::Type{<:StaticVector{N,T}}) where {N,T,U} = SVector{N,to_prectype(U,T)}
to_prectype(::Type{U}, ::Type{MVector{N,T}}) where {N,T,U} = MVector{N,to_prectype(U,T)}
to_prectype(::Type{U}, ::Type{<:StaticMatrix{M,N,T}}) where {M,N,T,U} = SMatrix{M,N,to_prectype(U,T)}
to_prectype(::Type{U}, ::Type{MMatrix{M,N,T}}) where {M,N,T,U} = MMatrix{M,N,to_prectype(U,T)}

"""
	promote_prectype(a, b[, ...])

Promote the precision types of the arguments to a joined supertype.
"""
promote_prectype(a) = a
promote_prectype(a, b) = _promote_prectype(prectype(a,b), a, b)
promote_prectype(a, b, c...) = _promote_prectype(prectype(a,b,c...), a, b, c...)
_promote_prectype(U, a) = convert_prectype(U, a)
_promote_prectype(U, a, b) = convert_prectype(U, a), convert_prectype(U, b)
_promote_prectype(U, a, b, c...) =
    (convert_prectype(U, a), convert_prectype(U, b), _promote_prectype(U, c...)...)

#################
# Numeric type
#################

"The numeric element type of `x` in a Euclidean space."
numtype(x) = numtype(typeof(x))
numtype(::Type{T}) where T = Any
numtype(::Type{T}) where {T<:Number} = T
numtype(::Type{<:AbstractArray{T}}) where T = T
numtype(::Type{NTuple{N,T}}) where {N,T} = T
numtype(::Type{Tuple{A,B}}) where {A,B} = promote_type(numtype(A), numtype(B))
numtype(::Type{Tuple{A,B,C}}) where {A,B,C} = promote_type(numtype(A), numtype(B), numtype(C))
numtype(::Type{Tuple{A,B,C,D}}) where {A,B,C,D} = promote_type(numtype(A), numtype(B), numtype(C), numtype(D))
@generated function numtype(T::Type{<:Tuple})
    quote $(promote_type(T.parameters[1].parameters...)) end
end

numtype(a...) = promote_type(map(numtype, a)...)

"""
	convert_numtype(T, x)

Convert `x` such that its `numtype` equals `T`.
"""
convert_numtype(::Type{T}, x) where {T} =
	convert_eltype(to_numtype(T, eltype(x)), x)

"""
	to_numtype(U, T)

Return the type to which `T` can be converted, such that the `numtype` becomes `U`.
"""
to_numtype(::Type{U}, ::Type{T}) where {T,U} = throw(ArgumentError("Don't know how to convert the numtype of $(T) to $(U)."))
to_numtype(::Type{U}, ::Type{T}) where {T <: Number,U <: Number} = U
to_numtype(::Type{U}, ::Type{Vector{T}}) where {T,U} = Vector{to_numtype(U,T)}
to_numtype(::Type{U}, ::Type{<:StaticVector{N,T}}) where {N,T,U} = SVector{N,to_numtype(U,T)}
to_numtype(::Type{U}, ::Type{MVector{N,T}}) where {N,T,U} = MVector{N,to_numtype(U,T)}
to_numtype(::Type{U}, ::Type{<:StaticMatrix{M,N,T}}) where {M,N,T,U} = SMatrix{M,N,to_numtype(U,T)}
to_numtype(::Type{U}, ::Type{MMatrix{M,N,T}}) where {M,N,T,U} = MMatrix{M,N,to_numtype(U,T)}

"""
	promote_numtype(a, b[, ...])

Promote the numeric types of the arguments to a joined supertype.
"""
promote_numtype(a) = a
promote_numtype(a, b) = _promote_numtype(numtype(a,b), a, b)
promote_numtype(a, b, c...) = _promote_numtype(numtype(a,b,c...), a, b, c...)
_promote_numtype(U, a) = convert_numtype(U, a)
_promote_numtype(U, a, b) = convert_numtype(U, a), convert_numtype(U, b)
_promote_numtype(U, a, b, c...) =
    (convert_numtype(U, a), convert_numtype(U, b), _promote_numtype(U, c...)...)

## Conversion from nested vectors to flat vectors and back

"""
Convert a vector from a cartesian format to a nested tuple according to the
given dimensions.

For example:
`convert_fromcartesian([1,2,3,4,5], Val{(2,2,1)}()) -> ([1,2],[3,4],5)`
"""
@generated function convert_fromcartesian(x::AbstractVector, ::Val{DIM}) where {DIM}
	dimsum = [0; cumsum([d for d in DIM])]
	E = Expr(:tuple, [ (dimsum[i+1]-dimsum[i] > 1 ? Expr(:call, :SVector, [:(x[$j]) for j = dimsum[i]+1:dimsum[i+1]]...) : :(x[$(dimsum[i+1])])) for i in 1:length(DIM)]...)
	return quote $(E) end
end

"The inverse function of `convert_fromcartesian`."
@generated function convert_tocartesian(x, ::Val{DIM}) where {DIM}
    dimsum = [0; cumsum([d for d in DIM])]
    E = vcat([[:(x[$i][$j]) for j in 1:DIM[i]] for i in 1:length(DIM)]...)
    quote SVector($(E...)) end
end

# we use matrix_pinv rather than pinv to preserve static matrices
matrix_pinv(A) = pinv(A)
# matrix_pinv(A::SMatrix{M,N}) where {M,N} = SMatrix{N,M}(pinv(A))
matrix_pinv(A::StaticVector{N}) where {N} = convert(Transpose{Float64, SVector{N,Float64}}, pinv(A))

## Composite objects

"Factors of a product-like composite object (equivalent to `components(d)`)."
function factors end
"The number of factors of a product-like composite object."
nfactors(d) = length(factors(d))
"Factor `I...` of a product-like composite object."
factor(d, I...) = getindex(factors(d), I...)

module DomainSetsMakieTests
using DomainSets, StaticArrays, Test
import Makie
import Makie: plot, Poly, Lines, Scatter
using DomainSets: Sphere, ×

@testset "Plotting" begin
    @testset "2D" begin
        @test plot(cartesianproduct(0..1, 1..2)).plot isa Poly
        @test plot(UnitCircle()).plot isa Lines
        @test plot(UnitDisk()).plot isa Poly
        @test plot(Sphere(2.0, SVector(1.0, 0.5))).plot isa Lines
        @test plot(Sphere(3.0, [1.0, 0.5])).plot isa Lines
        @test plot(Point(SVector(0.1,0.2))).plot isa Scatter
    end

    @testset "3D" begin
        @test plot(cartesianproduct(0..1, 1..2, 3..4)).plot isa Poly
        @test plot(UnitBall()).plot isa Poly
        @test plot(Sphere(2.0, SVector(1.0, 0.5,0.5))).plot isa Lines
        @test plot(Sphere(3.0, [1.0, 0.5,0.5])).plot isa Lines
    end
end
end # module

using Test, LinearAlgebra, StaticArrays, Random, StableRNGs

using DomainSets
using CompositeTypes.Indexing

using DomainSets: ×

const io = IOBuffer()
const textmime = MIME"text/plain"()

println("#############################")
println("# Aqua automated tests")
println("#############################")
include("aqua.jl")

println("#############################")
println("# Tests of DomainSets.jl")
println("#############################")
include("test_common.jl")
include("test_generic_domain.jl")
include("test_specific_domains.jl")
include("test_canonical.jl")
include("test_setoperations.jl")
include("test_interface.jl")
include("test_applications.jl")
include("test_readme.jl")

if isdefined(Base, :get_extension)
    println("#############################")
    println("# Tests of extensions")
    println("#############################")

    include("test_makieext.jl")
end

"""
An affine map has the general form `y = A*x + b`.

We use `affinematrix(m)` and `affinevector(m)` to denote `A` and `b` respectively. Concrete
subtypes include linear maps of the form `y = A*x` and translations of the
form `y = x + b`.
"""
abstract type AbstractAffineMap{T} <: Map{T} end

unsafe_matrix(m::AbstractAffineMap) = m.A
unsafe_vector(m::AbstractAffineMap) = m.b

"Return the matrix `A` in the affine map `Ax+b`."
affinematrix(m::AbstractAffineMap) = to_matrix(domaintype(m), unsafe_matrix(m), unsafe_vector(m))

"Return the vector `b` in the affine map `Ax+b`."
affinevector(m::AbstractAffineMap) = to_vector(domaintype(m), unsafe_matrix(m), unsafe_vector(m))

applymap(m::AbstractAffineMap, x) = _affine_applymap(m, x, unsafe_matrix(m), unsafe_vector(m))
_affine_applymap(m, x, A, b) = A*x + b

applymap!(y, m::AbstractAffineMap, x) = _affine_applymap!(y, m, x, unsafe_matrix(m), unsafe_vector(m))
function _affine_applymap!(y, m, x, A, b)
    mul!(y, A, x)
    y .+= b
    y
end

isreal(m::AbstractAffineMap) = _affine_isreal(m, unsafe_matrix(m), unsafe_vector(m))
_affine_isreal(m, A, b) = isreal(A) && isreal(b)

jacobian(m::AbstractAffineMap{T}) where {T} = ConstantMap{T}(affinematrix(m))
jacobian(m::AbstractAffineMap, x) = affinematrix(m)

jacdet(m::AbstractAffineMap, x) = _affine_jacdet(m, x, unsafe_matrix(m))
_affine_jacdet(m, x, A) = det(A)
_affine_jacdet(m, x::Number, A::UniformScaling) = A.λ
_affine_jacdet(m, x::AbstractVector, A::Number) = A^length(x)
_affine_jacdet(m, x::AbstractVector, A::UniformScaling) = A.λ^length(x)

function diffvolume(m::AbstractAffineMap{T}) where T
    J = jacobian(m)
    c = sqrt(det(affinevector(J)'*affinevector(J)))
    ConstantMap{T}(c)
end

islinearmap(m::AbstractMap) = false
islinearmap(m::AbstractAffineMap) = _affine_islinearmap(m, unsafe_vector(m))
_affine_islinearmap(m, b) = all(b .== 0)

isaffinemap(m) = false
isaffinemap(m::Map) = islinearmap(m) || isconstantmap(m)
isaffinemap(m::AbstractAffineMap) = true

isequalmap(m1::AbstractAffineMap, m2::AbstractAffineMap) =
    affinematrix(m1) == affinematrix(m2) && affinevector(m1) == affinevector(m2)

isequalmap(m1::AbstractAffineMap, m2::IdentityMap) =
    islinearmap(m1) && affinematrix(m1) == affinematrix(m2)
isequalmap(m1::IdentityMap, m2::AbstractAffineMap) = isequalmap(m2, m1)

map_hash(m::AbstractAffineMap, h::UInt) = hashrec("AbstractAffineMap", affinematrix(m), affinevector(m), h)

mapsize(m::AbstractAffineMap) = _affine_mapsize(m, domaintype(m), unsafe_matrix(m), unsafe_vector(m))
_affine_mapsize(m, T, A::AbstractArray, b) = size(A)
_affine_mapsize(m, T, A::AbstractVector, b::AbstractVector) = (length(A),)
_affine_mapsize(m, T, A::Number, b::Number) = ()
_affine_mapsize(m, T, A::Number, b::AbstractVector) = (length(b),length(b))
_affine_mapsize(m, T, A::UniformScaling, b::Number) = ()
_affine_mapsize(m, T, A::UniformScaling, b) = (length(b),length(b))


Display.displaystencil(m::AbstractAffineMap) = vcat(["x -> "], map_stencil(m, 'x'))
show(io::IO, mime::MIME"text/plain", m::AbstractAffineMap) = composite_show(io, mime, m)

map_stencil(m::AbstractAffineMap, x) = _affine_map_stencil(m, x, unsafe_matrix(m), unsafe_vector(m))
_affine_map_stencil(m, x, A, b) = [A, " * ", x, " + ", b]
_affine_map_stencil(m, x, A, b::Real) =
    b >= 0 ? [A, " * ", x, " + ", b] :  [A, " * ", x, " - ", abs(b)]

map_stencil_broadcast(m::AbstractAffineMap, x) = _affine_map_stencil_broadcast(m, x, unsafe_matrix(m), unsafe_vector(m))
_affine_map_stencil_broadcast(m, x, A, b) = [A, " .* ", x, " .+ ", b]
_affine_map_stencil_broadcast(m, x, A::Number, b) = [A, " * ", x, " .+ ", b]

map_object_parentheses(m::AbstractAffineMap) = true
map_stencil_parentheses(m::AbstractAffineMap) = true

########################
# Linear maps: y = A*x
########################

"""
The supertype of all linear maps `y = A*x`.
Concrete subtypes may differ in how `A` is represented.
"""
abstract type LinearMap{T} <: AbstractAffineMap{T} end

mapsize(m::LinearMap) = _linearmap_size(m, domaintype(m), unsafe_matrix(m))
_linearmap_size(m, T, A) = size(A)
_linearmap_size(m, ::Type{T}, A::Number) where {T<:Number} = ()
_linearmap_size(m, ::Type{T}, A::AbstractVector) where {T<:Number} = (length(A),)
_linearmap_size(m, ::Type{T}, A::Number) where {N,T<:StaticVector{N}} = (N,N)

affinematrix(m::LinearMap) = to_matrix(domaintype(m), unsafe_matrix(m))
affinevector(m::LinearMap) = to_vector(domaintype(m), unsafe_matrix(m))

LinearMap(A::Number) = ScalarLinearMap(A)
LinearMap(A::SMatrix) = StaticLinearMap(A)
LinearMap(A::MMatrix) = StaticLinearMap(A)
LinearMap(A::Matrix) = VectorLinearMap(A)
LinearMap(A) = GenericLinearMap(A)

LinearMap{T}(A::Number) where {T<:Number} = _LinearMap(A, T, promote_type(T,typeof(A)))
_LinearMap(A::Number, ::Type{T}, ::Type{T}) where {T<:Number} = ScalarLinearMap{T}(A)
_LinearMap(A::Number, ::Type{T}, ::Type{S}) where {T<:Number,S} = GenericLinearMap{T}(A)
LinearMap{T}(A::SMatrix{M,N}) where {M,N,S,T <: SVector{N,S}} = StaticLinearMap{S}(A)
LinearMap{T}(A::MMatrix{M,N}) where {M,N,S,T <: SVector{N,S}} = StaticLinearMap{S}(A)
LinearMap{T}(A::Matrix) where {S,T <: Vector{S}} = VectorLinearMap{S}(A)
LinearMap{T}(A) where {T} = GenericLinearMap{T}(A)

# convenience functions
LinearMap(a::Number...) = LinearMap(promote(a...))
LinearMap(a::NTuple{N,T}) where {N,T <: Number} = LinearMap{SVector{N,T}}(Diagonal(SVector{N,T}(a)))

applymap(m::LinearMap, x) = _linear_applymap(m, x, unsafe_matrix(m))
_linear_applymap(m, x, A) = A*x

applymap!(y, m::LinearMap, x) = _linear_applymap!(y, m, x, unsafe_matrix(m))
_linear_applymap!(y, m, x, A) = mul!(y, A, x)

islinearmap(m::LinearMap) = true

isreal(m::LinearMap) = _linear_isreal(m, unsafe_matrix(m))
_linear_isreal(m, A) = isreal(A)

isequalmap(m1::LinearMap, m2::LinearMap) = affinematrix(m1) == affinematrix(m2)

# inverse should be called only on square maps, otherwise use
# leftinverse or rightinverse in order to use pinv instead of inv
inverse(m::LinearMap) = (@assert issquaremap(m); LinearMap(inv(m.A)))
inverse(m::LinearMap, x) = (@assert issquaremap(m); m.A \ x)

function leftinverse(m::LinearMap)
    @assert isoverdetermined(m)
    LinearMap(matrix_pinv(m.A))
end
function rightinverse(m::LinearMap)
    @assert isunderdetermined(m)
    LinearMap(matrix_pinv(m.A))
end
function leftinverse(m::LinearMap, x)
    @assert isoverdetermined(m)
    m.A \ x
end
function rightinverse(m::LinearMap, x)
    @assert isunderdetermined(m)
    m.A \ x
end

similarmap(m::LinearMap, ::Type{T}) where {T} = LinearMap{T}(m.A)

convert(::Type{Map}, a::Number) = LinearMap(a)
convert(::Type{Map{T}}, a::Number) where {T} = LinearMap{T}(a)

convert(::Type{LinearMap}, ::StaticIdentityMap{T}) where {T} = LinearMap{T}(1)
convert(::Type{LinearMap{T}}, ::StaticIdentityMap) where {T} = LinearMap{T}(1)
convert(::Type{AbstractAffineMap}, m::StaticIdentityMap) = convert(LinearMap, m)
convert(::Type{AbstractAffineMap{T}}, m::StaticIdentityMap) where {T} = convert(LinearMap, m)


map_stencil(m::LinearMap, x) = [unsafe_matrix(m), " * ", x]
map_stencil_broadcast(m::LinearMap, x) = _linear_map_stencil_broadcast(m, x, unsafe_matrix(m))
_linear_map_stencil_broadcast(m, x, A) = [A, " .* ", x]
_linear_map_stencil_broadcast(m, x, A::Number) = [A, " * ", x]


"A `GenericLinearMap` is a linear map `y = A*x` for any type of `A`."
struct GenericLinearMap{T,AA} <: LinearMap{T}
    A   ::  AA
end

"""
What is the suggested domaintype for a generic linear map `A*x` with
the given argument 'A'?
"""
glm_domaintype(A) = Any
glm_domaintype(A::Number) = typeof(A)
glm_domaintype(A::AbstractMatrix{T}) where T = Vector{T}
glm_domaintype(A::StaticMatrix{M,N,T}) where {M,N,T} = SVector{N,T}
glm_domaintype(A::AbstractVector{T}) where {T} = T
glm_domaintype(A::Diagonal{T,<:StaticVector{N,T}}) where {N,T} = SVector{N,T}

GenericLinearMap(A) = GenericLinearMap{glm_domaintype(A)}(A)

# Allow any A
GenericLinearMap{T}(A) where {T} = GenericLinearMap{T,typeof(A)}(A)

# Promote some eltypes if applicable
GenericLinearMap{T}(A::Number) where {T <: Number} =
    _GenericLinearMap(A, T, promote_type(T,typeof(A)))
_GenericLinearMap(A::Number, ::Type{T}, ::Type{T}) where {T <: Number} =
    GenericLinearMap{T,T}(A)
_GenericLinearMap(A::Number, ::Type{T}, ::Type{S}) where {S,T<:Number} =
    GenericLinearMap{T,typeof(A)}(A)

GenericLinearMap{T}(A::Number) where {T <: AbstractVector} =
    _GenericLinearMap(A, T, promote_type(eltype(T),typeof(A)))
_GenericLinearMap(A::Number, ::Type{T}, ::Type{S}) where {S,T<:AbstractVector{S}} =
    GenericLinearMap{T,S}(A)
_GenericLinearMap(A::Number, ::Type{T}, ::Type{S}) where {S,T<:AbstractVector} =
    GenericLinearMap{T,typeof(A)}(A)

GenericLinearMap{T}(A::AbstractMatrix{S}) where {S,T <: AbstractVector{S}} =
    GenericLinearMap{T,typeof(A)}(A)
GenericLinearMap{T}(A::AbstractMatrix{U}) where {S,T <: AbstractVector{S},U} =
    GenericLinearMap{T}(convert(AbstractMatrix{S}, A))
GenericLinearMap{T}(A::AbstractVector{T}) where {T} =
    GenericLinearMap{T,typeof(A)}(A)
GenericLinearMap{T}(A::AbstractVector{S}) where {S,T} =
    GenericLinearMap{T}(convert(AbstractVector{T}, A))
GenericLinearMap{T}(A::AbstractMatrix) where {T<:Number} =
    throw(ArgumentError("Linear map with matrix A can not have scalar domaintype."))

# Preserve the action on vectors with a number type
inverse(m::GenericLinearMap{T,AA}) where {T<:AbstractVector,AA<:Number} =
    LinearMap{T}(inv(m.A))
leftinverse(m::GenericLinearMap{T,AA}) where {T<:AbstractVector,AA<:Number} =
    LinearMap{T}(inv(m.A))
rightinverse(m::GenericLinearMap{T,AA}) where {T<:AbstractVector,AA<:Number} =
    LinearMap{T}(inv(m.A))

convert(::Type{Map}, A::UniformScaling) = GenericLinearMap{Vector{Any}}(A)
convert(::Type{Map{T}}, A::UniformScaling) where {T} = GenericLinearMap{T}(A)

"A `ScalarLinearMap` is a linear map `y = A*x` for scalars."
struct ScalarLinearMap{T} <: LinearMap{T}
    A   ::  T
end

ScalarLinearMap(A::Number) = ScalarLinearMap{typeof(A)}(A)

isreal(m::ScalarLinearMap{T}) where {T} = isrealtype(T)

show(io::IO, m::ScalarLinearMap) = show_scalar_linear_map(io, m.A)
show_scalar_linear_map(io, A::Real) = print(io, "x -> $(A) * x")
show_scalar_linear_map(io, A::Complex) = print(io, "x -> ($(A)) * x")


"A `VectorLinearMap` is a linear map `y = A*x` using vectors and matrices."
struct VectorLinearMap{T} <: LinearMap{Vector{T}}
    A   ::  Matrix{T}
end

VectorLinearMap(A::AbstractMatrix{T}) where {T} =
    VectorLinearMap{T}(A)


"A `StaticLinearMap` is a linear map `y = A*x` using static arrays."
struct StaticLinearMap{T,N,M,L} <: LinearMap{SVector{N,T}}
    A   ::  SMatrix{M,N,T,L}
end

StaticLinearMap(A::AbstractMatrix{T}) where {T} =
    StaticLinearMap{T}(A)

StaticLinearMap{T}(A::StaticMatrix{M,N,S}) where {M,N,T,S} =
    StaticLinearMap{T}(convert(AbstractMatrix{T}, A))
StaticLinearMap{T}(A::StaticMatrix{M,N,T}) where {M,N,T} =
    StaticLinearMap{T,M,N}(A)
StaticLinearMap{T,N,M}(A::AbstractMatrix) where {T,N,M} =
    StaticLinearMap{T,N,M,M*N}(A)

convert(::Type{Map{SVector{N,T}}}, m::VectorLinearMap) where {N,T} = StaticLinearMap{T,N,N}(m.A)


# Implement the interface for abstract arrays,
# representing the linear map x->A*x
MapStyle(A::AbstractArray) = IsMap()

Map(A::AbstractArray) = LinearMap(A)
Map{T}(A::AbstractArray) where T = LinearMap{T}(A)

domaintype(A::AbstractArray) = domaintype(Map(A))

applymap(A::AbstractArray, x) = A*x
mapsize(A::AbstractArray) = size(A)

islinearmap(A::AbstractArray) = true
isaffinemap(A::AbstractArray) = true
affinematrix(A::AbstractArray) = A
affinevector(A::AbstractArray) = zerovector(A)

inverse(A::AbstractMatrix) = inv(A)
inverse(A::AbstractMatrix, x) = A \ x

jacobian(A::AbstractMatrix) = ConstantMap{glm_domaintype(A)}(A)
jacobian(A::AbstractMatrix, x) = A

canonicalmap(A::AbstractArray) = Map(A)
canonicalmap(::Equal, A::AbstractArray) = Map(A)




##########################
# Translations: y = x + b
##########################


"A `Translation` represents the map `y = x + b`."
abstract type Translation{T} <: AbstractAffineMap{T} end

# unsafe_matrix(m::Translation) = I
affinematrix(m::Translation) = to_matrix(domaintype(m), LinearAlgebra.I, unsafe_vector(m))
affinevector(m::Translation) = unsafe_vector(m)

mapsize(m::Translation) = _translation_mapsize(m, domaintype(m), unsafe_vector(m))
_translation_mapsize(m, ::Type{T}, b::Number) where {T} = ()
_translation_mapsize(m, ::Type{T}, b) where {T} = (length(b),length(b))

map_stencil(m::Translation, x) = _translation_map_stencil(m, x, unsafe_vector(m))
_translation_map_stencil(m, x, b) = [x, " + ", b]
_translation_map_stencil(m, x, b::Real) =
    b >= 0 ? [x, " + ", b] : [x, " - ", abs(b)]
map_stencil_broadcast(m::Translation, x) = _translation_map_stencil_broadcast(m, x, unsafe_vector(m))
_translation_map_stencil_broadcast(m, x, b) = [x, " .+ ", b]

"Translation by a scalar value."
struct ScalarTranslation{T} <: Translation{T}
    b   ::  T
end

isreal(m::ScalarTranslation{T}) where {T} = isrealtype(T)

show(io::IO, m::ScalarTranslation) = show_scalar_translation(io, m.b)
show_scalar_translation(io, b::Real) = print(io, "x -> x", b < 0 ? " - " : " + ", abs(b))
show_scalar_translation(io, b) = print(io, "x -> x + ", b)


"Translation by a static vector."
struct StaticTranslation{T,N} <: Translation{SVector{N,T}}
    b   ::  SVector{N,T}
end

"Translation by a vector."
struct VectorTranslation{T} <: Translation{Vector{T}}
    b   ::  Vector{T}
end

"Translation by a generic vectorlike object."
struct GenericTranslation{T,B} <: Translation{T}
    b   ::  B
end

Translation(b::Number) = ScalarTranslation(b)
Translation(b::StaticVector) = StaticTranslation(b)
Translation(b::Vector) = VectorTranslation(b)
Translation(b) = GenericTranslation(b)

Translation{T}(b::Number) where {T<:Number} = ScalarTranslation{T}(b)
Translation{T}(b::AbstractVector) where {N,S,T<:StaticVector{N,S}} = StaticTranslation{S,N}(b)
Translation{T}(b::Vector) where {S,T<:Vector{S}} = VectorTranslation{S}(b)
Translation{T}(b) where {T} = GenericTranslation{T}(b)

jacdet(m::Translation{T}) where {T} = UnityMap{T,eltype(T)}()
jacdet(m::Translation{T}, x) where {T} = one(eltype(T))

isreal(m::Translation) = isreal(unsafe_vector(m))

isequalmap(m1::Translation, m2::Translation) = unsafe_vector(m1)==unsafe_vector(m2)

similarmap(m::Translation, ::Type{T}) where {T} = Translation{T}(m.b)

applymap(m::Translation, x) = _translation_applymap(m, x, unsafe_vector(m))
_translation_applymap(m, x, b) = x + b
applymap!(y, m::Translation, x) = _translation_applymap!(y, m, x, unsafe_vector(m))
_translation_applymap!(y, m, x, b) = y .= x .+ m.b

inverse(m::Translation{T}) where {T} = Translation{T}(-m.b)
inverse(m::Translation, x) = x - m.b

ScalarTranslation(b::Number) = ScalarTranslation{typeof(b)}(b)

StaticTranslation(b::AbstractVector{T}) where {T} = StaticTranslation{T}(b)

StaticTranslation{T}(b::StaticVector{N}) where {N,T} =
    StaticTranslation{T,N}(b)

VectorTranslation(b::AbstractVector{T}) where {T} = VectorTranslation{T}(b)

GenericTranslation(b) = GenericTranslation{typeof(b)}(b)
GenericTranslation(b::AbstractVector{T}) where {T} =
    GenericTranslation{Vector{T}}(b)
GenericTranslation(b::StaticVector{N,T}) where {N,T} =
    GenericTranslation{SVector{N,T}}(b)

GenericTranslation{T}(b) where {T} = GenericTranslation{T,typeof(b)}(b)
GenericTranslation{T}(b::Number) where {T<:Number} =
    GenericTranslation{T,T}(b)


############################
# Affine maps: y = A*x + b
############################


"""
The supertype of all affine maps that store `A` and `b`.
Concrete subtypes differ in how `A` and `b` are represented.
"""
abstract type AffineMap{T} <: AbstractAffineMap{T} end

AffineMap(A::Number, b::Number) = ScalarAffineMap(A, b)
AffineMap(A::StaticMatrix, b::StaticVector) = StaticAffineMap(A, b)
AffineMap(A::Matrix, b::Vector) = VectorAffineMap(A, b)
AffineMap(A::UniformScaling{Bool}, b::Number) = ScalarAffineMap(one(b), b)
AffineMap(A, b) = GenericAffineMap(A, b)

AffineMap{T}(A::Number, b::Number) where {T<:Number} = ScalarAffineMap{T}(A, b)
AffineMap{T}(A::AbstractMatrix, b::AbstractVector) where {N,S,T<:SVector{N,S}} = StaticAffineMap{S,N}(A, b)
AffineMap{T}(A::Matrix, b::Vector) where {S,T<:Vector{S}} = VectorAffineMap{S}(A, b)
AffineMap{T}(A::UniformScaling{Bool}, b::Number) where {T} = ScalarAffineMap{T}(one(T), b)
AffineMap{T}(A, b) where {T} = GenericAffineMap{T}(A, b)

similarmap(m::AffineMap, ::Type{T}) where {T} = AffineMap{T}(m.A, m.b)

convert(::Type{AffineMap}, m) = (@assert isaffinemap(m); AffineMap(affinematrix(m), affinevector(m)))
convert(::Type{AffineMap{T}}, m) where {T} = (@assert isaffinemap(m); AffineMap{T}(affinematrix(m), affinevector(m)))
# avoid ambiguity errors with convert(::Type{T}, x::T) in Base:
convert(::Type{AffineMap}, m::AffineMap) = m
convert(::Type{AffineMap{T}}, m::AffineMap{T}) where T = m

# If y = A*x+b, then x = inv(A)*(y-b) = inv(A)*y - inv(A)*b
inverse(m::AffineMap) = (@assert issquaremap(m); AffineMap(inv(m.A), -inv(m.A)*m.b))
inverse(m::AffineMap, x) = (@assert issquaremap(m); m.A \ (x-m.b))

function leftinverse(m::AffineMap)
    @assert isoverdetermined(m)
    pA = matrix_pinv(m.A)
    AffineMap(pA, -pA*m.b)
end
function rightinverse(m::AffineMap)
    @assert isunderdetermined(m)
    pA = matrix_pinv(m.A)
    AffineMap(pA, -pA*m.b)
end
function leftinverse(m::AffineMap, x)
    @assert isoverdetermined(m)
    m.A \ (x-m.b)
end
function rightinverse(m::AffineMap, x)
    @assert isunderdetermined(m)
    m.A \ (x-m.b)
end


"An affine map for any combination of types of `A` and `b`."
struct GenericAffineMap{T,AA,B} <: AffineMap{T}
    A   ::  AA
    b   ::  B
end

GenericAffineMap(A, b) = GenericAffineMap{typeof(b)}(A, b)
GenericAffineMap(A::AbstractVector{S}, b::AbstractVector{T}) where {S,T} =
    GenericAffineMap{promote_type(S,T)}(A, b)
GenericAffineMap(A::AbstractArray{S}, b::AbstractVector{T}) where {S,T} =
    GenericAffineMap{Vector{promote_type(S,T)}}(A, b)
GenericAffineMap(A::StaticMatrix{M,N,S}, b::StaticVector{M,T}) where {M,N,S,T} =
    GenericAffineMap{SVector{N,promote_type(S,T)}}(A, b)
GenericAffineMap(A::StaticMatrix{M,N,S}, b::AbstractVector{T}) where {M,N,S,T} =
    GenericAffineMap{SVector{N,promote_type(S,T)}}(A, b)
GenericAffineMap(A::S, b::AbstractVector{T}) where {S<:Number,T} =
    GenericAffineMap{Vector{promote_type(S,T)}}(A, b)
GenericAffineMap(A::S, b::StaticVector{N,T}) where {S<:Number,N,T} =
    GenericAffineMap{SVector{N,promote_type(S,T)}}(A, b)
GenericAffineMap(A::UniformScaling{Bool}, b) =
    GenericAffineMap(UniformScaling{eltype(b)}(1), b)


# Fallback routine for generic A and b, special cases follow
GenericAffineMap{T}(A, b) where {T} = GenericAffineMap{T,typeof(A),typeof(b)}(A, b)

GenericAffineMap{T}(A::AbstractVector{S}, b::AbstractVector{U}) where {T<:Number,S,U} =
    GenericAffineMap{T}(convert(AbstractVector{T}, A), convert(AbstractVector{T}, b))
GenericAffineMap{T}(A::AbstractVector{T}, b::AbstractVector{T}) where {T<:Number} =
    GenericAffineMap{T,typeof(A),typeof(b)}(A, b)
GenericAffineMap{T}(A::Number, b) where {T} = GenericAffineMap{T,eltype(T),typeof(b)}(A, b)
GenericAffineMap{T}(A::Number, b::AbstractVector) where {N,S,T <: StaticVector{N,S}} =
    GenericAffineMap{T,S,SVector{N,S}}(A, b)
# Promote element types of abstract arrays
GenericAffineMap{T}(A::AbstractArray, b::AbstractVector) where {S,T<:AbstractVector{S}} =
    GenericAffineMap{T}(convert(AbstractArray{eltype(T)},A), convert(AbstractVector{eltype(T)}, b))
GenericAffineMap{T}(A::AbstractArray{S}, b::AbstractVector{S}) where {S,T<:AbstractVector{S}} =
    GenericAffineMap{T,typeof(A),typeof(b)}(A, b)
GenericAffineMap{T}(A::UniformScaling{Bool}, b::AbstractVector) where {S,T<:AbstractVector{S}} =
    GenericAffineMap{T}(A*one(S), convert(AbstractVector{S}, b))
GenericAffineMap{T}(A::UniformScaling{S}, b::AbstractVector{S}) where {S,T<:AbstractVector{S}} =
    GenericAffineMap{T,typeof(A),typeof(b)}(A, b)


similarmap(m::GenericAffineMap, ::Type{T}) where {T} = AffineMap{T}(m.A, m.b)

convert(::Type{GenericAffineMap{T}}, m::GenericAffineMap) where {T} =
    GenericAffineMap{T}(m.A, m.b)



"An affine map with scalar representation."
struct ScalarAffineMap{T} <: AffineMap{T}
    A   ::  T
    b   ::  T
end

ScalarAffineMap(A, b) = ScalarAffineMap(promote(A, b)...)

isreal(m::ScalarAffineMap{T}) where {T} = isrealtype(T)

show(io::IO, m::ScalarAffineMap) = show_scalar_affine_map(io, m.A, m.b)
show_scalar_affine_map(io, A::Real, b::Real) = print(io, "x -> $(A) * x", b < 0 ? " - " : " + ", abs(b))
show_scalar_affine_map(io, A::Complex, b::Complex) = print(io, "x -> ($(A)) * x + ", b)
show_scalar_affine_map(io, A, b) = print(io, "x -> ($(A)) * x + $(b)")


convert(::Type{ScalarAffineMap{T}}, m::ScalarAffineMap) where {T} =
    ScalarAffineMap{T}(m.A, m.b)

"An affine map with array and vector representation."
struct VectorAffineMap{T} <: AffineMap{Vector{T}}
    A   ::  Matrix{T}
    b   ::  Vector{T}
end

VectorAffineMap(A::AbstractArray{T}, b::AbstractVector{T}) where {T} =
    VectorAffineMap{T}(A, b)
function VectorAffineMap(A::AbstractArray{S}, b::AbstractVector{T}) where {S,T}
    U = promote_type(S,T)
    VectorAffineMap(convert(AbstractArray{U}, A), convert(AbstractVector{U}, b))
end

convert(::Type{VectorAffineMap{T}}, m::VectorAffineMap) where {T} =
    VectorAffineMap{T}(m.A, m.b)



"An affine map with representation using static arrays."
struct StaticAffineMap{T,N,M,L} <: AffineMap{SVector{N,T}}
    A   ::  SMatrix{M,N,T,L}
    b   ::  SVector{M,T}
end

# Constructors:
# - first, we deduce T
StaticAffineMap(A::AbstractMatrix{T}, b::AbstractVector{T}) where {T} =
    StaticAffineMap{T}(A, b)
function StaticAffineMap(A::AbstractMatrix{S}, b::AbstractVector{T}) where {S,T}
    U = promote_type(S,T)
    StaticAffineMap(convert(AbstractMatrix{U}, A), convert(AbstractVector{U}, b))
end

StaticAffineMap{T}(A::AbstractMatrix, b::AbstractVector) where {T} =
    StaticAffineMap{T}(convert(AbstractMatrix{T}, A), convert(AbstractVector{T}, b))

# - then, we determine N and/or M, from the arguments
function StaticAffineMap{T}(A::AbstractMatrix{T}, b::StaticVector{M,T}) where {T,M}
    @assert size(A) == (M,M)
    StaticAffineMap{T,M,M}(A, b)
end
StaticAffineMap{T}(A::StaticMatrix{M,N,T}, b::AbstractVector) where {T,N,M} =
    StaticAffineMap{T,N,M}(A, b)
StaticAffineMap{T}(A::StaticMatrix{M,N,T}, b::StaticVector{M,T}) where {T,N,M} =
    StaticAffineMap{T,N,M}(A, b)
# line below catches ambiguity error
StaticAffineMap{T}(A::StaticMatrix{M1,N,T}, b::StaticVector{M2,T}) where {T,N,M1,M2} =
    throw(ArgumentError("Non-matching dimensions"))
StaticAffineMap{T,N}(A::AbstractMatrix, b::AbstractVector) where {T,N} =
    StaticAffineMap{T,N,N}(A, b)
StaticAffineMap{T,N}(A::StaticMatrix{M,N}, b::AbstractVector) where {T,N,M} =
    StaticAffineMap{T,N,M}(A, b)

# - finally invoke the constructor (and implicitly convert the data if necessary)
StaticAffineMap{T,N,M}(A::AbstractMatrix, b::AbstractVector) where {T,N,M} =
    StaticAffineMap{T,N,M,M*N}(A, b)

convert(::Type{Map{SVector{N,T}}}, m::VectorAffineMap) where {N,T} =
    StaticAffineMap{T,N}(m.A, m.b)

"""
A `MappedDomain` represents the mapping of a domain.

The map of a domain `d` under the mapping `y=f(x)` consists of all points `f(x)`
with `x ∈ d`. The characteristic function of a mapped domain is defined in
terms of the inverse map `g = inverse(f)`:
```
x ∈ m ⟺ g(x) ∈ d
```
"""
abstract type AbstractMappedDomain{T} <: SimpleLazyDomain{T} end

superdomain(d::AbstractMappedDomain) = d.domain

const MappedVectorDomain{T} = AbstractMappedDomain{Vector{T}}

tointernalpoint(d::AbstractMappedDomain, x) = inverse_map(d, x)
toexternalpoint(d::AbstractMappedDomain, y) = forward_map(d, y)

canonicaldomain(d::AbstractMappedDomain) = canonicaldomain(superdomain(d))
mapfrom_canonical(d::AbstractMappedDomain) = forward_map(d) ∘ mapfrom_canonical(superdomain(d))
mapto_canonical(d::AbstractMappedDomain) = mapto_canonical(superdomain(d)) ∘ inverse_map(d)


# TODO: check whether the map alters the dimension
dimension(d::MappedVectorDomain) = dimension(superdomain(d))

# TODO: check whether the map affects these properties
isempty(d::AbstractMappedDomain) = isempty(superdomain(d))
isopenset(d::AbstractMappedDomain) = isopenset(superdomain(d))
isclosedset(d::AbstractMappedDomain) = isclosedset(superdomain(d))

corners(d::AbstractMappedDomain) = [forward_map(d, x) for x in corners(superdomain(d))]

## I/O functionality

show(io::IO, mime::MIME"text/plain", d::AbstractMappedDomain) = composite_show(io, mime, d)
Display.displaystencil(d::AbstractMappedDomain) =
    map_stencil_broadcast(forward_map(d), superdomain(d))
Display.object_parentheses(d::AbstractMappedDomain) =
    FunctionMaps.map_object_parentheses(forward_map(d))
Display.stencil_parentheses(d::AbstractMappedDomain) =
    FunctionMaps.map_stencil_parentheses(forward_map(d))


"""
    promote_map_domain_pair(map, domain)

Promote the map and the domain such that the output satisfies
`codomaintype(map) == domaineltype(domain)`.
"""
promote_map_domain_pair(map, domain) =
    _promote_map_domain_pair(map, domain, codomaintype(map), domaineltype(domain))
_promote_map_domain_pair(map, domain, ::Type{T}, ::Type{T}) where T = map, domain
_promote_map_domain_pair(map, domain, ::Type{S}, ::Type{T}) where {S,T} =
    _promote_map_domain_pair(map, domain, S, T, promote_type(S,T))
_promote_map_domain_pair(map, domain, ::Type{S}, ::Type{T}, ::Type{U}) where {S,T,U} =
    convert_codomaintype(U, map), convert_eltype(U, domain)
_promote_map_domain_pair(map, domain, ::Type{Any}, ::Type{T}, ::Type{Any}) where T =
    map, domain
_promote_map_domain_pair(map, domain, ::Type{S}, ::Type{Any}, ::Type{Any}) where S =
    map, domain
_promote_map_domain_pair(map, domain, ::Type{Any}, ::Type{Any}, ::Type{Any}) =
    map, domain
# ensure dimensions of static arrays match
_promote_map_domain_pair(map, domain, S::Type{<:StaticVector{N}}, T::Type{<:StaticVector{N}}) where N =
    _promote_map_domain_pair(map, domain, S, T, promote_type(S,T))
_promote_map_domain_pair(map, domain, S::Type{<:StaticVector{N}}, T::Type{<:StaticVector{M}}) where {N,M} =
    throw(ArgumentError("Map and domain have different static dimension."))
# assume that functions are fine
promote_map_domain_pair(map::Function, domain) = map, domain

mapped_domain_eltype(invmap::Function, domain) = domaineltype(domain)
mapped_domain_eltype(invmap, domain) = domaintype(invmap)

"A `MappedDomain` stores the inverse map of a mapped domain."
struct MappedDomain{T,F,D} <: AbstractMappedDomain{T}
    invmap  ::  F
    domain  ::  D
end

MappedDomain(invmap, domain) =
    _MappedDomain(promote_map_domain_pair(invmap, domain)...)
_MappedDomain(invmap, domain) =
    _MappedDomainT(mapped_domain_eltype(invmap,domain), invmap, domain)

MappedDomain{T}(invmap, domain) where T =
    _MappedDomainT(T, convert_domaintype(T, invmap), convert_eltype(T, domain))
_MappedDomainT(::Type{T}, invmap, domain) where T =
    MappedDomain{T,typeof(invmap),typeof(domain)}(invmap, domain)

similardomain(d::MappedDomain, ::Type{T}) where {T} =
    MappedDomain{T}(d.invmap, d.domain)

forward_map(d::MappedDomain) = rightinverse(d.invmap)
forward_map(d::MappedDomain, x) = rightinverse(d.invmap, x)

inverse_map(d::MappedDomain) = d.invmap
inverse_map(d::MappedDomain, y) = applymap(d.invmap, y)

"""
    map_domain(map, domain)

Map a domain with the inverse of the given map.
"""
map_domain(map, domain) = map_domain1(map, domain)
map_domain1(map, domain) = map_domain2(map, domain)
map_domain2(map, domain) = default_map_domain(map, domain)
default_map_domain(map, domain) = mapped_domain(leftinverse(map), domain)

isequaldomain(a::MappedDomain, b::MappedDomain) =
    isequalmap(a.invmap, b.invmap) && isequaldomain(superdomain(a), superdomain(b))
domainhash(d::MappedDomain, h::UInt) = hashrec("MappedDomain", d.invmap, hash(superdomain(d)))

"""
    mapped_domain(invmap, domain)

Make a mapped domain with the given inverse map.
"""
mapped_domain(invmap, domain) = mapped_domain1(invmap, domain)
mapped_domain1(invmap, domain) = mapped_domain2(invmap, domain)
mapped_domain2(invmap, domain) = default_mapped_domain(invmap, domain)
default_mapped_domain(invmap, domain) = MappedDomain(invmap, domain)

# We make a special case for linear mappings like 2 .* d, when d contains vectors
mapped_domain1(invmap::LinearMap{<:Number}, domain::Domain{T}) where {T<:AbstractVector} =
    mapped_domain(convert_prectype(prectype(invmap, domain), Map{T}(invmap)), domain)
# allow some mixing of SVector and Vector
mapped_domain1(invmap::Map{<:StaticVector{N,T}}, domain) where {N,T} =
    _vector_mapped_domain1(invmap, domain)
_vector_mapped_domain1(invmap::Map{<:StaticVector{N,T}}, domain::Domain{Vector{U}}) where {N,T,U} =
    mapped_domain(invmap, convert(Domain{SVector{N,promote_type(T,U)}}, domain))
_vector_mapped_domain1(invmap::Map{<:StaticVector{N,T}}, domain) where {N,T} =
    mapped_domain2(invmap, domain)

mapped_domain2(invmap, domain::Domain{<:StaticVector{N,T}}) where {N,T} =
    _vector_mapped_domain2(invmap, domain)
_vector_mapped_domain2(invmap::Map{Vector{U}}, domain::Domain{<:StaticVector{N,T}}) where {N,T,U} =
    mapped_domain(convert(Map{SVector{N,promote_type(T,U)}}, invmap), domain)
_vector_mapped_domain2(invmap, domain::Domain{<:StaticVector{N,T}}) where {N,T} =
    default_mapped_domain(invmap, domain)

# Avoid nested mapping domains, construct a composite map instead
mapped_domain2(invmap, d::MappedDomain) = mapped_domain(inverse_map(d) ∘ invmap, superdomain(d))

boundary(d::MappedDomain) = _boundary(d, boundary(superdomain(d)), inverse_map(d))
_boundary(d::MappedDomain, superbnd, invmap) = MappedDomain(invmap, superbnd)
_boundary(d::MappedDomain, superbnd::UnionDomain, invmap) =
    UnionDomain(map(t->mapped_domain(invmap, t), components(superbnd)))

interior(d::MappedDomain) = _interior(d, superdomain(d), inverse_map(d))
_interior(d::MappedDomain, superdomain, invmap) = MappedDomain(invmap, interior(superdomain))
closure(d::MappedDomain) = _closure(d, superdomain(d), inverse_map(d))
_closure(d::MappedDomain, superdomain, invmap) = MappedDomain(invmap, closure(superdomain))

convert(::Type{MappedDomain}, d::Domain{T}) where {T} =
    MappedDomain{T}(mapto_canonical(d), canonicaldomain(d))
convert(::Type{MappedDomain{T}}, d::Domain) where {T} =
    MappedDomain{T}(mapto_canonical(d), canonicaldomain(d))


"A `ParametricDomain` stores the forward map of a mapped domain."
struct ParametricDomain{T,F,D} <: AbstractMappedDomain{T}
    fmap    ::  F
    domain  ::  D
end

ParametricDomain(fmap, domain) =
    ParametricDomain{codomaintype(fmap)}(fmap, domain)
ParametricDomain{T}(fmap, domain::Domain) where {T} =
    ParametricDomain{T,typeof(fmap),typeof(domain)}(fmap, domain)
ParametricDomain{T}(fmap, domain) where {T} =
    _ParametricDomain(T, fmap, checkdomain(domain))
_ParametricDomain(::Type{T}, fmap, domain) where {T} =
    ParametricDomain{T,typeof(fmap),typeof(domain)}(fmap, domain)

similardomain(d::ParametricDomain, ::Type{T}) where {T} =
    ParametricDomain{T}(d.fmap, d.domain)

forward_map(d::ParametricDomain) = d.fmap
forward_map(d::ParametricDomain, x) = applymap(d.fmap, x)

function indomain(x, d::ParametricDomain)
    # To check for membership, we can't use the inverse map because it may not exist
    # We assume a left inverse exists, but the left inverse may be many-to-one.
    # So we also have to check whether the left-inverse-point maps back to x
    y = leftinverse(d.fmap, x)
    x2 = forward_map(d, y)
    isapprox(x, x2)
end

isequaldomain(d1::ParametricDomain, d2::ParametricDomain) =
    isequalmap(forward_map(d1), forward_map(d2)) && isequaldomain(superdomain(d1), superdomain(d2))
domainhash(d::ParametricDomain, h::UInt) = hashrec("ParametricDomain", forward_map(d), superdomain(d), h)

"""
    parametric_domain(fmap, domain)

The domain that results from mapping the given domain.
"""
parametric_domain(fmap, domain) = ParametricDomain(fmap, domain)
parametric_domain(fmap, domain::ParametricDomain) =
    parametric_domain(fmap ∘ forward_map(domain), superdomain(domain))

boundary(d::ParametricDomain) = _boundary(d, boundary(superdomain(d)), forward_map(d))
_boundary(d::ParametricDomain, superbnd, fmap) = ParametricDomain(fmap, superbnd)
_boundary(d::ParametricDomain, superbnd::UnionDomain, fmap) =
    UnionDomain(map(t -> parametric_domain(fmap, t), components(superbnd)))

interior(d::ParametricDomain) = _interior(d, superdomain(d), forward_map(d))
_interior(d::ParametricDomain, superdomain, fmap) = ParametricDomain(fmap, interior(superdomain))
closure(d::ParametricDomain) = _closure(d, superdomain(d), forward_map(d))
_closure(d::ParametricDomain, superdomain, fmap) = ParametricDomain(fmap, closure(superdomain))

using Documenter
using DomainSets
using DomainSets.FunctionMaps

DocMeta.setdocmeta!(DomainSets, :DocTestSetup, :(using DomainSets); recursive=true)

makedocs(;
    modules=[DomainSets,DomainSets.FunctionMaps],
    authors="Daan Huybrechs <daan.huybrechs@kuleuven.be> and contributors",
    sitename="DomainSets.jl",
    format=Documenter.HTML(;
        edit_link="main",
        assets=String[],
    ),
    pages=[
        "Home" => "index.md",
        "Examples" => "examples.md",
        "Specific domains" => Any[
            "Euclidean geometry" => "geometry.md",
            "Function approximation" => "approximation.md",
            "Complex analysis" => "complex.md",
            "Numbers" => "numbers.md"
        ],
        "Set operations" => "setoperations.md",
        "Design principles" => Any[
            "The domain interface" => "interface.md",
            "Equality of domains" => "equality.md",
            "Canonical domains" => "canonical.md"
        ],
        "API" => Any[
            "Public API Reference" => "api.md",
            "Internal API Reference" => "internal.md"
        ],
        "FunctionMaps.jl" => "maps.md"
    ],
)

deploydocs(
    repo   = "github.com/JuliaApproximation/DomainSets.jl.git",
    devbranch = "master"
)

using StaticArrays, DomainSets, Test

using DomainSets:
    MappedDomain,
    ParametricDomain,
    similar_interval,
    GenericBall, GenericSphere

struct Basis3Vector <: StaticVector{3,Float64} end

Base.getindex(::Basis3Vector, k::Int) = k == 1 ? 1.0 : 0.0

struct NamedBall <: DomainSets.DerivedDomain{SVector{2,Float64}}
    domain  ::  Domain{SVector{2,Float64}}

    NamedBall() = new(2UnitDisk())
end

include("test_domain_interval.jl")
include("test_domain_product.jl")
include("test_domain_ball.jl")
include("test_domain_simplex.jl")

@testset "specific domains" begin
    @testset "empty space" begin
        d1 = EmptySpace()
        show(io,d1)
        @test isempty(d1)
        @test String(take!(io)) == "{} (empty domain)"
        @test eltype(d1) == Float64
        @test convert(Domain{BigFloat}, d1) === EmptySpace{BigFloat}()
        @test 0.5 ∉ d1
        @test !approx_in(0.5, d1)
        @test d1 ∩ d1 == d1
        @test d1 ∪ d1 == d1
        @test d1 \ d1 == d1
        @test boundary(d1) == d1
        @test dimension(d1) == 1
        @test isclosedset(d1)
        @test isopenset(d1)
        @test interior(d1) == d1
        @test closure(d1) == d1
        @test boundingbox(d1) == d1
        @test distance_to(d1, 0) == Inf
        @test d1 == 2..1
        @test 2..1 == d1
        d2 = 0..1
        @test d1 ∩ d2 == d1
        @test d2 ∩ d1 == d1
        @test d1 ∪ d2 == d2
        @test d2 ∪ d1 == d2
        @test d1 \ d2 == d1
        @test d2 \ d1 == d2
        @test d2 \ d2 == d1
        # Test some promotions
        @test EmptySpace{Float64}() ∪ (0..1) isa AbstractInterval{Float64}
        @test EmptySpace{Int}() ∩ (0..1.0) isa EmptySpace{Float64}
        @test EmptySpace{Int}() \ (0..1.0) isa EmptySpace{Float64}
        @test (0..1) \ EmptySpace{Float64}() isa AbstractInterval{Float64}

        d2 = EmptySpace(SVector{2,Float64})
        @test isempty(d2)
        @test SA[0.1,0.2] ∉ d2
        @test [0.1,0.2] ∉ d2
        @test 1:2 ∉ d2
        @test !approx_in(SA[0.1,0.2], d2)
        @test boundary(d2) == d2
        @test dimension(d2) == 2

        @test EmptySpace{Int}() == EmptySpace{Float64}()
        @test hash(EmptySpace{Int}()) == hash(EmptySpace{Float64}())
        @test emptyspace(0..1) == EmptySpace{Int}()
        @test emptyspace([1,2]) == EmptySpace{Int}()

        m = LinearMap(2)
        @test map_domain(m, emptyspace(Int)) == EmptySpace{Int}()
        @test mapped_domain(m, emptyspace(Int)) == EmptySpace{Int}()

        @test mapto(EmptySpace(), OpenInterval(0,0)) isa IdentityMap
        @test mapto(OpenInterval(0,0), EmptySpace()) isa IdentityMap
        @test_throws ArgumentError mapto(EmptySpace(), 0..1)
        @test_throws ArgumentError mapto(0..1, EmptySpace())
    end

    @testset "full space" begin
        d1 = FullSpace()
        @test d1 == FullSpace{Float64}()
        show(io,d1)
        @test String(take!(io)) == "{x} (full space)"
        @test convert(Domain{BigFloat}, d1) === FullSpace{BigFloat}()
        @test DomainSets.euclideanspace(Val{2}()) == FullSpace{SVector{2,Float64}}()
        @test 0.5 ∈ d1
        @test choice(d1) == 0
        @test d1 ∪ d1 == d1
        @test d1 ∩ d1 == d1
        @test isempty(d1) == false
        @test boundary(d1) == EmptySpace{Float64}()
        @test isclosedset(d1)
        @test isopenset(d1)
        @test interior(d1) == d1
        @test closure(d1) == d1
        @test dimension(d1) == 1
        @test boundingbox(d1) == d1
        @test distance_to(d1, 0) == 0
        @test DomainSets.isequaldomain1(d1, d1)
        @test DomainSets.isequaldomain2(d1, d1)
        d2 = 0..1
        @test d1 ∪ d2 == d1
        @test d1 ∩ d2 == d2
        @test d2 ∩ d1 == d2
        @test (0..1.0) \ FullSpace{Int}() isa EmptySpace{Float64}
        @test typeof(FullSpace(0..1) .+ 1) <: FullSpace
        @test typeof(FullSpace(0..1) * 3) <: FullSpace
        @test infimum(d1) == typemin(Float64)
        @test supremum(d1) == typemax(Float64)
        @test FullSpace{Int}() == FullSpace{Float64}()

        d2 = FullSpace{SVector{2,Float64}}()
        @test SA[0.1,0.2] ∈ d2
        @test approx_in(SA[0.1,0.2], d2)
        @test !isempty(d2)
        @test boundary(d2) == EmptySpace{SVector{2,Float64}}()

        @test d2 == Domain(SVector{2,Float64})
        @test d2 == convert(Domain,SVector{2,Float64})
        @test d2 == convert(Domain{SVector{2,Float64}}, SVector{2,Float64})

        @test FullSpace{Int}() == FullSpace{Float64}()
        @test hash(FullSpace{Int}()) == hash(FullSpace{Float64}())
        @test fullspace(0..1) == FullSpace{Int}()
        @test fullspace([1,2]) == FullSpace{Int}()

        @test uniondomain(UnitDisk(), FullSpace{SVector{2,Float64}}()) == FullSpace{SVector{2,Float64}}()

        # type domains
        @test typedomain(0..1) == TypeDomain{Int}()
        td1 = TypeDomain{Float64}()
        @test 2 ∈ td1
        @test 2.5 ∈ td1
        @test π ∈ td1
        @test approx_in(π, td1)
        @test π+im ∉ td1
        @test [1,2,3] ∉ td1
        @test 5 ∈ TypeDomain{Any}()
        @test TypeDomain{Int}() == TypeDomain{Int}()
    end

    @testset "number sets" begin
        # natural numbers
        @test 2 ∈ ℕ
        @test 0 ∈ ℕ
        @test -1 ∉ ℕ
        @test 1.5 ∉ ℕ
        @test π ∉ ℕ
        @test [1] ∉ ℕ
        @test 2+im ∉ ℕ
        @test 4//2 ∈ ℕ
        @test (-4)//2 ∉ ℕ
        @test 5//2 ∉ ℕ
        @test approx_in(1.01, ℕ, 0.05)
        @test !approx_in(1.01, ℕ, 0.001)
        @test !approx_in(-1.01, ℕ, 0.05)
        @test ℕ == ℕ
        # integers
        @test 2 ∈ ℤ
        @test 0 ∈ ℤ
        @test -1 ∈ ℤ
        @test 1.5 ∉ ℤ
        @test π ∉ ℤ
        @test [1] ∉ ℤ
        @test 2+im ∉ ℤ
        @test 4//2 ∈ ℤ
        @test (-4)//2 ∈ ℤ
        @test 5//2 ∉ ℤ
        @test approx_in(1.01, ℤ, 0.05)
        @test !approx_in(1.01, ℤ, 0.001)
        @test approx_in(-1.01, ℤ, 0.05)
        @test ℤ == ℤ
        # rationals
        @test 2 ∈ ℚ
        @test 0 ∈ ℚ
        @test -1 ∈ ℚ
        @test 1.5 ∉ ℚ
        @test π ∉ ℚ
        @test [1] ∉ ℚ
        @test 2+im ∉ ℚ
        @test 4//2 ∈ ℚ
        @test (-4)//2 ∈ ℚ
        @test 5//2 ∈ ℚ
        @test ℚ == ℚ
        # real numbers
        @test 2 ∈ ℝ
        @test 0 ∈ ℝ
        @test -1 ∈ ℝ
        @test 1.5 ∈ ℝ
        @test π ∈ ℝ
        @test [1] ∉ ℝ
        @test 2+im ∉ ℝ
        @test 4//2 ∈ ℝ
        @test (-4)//2 ∈ ℝ
        @test 5//2 ∈ ℝ
        @test [π] ∈ ℝ1
        @test [π,exp(1)] ∈ ℝ2
        @test [1,2,3] ∈ ℝ3
        @test [1,2,3,4] ∈ ℝ4
        @test approx_in(1.0+0.01im, ℝ, 0.05)
        @test !approx_in(1.0+0.01im, ℝ, 0.005)
        @test ℝ == ℝ
        # complex numbers
        @test 2 ∈ ℂ
        @test 0 ∈ ℂ
        @test -1 ∈ ℂ
        @test 1.5 ∈ ℂ
        @test π ∈ ℂ
        @test [1] ∉ ℂ
        @test 2+im ∈ ℂ
        @test 4//2+im ∈ ℂ
        @test 4//2 ∈ ℂ
        @test (-4)//2 ∈ ℂ
        @test 5//2 ∈ ℂ
        @test ℂ == ℂ
    end

    @testset "point" begin
        d = Domain(1.0)
        @test d isa Point
        @test 1 ∈ d
        @test 1.1 ∉ d
        @test approx_in(1.1, d, 0.2)
        @test !approx_in(1.2, d, 0.1)
        @test !isempty(d)
        @test boundary(d) == d
        @test boundingbox(d) == 1.0..1.0
        @test infimum(d) == d.x
        @test supremum(d) == d.x
        @test isclosedset(d)
        @test !isopenset(d)
        @test dimension(d) == 1
        @test isempty(interior(d))
        @test closure(d) == d
        @test canonicaldomain(d) == Point(0.0)
        @test mapfrom_canonical(d) == Translation(1.0)

        @test distance_to(d, 0.5) == abs(0.5-d.x)

        @test d .+ 1 == Domain(2.0)
        @test 1 .+ d == Domain(2.0)
        @test 1 .- d == Domain(0.0)
        @test d .- 1 == Domain(0.0)
        @test 2d  == Domain(2.0)
        @test d * 2 == Domain(2.0)
        @test d / 2 == Domain(0.5)
        @test 2 \ d == Domain(0.5)

        d1 = Domain(Set([1,2,3]))
        d2 = Point(1) ∪ Point(2) ∪ Point(3)

        @test Point(0.5) ∩ (0..1) == Point(0.5)
        @test (0..1) ∩ Point(0.5) == Point(0.5)
        @test isempty(Point(0.5) ∩ (1..2))
        @test isempty((1..2) ∩ Point(0.5))
        @test Point(0.5) ∩ DomainRef(0.5) == Point(0.5)
        @test isempty(Point(0.5) ∩ DomainRef(0))

        @test d1 == d2

        @test convert(Domain{Float64}, Point(1)) ≡ Point(1.0)
        @test Number(Point(1)) ≡ convert(Number, Point(1)) ≡ convert(Int, Point(1)) ≡ 1
        @test convert(Domain{Float64}, 1) isa Point{Float64}
        @test Int(Point(2)) == 2
        @test Float64(Point(2.0)) == 2.0
        @test Float64(Point(2)) isa Float64

        @test choice(Point(1)) == 1

        @test Point(1) + Point(2) == Point(3)
        @test Point(1) - Point(2) == Point(-1)

        @test 0.5 ∉ (0..1)\Point(0.5)
        @test (0..1) \ Point(0.5) isa  UnionDomain{Float64}
        @test (0..1) \ Point(0.0) == Interval{:open,:closed,Float64}(0,1)
        @test (0..1) \ Point(1.0) == Interval{:closed,:open,Float64}(0,1)
        @test (0..1) \ Point(2.0) == Interval{:closed,:closed,Float64}(0,1)
        @test (0..1) \ DomainRef(2.0) == (0..1) \ Point(2.0)
        @test issubset(Point(1), (0..2))
        @test Point(0.5) \ (0..1) == EmptySpace{Float64}()
        @test Point(0.5) \ (1..2) == Point(0.5)
        @test isequaldomain(Point(1), Point(1.0))
        @test isequaldomain(Point(1), 1)

        pv = Point([1,2,3])
        @test dimension(pv)==3
        @test canonicaldomain(pv) == Point([0,0,0])
        @test mapfrom_canonical(pv) == Translation(pv.x)

        @test intersectdomain(Point(1), Point(1.0)) == Point(1)
        @test isempty(intersectdomain(Point(1), Point(2.0)))

        # show
        @test repr(Point(3)) == "Point(3)"
        @test repr(Point(3.0)) == "Point(3.0)"
    end

    # @testset "intervals" begin
    #     test_intervals()
    # end

    @testset "balls" begin
        test_balls()
    end

    @testset "spheres" begin
        test_spheres()
    end

    @testset "wrapped domains" begin
        B = NamedBall()
        @test SA[1.4, 1.4] ∈ B
        @test SA[1.5, 1.5] ∉ B
        @test typeof(1.2 * B)==typeof(B * 1.2)
        @test SA[1.5,1.5] ∈ 1.2 * B
        @test SA[1.5,1.5] ∈ B * 1.2
        @test eltype(B) == eltype(2UnitDisk())

        @test hascanonicaldomain(B)
        @test canonicaldomain(B) == UnitDisk()
        @test mapfrom_canonical(B) == LinearMap{eltype(B)}(2)
        @test DomainSets.simplifies(B)
        @test canonicaldomain(DomainSets.Equal(), B) === superdomain(B)
        @test B == superdomain(B)

        @test Domain([1,2,3]) isa DomainSets.WrappedDomain{Int,Vector{Int}}
        @test Domain([1,2,3]) == Domain([1.0,2.0,3.0])
        @test canonicaldomain(Domain([1,2,3])) == [1,2,3]

        d = DomainSets.ExampleNamedDomain(UnitBall())
        @test !DomainSets.isinterval(d)
        @test superdomain(d) == UnitBall()
        @test hascanonicaldomain(d)
        @test DomainSets.simplifies(d)
        @test canonicaldomain(DomainSets.Equal(), d) === superdomain(d)
        @test d == superdomain(d)
        @test canonicaldomain(DomainSets.Isomorphic(), d) === superdomain(d)
    end

    @testset "complex unit circle/disk" begin
        C = ComplexUnitCircle()
        @test eltype(C) == Complex{Float64}
        @test isclosedset(C)
        @test !isopenset(C)
        @test 1 ∈ C
        @test 1im ∈ C
        @test 1.1im ∉ C
        @test 0.2+0.5im ∉ C
        @test 1.2+0.5im ∉ C
        @test parameterdomain(C) == UnitInterval()

        D = ComplexUnitDisk()
        @test eltype(D) == Complex{Float64}
        @test isclosedset(D)
        @test !isopenset(D)
        @test 1 ∈ D
        @test 1im ∈ D
        @test 1.1im ∉ D
        @test 0.2+0.5im ∈ D
        @test 1.2+0.5im ∉ D

        D2 = ComplexUnitDisk{BigFloat,:open}()
        @test eltype(D2) == Complex{BigFloat}
        @test isopenset(D2)
        @test 1im ∉ D2
        @test 0.999 ∈ D2

        @test repr(ComplexUnitCircle()) == "ComplexUnitCircle()"
        @test repr(ComplexUnitDisk()) == "ComplexUnitDisk()"
        @test repr(ComplexUnitDisk{Float64,:open}()) == "ComplexUnitDisk()  (open)"
        @test repr(ComplexUnitDisk{BigFloat}()) == "ComplexUnitDisk{BigFloat}()"
        @test repr(ComplexUnitDisk{BigFloat,:open}()) == "ComplexUnitDisk{BigFloat}()  (open)"

        @test pseudolevel(ComplexUnitCircle(), 0.1) isa SublevelSet{Complex{Float64},:open}
        p = pseudolevel(ComplexUnitCircle(), 0.1)
        @test 0.8 ∉ p
        @test 0.95 ∈ p
        @test 1+0.1im ∈ p
        @test 1.1+0.2im ∉ p
    end

    @testset "derived types" begin
        # Create an ellipse, the curve
        E = ellipse(2.0, 4.0)
        @test SA[2.0,0.0] ∈ E
        @test SA[0.0,4.0] ∈ E
        @test SA[2.0+1e-10,0.0] ∉ E
        @test SA[0.0,0.0] ∉ E
        E = ellipse(1, 2.0)
        @test eltype(E) == SVector{2,Float64}

        # Create an ellipse, the domain with volume
        E2 = ellipse_shape(2.0, 4.0)
        @test SA[2.0,0.0] ∈ E2
        @test SA[0.0,4.0] ∈ E2
        @test SA[2.0+1e-10,0.0] ∉ E2
        @test SA[0.0,0.0] ∈ E2
        @test SA[1.0,1.0] ∈ E2

        E2 = ellipse_shape(1, 2.0)
        @test eltype(E) == SVector{2,Float64}

        C = cylinder()
        @test eltype(C) == SVector{3,Float64}
        C2 = cylinder(1.0, 2)
        @test SA[0.5,0.2,1.5] ∈ C2
    end

    @testset "mapped_domain" begin
        @test MappedDomain(cos, 0..1.0) isa MappedDomain{Float64}
        @test MappedDomain{Float64}(cos, 0..1.0) isa MappedDomain{Float64}
        @test cos.(0..1.0) isa ParametricDomain
        @test isempty(MappedDomain(LinearMap(2.0), EmptySpace()))
        @test mapped_domain(acos, 0..1.0) isa MappedDomain

        # Test chaining of maps
        D = UnitCircle()
        D1 = MappedDomain(inverse(LinearMap(2)), D)
        @test typeof(D1) <: MappedDomain
        @test typeof(superdomain(D1)) <: UnitSphere
        @test isclosedset(D1)
        @test !isopenset(D1)
        @test convert(Domain{SVector{2,BigFloat}}, D1) isa MappedDomain{SVector{2,BigFloat}}
        D2 = 2 * D1
        @test typeof(superdomain(D2)) <: UnitSphere

        D = UnitInterval()^2
        show(io, textmime, rotate(D,1.))
        @test String(take!(io))[1:17] == "A .* UnitSquare()"

        D = rotate(UnitInterval()^2, π/2)
        @test SA[-0.9, 0.9] ∈ D
        @test SA[-1.1, -1.1] ∉ D
        x = choice(D)
        @test forward_map(D)(x) ≈ forward_map(D, x)
        @test DomainSets.toexternalpoint(D, x) ≈ forward_map(D, x)

        D = rotate(UnitInterval()^2, π, SA[-.5,-.5])
        @test SA[-1.5, -1.5] ∈ D
        @test SA[-0.5, -0.5] ∉ D

        D = rotate(UnitInterval()^3 .+ SA[-.5,-.5,-.5], pi, pi, pi)
        @test SA[0.4, 0.4, 0.4] ∈ D
        @test SA[0.6, 0.6, 0.6] ∉ D

        D = rotate(cartesianproduct(-1.5.. 2.2, 0.5 .. 0.7, -3.0 .. -1.0), π, π, π, SA[.35, .65, -2.])
        @test SA[0.9, 0.6, -2.5] ∈ D
        @test SA[0.0, 0.6, 0.0] ∉ D

        B = mapped_domain(inverse(LinearMap(2.0)), VectorUnitBall(10))
        @test dimension(B) == 10
        @test mapped_domain(inverse_map(B), superdomain(B)) == B
        @test isopenset(interior(B))
        @test B == closure(interior(B))
        @test DomainSets.superdomain(boundary(B)) isa UnitSphere
        @test canonicaldomain(B) == VectorUnitBall(10)
        @test mapfrom_canonical(B) == forward_map(B)
        @test mapto_canonical(B) == inverse_map(B)
        @test parameterdomain(B) == canonicaldomain(B)
        @test mapfrom_parameterdomain(B) == mapfrom_canonical(B)
        @test mapto_parameterdomain(B) == mapto_canonical(B)

        # Test parametric domain
        using DomainSets: ParametricDomain
        m = AffineMap(ones(2), [4; 5])
        pd = ParametricDomain(m, UnitInterval())
        @test pd isa Domain{Vector{Float64}}
        @test forward_map(pd) == m
        @test forward_map(pd, 0.4) ≈ m(0.4)
        @test mapfrom_canonical(pd) == m
        @test canonicaldomain(pd) == 0..1
        @test boundary(pd) isa UnionDomain
        @test interior(pd) isa ParametricDomain
        @test closure(pd) isa ParametricDomain
        @test corners(pd) == [ [4.0; 5.0], [5.0; 6.0]]
        @test DomainSets.similardomain(pd, eltype(pd)) isa ParametricDomain

        @test convert(MappedDomain, 3..4.0) isa MappedDomain
        @test convert(MappedDomain{Float64}, 3..4.0) isa MappedDomain
    end

    @testset "simplex" begin
        test_simplex()
    end

    @testset "level sets" begin
        d1 = LevelSet(cos, 1.0)
        @test d1 isa LevelSet{Float64}
        @test convert(Domain{ComplexF64}, d1) isa LevelSet{ComplexF64}
        show(io,d1)
        @test String(take!(io)) == "level set f(x) = 1.0 with f = cos"
        @test 0.0 ∈ d1
        @test 0im ∈ d1
        @test 0.1 ∉ d1
        @test 0.1+1im ∉ d1
        @test hash(d1) == DomainSets.domainhash(d1)

        # prod yields the function (x,y) -> x*y
        d2 = ZeroSet{SVector{2,Float64}}(prod)
        @test d2 isa ZeroSet{SVector{2,Float64}}
        @test SA[0.1,0.3] ∉ d2
        @test SA[0.0,0.3] ∈ d2
        @test SA[0.1,0.0] ∈ d2
        @test ZeroSet(cos) isa ZeroSet{Float64}
        @test convert(Domain{BigFloat}, ZeroSet(cos)) isa ZeroSet{BigFloat}
        @test convert(LevelSet, ZeroSet{BigFloat}(cos)) isa LevelSet{BigFloat}
        @test convert(LevelSet{BigFloat}, ZeroSet{Float64}(cos)) isa LevelSet{BigFloat}
        @test hash(d2) == DomainSets.domainhash(d2)

        d3 = SublevelSet(cos, 0.5)
        d3_open = SublevelSet{Float64,:open}(cos,0.5)
        @test d3 isa SublevelSet{Float64,:closed}
        @test interior(d3) == d3_open
        @test closure(d3_open) == d3
        @test closure(d3) == d3
        @test interior(d3_open) == d3_open
        @test boundary(d3) == LevelSet(cos, 0.5)
        @test 3.0 ∈ d3
        @test 0.0 ∉ d3
        @test 0.0 ∉ d3_open
        show(io, d3)
        @test String(take!(io)) == "sublevel set f(x) <= 0.5 with f = cos"
        show(io, d3_open)
        @test String(take!(io)) == "sublevel set f(x) < 0.5 with f = cos"
        @test convert(Domain{BigFloat}, d3) isa SublevelSet{BigFloat,:closed}
        @test convert(Domain{BigFloat}, d3_open) isa SublevelSet{BigFloat,:open}
        @test d3 != d3_open
        @test hash(d3) == DomainSets.domainhash(d3)
        @test hash(d3_open) != hash(d3)

        d4 = SubzeroSet{SVector{2,Float64}}(prod)
        d4_open = SubzeroSet{SVector{2,Float64},:open}(prod)
        @test d4 isa SubzeroSet{SVector{2,Float64},:closed}
        @test interior(d4) == d4_open
        @test closure(d4_open) == d4
        @test closure(d4) == d4
        @test interior(d4_open) == d4_open
        @test boundary(d4) == ZeroSet{SVector{2,Float64}}(prod)
        @test SA[0.1,0.3] ∉ d4
        @test SA[-0.1,0.3] ∈ d4
        @test SA[-0.1,-0.3] ∉ d4
        @test SA[-0.1,0.3] ∈ d4_open
        convert(Domain{SVector{2,BigFloat}}, d4) isa SubzeroSet{SVector{2,BigFloat},:closed}
        convert(Domain{SVector{2,BigFloat}}, d4_open) isa SubzeroSet{SVector{2,BigFloat},:open}
        @test SubzeroSet(cos) == SubzeroSet{Float64}(cos)
        @test d4 != d4_open
        @test hash(d4) == DomainSets.domainhash(d4)
        @test hash(d4_open) != hash(d4)

        d5 = SuperlevelSet(cos, 0.5)
        d5_open = SuperlevelSet{Float64,:open}(cos, 0.5)
        @test d5 isa SuperlevelSet{Float64,:closed}
        @test interior(d5) == d5_open
        @test closure(d5_open) == d5
        @test closure(d5) == d5
        @test interior(d5_open) == d5_open
        @test boundary(d5) == LevelSet(cos, 0.5)
        @test 3.0 ∉ d5
        @test 0.0 ∈ d5
        @test 0.0 ∈ d5
        @test 0.0 ∈ d5_open
        show(io, d5)
        @test String(take!(io)) == "superlevel set f(x) >= 0.5 with f = cos"
        show(io, d5_open)
        @test String(take!(io)) == "superlevel set f(x) > 0.5 with f = cos"
        @test convert(Domain{BigFloat}, d5) isa SuperlevelSet{BigFloat}
        @test convert(Domain{BigFloat}, d5_open) isa SuperlevelSet{BigFloat,:open}
        @test d5 != d5_open
        @test hash(d5) == DomainSets.domainhash(d5)
        @test hash(d5_open) != hash(d5)

        d6 = SuperzeroSet{SVector{2,Float64}}(prod)
        d6_open = SuperzeroSet{SVector{2,Float64},:open}(prod)
        @test d6 isa SuperzeroSet{SVector{2,Float64},:closed}
        @test interior(d6) == d6_open
        @test closure(d6_open) == d6
        @test closure(d6) == d6
        @test interior(d6_open) == d6_open
        @test boundary(d6) == ZeroSet{SVector{2,Float64}}(prod)
        @test SA[0.1,0.3] ∈ d6
        @test SA[-0.1,0.3] ∉ d6
        @test SA[-0.1,-0.3] ∈ d6
        @test SuperzeroSet(cos) isa SuperzeroSet{Float64}
        @test convert(Domain{SVector{2,BigFloat}}, d6) isa SuperzeroSet{SVector{2,BigFloat},:closed}
        @test convert(Domain{SVector{2,BigFloat}}, d6_open) isa SuperzeroSet{SVector{2,BigFloat},:open}
        @test d6 != d6_open
        @test hash(d6) == DomainSets.domainhash(d6)
        @test hash(d6_open) != hash(d6)
    end

    @testset "indicator functions" begin
        using DomainSets: BoundedIndicatorFunction
        ispositive(x) = x >= 0
        d1 = IndicatorFunction(ispositive)
        @test d1 isa IndicatorFunction{Float64}
        @test DomainSets.indicatorfunction(d1) == ispositive
        show(io,d1)
        @test String(take!(io)) == "indicator domain defined by function f = ispositive"
        @test 0 ∈ d1
        @test big(0) ∈ d1
        @test -1 ∉ d1
        @test d1 ∩ ChebyshevInterval() isa BoundedIndicatorFunction
        @test ChebyshevInterval() ∩ d1 isa BoundedIndicatorFunction
        d1b = IndicatorFunction(ispositive)
        @test d1 == d1b
        @test hash(d1) == DomainSets.domainhash(d1)

        @test convert(IndicatorFunction, 0..1) isa IndicatorFunction
        @test convert(IndicatorFunction, d1) == d1
        @test convert(Domain{BigFloat}, d1) isa IndicatorFunction{BigFloat}
        @test 0.5 ∈ convert(IndicatorFunction, 0..1)

        d2 = BoundedIndicatorFunction(x -> prod(x)>0, UnitDisk())
        @test d2 isa BoundedIndicatorFunction
        @test eltype(d2) == SVector{2,Float64}
        @test SA[0.1,0.2] ∈ d2
        @test SA[-0.1,0.2] ∉ d2
        @test SA[0.1,-0.2] ∉ d2
        @test SA[-0.1,-0.2] ∈ d2
        @test isequaldomain(d2, d2)
        @test hash(d2) == DomainSets.domainhash(d2)
    end

    @testset "generator domains" begin
        d1 = Domain(x for x in 0..1)
        @test d1 == 0..1

        d2 = Domain(x>0 for x in -1..1)
        @test -0.5 ∉ d2
        @test 0.5 ∈ d2
        show(io, d2)
        @test String(take!(io)) == "indicator function bounded by: $(-1..1)"

        d3 = Domain(x*y>0 for (x,y) in UnitDisk())
        @test eltype(d3) == SVector{2,Float64}
        @test d3 isa DomainSets.BoundedIndicatorFunction
        @test d3.domain == UnitDisk()
        @test [0.4,0.2] ∈ d3
        @test [0.4,-0.2] ∉ d3

        d4 = Domain( x+y+z > 0 for (x,y) in UnitDisk(), z in 0..1.0)
        @test d4 isa DomainSets.BoundedIndicatorFunction{T,F,<:TupleProductDomain} where {T,F}
        @test eltype(d4) == Tuple{SVector{2, Float64}, Float64}
        @test DomainSets.indicatorfunction(d4) isa Function
        @test DomainSets.boundingdomain(d4) == TupleProductDomain(UnitDisk(), 0..1.0)
        @test boundingbox(d4) == boundingbox(DomainSets.boundingdomain(d4))
        @test ( [0.5,0.2], 0.5) ∈ d4
        @test ( [0.5,0.2], 1.5) ∉ d4
        @test ( [-0.5,-0.2], 0.1) ∉ d4

        # conditional comprehension syntax in 1d
        g5 = (x > 2 for x in 0..5.0 if x < 3)
        d5 = Domain(g5)
        @test d5 isa DomainSets.BoundedIndicatorFunction
        @test eltype(d5) == Float64
        @test -1 ∉ d5
        @test 1 ∉ d5
        @test 2 ∉ d5
        @test 2.5 ∈ d5
        @test 3 ∉ d5
        @test 3.1 ∉ d5
        @test 5.5 ∉ d5

        # conditional comprehension syntax in 2d
        g6 = (x<4 for x in 0..5.0, y in 1..2.0 if x > 3)
        d6 = Domain(g6)
        @test d6 isa DomainSets.BoundedIndicatorFunction
        @test eltype(d6) == Tuple{Float64,Float64}
        # test values for y smaller than 1, in 1..2, and larger than 2
        # test values for x smaller than 0, 3, 4, 5 and larger
        @test (-1, 1.5) ∉ d6
        @test (1, 1.5) ∉ d6
        @test (3.5, 1.5) ∈ d6
        @test (4.5, 1.5) ∉ d6
        @test (5.5, 1.5) ∉ d6
        @test (-1, 0.5) ∉ d6
        @test (1, 0.5) ∉ d6
        @test (3.5, 0.5) ∉ d6
        @test (4.5, 0.5) ∉ d6
        @test (5.5, 0.5) ∉ d6
        @test (-1, 2.5) ∉ d6
        @test (1, 2.5) ∉ d6
        @test (3.5, 2.5) ∉ d6
        @test (4.5, 2.5) ∉ d6
        @test (5.5, 2.5) ∉ d6

        g7 = (x+y+z<4 for (x,y) in UnitDisk(), z in ChebyshevInterval() if z < 0)
        d7 = Domain(g7)
        @test eltype(d7) == Tuple{SVector{2, Float64}, Float64}
        @test (SVector(0.1,0.2),-0.3) ∈ d7
        @test (SVector(0.1,0.2),0.3) ∉ d7
        @test (SVector(1,2),3) ∉ d7
    end
end

@testset "cartesian product" begin
    test_product_domains()
end

@testset "intervals" begin
    test_intervals()
end

@testset "balls" begin
    test_balls()
end

@testset "simplex" begin
    test_simplex()
end

# some renames, to be deprecated in a later breaking release
islinear(m::Map) = islinearmap(m)
isaffine(m::Map) = isaffinemap(m)
isconstant(m::Map) = isconstantmap(m)
constant(m::Map) = mapconstant(m)
isidentity(m::Map) = isidentitymap(m)

isreal(::Type{T}) where T = isrealtype(T)

matrix(m::Map) = affinematrix(m)
vector(m::Map) = affinevector(m)

@deprecate convert_domaintype(map::Map, ::Type{T}) where {T} convert_domaintype(T, map)
@deprecate convert_numtype(map::Map{T}, ::Type{U}) where {T,U} convert_numtype(U, map)
@deprecate convert_prectype(map::Map{T}, ::Type{U}) where {T,U} convert_prectype(U, map)

# In this file we group a number of concepts relating to geometrical features.
# These routines may make assumptions about orientations and a metric that
# might not be entirely generic.

"""
Return a bounding box of the given domain.

A bounding box is an interval, a hyperrectangle or the full space. It is such that
each point in the domain also lies in the bounding box.
"""
boundingbox(d) = fullspace(d)

"Return the boundary of the given domain as a domain."
function boundary end
const ∂ = boundary

"""
Return the normal of the domain at the point `x`.

It is assumed that `x` is a point on the boundary of the domain.
"""
function normal end

"""
Return the tangents of the domain at the point `x`. The tangents form a
basis for the tangent plane, perpendicular to the normal direction at `x`.
"""
function tangents end

"""
    distance_to(d, x)

Return the distance from the point `x` to the domain `d`.
"""
function distance_to end

"Return the volume of the domain."
function volume end

# Rotation around the origin
rotate(d::EuclideanDomain{2}, θ) = rotation_map(θ).(d)

rotate(d::EuclideanDomain{3}, phi, theta, psi) = rotation_map(phi,theta,psi).(d)
# Rotation around a fixed center.
rotate(d::EuclideanDomain{2}, θ, center::SVector{T}) where {T} = (Translation(center) ∘ rotation_map(θ) ∘ Translation(-center)).(d)

rotate(d::EuclideanDomain{3}, phi, theta, psi, center::SVector{T}) where {T} = (Translation(center) ∘ rotation_map(phi,theta,psi) ∘ Translation(-center)).(d)


#############################
# Rotations around the origin
#############################

# Rotation in positive (counterclockwise) direction
# (Note: the SMatrix constructor expects the arguments column-first)
rotationmatrix(theta) = SMatrix{2,2}(cos(theta), sin(theta), -sin(theta), cos(theta))

# Rotation about X-axis (phi), Y-axis (theta) and Z-axis (psi)
# As above, the matrix is given column-by-column
rotationmatrix(phi,theta,psi) =
    SMatrix{3,3}(cos(theta)*cos(psi), cos(theta)*sin(psi), -sin(theta),
        -cos(phi)*sin(psi)+sin(phi)*sin(theta)*cos(psi), cos(phi)*cos(psi)+sin(phi)*sin(theta)*sin(psi), sin(phi)*cos(theta),
        sin(phi)*sin(psi)+cos(phi)*sin(theta)*cos(psi), -sin(phi)*cos(psi)+cos(phi)*sin(theta)*sin(psi), cos(phi)*cos(theta))

rotation_map(theta) = LinearMap(rotationmatrix(theta))

rotation_map(phi, theta, psi) = LinearMap(rotationmatrix(phi,theta,psi))

# The contents of this file are a copy of the preliminary core package
# DomainSetsCore.jl. Once that package is registered and usable,
# this file can be removed.

export Domain,
    domain,
    domaineltype,
    DomainStyle,
    IsDomain,
    NotDomain,
    DomainRef,
    AnyDomain,
    checkdomain

"""
    domaineltype(d)

The `domaineltype` of a continuous set is a valid type for elements of that set.
By default it is equal to the `eltype` of `d`, which in turn defaults to `Any`.
"""
domaineltype(d) = eltype(d)


# Definition of Domain commented out as it is defined in IntervalSets.jl
# """
# A `Domain{T}` is a supertype for domains with `domaineltype` equal to `T`.
#
# In addition, the `eltype` of a `Domain{T}` is also equal to `T`.
# """
# abstract type Domain{T} end
#
domaineltype(d::Domain{T}) where T = T
Base.eltype(::Type{<:Domain{T}}) where T = T


"""
    DomainStyle(d)

Trait to indicate whether or not `d` implements the domain interface.
"""
abstract type DomainStyle end

"""
    IsDomain()

indicates an object implements the domain interface.
"""
struct IsDomain <: DomainStyle end

"""
    NotDomain()

indicates an object does not implement the domain interface.
"""
struct NotDomain <: DomainStyle end


DomainStyle(d) = DomainStyle(typeof(d))
# - the default is no domain
DomainStyle(::Type) = NotDomain()
# - subtypes of Domain are domains
DomainStyle(::Type{<:Domain}) = IsDomain()
# - declare Number, AbstractSet and AbstractArray to be valid domain types
DomainStyle(::Type{<:Number}) = IsDomain()
DomainStyle(::Type{<:AbstractSet}) = IsDomain()
DomainStyle(::Type{<:AbstractArray}) = IsDomain()

BaseDomainType = Union{<:Number,<:AbstractSet,<:AbstractArray}

"""
    domain(d)

Return a domain associated with the object `d`.
"""
domain(d::Domain) = d

"""
    DomainRef(d)

A reference to a domain.

In a function call, `DomainRef(x)` can be used to indicate that `x` should be
treated as a domain, e.g., `foo(x, DomainRef(d))`.
"""
struct DomainRef{D}
    domain  ::  D
end

domain(d::DomainRef) = d.domain
domaineltype(d::DomainRef) = domaineltype(domain(d))


"""
`AnyDomain` is the union of `Domain` and `DomainRef`.

In both cases `domain(d::AnyDomain)` returns the domain itself.
"""
const AnyDomain = Union{Domain,DomainRef}

"""
   checkdomain(d)

Checks that `d` is a domain or refers to a domain and if so returns that domain,
throws an error otherwise.
"""
checkdomain(d::Domain) = d
# we trust the explicit intention of a user providing a domain reference
checkdomain(d::DomainRef) = domain(d)
# for other objects we check DomainStyle
checkdomain(d) = _checkdomain(d, DomainStyle(d))
_checkdomain(d, ::IsDomain) = d
_checkdomain(d, ::NotDomain) =
    error("Domain does not implement domain interface as indicated by DomainStyle.")

module DomainSetsMakieExt
using DomainSets
using DomainSets.StaticArrays
import Makie
using DomainSets: leftendpoint, rightendpoint, Rectangle, HyperRectangle, Point, DomainPoint, pointval, point
import Makie: Point2f, Rect, Circle, Poly, Lines, convert_arguments, HyperSphere, Vec, Scatter, PointBased
import Base: convert

function convert(::Type{Makie.HyperRectangle}, r::Rectangle{<:SVector{N}}) where N
    l = leftendpoint(r)
    r = rightendpoint(r)
    Rect(convert(Vec{N}, l), convert(Vec{N}, r .- l))
end

convert(::Type{<:HyperSphere}, r::Union{Sphere{SVector{N,T}},Ball{SVector{N,T}}}) where {N,T} = HyperSphere{N,T}(Point(center(r)), radius(r))

function convert(::Type{<:HyperSphere}, r::Union{Sphere{<:AbstractVector{T}}, Ball{<:AbstractVector{T}}}) where T
    N = length(center(r))
    HyperSphere{N,T}(Makie.Point{N}(center(r)), radius(r))
end

convert(::Type{<:Makie.Point}, r::Point) = Makie.Point(pointval(r))
convert(::Type{<:Makie.Point}, r::DomainPoint) = convert(Makie.Point, point(r))

convert_arguments(::Type{Plt}, r::HyperRectangle; kwds...) where Plt <: Poly = convert_arguments(Plt, convert(Makie.HyperRectangle, r); kwds...)
convert_arguments(::Type{Plt}, r::Ball; kwds...) where Plt <: Poly = convert_arguments(Plt, convert(HyperSphere, r); kwds...)
convert_arguments(::Type{Plt}, r::Sphere; kwds...) where Plt <: Lines = convert_arguments(Plt, convert(HyperSphere, r); kwds...)
convert_arguments(::Type{Plt}, r::Point; kwds...) where Plt <: Scatter = convert_arguments(Plt, convert(Makie.Point, r); kwds...)



Makie.plottype(a::HyperRectangle) = Poly
Makie.plottype(a::Sphere) = Lines
Makie.plottype(a::Ball) = Poly
Makie.plottype(a::Union{DomainPoint,Point}) = Scatter

end # module

"The set of all natural numbers."
struct NaturalNumbers <: Domain{Int}
end

in(x, d::NaturalNumbers) = isinteger(x) && (x >= 0)
in(x::AbstractArray, d::NaturalNumbers) = false

approx_in(x::Real, d::NaturalNumbers, tol) =
    (abs(x-round(x)) < tol) && (round(Int, x) ∈ d)


"The set of all integers."
struct Integers <: Domain{Int}
end

in(x, d::Integers) = isinteger(x)
in(x::AbstractArray, d::Integers) = false

approx_in(x::Real, d::Integers, tol) =
    (abs(x-round(x)) < tol) && (round(Int, x) ∈ d)


"The set of all real numbers."
struct RealNumbers <: Domain{Float64}
end

in(x::Number, d::RealNumbers) = isreal(x)
# isreal also allows real arrays, we want to disallow that here:
in(x::AbstractArray, d::RealNumbers) = false

approx_in(x::Complex, d::RealNumbers, tol) = (imag(x) < tol) && (real(x) ∈ d)


"The set of all rationals."
struct Rationals <: Domain{Rational{Int}}
end

in(x, d::Rationals) = x ∈ Integers()
in(x::Rational, d::Rationals) = true


"The set of all complex numbers whose real and imaginary parts are real numbers."
struct ComplexNumbers <: Domain{Complex{Float64}}
end

in(x::Complex{T}, d::ComplexNumbers) where {T} =
    isreal(real(x)) && isreal(imag(x))
in(x::Complex{T}, d::ComplexNumbers) where {T<:Real} = true
in(x, d::ComplexNumbers) = x ∈ RealNumbers()


"The set of natural numbers."
const ℕ = NaturalNumbers()
"The set of integers."
const ℤ = Integers()
"The set of rational numbers."
const ℚ = Rationals()
"The set of real numbers."
const ℝ = RealNumbers()
"The set of complex numbers."
const ℂ = ComplexNumbers()

"The Euclidean space ``ℝ^1``."
const ℝ1 = VcatDomain(ℝ)
"The Euclidean space ``ℝ^2``."
const ℝ2 = VcatDomain(ℝ, ℝ)
"The Euclidean space ``ℝ^3``."
const ℝ3 = VcatDomain(ℝ, ℝ, ℝ)
"The Euclidean space ``ℝ^4``."
const ℝ4 = VcatDomain(ℝ, ℝ, ℝ, ℝ)

"Supertype of identity maps."
abstract type IdentityMap{T} <: Map{T} end

IdentityMap(n::Int) = DynamicIdentityMap(n)
IdentityMap() = StaticIdentityMap()
IdentityMap(::Val{N}) where {N} = StaticIdentityMap(Val(N))

IdentityMap{T}(n::Int) where {T} = DynamicIdentityMap{T}(n)
IdentityMap{T}(n::Int) where {T<:StaticTypes} = StaticIdentityMap{T}()
IdentityMap{T}(::Val{N}) where {N,T} = StaticIdentityMap{T}(Val(N))
IdentityMap{T}() where {T} = StaticIdentityMap{T}()

applymap(map::IdentityMap, x) = x
applymap!(y, map::IdentityMap, x) = y .= x

inverse(m::IdentityMap) = m
inverse(m::IdentityMap, x) = x

islinearmap(::IdentityMap) = true
isreal(::IdentityMap{T}) where {T} = isrealtype(T)

isidentitymap(::IdentityMap) = true
isidentitymap(m::Map{T}) where {T} = m == StaticIdentityMap{T}()

mapsize(m::IdentityMap{T}) where {T<:Number} = ()
mapsize(m::IdentityMap{T}) where {T} = (euclideandimension(T),euclideandimension(T))

affinematrix(m::IdentityMap) = identitymatrix(m)
affinevector(m::IdentityMap) = zerovector(m)

jacobian(m::IdentityMap) = ConstantMap(affinematrix(m))
jacobian(m::IdentityMap, x) = affinematrix(m)

jacdet(m::IdentityMap, x) = 1

determinantmap(m::IdentityMap{T}) where {T} = UnityMap{T,prectype(T)}()

mapcompose(m1::IdentityMap) = m1
mapcompose(m1::IdentityMap, maps...) = mapcompose(maps...)
mapcompose2(m1, m2::IdentityMap, maps...) = mapcompose(m1, maps...)

show(io::IO, m::IdentityMap{T}) where {T} = print(io, "x -> x")
map_object_parentheses(m::IdentityMap) = true

"The identity map for variables of type `T`."
struct StaticIdentityMap{T} <: IdentityMap{T}
end

StaticIdentityMap() = StaticIdentityMap{Float64}()
StaticIdentityMap(::Val{N}) where {N} = StaticIdentityMap{SVector{N,Float64}}()

StaticIdentityMap{T}(n::Int) where {T} =
    (@assert n == euclideandimension(T); StaticIdentityMap{T}())
StaticIdentityMap{T}(::Val{N}) where {N,T} =
    (@assert N == euclideandimension(T); StaticIdentityMap{T}())

similarmap(m::StaticIdentityMap, ::Type{T}) where {T<:StaticTypes} = StaticIdentityMap{T}()
similarmap(m::StaticIdentityMap, ::Type{T}) where {T} =
    DynamicIdentityMap{T}(euclideandimension(T))

convert(::Type{StaticIdentityMap{T}}, ::StaticIdentityMap) where {T} = StaticIdentityMap{T}()

isequalmap(m1::StaticIdentityMap, m2::StaticIdentityMap) = true
map_hash(m::StaticIdentityMap, h::UInt) = hash("StaticIdentityMap", h)

"Identity map with dynamic size determined by a dimension field."
struct DynamicIdentityMap{T} <: IdentityMap{T}
    dimension   ::  Int
end

const EuclideanIdentityMap{N,T} = StaticIdentityMap{SVector{N,T}}
const VectorIdentityMap{T} = DynamicIdentityMap{Vector{T}}

DynamicIdentityMap(dimension::Int) = VectorIdentityMap(dimension)
VectorIdentityMap(dimension::Int) = VectorIdentityMap{Float64}(dimension)

mapsize(m::DynamicIdentityMap) = (m.dimension, m.dimension)

similarmap(m::DynamicIdentityMap, ::Type{T}) where {T} =
    DynamicIdentityMap{T}(m.dimension)
similarmap(m::DynamicIdentityMap, ::Type{T}) where {T<:StaticTypes} =
    StaticIdentityMap{T}()

isequalmap(m1::DynamicIdentityMap, m2::DynamicIdentityMap) = m1.dimension == m2.dimension
map_hash(m::DynamicIdentityMap, h::UInt) = hashrec("DynamicIdentityMap", m.dimension, h)


"The supertype of constant maps from `T` to `U`."
abstract type ConstantMap{T,U} <: TypedMap{T,U} end

applymap(m::ConstantMap, x) = mapconstant(m)

isconstantmap(m::AbstractMap) = false
isconstantmap(m::ConstantMap) = true

isreal(m::ConstantMap{T,U}) where {T,U} =
    isrealtype(T) && isrealtype(U) && isreal(mapconstant(m))

mapsize(m::ConstantMap) = _constant_mapsize(m, mapconstant(m))
_constant_mapsize(m::ConstantMap{T,U}, c) where {T<:Number,U<:Number} = ()
_constant_mapsize(m::ConstantMap{T,U}, c) where {T<:Number,U} = (length(c),)
_constant_mapsize(m::ConstantMap{T,U}, c) where {T,U<:Number} = (1,euclideandimension(T))
_constant_mapsize(m::ConstantMap{T,U}, c) where {T,U} = (length(c), euclideandimension(T))

affinematrix(m::ConstantMap) = zeromatrix(m)
affinevector(m::ConstantMap) = mapconstant(m)

jacobian(m::ConstantMap{T}) where {T} = ConstantMap{T}(affinematrix(m))
jacobian(m::ConstantMap, x) = affinematrix(m)

jacdet(::ConstantMap, x) = 0

determinantmap(m::ConstantMap{T}) where {T} = ConstantMap{T}(det(mapconstant(m)))
absmap(m::ConstantMap{T}) where {T} = ConstantMap{T}(abs(mapconstant(m)))

diffvolume(m::ConstantMap{T,U}) where {T,U} = ZeroMap{T,U}()

isequalmap(m1::ConstantMap, m2::ConstantMap) = mapconstant(m1)==mapconstant(m2)
map_hash(m::ConstantMap, h::UInt) = hashrec("ConstantMap", mapconstant(m), h)

similarmap(m::ConstantMap, ::Type{T}) where {T} = ConstantMap{T}(mapconstant(m))
similarmap(m::ConstantMap, ::Type{T}, ::Type{U}) where {T,U} = ConstantMap{T,U}(m.c)

ConstantMap() = ConstantMap{Float64}()
ConstantMap(c) = FixedConstantMap(c)
ConstantMap{T}() where {T} = UnityMap{T}()
ConstantMap{T}(c) where {T} = FixedConstantMap{T}(c)
ConstantMap{T,U}() where {T,U} = UnityMap{T,U}()
ConstantMap{T,U}(c) where {T,U} = FixedConstantMap{T,U}(c)

show(io::IO, m::ConstantMap{T}) where {T} = print(io, "x -> $(mapconstant(m))")
map_object_parentheses(m::ConstantMap) = true


"The zero map `f(x) = 0`."
struct ZeroMap{T,U} <: ConstantMap{T,U}
end
ZeroMap{T}() where {T} = ZeroMap{T,T}()
mapconstant(m::ZeroMap{T,U}) where {T,U} = zero(U)
similarmap(m::ZeroMap{S,U}, ::Type{T}) where {T,S,U} = ZeroMap{T,U}()
similarmap(m::ZeroMap, ::Type{T}, ::Type{U}) where {T,U} = ZeroMap{T,U}()


"The unity map `f(x) = 1`."
struct UnityMap{T,U} <: ConstantMap{T,U}
end
UnityMap{T}() where {T} = UnityMap{T,real(numtype(T))}()
mapconstant(m::UnityMap{T,U}) where {T,U} = one(U)
similarmap(m::UnityMap{S,U}, ::Type{T}) where {T,S,U} = UnityMap{T,U}()
similarmap(m::UnityMap, ::Type{T}, ::Type{U}) where {T,U} = UnityMap{T,U}()


"The constant map `f(x) = c`."
struct FixedConstantMap{T,U} <: ConstantMap{T,U}
    c   ::  U
end
FixedConstantMap{T}(c::U) where {T,U} = FixedConstantMap{T,U}(c)
FixedConstantMap(c::T) where {T} = FixedConstantMap{T}(c)
mapconstant(m::FixedConstantMap) = m.c

function test_balls()
    # Test UnitBall constructor
    @test UnitBall(2) isa VectorUnitBall{Float64}
    @test UnitBall(Val(2)) isa EuclideanUnitBall{2,Float64}
    @test UnitBall{Float64}() isa StaticUnitBall{Float64}
    @test UnitBall{Float64}(1) isa StaticUnitBall{Float64}
    @test_throws AssertionError UnitBall{Float64}(2)
    @test UnitBall{SVector{2,Float64}}(Val(2)) isa EuclideanUnitBall{2,Float64}
    @test_throws AssertionError UnitBall{SVector{2,Float64}}(Val(3))
    @test UnitBall{SVector{2,Float64}}(2) isa EuclideanUnitBall{2,Float64}
    @test_throws AssertionError UnitBall{SVector{2,Float64}}(3)
    @test UnitBall{SVector{2,Float64}}() isa EuclideanUnitBall{2,Float64}
    @test UnitBall{Vector{Float64}}(2) isa VectorUnitBall{Float64}
    @test_throws MethodError UnitBall{Vector{Float64}}()

    @test UnitBall{Float64,:open}() isa StaticUnitBall{Float64,:open}
    @test UnitBall{Float64,:closed}(1) isa StaticUnitBall{Float64,:closed}
    @test_throws AssertionError UnitBall{Float64,:closed}(2)
    @test UnitBall{SVector{2,Float64},:open}(Val(2)) isa EuclideanUnitBall{2,Float64,:open}
    @test_throws AssertionError UnitBall{SVector{2,Float64},:closed}(Val(3))
    @test UnitBall{SVector{2,Float64},:open}(2) isa EuclideanUnitBall{2,Float64,:open}
    @test_throws AssertionError UnitBall{SVector{2,Float64},:closed}(3)
    @test UnitBall{SVector{2,Float64},:open}() isa EuclideanUnitBall{2,Float64,:open}
    @test UnitBall{Vector{Float64},:closed}(2) isa VectorUnitBall{Float64,:closed}
    @test_throws MethodError UnitBall{Vector{Float64},:open}()

    @test DynamicUnitBall{Float64}(1) isa DynamicUnitBall{Float64}
    @test_throws AssertionError DynamicUnitBall{Float64}(2)

    # and then the Ball constructor
    @test Ball() isa UnitBall
    @test Ball(1.0, 2.0) isa DomainSets.GenericBall{Float64}
    @test Ball(1.0, Point(2.0)) isa DomainSets.GenericBall{Float64}
    @test Ball{Float64}() isa UnitBall{Float64}
    @test Ball{Float64,:open}() isa UnitBall{Float64,:open}
    @test Ball(1.0) == DomainSets.GenericBall{SVector{3,Float64},:closed}(1.0)
    @test hash(Ball(1.0)) == hash(DomainSets.GenericBall{SVector{3,Float64},:closed}(1.0))
    @test Ball{BigFloat}(1) == DomainSets.GenericBall{BigFloat,:closed}(big(1))
    @test hash(Ball{BigFloat}(1)) == hash(DomainSets.GenericBall{BigFloat,:closed}(big(1)))
    @test Ball{BigFloat,:open}(1) == DomainSets.GenericBall{BigFloat,:open}(big(1))
    @test hash(Ball{BigFloat,:open}(1)) == hash(DomainSets.GenericBall{BigFloat,:open}(big(1)))
    @test_throws MethodError Ball{Vector{Float64}}(1.0)
    @test Ball(1.0, [1,2,3]) isa DomainSets.GenericBall{Vector{Float64},:closed,Float64}
    @test Ball{Vector{Float64}}(1.0, [1,2,3]) isa DomainSets.GenericBall{Vector{Float64},:closed,Float64}
    @test Ball{Vector{Float64}}(1.0, Point([1,2,3])) isa DomainSets.GenericBall{Vector{Float64},:closed,Float64}

    # the Disk constructor
    @test typeof(Disk()) == EuclideanUnitBall{2,Float64,:closed}
    @test Disk(2) isa Ball{SVector{2,Float64}}
    @test Disk(2.0) isa Ball{SVector{2,Float64}}
    @test Disk(2, SA[0.0,1.0]) isa Ball{SVector{2,Float64}}

    @test map_domain(AffineMap(2, [1,2,3]), UnitBall()) isa DomainSets.GenericBall
    @test map_domain(AffineMap(2, 3), UnitBall{Float64}()) isa DomainSets.GenericBall
    @test map_domain(LinearMap{SVector{3,Float64}}(2), UnitBall()) isa DomainSets.GenericBall
    @test map_domain(LinearMap(2), UnitBall{Float64}()) isa DomainSets.GenericBall
    @test map_domain(LinearMap(2), UnitBall()) isa DomainSets.GenericBall
    @test map_domain(Translation([1,2,3]), UnitBall()) isa DomainSets.GenericBall
    @test map_domain(Translation(1), UnitBall{Float64}()) isa DomainSets.GenericBall

    @test StaticUnitBall() isa StaticUnitBall{Float64}
    @test StaticUnitBall(Val(2)) isa StaticUnitBall{SVector{2,Float64}}

    @test GenericBall() == GenericBall(1.0)
    @test hash(GenericBall()) == hash(GenericBall(1.0))
    @test GenericBall(2.0, 1:5) isa GenericBall{Vector{Float64},:closed,Float64}
    @test GenericBall(2, 1.0:5.0) isa GenericBall{Vector{Float64},:closed,Float64}

    # set difference with mixed vector types
    @test eltype(Disk(0.8)\Rectangle([-0.15,-1.0],[0.15,0.0])) == AbstractVector{Float64}

    @test issubset(Ball(1.0, 2.0), Ball(1.0, 2.0))
    @test issubset(Ball(1.0, 2.0), Ball(2.0, 2.0))
    @test !issubset(Ball(2.0, 2.0), Ball(1.0, 2.0))
    @test issubset(Ball{Float64,:open}(2.0, 2.0), Ball(2.0, 2.0))
    @test !issubset(Ball(2.0, 2.0), Ball{Float64,:open}(2.0, 2.0))
    @test issubset(Ball(1.0, 0.0), Ball(2.5, 1.0))
    @test !issubset(Ball(1.0, 0.0), Ball(0.5, 1.0))
    @test !issubset(UnitBall(Val(2)), UnitBall(Val(3)))

    D = UnitDisk()
    @test SA[1.,0.] ∈ D
    @test SA[1.,1.] ∉ D
    @test approx_in(SA[1.0,0.0+1e-5], D, 1e-4)
    @test !isempty(D)
    @test isclosedset(D)
    @test !isopenset(D)
    D2 = convert(Domain{SVector{2,BigFloat}}, D)
    @test eltype(D2) == SVector{2,BigFloat}
    @test boundary(D) == UnitCircle()
    @test dimension(D) == 2
    @test boundingbox(D) == ProductDomain(ChebyshevInterval(), ChebyshevInterval())
    @test normal(UnitDisk(), [sqrt(2)/2, sqrt(2)/2]) ≈ [sqrt(2)/2, sqrt(2)/2]

    @test boundingbox(UnitBall{Float64}()) == ChebyshevInterval()
    @test boundingbox(Ball(1.0, 1.0)) == 0.0..2.0 # issue #113
    @test boundingbox(Ball(1.0, SA[BigFloat(1), BigFloat(2)])) == Rectangle([0.0, 1.0], [2.0, 3.0]) # issue #114

    @test convert(SublevelSet, UnitDisk()) isa SublevelSet{SVector{2,Float64},:closed}
    @test convert(SublevelSet{SVector{2,Float64}}, UnitDisk()) isa SublevelSet{SVector{2,Float64},:closed}
    @test convert(SublevelSet, EuclideanUnitBall{2,Float64,:open}()) isa SublevelSet{SVector{2,Float64},:open}

    @test convert(Interval, UnitBall{Float64}()) === ChebyshevInterval()
    @test convert(Interval, UnitBall{Float64,:open}()) === OpenInterval(-1.0, 1.0)
    @test UnitBall{Float64}() == ChebyshevInterval()

    @test convert(Domain{SVector{2,Float64}}, UnitBall(2)) isa StaticUnitBall
    @test convert(Domain{Vector{Float64}}, UnitBall(Val(2))) isa DynamicUnitBall

    @test repr(UnitBall()) == "UnitBall()"
    @test repr(UnitBall(Val(4))) == "UnitBall(Val(4))"
    @test repr(EuclideanUnitBall{3,Float64,:open}()) == "UnitBall()  (open)"
    @test repr(EuclideanUnitBall{4,Float64,:open}()) == "UnitBall(Val(4))  (open)"
    @test repr(UnitDisk()) == "UnitDisk()"
    @test repr(UnitDisk{BigFloat}()) == "UnitDisk{BigFloat}()"
    @test repr(UnitBall{Float64}()) == "UnitBall{Float64}()"
    @test repr(UnitBall{Float64,:open}()) == "UnitBall{Float64}()  (open)"
    @test repr(VectorUnitBall{Float64}(4)) == "UnitBall(4)"
    @test repr(VectorUnitBall{Float64,:open}(4)) == "UnitBall(4)  (open)"
    @test repr(Ball(1.0,2.0)) == "Ball(1.0, 2.0)"

    D = EuclideanUnitBall{2,Float64,:open}()
    @test !in(SA[1.0,0.0], D)
    @test in(SA[1.0-eps(Float64),0.0], D)
    @test approx_in(SA[1.1,0.0], D, 0.2)
    @test !approx_in(SA[1.1,0.0], D, 0.01)
    @test SA[0.2,0.2] ∈ D
    @test !isclosedset(D)
    @test isopenset(D)
    @test boundary(D) == UnitCircle()

    D = 2UnitDisk()
    @test D isa DomainSets.GenericBall
    @test SA[1.4, 1.4] ∈ D
    @test SA[1.5, 1.5] ∉ D
    @test typeof(1.2 * D)==typeof(D * 1.2)
    @test SA[1.5,1.5] ∈ 1.2 * D
    @test SA[1.5,1.5] ∈ D * 1.2
    @test !isempty(D)

    @test canonicaldomain(D) == UnitDisk()
    @test affinematrix(mapfrom_canonical(D)) == [2 0; 0 2]
    @test affinevector(mapfrom_canonical(D)) == [0; 0]
    @test parameterdomain(D) == UnitSquare()
    @test parameterdomain(UnitBall(2)) == UnitSquare()
    @test parameterdomain(UnitBall(3)) == UnitBall(3)
    @test mapfrom_parameterdomain(D)([0.2,0.4]) ∈ D
    @test mapfrom_parameterdomain(UnitBall(2))([0.2,0.4]) ∈ UnitBall(2)
    @test boundingbox(D) == (-2.0..2.0)^2

    D = 2UnitDisk() .+ SA[1.0,1.0]
    @test D isa DomainSets.GenericBall
    @test boundary(D) isa DomainSets.GenericSphere
    @test SA[2.4, 2.4] ∈ D
    @test SA[3.5, 2.5] ∉ D
    @test !isempty(D)
    @test isopenset(interior(D))
    @test isclosedset(closure(D))
    @test canonicaldomain(D) isa UnitDisk

    B = UnitBall()
    @test SA[1.,0.0,0.] ∈ B
    @test SA[1.,0.1,0.] ∉ B
    @test !isempty(B)
    @test isclosedset(B)
    @test !isopenset(B)
    @test boundary(B) == UnitSphere()
    @test isopenset(interior(B))
    @test isclosedset(closure(B))

    B = 2UnitBall()
    @test D isa DomainSets.GenericBall
    @test SA[1.9,0.0,0.0] ∈ B
    @test SA[0,-1.9,0.0] ∈ B
    @test SA[0.0,0.0,-1.9] ∈ B
    @test SA[1.9,1.9,0.0] ∉ B
    @test !isempty(B)

    B = 2.0UnitBall() .+ SA[1.0,1.0,1.0]
    @test D isa DomainSets.GenericBall
    @test SA[2.9,1.0,1.0] ∈ B
    @test SA[1.0,-0.9,1.0] ∈ B
    @test SA[1.0,1.0,-0.9] ∈ B
    @test SA[2.9,2.9,1.0] ∉ B
    @test !isempty(B)

    C = VectorUnitBall(4)
    @test [1, 0, 0, 0] ∈ C
    @test [0.0,0.1,0.2,0.1] ∈ C
    @test SA[0.0,0.1,0.2,0.1] ∈ C
    @test_logs (:warn, "`in`: incompatible combination of vector with length 2 and domain 'UnitBall(4)' with dimension 4. Returning false.") [0.0,0.1] ∉ C
    @test [0.0,1.1,0.2,0.1] ∉ C
    @test !isempty(C)
    @test isclosedset(C)
    @test !isopenset(C)
    @test boundary(C) == VectorUnitSphere(4)
    cheb = ChebyshevInterval()
    @test boundingbox(C) == ProductDomain([cheb, cheb, cheb, cheb])
    @test dimension(C) == 4
    @test isopenset(interior(C))

    D = VectorUnitBall{Float64,:open}(4)
    @test !in([1, 0, 0, 0], D)
    @test in([1-eps(Float64), 0, 0, 0], D)
    @test approx_in([1.1, 0, 0, 0], D, 0.2)
    @test !approx_in([1.1, 0, 0, 0], D, 0.01)
    @test !isempty(D)
    @test approx_in(SA[1.01,0.0,0.0,0.0], D, 0.05)

    E = Ball{Float64,:open}(2.0)
    @test 0.5 ∈ E
    @test approx_in(0.5, E)
    @test approx_in(0.5, closure(E))
    @test isclosedset(StaticUnitBall{SVector{2,Float64}}())
    @test EuclideanUnitBall{2}() isa EuclideanUnitBall{2,Float64}

    show(io, EuclideanUnitBall{2,Float64,:open}())
    @test String(take!(io)) == "UnitBall(Val(2))  (open)"
    show(io, UnitCircle())
    @test String(take!(io)) == "UnitCircle()"
end

function test_spheres()
    # test UnitSphere constructor
    @test UnitSphere(2) isa VectorUnitSphere{Float64}
    @test UnitSphere(Val(2)) isa EuclideanUnitSphere{2,Float64}
    @test UnitSphere{Float64}() isa StaticUnitSphere{Float64}
    @test UnitSphere{Float64}(1) isa StaticUnitSphere{Float64}
    @test_throws AssertionError UnitSphere{Float64}(2)
    @test UnitSphere{SVector{2,Float64}}(Val(2)) isa EuclideanUnitSphere{2,Float64}
    @test_throws AssertionError UnitSphere{SVector{2,Float64}}(Val(3))
    @test UnitSphere{SVector{2,Float64}}(2) isa EuclideanUnitSphere{2,Float64}
    @test_throws AssertionError UnitSphere{SVector{2,Float64}}(3)
    @test UnitSphere{SVector{2,Float64}}() isa EuclideanUnitSphere{2,Float64}
    @test UnitSphere{Vector{Float64}}(2) isa VectorUnitSphere{Float64}
    @test_throws MethodError UnitSphere{Vector{Float64}}()

    @test DynamicUnitSphere{Float64}(1) isa DynamicUnitSphere{Float64}
    @test_throws AssertionError DynamicUnitSphere{Float64}(2)

    # and the generic sphere constructor
    @test Sphere() isa UnitSphere
    @test Sphere(1.0, 2.0) isa DomainSets.GenericSphere{Float64}
    @test Sphere(1.0, Point(2.0)) isa DomainSets.GenericSphere{Float64}
    @test Sphere{Float64}() isa UnitSphere{Float64}
    @test Sphere(1.0) == DomainSets.GenericSphere{SVector{3,Float64}}(1.0)
    @test hash(Sphere(1.0)) == hash(DomainSets.GenericSphere{SVector{3,Float64}}(1.0))
    @test Sphere{BigFloat}(1) == DomainSets.GenericSphere{BigFloat}(big(1))
    @test hash(Sphere{BigFloat}(1)) == hash(DomainSets.GenericSphere{BigFloat}(big(1)))
    @test_throws MethodError Sphere{Vector{Float64}}(1.0)
    @test Sphere(1.0, [1,2,3]) isa DomainSets.GenericSphere{Vector{Float64},Float64}
    @test Sphere{Vector{Float64}}(1.0, [1,2,3]) isa DomainSets.GenericSphere{Vector{Float64},Float64}
    @test Sphere{Vector{Float64}}(1.0, Point([1,2,3])) isa DomainSets.GenericSphere{Vector{Float64},Float64}

    @test map_domain(AffineMap(2, [1,2,3]), UnitSphere()) isa DomainSets.GenericSphere
    @test map_domain(AffineMap(2, 3), UnitSphere{Float64}()) isa DomainSets.GenericSphere
    @test map_domain(LinearMap{SVector{3,Float64}}(2), UnitSphere()) isa DomainSets.GenericSphere
    @test map_domain(LinearMap(2), UnitSphere{Float64}()) isa DomainSets.GenericSphere
    @test map_domain(LinearMap(2), UnitSphere()) isa DomainSets.GenericSphere
    @test map_domain(Translation([1,2,3]), UnitSphere()) isa DomainSets.GenericSphere
    @test map_domain(Translation(1), UnitSphere{Float64}()) isa DomainSets.GenericSphere

    @test StaticUnitSphere() isa StaticUnitSphere{Float64}
    @test StaticUnitSphere(Val(2)) isa StaticUnitSphere{SVector{2,Float64}}

    @test GenericSphere() == GenericSphere(1.0)
    @test hash(GenericSphere()) == hash(GenericSphere(1.0))
    @test GenericSphere(2.0, 1:5) isa GenericSphere{Vector{Float64},Float64}
    @test GenericSphere(2, 1.0:5.0) isa GenericSphere{Vector{Float64},Float64}

    @test repr(UnitSphere()) == "UnitSphere()"
    @test repr(UnitSphere(Val(4))) == "UnitSphere(Val(4))"
    @test repr(UnitCircle()) == "UnitCircle()"
    @test repr(UnitCircle{BigFloat}()) == "UnitCircle{BigFloat}()"
    @test repr(VectorUnitSphere{Float64}(4)) == "UnitSphere(4)"
    @test repr(UnitSphere{Float64}()) == "UnitSphere{Float64}()"
    @test repr(Sphere(1.0,2.0)) == "Sphere(1.0, 2.0)"

    @test DomainSets.UnitCircleMap() == DomainSets.UnitCircleMap{Float64}()
    @test DomainSets.AngleMap() == DomainSets.AngleMap{Float64}()

    C = UnitCircle()
    @test SA[1.,0.] ∈ C
    @test SA[1.,1.] ∉ C
    @test approx_in(SA[1.,0.], C)
    @test !approx_in(SA[1.,1.], C)
    @test !isempty(C)
    @test isclosedset(C)
    @test !isopenset(C)
    @test parameterdomain(C) == UnitInterval()
    @test parameterdomain(UnitSphere(2)) == UnitInterval()
    @test parameterdomain(UnitSphere(3)) == UnitSphere(3)
    @test hasparameterization(C)
    @test hasparameterization(UnitSphere(2))

    p = parameterization(C)
    @test mapsize(p) == (2,)
    x = applymap(p, 1/2)
    @test jacobian(p, 0.4) ≈ SA[-2pi*sin(2pi*0.4), 2pi*cos(2pi*0.4)]
    @test diffvolume(p, 0.4) ≈ 2*pi
    @test diffvolume(p)(0.4) ≈ 2*pi
    @test approx_in(x, C)
    q = leftinverse(p)
    @test applymap(q, x) ≈ 1/2
    @test applymap(q, x) ≈ leftinverse(p, x)
    @test applymap(q, -x) ≈ 1
    @test rightinverse(q) == p
    @test rightinverse(q)(0) ≈ rightinverse(q, 0)
    @test jacobian(q) isa DomainSets.LazyJacobian
    @test jacobian(q, x) isa LinearAlgebra.Transpose{Float64,SVector{2,Float64}}

    @test boundingbox(C) == ProductDomain(ChebyshevInterval(), ChebyshevInterval())
    @test boundingbox(UnitSphere{Float64}()) == ChebyshevInterval()

    @test convert(LevelSet, UnitCircle()) isa LevelSet{SVector{2,Float64}}
    @test convert(LevelSet{SVector{2,BigFloat}}, UnitCircle()) isa LevelSet{SVector{2,BigFloat}}
    @test pseudolevel(UnitCircle(), 0.1) isa SublevelSet
    @test SA[1.05,0] ∈ pseudolevel(UnitCircle(), 0.1)
    @test SA[1.15,0] ∉ pseudolevel(UnitCircle(), 0.1)

    C2 = convert(Domain{SVector{2,BigFloat}}, C)
    @test eltype(C2) == SVector{2,BigFloat}

    @test convert(Domain{SVector{2,Float64}}, UnitSphere(2)) isa StaticUnitSphere
    @test convert(Domain{Vector{Float64}}, UnitSphere(Val(2))) isa DynamicUnitSphere

    C = 2UnitCircle() .+ SA[1.,1.]
    @test C isa DomainSets.GenericSphere
    @test approx_in(SA[3.,1.], C)

    @test canonicaldomain(C) == UnitCircle()
    @test affinematrix(mapfrom_canonical(C)) == [2 0; 0 2]
    @test affinevector(mapfrom_canonical(C)) == [1; 1]
    @test parameterdomain(C) == UnitInterval()
    @test mapfrom_parameterdomain(C) isa ComposedMap
    @test mapfrom_parameterdomain(C)(0.5) ≈ [-1; 1]
    @test mapfrom_parameterdomain(C, 0.5) ≈ [-1; 1]
    @test mapto_parameterdomain(C)([-1; 1]) ≈ 0.5
    @test mapto_parameterdomain(C, [-1; 1]) ≈ 0.5
    @test boundingbox(C) == (-1.0..3.0)^2

    C = UnitCircle() .+ SA[1,1]
    @test C isa DomainSets.GenericSphere
    @test approx_in(SA[2,1], C)

    S = UnitSphere()
    @test SA[1.,0.,0.] ∈ S
    @test SA[1.,0.,1.] ∉ S
    @test approx_in(SA[cos(1.),sin(1.),0.], S)
    @test !isempty(S)
    S2 = convert(Domain{SVector{3,BigFloat}}, S)
    @test eltype(S2) == SVector{3,BigFloat}

    @test Basis3Vector() in S

    @test issubset(UnitSphere(), UnitBall())

    S = 2 * UnitSphere() .+ SA[1.,1.,1.]
    @test S isa DomainSets.GenericSphere
    @test approx_in(SA[1. + 2*cos(1.),1. + 2*sin(1.),1.], S)
    @test !approx_in(SA[4.,1.,5.], S)

    D = UnitCircle()
    @test convert(Domain{SVector{2,BigFloat}}, D) ≡ UnitCircle{BigFloat}()
    @test SVector(1,0) in D
    @test SVector(nextfloat(1.0),0) ∉ D

    D = UnitSphere()
    @test convert(Domain{SVector{3,BigFloat}}, D) ≡ UnitSphere{SVector{3,BigFloat}}()
    @test SVector(1,0,0) in D
    @test SVector(nextfloat(1.0),0,0) ∉ D

    D4 = UnitSphere(4)
    @test D4 isa DynamicUnitSphere
    @test D4 isa VectorUnitSphere
    @test dimension(D4) == 4
    cheb = ChebyshevInterval()
    @test boundingbox(D4) == ProductDomain([cheb, cheb, cheb, cheb])

    ## sphere points
    x_sphere = [0.1,0.2,sqrt(1-(0.1)^2-(0.2)^2)]
    p1 = DomainSets.EuclideanSpherePoint(x_sphere)
    @test domain(p1) == UnitSphere(3)
    @test DomainSets.point(p1) == x_sphere
    @test p1 ∈ UnitSphere(3)

    p2 = DomainSets.EuclideanSpherePoint(SVector{3}(x_sphere))
    @test domain(p2) === UnitSphere()
    @test DomainSets.point(p2) == x_sphere
    @test p2 ∈ UnitSphere(Val(3))

    p3 = DomainSets.SphericalCoordinate(0.4, 0.5)
    @test domain(p3) === UnitSphere()
    @test p3 ∈ UnitSphere()
    @test approx_in(DomainSets.point(p3), UnitSphere())
end

function test_rotation_map(T)
    ϕ = T(pi)/4
    m = rotation_map(ϕ)
    x = [one(T), zero(T)]
    y = m(x)
    @test y[1] ≈ sqrt(T(2))/2
    @test y[2] ≈ sqrt(T(2))/2

    ϕ = T(pi)/4
    m = rotation_map(ϕ, 0, 0)
    x = [zero(T), one(T), zero(T)]
    y = m(x)
    @test y[1] ≈ 0
    @test y[2] ≈ sqrt(T(2))/2
    @test y[3] ≈ sqrt(T(2))/2

    m = rotation_map(zero(T), ϕ, zero(T))
    x = [one(T), zero(T), zero(T)]
    y = m(x)
    @test y[1] ≈ sqrt(T(2))/2
    @test y[2] ≈ 0
    @test y[3] ≈ -sqrt(T(2))/2

    m = rotation_map(zero(T), zero(T), ϕ)
    x = [one(T), zero(T), zero(T)]
    y = m(x)
    @test y[1] ≈ sqrt(T(2))/2
    @test y[2] ≈ sqrt(T(2))/2
    @test y[3] ≈ 0

    theta = T(rand())
    phi = T(rand())
    psi = T(rand())
    m2 = rotation_map(theta)
    r = rand(T, mapsize(m2,2))
    @test norm(m2(r))≈norm(r)

    m3 = rotation_map(phi, theta, psi)
    r = rand(T, mapsize(m3,2))
    @test norm(m3(r))≈norm(r)
    @test islinearmap(m3)
end

function test_cart_polar_map(T)
    m1 = CartToPolarMap{T}()
    @test !islinearmap(m1)
    @test isrealmap(m1)

    m2 = PolarToCartMap{T}()
    @test !islinearmap(m2)
    @test isrealmap(m2)

    @test inverse(m1) == m2
    @test inverse(m2) == m1
end

function test_rand(T)
    r = Rectangle(T[-1, 2], T[3, 4])
    @test @inferred(Random.gentype(r)) == Vector{T}
    @test typeof(rand(r)) == Random.gentype(r)
    @test @inferred(rand(r)) in r

    r = Rectangle(SA[T(-1), T(2)], SA[T(3), T(4)])
    @test @inferred(Random.gentype(r)) == SVector{2, T}
    @test typeof(rand(r)) == Random.gentype(r)
    @test @inferred(rand(r)) in r

    hybrid_product = ProductDomain(["a", "b"], T(1.0)..T(2.0))
    @test @inferred(Random.gentype(hybrid_product)) == Tuple{String, T}
    @test typeof(rand(hybrid_product)) == Random.gentype(hybrid_product)
    @test @inferred(rand(hybrid_product)) in hybrid_product

    b = Ball(2.0, SA[T(1.0), T(2.0)])
    @test @inferred(Random.gentype(b)) == SVector{2, T}
    @test typeof(rand(b)) == Random.gentype(b)
    @test @inferred(rand(b)) in b
    @test all(p in b for p in rand(b, 100))
    test_rng_consistency(b)

    b = Ball(2.0, [T(1.0), T(2.0)])
    @test @inferred(Random.gentype(b)) == Vector{T}
    @test typeof(rand(b)) == Random.gentype(b)
    @test @inferred(rand(b)) in b
    @test all(p in b for p in rand(b, 100))
    test_rng_consistency(b)

    b = Ball(2.0, T(1.0))
    @test @inferred(Random.gentype(b)) == T
    @test typeof(rand(b)) == Random.gentype(b)
    @test @inferred(rand(b)) in b
    test_rng_consistency(b)

    # Higher dimension
    # Only works for Float64 since there is no randn(BigFloat)
    if T == Float64
        b = Ball(1.5, SA[1.0, -1.0, 2.0, -3.0])
        @test @inferred(Random.gentype(b)) == SVector{4, T}
        @test typeof(rand(b)) == Random.gentype(b)
        @test @inferred(rand(b)) in b
        @test all(p in b for p in rand(b, 100))
        test_rng_consistency(b)

        # Test numerical accuracy - two rectangles of the same size should have the same number of points
        rng = StableRNG(1)
        n = 1_000_000
        region_1 = Rectangle([0.0, -0.3, 0.0, -0.3], [0.3, 0.0, 0.3, 0.0]) .+ center(b)
        lower_corner = radius(b)*fill(-0.5, 4)
        region_2 = Rectangle(lower_corner, lower_corner.+0.3) .+ center(b)
        rs = rand(rng, b, n)
        n_1 = sum(r in region_1 for r in rs)
        n_2 = sum(r in region_2 for r in rs)
        @test isapprox(n_1, n_2, rtol=0.1)
    end
end

function test_rng_consistency(set)
    rng1 = Random.MersenneTwister(1)
    rng2 = Random.MersenneTwister(1)
    @test rand(rng1, set) == rand(rng2, set)
end

function test_coordinates()
    p1 = DomainSets.EuclideanSpherePoint(SA[1/sqrt(3),1/sqrt(3),1/sqrt(3)])
    @test p1 ∈ UnitSphere(Val(3))
    p2 = DomainSets.EuclideanSpherePoint([1/sqrt(3),1/sqrt(3),1/sqrt(3)])
    @test p2 ∈ UnitSphere(3)
    p3 = DomainSets.SphericalCoordinate(0.4, 0.5)
    @test p3 ∈ UnitSphere(Val(3))
    @test DomainSets.SphericalCoordinate(1, 0.5) isa DomainSets.SphericalCoordinate{Float64}
    @test DomainSets.SphericalCoordinate(1, 2) isa DomainSets.SphericalCoordinate{Float64}
end

function test_applications(T)
    test_rotation_map(T)
    test_cart_polar_map(T)
    test_rand(T)
    test_coordinates()
end

@testset "applications" begin
    test_applications(Float64)
    test_applications(BigFloat)

    # Test an additional composite map
    m1 = LinearMap(SMatrix{2,2}(1,2,3,4.0))
    m2 = CartToPolarMap()
    cmap = m1 ∘ m2 ∘ m1
    x = rand(2)
    @test cmap(x) == m1(m2(m1(x)))
end

"A `FunctionLevelSet` is a set that derives from the levels of a function."
abstract type FunctionLevelSet{T} <: Domain{T} end

# Convenience: assume the function and the level are stored fields
levelfun(d::FunctionLevelSet) = d.f
levelfun(d::FunctionLevelSet, x) = d.f(x)
level(d::FunctionLevelSet) = d.level


"Supertype of level set domains of the form `f(x)=C`."
abstract type AbstractLevelSet{T} <: FunctionLevelSet{T} end

indomain(x, d::AbstractLevelSet) = levelfun(d, x) == level(d)

show(io::IO, d::AbstractLevelSet) =
    print(io, "level set f(x) = $(level(d)) with f = $(levelfun(d))")

isequaldomain(d1::AbstractLevelSet, d2::AbstractLevelSet) =
    levelfun(d1)==levelfun(d2) && level(d1)==level(d2)
domainhash(d::AbstractLevelSet, h::UInt) =
    hashrec("AbstractLevelSet", levelfun(d), level(d), h)

"The domain defined by `f(x)=0` for a given function `f`."
struct ZeroSet{T,F} <: AbstractLevelSet{T}
    f   ::  F
end

ZeroSet(f) = ZeroSet{Float64}(f)
ZeroSet{T}(f::F) where {T,F} = ZeroSet{T,F}(f)

level(d::ZeroSet) = 0

similardomain(d::ZeroSet, ::Type{T}) where {T} = ZeroSet{T}(levelfun(d))


"The domain defined by `f(x)=C` for a given function `f` and constant `C`."
struct LevelSet{T,F,S} <: AbstractLevelSet{T}
    f       ::  F
    level   ::  S
end

LevelSet(f, level) = LevelSet{typeof(level)}(f, level)
LevelSet{T}(f::F, level::S) where {T,F,S} = LevelSet{T,F,S}(f, level)

similardomain(d::LevelSet, ::Type{T}) where {T} = LevelSet{T}(levelfun(d), level(d))

convert(::Type{LevelSet}, d::ZeroSet{T}) where {T} = LevelSet{T}(levelfun(d), level(d))
convert(::Type{LevelSet{T}}, d::ZeroSet) where {T} = LevelSet{T}(levelfun(d), level(d))


"Supertype of sublevel set domains."
abstract type AbstractSublevelSet{T,C} <: FunctionLevelSet{T} end

indomain(x, d::AbstractSublevelSet{T,:closed}) where {T} = levelfun(d, x) <= level(d)
indomain(x, d::AbstractSublevelSet{T,:open}) where {T} = levelfun(d, x) < level(d)

isclosedset(d::AbstractSublevelSet{T,:closed}) where {T} = true
isclosedset(d::AbstractSublevelSet{T,:open}) where {T} = false
isopenset(d::AbstractSublevelSet{T,:closed}) where {T} = false
isopenset(d::AbstractSublevelSet{T,:open}) where {T} = true

show(io::IO, d::AbstractSublevelSet{T,:closed}) where {T} =
    print(io, "sublevel set f(x) <= $(level(d)) with f = $(levelfun(d))")
show(io::IO, d::AbstractSublevelSet{T,:open}) where {T} =
    print(io, "sublevel set f(x) < $(level(d)) with f = $(levelfun(d))")

isequaldomain(d1::AbstractSublevelSet, d2::AbstractSublevelSet) =
    isclosedset(d1)==isclosedset(d2) && levelfun(d1)==levelfun(d2) &&
    level(d1)==level(d2)
domainhash(d::AbstractSublevelSet, h::UInt) =
    hashrec("AbstractSublevelSet", isclosedset(d), levelfun(d), level(d), h)

"The domain where `f(x) <= 0` (or `f(x) < 0`)."
struct SubzeroSet{T,C,F} <: AbstractSublevelSet{T,C}
    f   ::  F
end

SubzeroSet(f) = SubzeroSet{Float64}(f)
SubzeroSet{T}(f) where {T} = SubzeroSet{T,:closed}(f)
SubzeroSet{T,C}(f::F) where {T,C,F} = SubzeroSet{T,C,F}(f)

level(d::SubzeroSet) = 0

similardomain(d::SubzeroSet{S,C}, ::Type{T}) where {S,C,T} =
    SubzeroSet{T,C}(levelfun(d))

interior(d::SubzeroSet{T}) where {T} = SubzeroSet{T,:open}(d.f)
closure(d::SubzeroSet{T}) where {T} = SubzeroSet{T,:closed}(d.f)

boundary(d::SubzeroSet{T}) where {T} = ZeroSet{T}(d.f)

"The domain defined by `f(x) <= C` (or `f(x) < C`) for a given function `f` and constant `C`."
struct SublevelSet{T,C,F,S} <: AbstractSublevelSet{T,C}
    f       ::  F
    level   ::  S
end

SublevelSet(f, level) = SublevelSet{typeof(level)}(f, level)
SublevelSet{T}(f, level) where {T} = SublevelSet{T,:closed}(f, level)
SublevelSet{T,C}(f::F, level::S) where {T,C,F,S} = SublevelSet{T,C,F,S}(f, level)

similardomain(d::SublevelSet{S,C}, ::Type{T}) where {S,C,T} =
    SublevelSet{T,C}(levelfun(d), level(d))

interior(d::SublevelSet{T}) where {T} = SublevelSet{T,:open}(d.f, d.level)
closure(d::SublevelSet{T}) where {T} = SublevelSet{T,:closed}(d.f, d.level)

boundary(d::SublevelSet{T}) where {T} = LevelSet{T}(d.f, d.level)


"Supertype of superlevel set domains."
abstract type AbstractSuperlevelSet{T,C} <: FunctionLevelSet{T} end

indomain(x, d::AbstractSuperlevelSet{T,:closed}) where {T} = levelfun(d, x) >= level(d)
indomain(x, d::AbstractSuperlevelSet{T,:open}) where {T} = levelfun(d, x) > level(d)

isclosedset(d::AbstractSuperlevelSet{T,:closed}) where {T} = true
isclosedset(d::AbstractSuperlevelSet{T,:open}) where {T} = false
isopenset(d::AbstractSuperlevelSet{T,:closed}) where {T} = false
isopenset(d::AbstractSuperlevelSet{T,:open}) where {T} = true

show(io::IO, d::AbstractSuperlevelSet{T,:closed}) where {T} =
    print(io, "superlevel set f(x) >= $(level(d)) with f = $(levelfun(d))")
show(io::IO, d::AbstractSuperlevelSet{T,:open}) where {T} =
    print(io, "superlevel set f(x) > $(level(d)) with f = $(levelfun(d))")

isequaldomain(d1::AbstractSuperlevelSet, d2::AbstractSuperlevelSet) =
    isclosedset(d1)==isclosedset(d2) && levelfun(d1)==levelfun(d2) && level(d1)==level(d2)
domainhash(d::AbstractSuperlevelSet, h::UInt) =
    hashrec("AbstractSuperlevelSet", isclosedset(d), levelfun(d), level(d), h)


"The domain where `f(x) >= 0` (or `f(x) > 0`)."
struct SuperzeroSet{T,C,F} <: AbstractSuperlevelSet{T,C}
    f   ::  F
end

SuperzeroSet(f) = SuperzeroSet{Float64}(f)
SuperzeroSet{T}(f) where {T} = SuperzeroSet{T,:closed}(f)
SuperzeroSet{T,C}(f::F) where {T,C,F} = SuperzeroSet{T,C,F}(f)

level(d::SuperzeroSet) = 0

similardomain(d::SuperzeroSet{S,C}, ::Type{T}) where {S,C,T} =
    SuperzeroSet{T,C}(levelfun(d))

interior(d::SuperzeroSet{T}) where {T} = SuperzeroSet{T,:open}(d.f)
closure(d::SuperzeroSet{T}) where {T} = SuperzeroSet{T,:closed}(d.f)

boundary(d::SuperzeroSet{T}) where {T} = ZeroSet{T}(d.f)


"The domain defined by `f(x) >= C` (or `f(x) > C`) for a given function `f` and constant `C`."
struct SuperlevelSet{T,C,F,S} <: AbstractSuperlevelSet{T,C}
    f       ::  F
    level   ::  S
end

SuperlevelSet(f, level) = SuperlevelSet{typeof(level)}(f, level)
SuperlevelSet{T}(f, level) where {T} = SuperlevelSet{T,:closed}(f, level)
SuperlevelSet{T,C}(f::F, level::S) where {T,C,F,S} = SuperlevelSet{T,C,F,S}(f, level)

similardomain(d::SuperlevelSet{S,C}, ::Type{T}) where {S,C,T} =
    SuperlevelSet{T,C}(levelfun(d), level(d))

interior(d::SuperlevelSet{T}) where {T} = SuperlevelSet{T,:open}(d.f, d.level)
closure(d::SuperlevelSet{T}) where {T} = SuperlevelSet{T,:closed}(d.f, d.level)

boundary(d::SuperlevelSet{T}) where {T} = LevelSet{T}(d.f, d.level)

## Additional functionality

pseudolevel(d::AbstractLevelSet, epsilon) =
    _pseudolevel(d, epsilon, levelfun(d), level(d))
_pseudolevel(d::AbstractLevelSet{T}, epsilon, fun, C) where {T} =
    SublevelSet{T,:open}(x -> norm(fun(x)-C), epsilon)

pseudolevel(d::Domain, epsilon) = pseudolevel(convert(LevelSet, d), epsilon)

using Aqua

# Aqua.test_all(DomainSets)

# A few ambiguities remain in deprecated function calls. Tests to be activated
# in next breaking release when those deprecations are removed:
# Aqua.test_ambiguities(DomainSets)

# The unbound tests annoyingly flag several valid uses of NTuple{N,T}
# Aqua.test_unbound_args(DomainSets)

Aqua.test_undefined_exports(DomainSets)
Aqua.test_project_extras(DomainSets)
Aqua.test_stale_deps(DomainSets)
Aqua.test_deps_compat(DomainSets)
# Most remaining piracies have to do with Domain being defined elsewhere
# Aqua.test_piracies(DomainSets)
Aqua.test_persistent_tasks(DomainSets)

"""
Supertype of domains that are defined by an indicator function.

An indicator function is a function `f : S -> [0,1]` that indicates membership
of `x` to a domain `D` with `D ⊂ S`. The indicator function corresponds exactly
to the `in` function of a domain: `f(x) = x ∈ D`.

Concrete subtypes of `AbstractIndicatorFunction` store a representation of this
indicator function and implement `in` using that representation, rather than
implementing `in` directly.
"""
abstract type AbstractIndicatorFunction{T} <: Domain{T} end

"The indicator function of a domain is the function `f(x) = x ∈ D`."
indicatorfunction(d) = x -> x ∈ d

indomain(x, d::AbstractIndicatorFunction) = _indomain(x, d, indicatorfunction(d))
_indomain(x, d::AbstractIndicatorFunction, f) = f(x)

show(io::IO, d::AbstractIndicatorFunction) =
    print(io, "indicator domain defined by function f = $(indicatorfunction(d))")


"An `IndicatorFunction` is a domain that implements `f(x) = x ∈ D` by storing `f`."
struct IndicatorFunction{T,F} <: AbstractIndicatorFunction{T}
    f       ::  F
end

IndicatorFunction(f) = IndicatorFunction{Float64}(f)
IndicatorFunction{T}(f::F) where {T,F} = IndicatorFunction{T,F}(f)

indicatorfunction(d::IndicatorFunction) = d.f

similardomain(d::IndicatorFunction, ::Type{T}) where {T} = IndicatorFunction{T}(d.f)

convert(::Type{IndicatorFunction}, d::AbstractIndicatorFunction) = d
convert(::Type{IndicatorFunction}, d) =
    IndicatorFunction{domaineltype(d)}(indicatorfunction(checkdomain(d)))

isequaldomain(d1::IndicatorFunction, d2::IndicatorFunction) =
    indicatorfunction(d1)==indicatorfunction(d2)
domainhash(d1::IndicatorFunction, h::UInt) = hashrec("IndicatorFunction", indicatorfunction(d1), h)

intersectdomain1(d1::IndicatorFunction, d2) = BoundedIndicatorFunction(d1.f, d2)
intersectdomain2(d1, d2::IndicatorFunction) = BoundedIndicatorFunction(d2.f, d1)

"An indicator function with a known bounding domain."
struct BoundedIndicatorFunction{T,F,D} <: AbstractIndicatorFunction{T}
    f       ::  F
    domain  ::  D
end

BoundedIndicatorFunction(f, domain) =
    BoundedIndicatorFunction{domaineltype(domain)}(f, domain)
BoundedIndicatorFunction{T}(f, domain::Domain{T}) where {T} =
    BoundedIndicatorFunction{T,typeof(f),typeof(domain)}(f, domain)
BoundedIndicatorFunction{T}(f, domain) where {T} =
    _BoundedIndicatorFunction(T, f, checkdomain(domain))
_BoundedIndicatorFunction(::Type{T}, f, domain) where {T} =
    BoundedIndicatorFunction{T,typeof(f),typeof(domain)}(f, domain)

indicatorfunction(d::BoundedIndicatorFunction) = d.f

boundingdomain(d::BoundedIndicatorFunction) = d.domain

indomain(x, d::BoundedIndicatorFunction) = in(x, boundingdomain(d)) && d.f(x)

isequaldomain(d1::BoundedIndicatorFunction, d2::BoundedIndicatorFunction) =
    indicatorfunction(d1)==indicatorfunction(d2) && boundingdomain(d1)==boundingdomain(d2)
domainhash(d::BoundedIndicatorFunction, h::UInt) =
    hashrec("BoundedIndicatorFunction", indicatorfunction(d), boundingdomain(d), h)

similardomain(d::BoundedIndicatorFunction, ::Type{T}) where {T} =
    BoundedIndicatorFunction(d.f, convert_eltype(T, d.domain))

boundingbox(d::BoundedIndicatorFunction) = boundingbox(boundingdomain(d))

function show(io::IO, d::BoundedIndicatorFunction)
    print(io, "indicator function bounded by: ")
    show(io, boundingdomain(d))
end

"""
    ComplexUnitCircle()
    ComplexUnitCircle{T}()

The unit circle in the complex plane.

See also: [`ComplexUnitDisk`](@ref).
"""
const ComplexUnitCircle{T} = StaticUnitSphere{Complex{T}}

"""
    ComplexUnitDisk()
    ComplexUnitDisk{T}()
    ComplexUnitDisk{T,C}()

The unit disk in the complex plane. The disk is open when `C=:open` and closed
when `C=:closed`.

See also: [`ComplexUnitCircle`](@ref).
"""
const ComplexUnitDisk{T,C} = StaticUnitBall{Complex{T},C}

ComplexUnitCircle() = ComplexUnitCircle{Float64}()
ComplexUnitDisk() = ComplexUnitDisk{Float64}()
ComplexUnitDisk{T}() where {T} = ComplexUnitDisk{T,:closed}()

show(io::IO, d::ComplexUnitCircle{Float64}) = print(io, "ComplexUnitCircle()")
show(io::IO, d::ComplexUnitDisk{Float64,:closed}) = print(io, "ComplexUnitDisk()")
show(io::IO, d::ComplexUnitDisk{Float64,:open}) = print(io, "ComplexUnitDisk()  (open)")
show(io::IO, d::ComplexUnitDisk{T,:closed}) where {T} = print(io, "ComplexUnitDisk{$(T)}()")
show(io::IO, d::ComplexUnitDisk{T,:open}) where {T} = print(io, "ComplexUnitDisk{$(T)}()  (open)")

canonicaldomain(::Parameterization, d::ComplexUnitCircle{T}) where {T} =
    UnitInterval{T}()
mapfrom_canonical(::Parameterization, d::ComplexUnitCircle{T}) where {T} =
    VectorToComplex{T}() ∘ UnitCircleMap{T}()

canonicaldomain(::Isomorphic, d::ComplexUnitCircle{T}) where {T} = UnitCircle{T}()
mapfrom_canonical(::Isomorphic, d::ComplexUnitCircle{T}) where {T} = VectorToComplex{T}()

canonicaldomain(::Parameterization, d::ComplexUnitDisk{T}) where {T} = UnitSquare{T}()
mapfrom_canonical(::Parameterization, d::ComplexUnitDisk{T}) where {T} =
    VectorToComplex{T}() ∘ UnitDiskMap{T}()

canonicaldomain(::Isomorphic, d::ComplexUnitDisk{T}) where {T} = UnitCircle{T}()
mapfrom_canonical(::Isomorphic, d::ComplexUnitDisk{T}) where {T} = VectorToComplex{T}()

module DomainSetsRandomExt

using DomainSets
using Random

using LinearAlgebra, StaticArrays

import Random:
    gentype,
    rand

gentype(::Type{<:Domain{T}}) where T = T

rand(rng::Random.AbstractRNG, s::Random.SamplerTrivial{<:ProductDomain}) =
    DomainSets.toexternalpoint(s[], map(i->(rand(rng, i)), factors(s[])))

rand(rng::Random.AbstractRNG, s::Random.SamplerTrivial{<:DomainSets.SimpleLazyDomain}) =
    DomainSets.toexternalpoint(s[], rand(rng, superdomain(s[])))

function rand(rng::Random.AbstractRNG, s::Random.SamplerTrivial{<:Ball})
    # Technical details: http://extremelearning.com.au/how-to-generate-uniformly-random-points-on-n-spheres-and-n-balls/

    b = s[]

    # for low-dimensional balls, use rejection sampling - acceptance rate is at least 52%
    if dimension(b) <= 3
        bb = boundingbox(b)
        while true
            r = rand(rng, bb)
            if r in b
                return r
            end
        end
    # for higher dimensional balls, use the "Mueller" method
    else
        u = randn_dimension(rng, eltype(b), dimension(b))
        r = radius(b)*rand(rng)^(1/dimension(b))
        return (r/norm(u))*u + center(b)
    end
end

randn_dimension(rng::Random.AbstractRNG, t::Type{<:StaticVector}, d) = randn(rng, t)
randn_dimension(rng::Random.AbstractRNG, t::Type{<:Vector}, d) = randn(rng, eltype(t), d)

# Implementation notes
# ====================
#
# The methods implemented above are the easy ones
# Unions and intersections could be implemented with rejection sampling, but it might be inefficient
# Sphere will require some decisions because `rand(sphere) in sphere` will usually only be approximately satisfied
# Maps may be difficult because the map could distort the distribution so that it is not uniform.

end # module

# The trivial domains include the empty space and the full space.

"The empty space."
struct EmptySpace{T} <: Domain{T}
end

EmptySet = EmptySpace

const AnyEmptySpace = EmptySpace{Any}

EmptySpace() = EmptySpace{Float64}()
EmptySpace(::Type{T}) where {T} = EmptySpace{T}()

similardomain(::EmptySpace, ::Type{T}) where {T} = EmptySpace{T}()

"Return the empty space with the same element type as the given domain."
emptyspace(d) = emptyspace(domaineltype(d))
emptyspace(::Type{T}) where {T} = EmptySpace{T}()

indomain(x::T, d::EmptySpace{T}) where {T} = false
approx_indomain(x, d::EmptySpace, tolerance) = in(x, d)

show(io::IO, d::EmptySpace) = print(io, "{} (empty domain)")

isempty(d::EmptySpace) = true

isopenset(d::EmptySpace) = true
isclosedset(d::EmptySpace) = true

boundary(d::EmptySpace) = d
interior(d::EmptySpace) = d
closure(d::EmptySpace) = d
boundingbox(d::EmptySpace) = d

distance_to(d::EmptySpace, x) = convert(prectype(d), Inf)

# Arithmetic operations

issubset1(d1::EmptySpace, d2) = true
issubset2(d1, d2::EmptySpace) = isempty(d1)

# setdiffdomain2(d1, d2::EmptySpace) = d2

map_domain(map::Map{T}, d::EmptySpace{T}) where {T} = d
mapped_domain(map::Map, d::EmptySpace) = EmptySpace{codomaintype(map)}()

isequaldomain(d1::EmptySpace, d2::EmptySpace) = true
isequaldomain1(d1::EmptySpace, d2) = isempty(d2)
isequaldomain2(d1, d2::EmptySpace) = isempty(d1)
domainhash(d::EmptySpace, h::UInt) = hash("EmptySpace", h)

mapto1(d1::EmptySpace{T}, d2) where {T} =
    isempty(d2) ? StaticIdentityMap{T}() : throw(ArgumentError("Can't map empty to non-empty domain"))
mapto2(d1, d2::EmptySpace{T}) where {T} =
    isempty(d1) ? StaticIdentityMap{T}() : throw(ArgumentError("Can't map non-empty to empty domain"))


"""
A domain that represents the full space.

The element type `T` in `FullSpace{T}` should only be seen as an indication of
the expected types of the elements in the context where the domain is intended
to be used. Due to the default, loose interpretation of `T`, any `FullSpace{T}`
actually contains any `x` regardless of the type of `x`. For a strict domain
of all elements of type `T`, or elements convertible exactly to `T`, use
`TypeDomain{T}`.
"""
struct FullSpace{T} <: Domain{T} end

const AnyFullSpace = FullSpace{Any}

FullSpace() = FullSpace{Float64}()
FullSpace(d) = FullSpace{domaineltype(d)}()

"Return the full space with the same element type as the given domain."
fullspace(d) = fullspace(domaineltype(d))
fullspace(::Type{T}) where {T} = FullSpace{T}()

isfullspace(d::FullSpace) = true
isfullspace(d::Domain) = false
isfullspace(d) = _isfullspace(d, DomainStyle(d))
_isfullspace(d, ::IsDomain) = false
_isfullspace(d, ::NotDomain) = error("isfullspace invoked on non-domain type")

similardomain(::FullSpace, ::Type{T}) where {T} = FullSpace{T}()

euclideanspace(n::Val{N}) where {N} = euclideanspace(n, Float64)
euclideanspace(::Val{N}, ::Type{T}) where {N,T} = FullSpace{SVector{N,T}}()

indomain(x::T, d::FullSpace{T}) where {T} = true
approx_indomain(x, d::FullSpace, tolerance) = in(x, d)

show(io::IO, d::FullSpace) = print(io, "{x} (full space)")

# We choose the origin as a point in the full space
choice(d::FullSpace) = zero(eltype(d))

isempty(::FullSpace) = false

isopenset(d::FullSpace) = true
isclosedset(d::FullSpace) = true

boundary(d::FullSpace{T}) where {T} = EmptySpace{T}()
interior(d::FullSpace) = d
closure(d::FullSpace) = d

distance_to(d::FullSpace, x) = zero(prectype(d))

# Arithmetic operations

issubset1(d1::FullSpace, d2) = isfullspace(d2)
issubset2(d1, d2::FullSpace) = true

map_domain(m::AbstractAffineMap{T}, d::FullSpace{T}) where {T} = d

isequaldomain(d1::FullSpace, d2::FullSpace) = true
isequaldomain1(d1::FullSpace, d2) = isfullspace(d2)
isequaldomain2(d1, d2::FullSpace) = isfullspace(d1)
domainhash(d::FullSpace, h::UInt) = hash("FullSpace", h)


convert(::Type{Domain}, ::Type{T}) where T = FullSpace{T}()
convert(::Type{Domain{S}}, ::Type{T}) where {T,S} = convert(Domain{S}, convert(Domain, T))

infimum(d::FullSpace{T}) where {T} = typemin(T)
supremum(d::FullSpace{T}) where {T} = typemax(T)



"""
The domain of all objects of type `T` and all objects convertible exactly to
type `T`.
"""
struct TypeDomain{T} <: Domain{T} end

"Return the domain for the element type of the given domain."
typedomain(d) = typedomain(domaineltype(d))
typedomain(::Type{T}) where {T} = TypeDomain{T}()

iscompatiblepair(x::T, d::TypeDomain{T}) where {T} = true
iscompatiblepair(x::T, d::TypeDomain{Any}) where {T} = true
function iscompatiblepair(x::S, d::TypeDomain{T}) where {S,T}
    # There is no generic function to check whether x can be converted to T.
    # A try-catch is not optimal, but it is a failsafe backup.
    # We can at least efficiently check promotion: if x can be converted to
    # T, then S and T must have a joined supertype.
    # For specific T and S, it would be better to specialize this function.
    promote_type(S,T) != Any &&
        try
            convert(T, x) == x
        catch
            false
        end
end

# Suppress the warning about incompatibility because it is not likely to be
# relevant for this domain
compatible_or_false(x, domain::TypeDomain) = iscompatiblepair(x, domain)

indomain(x::T, d::TypeDomain{T}) where {T} = true
approx_indomain(x, d::TypeDomain, tolerance) = in(x, d)

isequaldomain(d1::TypeDomain{S}, d2::TypeDomain{T}) where {S,T} = S==T


# some special cases
iscompatiblepair(x::Irrational, d::TypeDomain{<:Real}) = true

using DomainSets:
    isrealtype,
    convert_eltype,
    domaineltype,
    domain_numtype,
    domain_prectype

function test_components()
    @test components([1,2,3]) == ()
    d = UnionDomain(Point(1),Point(2))
    @test iscomposite(d)
    @test ncomponents(d) == length(components(d))
end

function test_eltype()
    @test convert_eltype(Float64, Point(0)) isa Point{Float64}
    @test convert_eltype(Float64, Point(0)) == Point(0)
    @test convert_eltype(Float64, [1,2]) isa Vector{Float64}
    @test convert_eltype(Float64, [1,2]) == [1,2]
    @test convert_eltype(Float64, Set([1,2])) isa Set{Float64}
    @test convert_eltype(Float64, Set([1,2])) == Set([1,2])
    @test convert_eltype(Float64, 1:5) isa AbstractVector{Float64}
    @test convert_eltype(Float64, 1:5) == 1:5
    @test convert_eltype(Float64, 1) isa Float64
    @test convert_eltype(Float64, 1) == 1
end

@testset "common functionality" begin
    @testset "elements" begin
        test_components()
    end
    @testset "eltype" begin
        test_eltype()
    end
end

function test_product_map(T)
    ma = StaticIdentityMap{T}()
    mb = interval_map(T(0), T(1), T(2), T(3))

    r1 = suitable_point_to_map(ma)
    r2 = suitable_point_to_map(ma)
    r3 = suitable_point_to_map(ma)
    r4 = suitable_point_to_map(ma)
    r5 = suitable_point_to_map(ma)

    m1 = productmap(ma,mb)
    test_generic_map(m1)
    @test m1(SVector(r1,r2)) ≈ SVector(ma(r1),mb(r2))
    m2 = productmap(m1,mb)
    test_generic_map(m2)
    @test m2(SVector(r1,r2,r3)) ≈ SVector(ma(r1),mb(r2),mb(r3))
    m3 = productmap(mb,m2)
    test_generic_map(m3)
    @test m3(SVector(r1,r2,r3,r4)) ≈ SVector(mb(r1),ma(r2),mb(r3),mb(r4))
    m4 = productmap(m1,m2)
    test_generic_map(m4)
    @test m4(SVector(r1,r2,r3,r4,r5)) ≈ SVector(m1(SVector(r1,r2))...,m2(SVector(r3,r4,r5))...)

    @test ProductMap(ma, mb) == ProductMap([ma,mb])
    @test hash(ProductMap(ma, mb)) == hash(ProductMap([ma,mb]))

    m5 = productmap(AffineMap(SMatrix{2,2,T}(1.0,2,3,4), SVector{2,T}(1,3)), LinearMap{T}(2.0))
    @test domaintype(component(m5,1)) == SVector{2,T}
    @test domaintype(component(m5,2)) == T
    test_generic_map(m5)
    x = SVector{3,T}(rand(T,3))
    @test m5(x) ≈ SVector(component(m5,1)(SVector(x[1],x[2]))...,component(m5,2)(x[3]))

    m6 = ProductMap([ma,mb])
    @test m6 isa VectorProductMap
    @test mapsize(m6) == (2,2)
    @test convert(Map{SVector{2,T}}, m6) isa VcatMap
    test_generic_map(m6)

    @test components(productmap(LinearMap(1), LinearMap(one(T)))) isa Tuple{<:Map{T},<:Map{T}}

    # test a non-rectangular product map
    m_rect = AffineMap(SA[one(T) 2; 3 4; 5 6], SA[one(T),one(T),zero(T)])
    pm = productmap(m_rect, m_rect)
    @test pm isa VcatMap{T,6,4,(3,3),(2,2)}
    @test jacobian(pm, SA[one(T),0,0,0]) isa SMatrix{6,4,T}
    @test diffvolume(pm, SA[one(T),0,0,0]) == 24
end

"""
    canonicalmap([ctype::CanonicalType, ]map)

Return an associated canonical map, if any, of the given map.

Optionally, a canonical type argument may specify an alternative canonical map.
Canonical maps help with converting between equal maps of different types.
"""
canonicalmap(m) = m

"Does the map have a canonical map?"
hascanonicalmap(m) = !(m === canonicalmap(m))


"Supertype of different kinds of canonical objects."
abstract type CanonicalType end

canonicalmap(ctype::CanonicalType, m) = m
hascanonicalmap(ctype::CanonicalType, m) = !(m === canonicalmap(ctype, m))


"""
    Equal <: CanonicalType

A canonical object that is equal but simpler.
"""
struct Equal <: CanonicalType end

canonicalmap(::Equal, m) = m
equalmap(m) = canonicalmap(Equal(), m)
hasequalmap(m) = hascanonicalmap(Equal(), m)

"""
    simplify(m)

Simplify the given map to an equal map.
"""
simplify(m) = equalmap(m)
"""
    simplifies(m)

Does the map simplify?
"""
simplifies(m) = hasequalmap(m)

"Convert the given map to a map defined in FunctionMaps.jl."
tofunctionmap(m::Map) = m
tofunctionmap(m::MapRef) = tofunctionmap(functionmap(m))


"""
    Equivalent <: CanonicalType

A canonical object that is equivalent but may have different type.
"""
struct Equivalent <: CanonicalType end

canonicalmap(::Equivalent, m) = canonicalmap(Equal(), m)

canonicalmap(::Equivalent, m::Map{<:StaticVector{1,T}}) where {T} = convert(Map{T}, m)
canonicalmap(::Equivalent, m::Map{NTuple{N,T}}) where {N,T} = convert(Map{SVector{N,T}}, m)

equivalentmap(m) = canonicalmap(Equivalent(), m)
hasequivalentmap(m) = hascanonicalmap(Equivalent(), m)

"""
    CanonicalExtensionType <: CanonicalType

Canonical types used to translate between packages.
"""
abstract type CanonicalExtensionType <: CanonicalType
end

"Return the extension type associated with the given object."
canonicalextensiontype(m) = canonicalextensiontype(typeof(m))


==(m1::Map, m2::Map) = isequalmap(m1, m2)   # Method from Base

"""
    isequalmap(map1, map2)

Are the two given maps equal?
"""
isequalmap(m1, m2) = isequalmap1(m1, m2)
isequalmap1(m1, m2) = simplifies(m1) ? isequalmap(simplify(m1), m2) : isequalmap2(m1, m2)
isequalmap2(m1, m2) = simplifies(m2) ? isequalmap(m1, simplify(m2)) : default_isequalmap(m1, m2)
default_isequalmap(m1, m2) = m1===m2

# Associated with == we have to define the hashes of maps
Base.hash(m::Map, h::UInt) = map_hash(m, h)

map_hash(m) = map_hash(m, zero(UInt))
map_hash(m, h::UInt) = invoke(hash, Tuple{Any,UInt}, m, h)

module FunctionMaps

using CompositeTypes, CompositeTypes.Display, CompositeTypes.Indexing
using LinearAlgebra
using StaticArrays

import Base:
    convert, show,
    ==, hash,       # for the equality of maps
    ∘,              # used to compose maps
    isreal          # to check whether maps are real

import CompositeTypes: component, components

# Exhaustive list of exports:

# from util/common.jl
export prectype, numtype

# from generic/map.jl
export Map, MapRef,
    applymap, isequalmap,
    domaintype, codomaintype,
    inverse, leftinverse, rightinverse,
    mapsize, jacobian, jacdet, diffvolume,
    isreal
# from generic/canonical.jl
export canonicalmap
# from generic/composite.jl
export composedmap
# from generic/product.jl
export productmap

# from types/basic.jl
export IdentityMap,
    StaticIdentityMap, VectorIdentityMap,
    ZeroMap, UnityMap, ConstantMap,
    isconstantmap, mapconstant
# from types/affine.jl
export AffineMap, Translation, LinearMap,
    affinematrix, affinevector,
    islinearmap, isaffinemap

include("util/common.jl")

include("generic/map.jl")
include("generic/interface.jl")
include("generic/canonical.jl")
include("generic/lazy.jl")
include("generic/inverse.jl")
include("generic/jacobian.jl")
include("generic/composite.jl")
include("generic/product.jl")
include("generic/isomorphism.jl")
include("types/basic.jl")
include("types/affine.jl")
include("types/coordinates.jl")
include("types/arithmetics.jl")

include("deprecated.jl")

end

"""
A product map is diagonal and acts on each of the components of x separately:
`y = f(x)` becomes `y_i = f_i(x_i)`.
"""
abstract type ProductMap{T} <: CompositeLazyMap{T} end

components(m::ProductMap) = m.maps
factors(d::ProductMap) = components(d)

VcatMapElement = Union{Map{<:StaticVector},Map{<:Number}}

ProductMap(maps::Tuple) = ProductMap(maps...)
ProductMap(maps::StaticVector) = ProductMap(maps...)
ProductMap(maps...) = TupleProductMap(maps...)
ProductMap(maps::VcatMapElement...) = VcatMap(maps...)
ProductMap(maps::AbstractVector) = VectorProductMap(maps)

ProductMap{T}(maps...) where {T} = _TypedProductMap(T, maps...)
_TypedProductMap(::Type{T}, maps...) where {T<:Tuple} = TupleProductMap(maps...)
_TypedProductMap(::Type{SVector{N,T}}, maps...) where {N,T} = VcatMap{T}(maps...)
_TypedProductMap(::Type{T}, maps...) where {T<:AbstractVector} = VectorProductMap{T}(maps...)

compatibleproductdims(d1::ProductMap, d2::ProductMap) =
	mapsize(d1) == mapsize(d2) &&
		all(map(==, map(mapsize, components(d1)), map(mapsize, components(d2))))

isconstantmap(m::ProductMap) = mapreduce(isconstantmap, &, components(m))
islinearmap(m::ProductMap) = mapreduce(islinearmap, &, components(m))
isaffinemap(m::ProductMap) = mapreduce(isaffinemap, &, components(m))

affinematrix(m::ProductMap) = toexternalmatrix(m, map(affinematrix, components(m)))
affinevector(m::ProductMap) = toexternalpoint(m, map(affinevector, components(m)))
mapconstant(m::ProductMap) = toexternalpoint(m, map(mapconstant, components(m)))

jacobian(m::ProductMap, x) =
	toexternalmatrix(m, map(jacobian, components(m), tointernalpoint(m, x)))
function jacobian(m::ProductMap{T}) where {T}
	if isaffinemap(m)
		ConstantMap{T}(affinematrix(m))
	else
		LazyJacobian(m)
	end
end

# diffvolume(m::ProductMap) = multiply_map(map(diffvolume, factors(m))...)

similarmap(m::ProductMap, ::Type{T}) where {T} = ProductMap{T}(components(m))

tointernalpoint(m::ProductMap, x) = x
toexternalpoint(m::ProductMap, y) = y

applymap(m::ProductMap, x) =
	toexternalpoint(m, map(applymap, components(m), tointernalpoint(m, x)))

productmap(m1, m2) = productmap1(m1, m2)
productmap1(m1, m2) = productmap2(m1, m2)
productmap2(m1, m2) = default_productmap(m1, m2)
default_productmap(m1, m2) = ProductMap(m1, m2)

productmap(m1::ProductMap, m2::ProductMap) =
	ProductMap(components(m1)..., components(m2)...)
productmap1(m1::ProductMap, m2) = ProductMap(components(m1)..., m2)
productmap2(m1, m2::ProductMap) = ProductMap(m1, components(m2)...)

for op in (:inverse, :leftinverse, :rightinverse)
    @eval $op(m::ProductMap) = ProductMap(map($op, components(m)))
	@eval $op(m::ProductMap, x) = toexternalpoint(m, map($op, components(m), tointernalpoint(m, x)))
end

function composedmap(m1::ProductMap, m2::ProductMap)
	if compatibleproductdims(m1, m2)
		ProductMap(map(composedmap, components(m1), components(m2)))
	else
		ComposedMap(m1,m2)
	end
end

mapsize(m::ProductMap) = (sum(t->mapsize(t,1), components(m)), sum(t->mapsize(t,2), components(m)))

isequalmap(m1::ProductMap, m2::ProductMap) = all(map(isequalmap, components(m1), components(m2)))
map_hash(m::ProductMap, h::UInt) = hashrec("ProductMap", collect(components(m)), h)

canonicalmap(m::ProductMap) = any(map(hascanonicalmap, factors(m))) ?
	ProductMap(map(canonicalmap, factors(m))) : m
canonicalmap(::Equal, m::ProductMap) = any(map(hasequalmap, factors(m))) ?
	ProductMap(map(equalmap, factors(m))) : m
canonicalmap(::Equivalent, m::ProductMap) = any(map(hasequivalentmap, factors(m))) ?
	ProductMap(map(equivalentmap, factors(m))) : m

Display.combinationsymbol(m::ProductMap) = Display.Symbol('⊗')
Display.displaystencil(m::ProductMap) = composite_displaystencil(m)
map_object_parentheses(m::ProductMap) = true
map_stencil_parentheses(m::ProductMap) = true
show(io::IO, mime::MIME"text/plain", m::ProductMap) = composite_show(io, mime, m)
show(io::IO, m::ProductMap) = composite_show_compact(io, m)

"""
A `VcatMap` is a product map with domain and codomain vectors
concatenated (`vcat`) into a single vector.
"""
struct VcatMap{T,M,N,DIM1,DIM2,MAPS} <: ProductMap{SVector{N,T}}
    maps    ::  MAPS
end

VcatMap(maps::Union{Tuple,Vector}) = VcatMap(maps...)
VcatMap(maps...) = VcatMap{numtype(maps...)}(maps...)

VcatMap{T}(maps::Union{Tuple,Vector}) where T = VcatMap{T}(maps...)
function VcatMap{T}(maps...) where T
	M = sum(t->mapsize(t,1), maps)
	N = sum(t->mapsize(t,2), maps)
	VcatMap{T,M,N}(maps...)
end

mapdim(map) = mapsize(map,2)

VcatMap{T,M,N}(maps::Union{Tuple,Vector}) where {T,M,N} = VcatMap{T,M,N}(maps...)
function VcatMap{T,M,N}(maps...) where {T,M,N}
	DIM1 = map(t->mapsize(t,1), maps)
	DIM2 = map(t->mapsize(t,2), maps)
	VcatMap{T,M,N,DIM1,DIM2}(convert_numtype.(Ref(T), maps)...)
end

VcatMap{T,M,N,DIM1,DIM2}(maps...) where {T,M,N,DIM1,DIM2} =
	VcatMap{T,M,N,DIM1,DIM2,typeof(maps)}(maps)

mapsize(m::VcatMap{T,M,N}) where {T,M,N} = (M,N)

tointernalpoint(m::VcatMap{T,M,N,DIM1,DIM2}, x) where {T,M,N,DIM1,DIM2} =
	convert_fromcartesian(x, Val{DIM2}())
toexternalpoint(m::VcatMap{T,M,N,DIM1,DIM2}, y) where {T,M,N,DIM1,DIM2} =
	convert_tocartesian(y, Val{DIM1}())

size_as_matrix(A::AbstractArray) = size(A)
size_as_matrix(A::Number) = (1,1)

# The Jacobian is block-diagonal
function toexternalmatrix(m::VcatMap{T,M,N}, matrices) where {T,M,N}
	A = zeros(T, M, N)
	k = 0
	l = 0
	for el in matrices
		m,n = size_as_matrix(el)
		A[k+1:k+m,l+1:l+n] .= el
		k += m
		l += n
	end
	SMatrix{M,N}(A)
end


"""
A `VectorProductMap` is a product map where all components are univariate maps,
with inputs and outputs collected into a `Vector`.
"""
struct VectorProductMap{T<:AbstractVector,M} <: ProductMap{T}
    maps    ::  Vector{M}
end

VectorProductMap(maps...) = VectorProductMap(maps)
VectorProductMap(maps) = VectorProductMap(collect(maps))
function VectorProductMap(maps::Vector)
	T = mapreduce(numtype, promote_type, maps)
	VectorProductMap{Vector{T}}(maps)
end

VectorProductMap{T}(maps...) where {T} = VectorProductMap{T}(maps)
VectorProductMap{T}(maps) where {T} = VectorProductMap{T}(collect(maps))
function VectorProductMap{T}(maps::Vector) where {T}
	Tmaps = convert.(Map{eltype(T)}, maps)
	VectorProductMap{T,eltype(Tmaps)}(Tmaps)
end

# the Jacobian is a diagonal matrix
toexternalmatrix(m::VectorProductMap, matrices) = Diagonal(matrices)

mapsize(m::VectorProductMap) = (length(m.maps), length(m.maps))

"""
A `TupleProductMap` is a product map with all components collected in a tuple.
There is no vector-valued function associated with this map.
"""
struct TupleProductMap{T<:Tuple,MM} <: ProductMap{T}
    maps    ::  MM
end

TupleProductMap(maps::Vector) = TupleProductMap(maps...)
TupleProductMap(maps...) = TupleProductMap(maps)
function TupleProductMap(maps::Tuple)
	T = Tuple{map(domaintype, maps)...}
	TupleProductMap{T}(maps)
end

TupleProductMap{T}(maps::Vector) where {T<:Tuple} = TupleProductMap{T}(maps...)
TupleProductMap{T}(maps...) where {T<:Tuple} = TupleProductMap{T}(maps)
function TupleProductMap{T}(maps::NTuple{N,<:AbstractMap}) where {N,T <: Tuple}
	Tmaps = map((t,d) -> convert(Map{t},d), tuple(T.parameters...), maps)
	TupleProductMap{T,typeof(Tmaps)}(Tmaps)
end
TupleProductMap{T}(maps) where {T <: Tuple} = TupleProductMap{T,typeof(maps)}(maps)

@testset "map interval" begin
        @test interval_map(1.0, Inf, 2.0, Inf) == AffineMap(1.0, 1.0)
        @test interval_map(1.0, Inf, Inf, 2.0) == AffineMap(-1.0, 3.0)
        @test interval_map(Inf, 1.0, 2.0, Inf) == AffineMap(-1.0, 3.0)
        @test interval_map(Inf, 1.0, Inf, 2.0) == AffineMap(1.0, 1.0)
        @test interval_map(-Inf, Inf, -Inf, Inf) == IdentityMap()
        @test interval_map(-Inf, Inf, Inf, -Inf) == LinearMap(-1)
        @test interval_map(Inf, -Inf, -Inf, Inf) == LinearMap(-1)
        @test interval_map(Inf, -Inf, Inf, -Inf) == IdentityMap()
        @test interval_map(Inf, Inf, Inf, Inf) == IdentityMap()
        @test interval_map(-Inf, -Inf, -Inf, -Inf) == IdentityMap()
        @test interval_map(Inf, Inf, -Inf, -Inf) == LinearMap(-1)
        @test interval_map(-Inf, -Inf, Inf, Inf) == LinearMap(-1)
        @test_throws ArgumentError interval_map(-Inf, Inf, -Inf, -Inf)
        @test_throws ArgumentError interval_map(-1, 1, -1, Inf)
        @test_throws ArgumentError interval_map(-1, 1, -1, Inf)

        a = 1.0; b = 2.0; c = 3.0; d = 5;
        @test interval_map(a, b, c, d)(a) == c
        @test interval_map(a, b, c, d)(b) == d
        @test interval_map(a, b, c, d) == bounded_interval_map(a, b, c, d)
end

"""
A lazy map has an action that is defined in terms of other maps. Those maps are
stored internally, and the action of the lazy map is computed on-the-fly and only
when invoked.
"""
abstract type LazyMap{T} <: Map{T} end


"A composite lazy map is defined in terms of several other maps."
abstract type CompositeLazyMap{T} <: LazyMap{T} end
"A simple lazy map derives from a single other map."
abstract type SimpleLazyMap{T} <: LazyMap{T} end

supermap(m::SimpleLazyMap) = m.map
components(m::CompositeLazyMap) = m.maps

Base.getindex(m::CompositeLazyMap, I::ComponentIndex...) = component(m, map(Indexing.to_index, I)...)

isreal(m::SimpleLazyMap) = isreal(supermap(m))
isreal(m::CompositeLazyMap) = all(map(isreal, components(m)))

"A `DerivedMap` inherits all of its properties from another map, but has its own type."
abstract type DerivedMap{T} <: SimpleLazyMap{T} end

applymap(m::DerivedMap, x) = supermap(m)(x)
appymap!(y, m::DerivedMap, x) = applymap!(y, supermap(m), x)

jacobian(m::DerivedMap) = jacobian(supermap(m))


"A `WrappedMap{T}` takes any object and turns it into a `Map{T}`."
struct WrappedMap{T,M} <: DerivedMap{T}
    map ::  M
end
WrappedMap{T}(map) where {T} = WrappedMap{T,typeof(map)}(map)
WrappedMap(map) = WrappedMap{Float64}(map)

similarmap(m::WrappedMap, ::Type{T}) where {T} = WrappedMap{T}(m)

convert(::Type{Map}, m::Map) = m
convert(::Type{Map}, m) = WrappedMap(m)
convert(::Type{Map{T}}, m) where {T} = WrappedMap{T}(m)
convert(::Type{Map{T}}, m::WrappedMap) where {T} = WrappedMap{T}(m.map)

isequalmap(m1::WrappedMap, m2::Function) = m1.map == m2
isequalmap(m1::Function, m2::WrappedMap) = m1 == m2.map

map_hash(m::WrappedMap, h::UInt) = hashrec("WrappedMap", supermap(m), h)

Display.displaystencil(m::WrappedMap{T}) where {T} =
	["WrappedMap{$T}(", supermap(m), ")"]
show(io::IO, mime::MIME"text/plain", m::WrappedMap) = composite_show(io, mime, m)

# Examples

These are the same examples as those in the README of the package repository.

## Intervals from IntervalSets

DomainSets.jl uses [IntervalSets.jl](https://github.com/JuliaMath/IntervalSets.jl) for closed and open intervals. In addition, it defines a few standard intervals.

```julia
julia> using DomainSets

julia> UnitInterval()
0.0..1.0 (Unit)

julia> ChebyshevInterval()
-1.0..1.0 (Chebyshev)

julia> HalfLine()
0.0..Inf (closed–open) (HalfLine)
```

## Rectangles

Rectangles can be constructed as a product of intervals, where the elements of the domain
are `SVector{2}`:

```julia
julia> using DomainSets: ×

julia> (-1..1) × (0..3) × (4.0..5.0)
(-1.0..1.0) × (0.0..3.0) × (4.0..5.0)

julia> [1,2] in (-1..1) × (0..3)
true

julia> UnitInterval()^3
UnitCube()
```

## Circles and Spheres

A `UnitSphere`  contains `x` if `norm(x) == 1`. The unit sphere is N-dimensional,
and its dimension is specified with the constructor. The element types are
`SVector{N,T}` when the dimension is specified as `Val(3)`, and they
are `Vector{T}` when the dimension is specified by an integer value instead:
```julia
julia> using StaticArrays

julia> SA[0,0,1.0] in UnitSphere(Val(3))
true

julia> [0.0,1.0,0.0,0.0] in UnitSphere(4)
true
```
`UnitSphere` itself is an abstract type, hence the examples above return
concrete types `<:UnitSphere`. The intended element type can also be explicitly
specified with the `UnitSphere{T}` constructor:
```julia
julia> typeof(UnitSphere{SVector{3,BigFloat}}())
EuclideanUnitSphere{3, BigFloat} (alias for StaticUnitSphere{SArray{Tuple{3}, BigFloat, 1, 3}})

julia> typeof(UnitSphere{Vector{Float32}}(6))
VectorUnitSphere{Float32} (alias for DynamicUnitSphere{Array{Float32, 1}})
```

Without arguments, `UnitSphere()` defaults to a 3D domain with `SVector{3,Float64}`
elements. Similarly, there is a special case `UnitCircle` in 2D:
```julia
julia> SVector(1,0) in UnitCircle()
true
```



## Disks and Balls

A `UnitBall`  contains `x` if `norm(x) ≤ 1`. As with `UnitSphere`, the dimension
is specified via the constructor by type or by value:
```julia
julia> SVector(0.1,0.2,0.3) in UnitBall(Val(3))
true

julia> [0.1,0.2,0.3,-0.1] in UnitBall(4)
true
```
By default `N=3`, but `UnitDisk` is a special case in 2D, and so are `ComplexUnitDisk` and `ComplexUnitCircle` in the complex plane:
```julia
julia> SVector(0.1,0.2) in UnitDisk()
true

julia> 0.5+0.2im ∈ ComplexUnitDisk()
true
```

`UnitBall` itself is an abstract type, hence the examples above return
concrete types `<:UnitBall`. The types are similar to those associated with
`UnitSphere`. Like intervals, balls can also be open or closed:
```julia
julia> EuclideanUnitBall{3,Float64,:open}()
the 3-dimensional open unit ball
```


## Cartesian products

The cartesian product of domains is constructed with the `ProductDomain` or
`ProductDomain{T}` constructor. This abstract constructor returns concrete types
best adapted to the arguments given.

If `T` is not given, `ProductDomain` makes a suitable choice based on the
arguments. If all arguments are Euclidean, i.e., their element types are numbers
or static vectors, then the product is a Euclidean domain as well:
```julia
julia> ProductDomain(0..2, UnitCircle())
0.0..2.0 x the unit circle

julia> eltype(ans)
SVector{3, Float64} (alias for SArray{Tuple{3}, Float64, 1, 3})
```
The elements of the interval and the unit circle are flattened into a single
vector, much like the `vcat` function. The result is a `VcatDomain`.

If a `Vector` of domains is given, the element type is a `Vector` as well:
```julia
julia> 1:5 in ProductDomain([0..i for i in 1:5])
true
```
In other cases, the points are concatenated into a tuple and membership is
evaluated element-wise:
```julia
julia> ("a", 0.4) ∈ ProductDomain(["a","b"], 0..1)
true
```

Some arguments are recognized and return a more specialized product domain.
Examples are the unit box and more general hyperrectangles:
```julia
julia> ProductDomain(UnitInterval(), UnitInterval())
0.0..1.0 (Unit) x 0.0..1.0 (Unit)

julia> ProductDomain(0..2, 4..5, 6..7.0)
0.0..2.0 x 4.0..5.0 x 6.0..7.0

julia> typeof(ans)
Rectangle{SVector{3, Float64}}
```


## Union, intersection, and setdiff of domains

Domains can be unioned and intersected together:
```julia
julia> d = UnitCircle() ∪ 2UnitCircle();

julia> in.([SVector(1,0),SVector(0,2), SVector(1.5,1.5)], d)
3-element BitArray{1}:
 1
 1
 0

julia> d = UnitCircle() ∩ (2UnitCircle() .+ SVector(1.0,0.0))
the intersection of 2 domains:
	1.	: the unit circle
	2.	: A mapped domain based on the unit circle

julia> SVector(1,0) in d
false

julia> SVector(-1,0) in d
true
```


## Level sets

A domain can be defined by the level sets of a function. The domains of all
points `[x,y]` for which `x*y = 1` or `x*y >= 1` are represented as follows:
```julia
julia> d = LevelSet{SVector{2,Float64}}(prod, 1.0)
level set f(x) = 1.0 with f = prod

julia> [0.5,2] ∈ d
true

julia> SuperlevelSet{SVector{2,Float64}}(prod, 1.0)
superlevel set f(x) >= 1.0 with f = prod
```
There is also `SublevelSet`, and there are the special cases `ZeroSet`,
`SubzeroSet` and `SuperzeroSet`.

## Indicator functions

A domain can be defined by an indicator function or a characteristic function.
This is a function `f(x)` which evaluates to true or false, depending on whether or
not the point `x` belongs to the domain.
```julia
julia> d = IndicatorFunction{Float64}( t ->  cos(t) > 0)
indicator domain defined by function f = #5

julia> 0.5 ∈ d, 3.1 ∈ d
(true, false)
```
This enables generator syntax to define domains:
```julia
julia> d = Domain(x>0 for x in -1..1)
indicator function bounded by: -1..1

julia> 0.5 ∈ d, -0.5 ∈ d
(true, false)

julia> d = Domain( x*y > 0 for (x,y) in UnitDisk())
indicator function bounded by: the 2-dimensional closed unit ball

julia> [0.2, 0.3] ∈ d, [0.2, -0.3] ∈ d
(true, false)

julia> d = Domain( x+y+z > 0 for (x,y,z) in ProductDomain(UnitDisk(), 0..1))
indicator function bounded by: the 2-dimensional closed unit ball x 0..1

julia> [0.3,0.2,0.5] ∈ d
true
```

# The domain interface

Existing types may add the interpretation of being a domain by implementing the
domain interface. They gain the ability to interact with other domains.

## The `in` function

A domain is a set of elements that is possibly continuous. Continuous sets are
defined mathematically, not by an exhaustive list of their elements. In practice membership of the set is defined by the implementation of `in`. The function
call `in(x, domain)` evaluates to true if the domain contains an element `y`
such that `y == x`.

!!! note
    **Incompatible element types.**
    In principle, the function `in(x, domain)` should not throw an exception even
    if the types seem mathematically nonsensical. In that case, the correct return
    value is `false`. This mimicks the behaviour of `in` for finite sets in Julia:
    ```julia
    julia> in(rand(3,3), 1:3)
    false
    ```
    Indeed, a `3x3` matrix is not equal to any of the numbers `1`, `2` or `3`.


## The `domaineltype` function

The defining mathematical condition of a continuous set might be satisfied by
variables of different types. Still, the interface defines the `domaineltype`
of a domain. It is a valid type for elements of the set.

Functions that generate elements of the domain should generate elements
of that type. As a consequence, for finite sets such as an `AbstractArray` or `AbstractSet`, the `domaineltype` agrees with the `eltype` of that set. For
intervals on the real line, the `domaineltype` might be `Float64`. When there is
no clear candidate the `domaineltype` might simply be `Any`.


## Minimal formal interface

The domain interface is formally summarised in the following table:

| Required methods           |                             | Brief description                        |
|:-------------------------- |:--------------------------- |:---------------------------------------- |
| `in(x, d)`                 |                             | Returns `true` when `x` is an element of the domain, `false` otherwise |
| `DomainStyle(d)`           |                             | Returns `IsDomain()` if `d` implements this interface |
| **Optional methods**       | **Default definition**      | **Brief description**                 |
| `domaineltype(d)`          | `eltype(d)`                 | Returns a valid type for elements of the domain |

Several extensions of this minimal interface are defined in the `DomainSets` package.


## The Domain supertype and DomainStyle trait

Domains in this package inherit from the abstract type `Domain{T}`. It is the
supertype of continuous sets with `domaineltype` equal to `T`.

The package also defines the trait `DomainStyle`. Any type can declare to
implement the domain interface by defining
```julia
DomainSets.DomainStyle(d::MyDomain) = IsDomain()
```
Objects of type `Number`, `AbstractArray` and `AbstractSet` are declared to be
domains in this package.

# Euclidean geometry

Domains appearing in geometry are an important special case. A small number of
primitive domains are implemented.

Several of these may be open or closed.

DomainSets favours the definition of canonical types without state, which can
be implemented as singleton types without fields or data. It is made easy to map the
canonical domain to a more specific one, often using
an affine map. See: [Canonical domains](@ref).

## A note on Euclidean dimension

The Euclidean dimension of a domain can be implicit in the element type, if it
is scalar or a static vector. One could have `T=Float64` or
`T = SVector{3,Float64}` for 3D domains. The dimension can also be variable, if the element type is a `Vector{T}`. In the latter case the dimension is typically
explicitly stored in a field of the type. In the former case the dimension is implicit in the type and the type itself can be stateless.

!!! note
    `DomainSets` imposes no preference and enables both representations. Among other
    things, this leads to having more types, sometimes with funny or unexpected names.
    For example, `StaticUnitBall{T}` is a singleton type,
    whose dimension is fixed by the element type `T`. The word "static" in the name of the type refers to this aspect of dimensionality being known at compile-time.
    The alternative is `DynamicUnitBall{T}`. This is a domain with element type `Vector{T}`, whose dimension is explicitly stored in a field.


## Intervals

DomainSets uses [IntervalSets.jl](https://github.com/JuliaMath/IntervalSets.jl)
for the definition and manipulation of intervals. Most notably intervals can be
easily created using the ellipsis notation `a..b`.

`IntervalSets` supports open and closed intervals, finite and infinite intervals,
and intervals of non-numeric types such as dates and times. See the documentation
of the package for the full interface.

A number of intervals with fixed endpoints, known at compile-time, are added in
`DomainSets`, see [Approximation intervals](@ref).

## Rectangles and cubes

Rectangles and cubes are implemented as a `ProductDomain` (see [Product domains](@ref)).
They can be obtained by passing closed intervals to the `ProductDomain` constructor,
or by invoking the `Rectangle` constructor.

Two special cases are the `UnitSquare` and `UnitCube` types. These types have no state.

Some examples:
```julia
julia> ProductDomain(1.5..2.5, 3.5..6.0)
(1.5 .. 2.5) × (3.5 .. 6.0)

julia> [0.5,0.3] ∈ UnitSquare()
true

julia> [0.5,0.3,0.1] ∈ UnitCube()
true

julia> ProductDomain(UnitInterval(), UnitInterval())
UnitSquare()

julia> Rectangle([0.0,1.0,2.0], [1.0,4.0,6.0])
(0.0 .. 1.0) × (1.0 .. 4.0) × (2.0 .. 6.0)
```

##### Relevant functions

```@docs; canonical=false
Rectangle
UnitSquare
UnitCube
```

## Balls and spheres

The unit ball in a space is the volume consisting of all points `x` for which
`norm(x) < 1` or `norm(x) ≤ 1`, depending on whether the ball is open or closed.
The sphere is the boundary of the volume, i.e., the set of points for which
`norm(x) = 1`.

The canonical ball is a `UnitBall`, which can either have a dimension determined
by the element type `T` or, in case of `Vector` elements, a dimension that is
specified explicitly.

The constructor of the abstract type `Ball` returns a suitable concrete type depending on the arguments.

Types and syntax for spheres are analogous to those of balls.
```julia
julia> UnitBall()
UnitBall()

julia> Ball(3.0)
Ball(3.0, [0.0, 0.0, 0.0])

julia> Ball(3.0, [0.4, 2.0, 5.0])
Ball(3.0, [0.4, 2.0, 5.0])

julia> Ball{SVector{3,Float64}}(3, [0, 1, 2])
Ball(3.0, [0.0, 1.0, 2.0])

julia> eltype(ans)
SVector{3, Float64}
```

##### Relevant functions

```@docs; canonical=false
Ball()
Sphere()
UnitBall()
UnitSphere()
```

The unit disk and unit circle are special cases in 2D.
```@docs; canonical=false
UnitDisk
UnitCircle
```


## Simplices

The type hierarchy is similar to that of balls. The abstract supertype
`UnitSimplex` has a constructor which returns a suitable concrete subtype
depending on the arguments.

```@docs; canonical=false
UnitSimplex()
```

# DomainSets.jl

DomainSets.jl is a package designed to represent simple infinite sets. The package makes it easy to represent sets, verify membership of the set, compare sets and construct new sets from existing ones. Domains are considered equivalent if they describe the same set, regardless of their type.

Get started quickly by looking at the [Examples](@ref).

## What is a domain?

A domain is a continuous set of elements. Typical examples are geometrical
shapes such as cubes and triangles, see [Euclidean geometry](@ref). One can
construct new sets from existing ones as unions and intersections, see [Set operations](@ref). Domains can be combined this way regardless of their types,
see [The domain interface](@ref).

# Internal API Reference

This is an exhaustive list of all non-exported modules, constants, types, functions
and macros in `DomainSets.jl`.

!!! warning
    Unexported functions and types are subject to change across different
    releases of the package, even if the release is said to be non-breaking.
    This overview is useful to better understand or to help develop the
    internals of DomainSets.

## Constants

```@autodocs
Modules = [DomainSets]
Order   = [:constant]
Public  = false
Private = true
```

## Functions

```@autodocs
Modules = [DomainSets]
Order   = [:function]
Public  = false
Private = true
```

## Types

```@autodocs
Modules = [DomainSets]
Order   = [:type]
Public  = false
Private = true
```

# FunctionMaps.jl

## What is FunctionMaps.jl

`FunctionMaps` is a submodule of `DomainSets` as of version `0.7.10`. The
module collects all functionality in the package that relates to functions in
the sense of a map between spaces. It defines properties such as the `jacobian`
etcetera.

The module is expected to be moved into a separate package in the future and will
be independently documented.


## Public API Reference

### Constants

```@autodocs
Modules = [FunctionMaps]
Order   = [:constant]
Public  = true
Private = false
```

### Functions

```@autodocs
Modules = [FunctionMaps]
Order   = [:function]
Public  = true
Private = false
```

### Types

```@autodocs
Modules = [FunctionMaps]
Order   = [:type]
Public  = true
Private = false
```


## Internal API Reference

This is an exhaustive list of all non-exported constants, types and functions
in `FunctionMaps.jl`.

!!! warning
    Unexported functions and types are subject to change across different
    releases of the package, even if the release is said to be non-breaking.

### Constants

```@autodocs
Modules = [FunctionMaps]
Order   = [:constant]
Public  = false
Private = true
```

### Functions

```@autodocs
Modules = [FunctionMaps]
Order   = [:function]
Public  = false
Private = true
```

### Types

```@autodocs
Modules = [FunctionMaps]
Order   = [:type]
Public  = false
Private = true
```

# Canonical domains

The package favours the implementation of a small number of canonical domains,
in terms of which other domains can be defined. The mechanism to associate domains with
canonical domains, with various meanings of the word "canonical", turns out to be both flexible and productive.

This part of the documentation is oriented towards library developers, rather
than users. As a user, apart from learning applicable syntax, you'll also read
the "why" of it.

## A representative of a class

We will use a ball as a running example.
```julia
julia> using DomainSets, StaticArrays

julia> d = Ball(2.0, SA[0.3, 0.5])
Ball(2.0, [0.3, 0.5])
```
The type of `d` is `GenericBall`, which stores the radius and the center of the
ball. This is a common thing to do: a ball is defined mathematically by its
center and its radius.

The canonical domain is much simpler. In this case it is a unit ball or
`UnitDisk`, the 2D unit ball with radius 1. This domain can be represented without state, as a singleton type without fields. It is easy to reason about and simple to implement functionality for. In turn, much of the functionality for more general balls can be implemented in terms of the map from the unit disk. Better yet, that kind of functionality may itself be generic, i.e., the implementation of the generalized
functionality is not specific to balls. For example, the boundary of a domain is the boundary of the canonical domain, mapped by the same map that takes points of the canonical domain to points of the domain.

The map from the unit ball to a more general one is affine.
```julia
julia> canonicaldomain(d)
UnitDisk()

julia> m = mapfrom_canonical(d)
x -> 2.0 * x + v

v = 2-element SVector{2, Float64} with indices SOneTo(2):
 0.3
 0.5
```

The boundary of a unit ball is a unit sphere.
```julia
julia> boundary(canonicaldomain(d))
UnitCircle()

julia> boundary(d)
Sphere(2.0, [0.3, 0.5])
```
The code does not "know" that the boundary of a generic ball is also a generic
sphere. It simply applies the map to the unit circle:
```julia
julia> map_domain(m, boundary(canonicaldomain(d)))
Sphere(2.0, [0.3, 0.5])
```

Some canonical domains are [`UnitInterval`](@ref), [`UnitBall`](@ref), [`UnitSphere`](@ref) and [`UnitSimplex`](@ref).

##### Relevant functions

```@docs; canonical=false
canonicaldomain
hascanonicaldomain
mapfrom_canonical
mapto_canonical
```

## Equal domains

Different types of canonical domains can be obtained by using a different
`CanonicalType` argument to `canonicaldomain`. The first one we consider is
`Equal()`.

Domains can be the same even if they have different types. This is hard to capture in general without a symbolic engine. The system of canonical domains provides a partial solution by associating domains
with a simpler "equal" domain, whenever that is possible.

The unit ball in one dimension with scalar elements is the same as the interval $[-1,1]$.
```julia
julia> d = UnitBall{Float64}()
UnitBall{Float64}()

julia> canonicaldomain(DomainSets.Equal(), d)
-1.0 .. 1.0 (Chebyshev)

julia> equaldomain(d)
-1.0 .. 1.0 (Chebyshev)

julia> UnitBall{Float64}() == -1..1
true
```
The `equaldomain(d)` function is a convenience shorthand for `canonicaldomain(Equal(), d)`.

Similarly, the one-dimensional unit simplex with scalar element type is really
just the unit interval.
```julia
julia> equaldomain(UnitSimplex{Float64}())
0.0 .. 1.0 (Unit)
```


##### Relevant functions

```@docs; canonical=false
equaldomain
hasequaldomain
```

## Isomorphic domains

Two domains can be isomorphic but not equal. One example results from the
isomorphism between numbers and vectors of length 1, namely $x ↔ [x]$.

The unit ball with length 1 vector elements is isomorphic to the unit ball
with scalar element type:
```julia
julia> eltype(UnitBall(Val(1)))
SVector{1, Float64} (alias for SArray{Tuple{1}, Float64, 1, 1})

julia> canonicaldomain(DomainSets.Isomorphic(), UnitBall(Val(1)))
UnitBall{Float64}()

julia> mapfrom_canonical(DomainSets.Isomorphic(), UnitBall(Val(1)))
x : Float64 -> x : SVector{1, Float64}
```

Another common example is the identification of a region of the complex plane
with a domain in the 2D Euclidean plane, $[a;b] ↔ a+bi$. One such implementation
in the package is the complex unit circle:
```julia
julia> canonicaldomain(DomainSets.Isomorphic(), ComplexUnitCircle())
UnitCircle()

julia> mapto_canonical(DomainSets.Isomorphic(), ComplexUnitCircle())
x : ComplexF64 -> x : StaticArraysCore.SVector{2, Float64}
```

##### Relevant functions

```@docs; canonical=false
DomainSets.Isomorphic
```

The isomorphisms in the two examples above are defined in [FunctionMaps.jl](@ref).

```@docs; canonical=false
FunctionMaps.NumberToVector
FunctionMaps.VectorToNumber
FunctionMaps.ComplexToVector
FunctionMaps.VectorToComplex
```


## Parametric domains

A domain can be parameterised if it is easy to map from a parameter domain to
the domain at hand, but not the other way around. The map might not be invertible,
or might be difficult to invert (numerically or analytically).

We associate a circle with a radius and center with the unit circle. The unit
circle is the canonical domain. However, in turn, the unit circle can be
parameterised from the unit interval. Consequently, by chaining maps, any other
circle can be parameterised from the unit interval as well.

```julia
julia> parameterdomain(UnitCircle())
0.0 .. 1.0 (Unit)

julia> canonicaldomain(DomainSets.Parameterization(), UnitCircle())
0.0 .. 1.0 (Unit)

julia> mapfrom_parameterdomain(UnitCircle())
DomainSets.FunctionMaps.UnitCircleMap{Float64}()

julia> using StaticArrays

julia> canonicaldomain(DomainSets.Parameterization(), Sphere(2.0, SA[1.0, 5.0]))
0.0 .. 1.0 (Unit)

julia> mapfrom_parameterdomain(Sphere(2.0, SA[1.0, 5.0]))
(x -> 2.0 * x + v) ∘ UnitCircleMap{Float64}()

v = 2-element Vector{Float64}:
 1.0
 5.0
```
Note that `parameterdomain` is a convenience function similar to `equaldomain`.


Another common case is a line segment in 2D, which can be described in terms of an
interval and an affine map from ``ℝ`` to ``ℝ^2``.
```julia
julia> using StaticArrays

julia> m = AffineMap(SA[2.0, 3.0], SA[1.0, 2.0]);

julia> d = DomainSets.parametric_domain(m, UnitInterval());

julia> parameterdomain(d)
0.0 .. 1.0 (Unit)

julia> mapfrom_parameterdomain(d)
x -> v₁ * x + v₂

v₁ = 2-element SVector{2, Float64} with indices SOneTo(2):
 2.0
 3.0
v₂ = 2-element SVector{2, Float64} with indices SOneTo(2):
 1.0
 2.0
```

##### Relevant functions

```@docs; canonical=false
parameterdomain
mapfrom_parameterdomain
FunctionMaps.UnitCircleMap
```


## Simplifying a domain

The mechanisms involving various canonical types defined above allow one to
generically simplify a domain. The first possible simplification of a domain
is its [`equaldomain`](@ref).

However, even if the domain does not have an equivalent domain, its canonical
domain might have one. Or its parameter domain, if it exists. The function
[`DomainSets.simplify`](@ref) goes one step further than [`equaldomain`](@ref) and
also checks the latter property.

Since a scalar unit ball is an interval, any affine map of that ball also
corresponds to a similarly mapped interval.
```julia
julia> 2*UnitBall{Float64}()
Ball(2.0, 0.0)

julia> DomainSets.simplify(UnitBall{Float64}())
-1.0 .. 1.0 (Chebyshev)

julia> equaldomain(2*UnitBall{Float64}())
Ball(2.0, 0.0)

julia> DomainSets.simplify(2*UnitBall{Float64}())
-2.0 .. 2.0
```

The simplification of a domain is used in `isequaldomain` to simplify the
arguments before verifying equality. The mechanism above results in the following
positive identification of equality between domains with very different types:
```julia
julia> isequaldomain(2*UnitBall{Float64}() .+ 1, -1..3)
true
```

##### Relevant functions

```@docs; canonical=false
DomainSets.simplify
DomainSets.simplifies
```

# Approximation domains

DomainSets has its roots in the JuliaApproximation community. It is used for
example in the packages [ApproxFun](https://github.com/JuliaApproximation/ApproxFun.jl)
and [BasisFunctions](https://github.com/JuliaApproximation/BasisFunctions.jl).

## Approximation intervals

There are a number of stateless intervals (i.e. singleton types without data) to
represent standard intervals used in approximation theory. The endpoints of
these intervals are fixed and hence, at least in principle, known to the compiler.

```@docs; canonical=false
UnitInterval
ChebyshevInterval
HalfLine
NegativeHalfLine
```

The types are simple enough that some common set arithmetic operations retain
their special structure:
```julia
julia> HalfLine() ∩ ChebyshevInterval()
0.0 .. 1.0 (Unit)

julia> NegativeHalfLine() \ UnitInterval()
-Inf .. 0.0 (open) (NegativeHalfLine)
```

## The unit cube and other cubes

The product domain associated with any of the fixed intervals remains stateless
if the dimension is fixed as well:
```julia
julia> UnitInterval()^2
UnitSquare()

julia> ChebyshevInterval()^3
(-1.0 .. 1.0 (Chebyshev)) × (-1.0 .. 1.0 (Chebyshev)) × (-1.0 .. 1.0 (Chebyshev))
```

Some special cases are named.
```@docs; canonical=false
UnitSquare
UnitCube
```

# Complex analysis

## Regions of the complex plane

A number of domains relate to the complex plane:
- [ComplexUnitCircle](@ref)
- [ComplexUnitDisk](@ref)

For a more specific package dealing with complex regions, see [ComplexRegions.jl](https://github.com/complexvariables/ComplexRegions.jl).

## Identification with the plane

Any domain in $ℝ^2$ can be identified with a region of the complex plane. The
relevant maps to use are [`FunctionMaps.VectorToComplex`](@ref) and [`FunctionMaps.ComplexToVector`](@ref).

```@docs; canonical=false
FunctionMaps.VectorToComplex
FunctionMaps.ComplexToVector
```

# Public API Reference

This is an exhaustive list of all exported modules, constants, types, functions
and macros in `DomainSets.jl`.

## Constants

```@autodocs
Modules = [DomainSets]
Order   = [:constant]
Public  = true
Private = false
```

## Functions

```@autodocs
Modules = [DomainSets]
Order   = [:function]
Public  = true
Private = false
```

## Types

```@autodocs
Modules = [DomainSets]
Order   = [:type]
Public  = true
Private = false
```

# Equality of domains

A domain behaves as much as possible like the mathematical set it represents, irrespective of its type. Thus, for example, two domains are considered
equal if their membership functions agree.

It is not always possible to realize this intended behaviour in practice. Indeed
it may be difficult to discover automatically whether two domains are equal,
especially when their types are different. Deciding whether two domains are equal requires supporting implementation, hence the outcome is not always accurate.
Still, the principle serves as a design goal.

## The `isequaldomain` function

Equality of domains is decided by the `isequaldomain` function in general, and
simply by `==` for subtypes of the `Domain` supertype.
```julia
julia> UnitInterval() == UnitSimplex{Float64}() == 0..1
true

julia> ChebyshevInterval() == UnitBall{Float64}() == -1 .. 1
true
```
The methodology behind this example is explained in the section on
[Canonical domains](@ref).

!!! note
    If two domains are equal according to `==`, then their hashes are also equal.
    This allows the use of domains as keys in a `Dict`, if one is so inclined.


```@docs; canonical=false
isequaldomain
```


## Types versus mathematical sets

In some cases the notion of a set is more interesting than the functionality
provided by the membership function. A concrete type offers a representation of
a notion. Having a type for the real numbers (see [`ℝ`](@ref)) allows one to
specify the domain of a function of a real variable.

A type can also be convenient for other reasons. Although a ball with center and radius can be represented in terms of an affine map and a unit ball, not all affine maps
map the unit ball to a ball. Thus, in Julia, such a representation does not allow one to dispatch on the property of being a ball.

Yet, having more types also comes with disadvantages. Dispatching on the type of
a domain such as an `Interval` does not make a function apply to all intervals - because a scalar unit ball has a different type but mathematically is also an interval.

This tension is not resolved in the package. Still, deciding whether two domains are equal is a relevant aspect.

# Set operations

DomainSets implements a number of standard set operations. In some cases the
operation can be performed analytically and a concrete domain is returned. More
often than not, however, the operation results in a lazy structure.

Functions like `uniondomain` and `intersectdomain` are not restricted to
arguments of type `Domain`. Thus, one can construct the lazy union of any two
objects, regardless of their types.

A distinction is made for set operations between functions in lowercase, such as `uniondomain`, and capitalized functions, in this case `UnionDomain`. The former
attempts to simplify the arguments (see [Canonical domains](@ref)) and returns
a domain that is mathematically equivalent to the union of the two domains.
The latter is the constructor of a type and hence always returns an instance of `UnionDomain`.

!!! note
    For concrete subtypes of `Domain` one can use standard Julia operators and
    functions for common set operations. The relevant symbols and functions are
    `∪` (union), `∩` (intersect) and `∖` (setdiff). For example:
    ```julia
    julia> UnitBall(3) ∩ Point([0,0,0])
    Point([0.0, 0.0, 0.0])
    ```

!!! warning
    Set operations in DomainSets are often **not type-stable**. For example,
    by convention `uniondomain(d1,d2)` returns a domain of the simplest type
    that is mathematically equivalent to the union of `d1` and `d2`. The union
    of two overlapping intervals is a single interval, but the union of
    non-overlapping intervals is a `UnionDomain`:
    ```julia
    julia> uniondomain(1..3, 2..4)
    1 .. 4
    julia> uniondomain(1..3, 5..7)
    (1 .. 3) ∪ (5 .. 7)
    ```
    When type-safety is important, use the corresponding constructor:
    ```julia
    julia> UnionDomain(1..3, 2..4)
    (1 .. 3) ∪ (2 .. 4)
    ```


## Product domains

Product domains are created most easily by invoking the `ProductDomain`
constructor. The constructor of the associated abstract type `ProductDomain`
returns an instance of a suitable concrete subtype. In many cases a user need
not be aware of which type is being returned by `ProductDomain`, as it always
behaves like the requested domain.


```@docs; canonical=false
ProductDomain()
```

A number of concrete product domain types are implemented. They differ in what
the `eltype` of the product domain is. In the most generic case `T` is a tuple,
with each element representing the element type of the corresponding factor. A
`VcatDomain` is a special case for product domains of Euclidean type, i.e.,
one in which each factor has a scalar or statically-sized vector as element type. Finally, a `VectorProductDomain` has a `Vector` element type whose dimension is determined by the number of factors. The `ProductDomain` aims to return the most specialized type of domain, but the individual constructors may be invoked to ensure a
specific one.


```julia
julia> ProductDomain(2..4.5, 3.0..5.0)
(2.0 .. 4.5) × (3.0 .. 5.0)

julia> eltype(ProductDomain(2..4.5, 3.0..5.0))
SVector{2, Float64}

julia> [2.4, 4] ∈ ProductDomain(2..4.5, 3.0..5.0)
true

julia> TupleProductDomain(2..4.5, 3.0..5.0)
(2.0 .. 4.5) × (3.0 .. 5.0)

julia> eltype(TupleProductDomain(2..4.5, 3.0..5.0))
Tuple{Float64, Float64}

julia> (2.4, 4) ∈ TupleProductDomain(2..4.5, 3.0..5.0)
true

julia> ProductDomain([ i..i+1.0 for i in 1:10])
(1.0 .. 2.0) × (2.0 .. 3.0) × (3.0 .. 4.0) × ... × (10.0 .. 11.0)

julia> eltype(ProductDomain([ i..i+1.0 for i in 1:10]))
Vector{Float64}

julia> 1:10 ∈ ProductDomain([ i..i+1.0 for i in 1:10])
true
```

It is noteworthy that a `VcatDomain` can cope with the concatenation of scalars
and vectors. In the example below, a cylinder is represented as the product of
a two-dimensional disk with a one-dimensional interval.
```julia
julia> using DomainSets: ×

julia> cylinder = UnitDisk() × UnitInterval()
UnitDisk() × (0.0 .. 1.0 (Unit))

julia> eltype(cylinder)
SVector{3, Float64}

julia> [0.4,0.2,0.6] ∈ cylinder
true
```

A number of concrete product domains are implemented in `DomainSets`.
```@docs; canonical=false
VcatDomain
VectorProductDomain
TupleProductDomain
Rectangle
```

## Set union

The mathematical union of two sets is guaranteed by `uniondomain`, while a lazy
union is returned by `UnionDomain`.

For vectors and sets in Julia, `uniondomain` returns precisely what the standard
`union` operation would do, while `UnionDomain` returns a lazy construct:
```julia
julia> uniondomain(1:3, 10)
4-element Vector{Int64}:
  1
  2
  3
 10
julia> UnionDomain(1:3, 10)
1:3 ∪ 10

julia> 10 ∈ ans
true
```

```@docs; canonical=false
uniondomain
UnionDomain
```

## Set intersection

The mathematical intersection of two sets is guaranteed by `intersectdomain`,
while a lazy intersection is returned by `IntersectDomain`.

```@docs; canonical=false
intersectdomain
IntersectDomain
```


## Set difference

The mathematical difference of two sets is guaranteed by `setdiffdomain`,
while a lazy difference is returned by `SetdiffDomain`.

```@docs; canonical=false
setdiffdomain
SetdiffDomain
```
